/* game-window.c generated by valac 0.45.91, the Vala compiler
 * generated from game-window.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2015, 2016, 2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

typedef enum  {
	GAME_WINDOW_FLAGS_HAS_SOUND = 1 << 0,
	GAME_WINDOW_FLAGS_SHORTCUTS = 1 << 1,
	GAME_WINDOW_FLAGS_SHOW_HELP = 1 << 2,
	GAME_WINDOW_FLAGS_SHOW_HINT = 1 << 3,
	GAME_WINDOW_FLAGS_SHOW_REDO = 1 << 4,
	GAME_WINDOW_FLAGS_SHOW_UNDO = 1 << 5,
	GAME_WINDOW_FLAGS_SHOW_START_BUTTON = 1 << 6
} GameWindowFlags;

#define TYPE_GAME_WINDOW_FLAGS (game_window_flags_get_type ())

#define TYPE_ADAPTATIVE_WINDOW (adaptative_window_get_type ())
#define ADAPTATIVE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_WINDOW, AdaptativeWindow))
#define ADAPTATIVE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADAPTATIVE_WINDOW, AdaptativeWindowClass))
#define IS_ADAPTATIVE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_WINDOW))
#define IS_ADAPTATIVE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADAPTATIVE_WINDOW))
#define ADAPTATIVE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADAPTATIVE_WINDOW, AdaptativeWindowClass))

typedef struct _AdaptativeWindow AdaptativeWindow;
typedef struct _AdaptativeWindowClass AdaptativeWindowClass;
typedef struct _AdaptativeWindowPrivate AdaptativeWindowPrivate;

#define TYPE_ADAPTATIVE_WIDGET (adaptative_widget_get_type ())
#define ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget))
#define IS_ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_WIDGET))
#define ADAPTATIVE_WIDGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidgetIface))

typedef struct _AdaptativeWidget AdaptativeWidget;
typedef struct _AdaptativeWidgetIface AdaptativeWidgetIface;
typedef enum  {
	ADAPTATIVE_WIDGET_WINDOW_SIZE_START_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_USUAL_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_QUITE_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_FLAT
} AdaptativeWidgetWindowSize;

#define ADAPTATIVE_WIDGET_TYPE_WINDOW_SIZE (adaptative_widget_window_size_get_type ())

#define TYPE_BASE_WINDOW (base_window_get_type ())
#define BASE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BASE_WINDOW, BaseWindow))
#define BASE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BASE_WINDOW, BaseWindowClass))
#define IS_BASE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BASE_WINDOW))
#define IS_BASE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BASE_WINDOW))
#define BASE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BASE_WINDOW, BaseWindowClass))

typedef struct _BaseWindow BaseWindow;
typedef struct _BaseWindowClass BaseWindowClass;
typedef struct _BaseWindowPrivate BaseWindowPrivate;

#define TYPE_GAME_WINDOW (game_window_get_type ())
#define GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_WINDOW, GameWindow))
#define GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_WINDOW, GameWindowClass))
#define IS_GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_WINDOW))
#define IS_GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_WINDOW))
#define GAME_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_WINDOW, GameWindowClass))

typedef struct _GameWindow GameWindow;
typedef struct _GameWindowClass GameWindowClass;
typedef struct _GameWindowPrivate GameWindowPrivate;

#define TYPE_NIGHT_TIME_AWARE_HEADER_BAR (night_time_aware_header_bar_get_type ())
#define NIGHT_TIME_AWARE_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIGHT_TIME_AWARE_HEADER_BAR, NightTimeAwareHeaderBar))
#define NIGHT_TIME_AWARE_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIGHT_TIME_AWARE_HEADER_BAR, NightTimeAwareHeaderBarClass))
#define IS_NIGHT_TIME_AWARE_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIGHT_TIME_AWARE_HEADER_BAR))
#define IS_NIGHT_TIME_AWARE_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIGHT_TIME_AWARE_HEADER_BAR))
#define NIGHT_TIME_AWARE_HEADER_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIGHT_TIME_AWARE_HEADER_BAR, NightTimeAwareHeaderBarClass))

typedef struct _NightTimeAwareHeaderBar NightTimeAwareHeaderBar;
typedef struct _NightTimeAwareHeaderBarClass NightTimeAwareHeaderBarClass;

#define TYPE_BASE_HEADER_BAR (base_header_bar_get_type ())
#define BASE_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BASE_HEADER_BAR, BaseHeaderBar))
#define BASE_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BASE_HEADER_BAR, BaseHeaderBarClass))
#define IS_BASE_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BASE_HEADER_BAR))
#define IS_BASE_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BASE_HEADER_BAR))
#define BASE_HEADER_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BASE_HEADER_BAR, BaseHeaderBarClass))

typedef struct _BaseHeaderBar BaseHeaderBar;
typedef struct _BaseHeaderBarClass BaseHeaderBarClass;

#define TYPE_GAME_HEADER_BAR (game_header_bar_get_type ())
#define GAME_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_HEADER_BAR, GameHeaderBar))
#define GAME_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_HEADER_BAR, GameHeaderBarClass))
#define IS_GAME_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_HEADER_BAR))
#define IS_GAME_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_HEADER_BAR))
#define GAME_HEADER_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_HEADER_BAR, GameHeaderBarClass))

typedef struct _GameHeaderBar GameHeaderBar;
typedef struct _GameHeaderBarClass GameHeaderBarClass;

#define TYPE_BASE_VIEW (base_view_get_type ())
#define BASE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BASE_VIEW, BaseView))
#define BASE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BASE_VIEW, BaseViewClass))
#define IS_BASE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BASE_VIEW))
#define IS_BASE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BASE_VIEW))
#define BASE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BASE_VIEW, BaseViewClass))

typedef struct _BaseView BaseView;
typedef struct _BaseViewClass BaseViewClass;

#define TYPE_GAME_VIEW (game_view_get_type ())
#define GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_VIEW, GameView))
#define GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_VIEW, GameViewClass))
#define IS_GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_VIEW))
#define IS_GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_VIEW))
#define GAME_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_VIEW, GameViewClass))

typedef struct _GameView GameView;
typedef struct _GameViewClass GameViewClass;
enum  {
	GAME_WINDOW_0_PROPERTY,
	GAME_WINDOW_NUM_PROPERTIES
};
static GParamSpec* game_window_properties[GAME_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_NIGHT_LIGHT_MONITOR (night_light_monitor_get_type ())
#define NIGHT_LIGHT_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIGHT_LIGHT_MONITOR, NightLightMonitor))
#define NIGHT_LIGHT_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIGHT_LIGHT_MONITOR, NightLightMonitorClass))
#define IS_NIGHT_LIGHT_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIGHT_LIGHT_MONITOR))
#define IS_NIGHT_LIGHT_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIGHT_LIGHT_MONITOR))
#define NIGHT_LIGHT_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIGHT_LIGHT_MONITOR, NightLightMonitorClass))

typedef struct _NightLightMonitor NightLightMonitor;
typedef struct _NightLightMonitorClass NightLightMonitorClass;

#define TYPE_REVERSI_VIEW (reversi_view_get_type ())
#define REVERSI_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_REVERSI_VIEW, ReversiView))
#define REVERSI_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_REVERSI_VIEW, ReversiViewClass))
#define IS_REVERSI_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_REVERSI_VIEW))
#define IS_REVERSI_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_REVERSI_VIEW))
#define REVERSI_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_REVERSI_VIEW, ReversiViewClass))

typedef struct _ReversiView ReversiView;
typedef struct _ReversiViewClass ReversiViewClass;
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())
enum  {
	GAME_WINDOW_PLAY_SIGNAL,
	GAME_WINDOW_WAIT_SIGNAL,
	GAME_WINDOW_BACK_SIGNAL,
	GAME_WINDOW_RESTART_SIGNAL,
	GAME_WINDOW_UNDO_SIGNAL,
	GAME_WINDOW_REDO_SIGNAL,
	GAME_WINDOW_HINT_SIGNAL,
	GAME_WINDOW_NUM_SIGNALS
};
static guint game_window_signals[GAME_WINDOW_NUM_SIGNALS] = {0};

struct _AdaptativeWindow {
	GtkApplicationWindow parent_instance;
	AdaptativeWindowPrivate * priv;
};

struct _AdaptativeWindowClass {
	GtkApplicationWindowClass parent_class;
	void (*on_fullscreen) (AdaptativeWindow* self);
	void (*on_unfullscreen) (AdaptativeWindow* self);
	void (*before_destroy) (AdaptativeWindow* self);
};

struct _AdaptativeWidgetIface {
	GTypeInterface parent_iface;
	void (*set_window_size) (AdaptativeWidget* self, AdaptativeWidgetWindowSize new_size);
};

struct _BaseWindow {
	AdaptativeWindow parent_instance;
	BaseWindowPrivate * priv;
};

struct _BaseWindowClass {
	AdaptativeWindowClass parent_class;
	gboolean (*handle_copy_text) (BaseWindow* self, gchar* * copy_text);
	gboolean (*get_alt_copy_text) (BaseWindow* self, gchar* * copy_text);
	void (*paste_text) (BaseWindow* self, const gchar* text);
	void (*menu_pressed) (BaseWindow* self);
	gboolean (*on_key_press_event) (BaseWindow* self, GtkWidget* widget, GdkEventKey* event);
	void (*set_window_size) (BaseWindow* self, AdaptativeWidgetWindowSize new_size);
	void (*close_in_window_panels) (BaseWindow* self);
	gboolean (*escape_pressed) (BaseWindow* self);
	void (*show_default_view) (BaseWindow* self);
};

struct _GameWindow {
	BaseWindow parent_instance;
	GameWindowPrivate * priv;
};

struct _GameWindowClass {
	BaseWindowClass parent_class;
};

struct _GameWindowPrivate {
	gboolean game_finished;
	GameHeaderBar* headerbar;
	GameView* game_view;
	GtkBox* new_game_screen;
	GSimpleAction* undo_action;
	GSimpleAction* redo_action;
	gboolean back_action_disabled;
};

static gint GameWindow_private_offset;
static gpointer game_window_parent_class = NULL;
static AdaptativeWidgetIface * game_window_adaptative_widget_parent_iface = NULL;

GType game_window_flags_get_type (void) G_GNUC_CONST;
GType adaptative_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdaptativeWindow, g_object_unref)
GType adaptative_widget_window_size_get_type (void) G_GNUC_CONST;
GType adaptative_widget_get_type (void) G_GNUC_CONST;
GType base_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BaseWindow, g_object_unref)
GType game_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameWindow, g_object_unref)
GType night_time_aware_header_bar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NightTimeAwareHeaderBar, g_object_unref)
GType base_header_bar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BaseHeaderBar, g_object_unref)
GType game_header_bar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHeaderBar, g_object_unref)
GType base_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BaseView, g_object_unref)
GType game_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameView, g_object_unref)
static void game_window_new_game_cb (GameWindow* self);
static void _game_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static void game_window_start_game_cb (GameWindow* self);
static void _game_window_start_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void game_window_undo_cb (GameWindow* self);
static void _game_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void game_window_redo_cb (GameWindow* self);
static void _game_window_redo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void game_window_hint_cb (GameWindow* self);
static void _game_window_hint_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
GType night_light_monitor_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NightLightMonitor, g_object_unref)
GameWindow* game_window_new (const gchar* css_resource,
                             const gchar* name,
                             const gchar* about_action_label,
                             gboolean start_now,
                             GameWindowFlags flags,
                             GtkBox* _new_game_screen,
                             GtkWidget* view_content,
                             GMenu* appearance_menu,
                             NightLightMonitor* night_light_monitor);
GameWindow* game_window_construct (GType object_type,
                                   const gchar* css_resource,
                                   const gchar* name,
                                   const gchar* about_action_label,
                                   gboolean start_now,
                                   GameWindowFlags flags,
                                   GtkBox* _new_game_screen,
                                   GtkWidget* view_content,
                                   GMenu* appearance_menu,
                                   NightLightMonitor* night_light_monitor);
GameHeaderBar* game_header_bar_new (const gchar* _window_name,
                                    const gchar* _about_action_label,
                                    GameWindowFlags flags,
                                    GMenu* _appearance_menu,
                                    NightLightMonitor* _night_light_monitor);
GameHeaderBar* game_header_bar_construct (GType object_type,
                                          const gchar* _window_name,
                                          const gchar* _about_action_label,
                                          GameWindowFlags flags,
                                          GMenu* _appearance_menu,
                                          NightLightMonitor* _night_light_monitor);
GameView* game_view_new (GameWindowFlags flags,
                         GtkBox* new_game_screen,
                         GtkWidget* content);
GameView* game_view_construct (GType object_type,
                               GameWindowFlags flags,
                               GtkBox* new_game_screen,
                               GtkWidget* content);
#define IAGNO_PROGRAM_NAME _ ("Iagno")
GType reversi_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ReversiView, g_object_unref)
static void __lambda22_ (GameWindow* self,
                  gboolean undoing);
void game_header_bar_update_history_button (GameHeaderBar* self,
                                            gboolean finish_animation);
static void ___lambda22__reversi_view_notify_final_animation (ReversiView* _sender,
                                                       gboolean undo,
                                                       gpointer self);
static void game_window_install_ui_action_entries (GameWindow* self);
static void game_window_show_view (GameWindow* self);
static void game_window_show_new_game_screen (GameWindow* self);
static void game_window_real_set_window_size (AdaptativeWidget* base,
                                       AdaptativeWidgetWindowSize new_size);
void base_window_set_window_size (BaseWindow* self,
                                  AdaptativeWidgetWindowSize new_size);
void adaptative_widget_set_window_size (AdaptativeWidget* self,
                                        AdaptativeWidgetWindowSize new_size);
void game_window_finish_game (GameWindow* self);
void game_header_bar_finish_game (GameHeaderBar* self);
static gboolean game_window_real_escape_pressed (BaseWindow* base);
gboolean base_window_escape_pressed (BaseWindow* self);
static void game_window_back_cb (GameWindow* self);
gboolean game_view_game_content_visible_if_true (GameView* self);
void game_view_configure_transition (GameView* self,
                                     GtkStackTransitionType transition_type,
                                     guint transition_duration);
void base_window_hide_notification (BaseWindow* self);
gboolean game_header_bar_show_new_game_screen (GameHeaderBar* self,
                                               gboolean game_finished);
void game_view_show_new_game_box (GameView* self,
                                  gboolean grab_focus);
gboolean game_header_bar_show_view (GameHeaderBar* self,
                                    gboolean game_finished);
void game_view_show_game_content (GameView* self,
                                  gboolean grab_focus);
gboolean base_view_is_in_in_window_mode (BaseView* self);
static void game_window_new_game (GameWindow* self);
void game_window_cannot_undo_more (GameWindow* self);
void game_window_new_turn_start (GameWindow* self,
                                 gboolean can_undo);
void game_window_clear_subtitle (GameWindow* self);
GType player_get_type (void) G_GNUC_CONST;
void game_window_set_history_button_label (GameWindow* self,
                                           Player player);
void game_header_bar_set_history_button_label (GameHeaderBar* self,
                                               Player player);
void game_header_bar_new_game (GameHeaderBar* self);
void game_header_bar_history_button_new_game (GameHeaderBar* self);
static void game_window_finalize (GObject * obj);

static const GActionEntry GAME_WINDOW_ui_action_entries[5] = {{"new-game", _game_window_new_game_cb_gsimple_action_activate_callback}, {"start-game", _game_window_start_game_cb_gsimple_action_activate_callback}, {"undo", _game_window_undo_cb_gsimple_action_activate_callback}, {"redo", _game_window_redo_cb_gsimple_action_activate_callback}, {"hint", _game_window_hint_cb_gsimple_action_activate_callback}};

GType
game_window_flags_get_type (void)
{
	static volatile gsize game_window_flags_type_id__volatile = 0;
	if (g_once_init_enter (&game_window_flags_type_id__volatile)) {
		static const GFlagsValue values[] = {{GAME_WINDOW_FLAGS_HAS_SOUND, "GAME_WINDOW_FLAGS_HAS_SOUND", "has-sound"}, {GAME_WINDOW_FLAGS_SHORTCUTS, "GAME_WINDOW_FLAGS_SHORTCUTS", "shortcuts"}, {GAME_WINDOW_FLAGS_SHOW_HELP, "GAME_WINDOW_FLAGS_SHOW_HELP", "show-help"}, {GAME_WINDOW_FLAGS_SHOW_HINT, "GAME_WINDOW_FLAGS_SHOW_HINT", "show-hint"}, {GAME_WINDOW_FLAGS_SHOW_REDO, "GAME_WINDOW_FLAGS_SHOW_REDO", "show-redo"}, {GAME_WINDOW_FLAGS_SHOW_UNDO, "GAME_WINDOW_FLAGS_SHOW_UNDO", "show-undo"}, {GAME_WINDOW_FLAGS_SHOW_START_BUTTON, "GAME_WINDOW_FLAGS_SHOW_START_BUTTON", "show-start-button"}, {0, NULL, NULL}};
		GType game_window_flags_type_id;
		game_window_flags_type_id = g_flags_register_static ("GameWindowFlags", values);
		g_once_init_leave (&game_window_flags_type_id__volatile, game_window_flags_type_id);
	}
	return game_window_flags_type_id__volatile;
}

static inline gpointer
game_window_get_instance_private (GameWindow* self)
{
	return G_STRUCT_MEMBER_P (self, GameWindow_private_offset);
}

static void
_game_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 176 "../src/game-window.vala"
	game_window_new_game_cb ((GameWindow*) self);
#line 409 "game-window.c"
}

static void
_game_window_start_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 176 "../src/game-window.vala"
	game_window_start_game_cb ((GameWindow*) self);
#line 419 "game-window.c"
}

static void
_game_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 176 "../src/game-window.vala"
	game_window_undo_cb ((GameWindow*) self);
#line 429 "game-window.c"
}

static void
_game_window_redo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 176 "../src/game-window.vala"
	game_window_redo_cb ((GameWindow*) self);
#line 439 "game-window.c"
}

static void
_game_window_hint_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 176 "../src/game-window.vala"
	game_window_hint_cb ((GameWindow*) self);
#line 449 "game-window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 55 "../src/game-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 457 "game-window.c"
}

static void
__lambda22_ (GameWindow* self,
             gboolean undoing)
{
	GameHeaderBar* _tmp0_;
#line 59 "../src/game-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 59 "../src/game-window.vala"
	game_header_bar_update_history_button (_tmp0_, !undoing);
#line 469 "game-window.c"
}

static void
___lambda22__reversi_view_notify_final_animation (ReversiView* _sender,
                                                  gboolean undo,
                                                  gpointer self)
{
#line 59 "../src/game-window.vala"
	__lambda22_ ((GameWindow*) self, undo);
#line 479 "game-window.c"
}

GameWindow*
game_window_construct (GType object_type,
                       const gchar* css_resource,
                       const gchar* name,
                       const gchar* about_action_label,
                       gboolean start_now,
                       GameWindowFlags flags,
                       GtkBox* _new_game_screen,
                       GtkWidget* view_content,
                       GMenu* appearance_menu,
                       NightLightMonitor* night_light_monitor)
{
	GameWindow * self = NULL;
	GameHeaderBar* _headerbar = NULL;
	GameHeaderBar* _tmp0_;
	GameView* _game_view = NULL;
	GameView* _tmp1_;
	GameHeaderBar* _tmp2_;
	GameView* _tmp3_;
	GameHeaderBar* _tmp4_;
	GameHeaderBar* _tmp5_;
	GameView* _tmp6_;
	GameView* _tmp7_;
	GtkBox* _tmp8_;
#line 43 "../src/game-window.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 43 "../src/game-window.vala"
	g_return_val_if_fail (about_action_label != NULL, NULL);
#line 43 "../src/game-window.vala"
	g_return_val_if_fail (_new_game_screen != NULL, NULL);
#line 43 "../src/game-window.vala"
	g_return_val_if_fail (view_content != NULL, NULL);
#line 43 "../src/game-window.vala"
	g_return_val_if_fail (night_light_monitor != NULL, NULL);
#line 45 "../src/game-window.vala"
	_tmp0_ = game_header_bar_new (name, about_action_label, flags, appearance_menu, night_light_monitor);
#line 45 "../src/game-window.vala"
	g_object_ref_sink (_tmp0_);
#line 45 "../src/game-window.vala"
	_headerbar = _tmp0_;
#line 46 "../src/game-window.vala"
	_tmp1_ = game_view_new (flags, _new_game_screen, view_content);
#line 46 "../src/game-window.vala"
	g_object_ref_sink (_tmp1_);
#line 46 "../src/game-window.vala"
	_game_view = _tmp1_;
#line 48 "../src/game-window.vala"
	_tmp2_ = _headerbar;
#line 48 "../src/game-window.vala"
	_tmp3_ = _game_view;
#line 48 "../src/game-window.vala"
	self = (GameWindow*) g_object_new (object_type, "nta-headerbar", G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_NIGHT_TIME_AWARE_HEADER_BAR, NightTimeAwareHeaderBar), "base-view", G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_BASE_VIEW, BaseView), "window-title", IAGNO_PROGRAM_NAME, "specific-css-class-or-empty", "", "help-string-or-empty", "help:iagno", "schema-path", "/org/gnome/iagno/", NULL);
#line 55 "../src/game-window.vala"
	_tmp4_ = _headerbar;
#line 55 "../src/game-window.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 55 "../src/game-window.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 55 "../src/game-window.vala"
	self->priv->headerbar = _tmp5_;
#line 56 "../src/game-window.vala"
	_tmp6_ = _game_view;
#line 56 "../src/game-window.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 56 "../src/game-window.vala"
	_g_object_unref0 (self->priv->game_view);
#line 56 "../src/game-window.vala"
	self->priv->game_view = _tmp7_;
#line 57 "../src/game-window.vala"
	_tmp8_ = _g_object_ref0 (_new_game_screen);
#line 57 "../src/game-window.vala"
	_g_object_unref0 (self->priv->new_game_screen);
#line 57 "../src/game-window.vala"
	self->priv->new_game_screen = _tmp8_;
#line 59 "../src/game-window.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (view_content, TYPE_REVERSI_VIEW, ReversiView), "notify-final-animation", (GCallback) ___lambda22__reversi_view_notify_final_animation, self, 0);
#line 62 "../src/game-window.vala"
	if (css_resource != NULL) {
#line 560 "game-window.c"
		GtkCssProvider* css_provider = NULL;
		GtkCssProvider* _tmp9_;
		GtkCssProvider* _tmp10_;
		GdkScreen* gdk_screen = NULL;
		GdkScreen* _tmp11_;
		GdkScreen* _tmp12_;
		GdkScreen* _tmp13_;
#line 64 "../src/game-window.vala"
		_tmp9_ = gtk_css_provider_new ();
#line 64 "../src/game-window.vala"
		css_provider = _tmp9_;
#line 65 "../src/game-window.vala"
		_tmp10_ = css_provider;
#line 65 "../src/game-window.vala"
		gtk_css_provider_load_from_resource (_tmp10_, (const gchar*) css_resource);
#line 66 "../src/game-window.vala"
		_tmp11_ = gdk_screen_get_default ();
#line 66 "../src/game-window.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 66 "../src/game-window.vala"
		gdk_screen = _tmp12_;
#line 67 "../src/game-window.vala"
		_tmp13_ = gdk_screen;
#line 67 "../src/game-window.vala"
		if (_tmp13_ != NULL) {
#line 586 "game-window.c"
			GdkScreen* _tmp14_;
			GtkCssProvider* _tmp15_;
#line 68 "../src/game-window.vala"
			_tmp14_ = gdk_screen;
#line 68 "../src/game-window.vala"
			_tmp15_ = css_provider;
#line 68 "../src/game-window.vala"
			gtk_style_context_add_provider_for_screen (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gdk_screen_get_type (), GdkScreen), (GtkStyleProvider*) _tmp15_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 595 "game-window.c"
		}
#line 62 "../src/game-window.vala"
		_g_object_unref0 (gdk_screen);
#line 62 "../src/game-window.vala"
		_g_object_unref0 (css_provider);
#line 601 "game-window.c"
	}
#line 72 "../src/game-window.vala"
	game_window_install_ui_action_entries (self);
#line 75 "../src/game-window.vala"
	gtk_window_set_title ((GtkWindow*) self, name);
#line 78 "../src/game-window.vala"
	if (start_now) {
#line 79 "../src/game-window.vala"
		game_window_show_view (self);
#line 611 "game-window.c"
	} else {
#line 81 "../src/game-window.vala"
		game_window_show_new_game_screen (self);
#line 615 "game-window.c"
	}
#line 43 "../src/game-window.vala"
	_g_object_unref0 (_game_view);
#line 43 "../src/game-window.vala"
	_g_object_unref0 (_headerbar);
#line 43 "../src/game-window.vala"
	return self;
#line 623 "game-window.c"
}

GameWindow*
game_window_new (const gchar* css_resource,
                 const gchar* name,
                 const gchar* about_action_label,
                 gboolean start_now,
                 GameWindowFlags flags,
                 GtkBox* _new_game_screen,
                 GtkWidget* view_content,
                 GMenu* appearance_menu,
                 NightLightMonitor* night_light_monitor)
{
#line 43 "../src/game-window.vala"
	return game_window_construct (TYPE_GAME_WINDOW, css_resource, name, about_action_label, start_now, flags, _new_game_screen, view_content, appearance_menu, night_light_monitor);
#line 639 "game-window.c"
}

static void
game_window_real_set_window_size (AdaptativeWidget* base,
                                  AdaptativeWidgetWindowSize new_size)
{
	GameWindow * self;
	GtkBox* _tmp0_;
	GameView* _tmp1_;
#line 84 "../src/game-window.vala"
	self = (GameWindow*) base;
#line 86 "../src/game-window.vala"
	BASE_WINDOW_CLASS (game_window_parent_class)->set_window_size (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BASE_WINDOW, BaseWindow), new_size);
#line 88 "../src/game-window.vala"
	_tmp0_ = self->priv->new_game_screen;
#line 88 "../src/game-window.vala"
	adaptative_widget_set_window_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget), new_size);
#line 89 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 89 "../src/game-window.vala"
	adaptative_widget_set_window_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget), new_size);
#line 661 "game-window.c"
}

void
game_window_finish_game (GameWindow* self)
{
	GameHeaderBar* _tmp0_;
#line 96 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 98 "../src/game-window.vala"
	self->priv->game_finished = TRUE;
#line 99 "../src/game-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 99 "../src/game-window.vala"
	game_header_bar_finish_game (_tmp0_);
#line 676 "game-window.c"
}

static gboolean
game_window_real_escape_pressed (BaseWindow* base)
{
	GameWindow * self;
	gboolean result = FALSE;
#line 102 "../src/game-window.vala"
	self = (GameWindow*) base;
#line 104 "../src/game-window.vala"
	if (BASE_WINDOW_CLASS (game_window_parent_class)->escape_pressed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BASE_WINDOW, BaseWindow))) {
#line 105 "../src/game-window.vala"
		result = TRUE;
#line 105 "../src/game-window.vala"
		return result;
#line 692 "game-window.c"
	}
#line 106 "../src/game-window.vala"
	if (self->priv->back_action_disabled) {
#line 107 "../src/game-window.vala"
		result = TRUE;
#line 107 "../src/game-window.vala"
		return result;
#line 700 "game-window.c"
	}
#line 108 "../src/game-window.vala"
	game_window_back_cb (self);
#line 109 "../src/game-window.vala"
	result = TRUE;
#line 109 "../src/game-window.vala"
	return result;
#line 708 "game-window.c"
}

static void
game_window_back_cb (GameWindow* self)
{
	GameView* _tmp0_;
	GameView* _tmp1_;
#line 111 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 113 "../src/game-window.vala"
	_tmp0_ = self->priv->game_view;
#line 113 "../src/game-window.vala"
	if (game_view_game_content_visible_if_true (_tmp0_)) {
#line 114 "../src/game-window.vala"
		return;
#line 724 "game-window.c"
	}
#line 117 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 117 "../src/game-window.vala"
	game_view_configure_transition (_tmp1_, GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT, (guint) 800);
#line 118 "../src/game-window.vala"
	game_window_show_view (self);
#line 120 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_BACK_SIGNAL], 0);
#line 734 "game-window.c"
}

static void
game_window_show_new_game_screen (GameWindow* self)
{
	gboolean grabs_focus = FALSE;
	GameHeaderBar* _tmp0_;
	GameView* _tmp1_;
#line 127 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/game-window.vala"
	base_window_hide_notification ((BaseWindow*) self);
#line 130 "../src/game-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 130 "../src/game-window.vala"
	grabs_focus = game_header_bar_show_new_game_screen (_tmp0_, self->priv->game_finished);
#line 131 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 131 "../src/game-window.vala"
	game_view_show_new_game_box (_tmp1_, !grabs_focus);
#line 755 "game-window.c"
}

static void
game_window_show_view (GameWindow* self)
{
	gboolean grabs_focus = FALSE;
	GameHeaderBar* _tmp0_;
	GameView* _tmp1_;
#line 134 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/game-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 136 "../src/game-window.vala"
	grabs_focus = game_header_bar_show_view (_tmp0_, self->priv->game_finished);
#line 137 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 137 "../src/game-window.vala"
	game_view_show_game_content (_tmp1_, !grabs_focus);
#line 774 "game-window.c"
}

static void
game_window_install_ui_action_entries (GameWindow* self)
{
	GSimpleActionGroup* action_group = NULL;
	GSimpleActionGroup* _tmp0_;
	GAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GAction* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleAction* _tmp6_;
#line 160 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/game-window.vala"
	_tmp0_ = g_simple_action_group_new ();
#line 162 "../src/game-window.vala"
	action_group = _tmp0_;
#line 163 "../src/game-window.vala"
	g_action_map_add_action_entries ((GActionMap*) action_group, GAME_WINDOW_ui_action_entries, (gint) G_N_ELEMENTS (GAME_WINDOW_ui_action_entries), self);
#line 164 "../src/game-window.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "ui", (GActionGroup*) action_group);
#line 167 "../src/game-window.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) action_group, "undo");
#line 167 "../src/game-window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction));
#line 167 "../src/game-window.vala"
	_g_object_unref0 (self->priv->undo_action);
#line 167 "../src/game-window.vala"
	self->priv->undo_action = _tmp2_;
#line 168 "../src/game-window.vala"
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) action_group, "redo");
#line 168 "../src/game-window.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_simple_action_get_type (), GSimpleAction));
#line 168 "../src/game-window.vala"
	_g_object_unref0 (self->priv->redo_action);
#line 168 "../src/game-window.vala"
	self->priv->redo_action = _tmp4_;
#line 172 "../src/game-window.vala"
	_tmp5_ = self->priv->undo_action;
#line 172 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp5_, FALSE);
#line 173 "../src/game-window.vala"
	_tmp6_ = self->priv->redo_action;
#line 173 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp6_, FALSE);
#line 160 "../src/game-window.vala"
	_g_object_unref0 (action_group);
#line 824 "game-window.c"
}

static void
game_window_new_game_cb (GameWindow* self)
{
	GameView* _tmp0_;
	GameView* _tmp1_;
#line 187 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/game-window.vala"
	_tmp0_ = self->priv->game_view;
#line 189 "../src/game-window.vala"
	if (base_view_is_in_in_window_mode ((BaseView*) _tmp0_)) {
#line 190 "../src/game-window.vala"
		return;
#line 840 "game-window.c"
	}
#line 191 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 191 "../src/game-window.vala"
	if (!game_view_game_content_visible_if_true (_tmp1_)) {
#line 192 "../src/game-window.vala"
		return;
#line 848 "game-window.c"
	}
#line 194 "../src/game-window.vala"
	game_window_new_game (self);
#line 852 "game-window.c"
}

static void
game_window_undo_cb (GameWindow* self)
{
	GameView* _tmp0_;
	GameView* _tmp1_;
	GameView* _tmp2_;
#line 197 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/game-window.vala"
	_tmp0_ = self->priv->game_view;
#line 199 "../src/game-window.vala"
	if (base_view_is_in_in_window_mode ((BaseView*) _tmp0_)) {
#line 200 "../src/game-window.vala"
		return;
#line 869 "game-window.c"
	}
#line 201 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 201 "../src/game-window.vala"
	if (!game_view_game_content_visible_if_true (_tmp1_)) {
#line 203 "../src/game-window.vala"
		if (!self->priv->back_action_disabled) {
#line 204 "../src/game-window.vala"
			game_window_back_cb (self);
#line 879 "game-window.c"
		}
#line 205 "../src/game-window.vala"
		return;
#line 883 "game-window.c"
	}
#line 208 "../src/game-window.vala"
	self->priv->game_finished = FALSE;
#line 210 "../src/game-window.vala"
	_tmp2_ = self->priv->game_view;
#line 210 "../src/game-window.vala"
	game_view_show_game_content (_tmp2_, TRUE);
#line 213 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_UNDO_SIGNAL], 0);
#line 893 "game-window.c"
}

static void
game_window_redo_cb (GameWindow* self)
{
	GameView* _tmp0_;
	GameView* _tmp1_;
	GameView* _tmp2_;
	GSimpleAction* _tmp3_;
#line 216 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 218 "../src/game-window.vala"
	_tmp0_ = self->priv->game_view;
#line 218 "../src/game-window.vala"
	if (base_view_is_in_in_window_mode ((BaseView*) _tmp0_)) {
#line 219 "../src/game-window.vala"
		return;
#line 911 "game-window.c"
	}
#line 220 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 220 "../src/game-window.vala"
	if (!game_view_game_content_visible_if_true (_tmp1_)) {
#line 221 "../src/game-window.vala"
		return;
#line 919 "game-window.c"
	}
#line 223 "../src/game-window.vala"
	_tmp2_ = self->priv->game_view;
#line 223 "../src/game-window.vala"
	game_view_show_game_content (_tmp2_, TRUE);
#line 225 "../src/game-window.vala"
	_tmp3_ = self->priv->undo_action;
#line 225 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp3_, TRUE);
#line 227 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_REDO_SIGNAL], 0);
#line 931 "game-window.c"
}

static void
game_window_hint_cb (GameWindow* self)
{
	GameView* _tmp0_;
	GameView* _tmp1_;
#line 230 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 232 "../src/game-window.vala"
	_tmp0_ = self->priv->game_view;
#line 232 "../src/game-window.vala"
	if (base_view_is_in_in_window_mode ((BaseView*) _tmp0_)) {
#line 233 "../src/game-window.vala"
		return;
#line 947 "game-window.c"
	}
#line 234 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 234 "../src/game-window.vala"
	if (!game_view_game_content_visible_if_true (_tmp1_)) {
#line 235 "../src/game-window.vala"
		return;
#line 955 "game-window.c"
	}
#line 237 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_HINT_SIGNAL], 0);
#line 959 "game-window.c"
}

void
game_window_cannot_undo_more (GameWindow* self)
{
	GSimpleAction* _tmp0_;
	GameView* _tmp1_;
#line 244 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 246 "../src/game-window.vala"
	_tmp0_ = self->priv->undo_action;
#line 246 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp0_, FALSE);
#line 247 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 247 "../src/game-window.vala"
	game_view_show_game_content (_tmp1_, TRUE);
#line 977 "game-window.c"
}

void
game_window_new_turn_start (GameWindow* self,
                            gboolean can_undo)
{
	GSimpleAction* _tmp0_;
#line 250 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 252 "../src/game-window.vala"
	_tmp0_ = self->priv->undo_action;
#line 252 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp0_, can_undo);
#line 253 "../src/game-window.vala"
	base_window_hide_notification ((BaseWindow*) self);
#line 993 "game-window.c"
}

void
game_window_clear_subtitle (GameWindow* self)
{
	GameHeaderBar* _tmp0_;
#line 256 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 258 "../src/game-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 258 "../src/game-window.vala"
	gtk_header_bar_set_subtitle ((GtkHeaderBar*) _tmp0_, NULL);
#line 1006 "game-window.c"
}

void
game_window_set_history_button_label (GameWindow* self,
                                      Player player)
{
	GameHeaderBar* _tmp0_;
#line 261 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/game-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 263 "../src/game-window.vala"
	game_header_bar_set_history_button_label (_tmp0_, player);
#line 1020 "game-window.c"
}

static void
game_window_new_game (GameWindow* self)
{
	GameView* _tmp0_;
	GameHeaderBar* _tmp1_;
#line 270 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_WAIT_SIGNAL], 0);
#line 274 "../src/game-window.vala"
	_tmp0_ = self->priv->game_view;
#line 274 "../src/game-window.vala"
	game_view_configure_transition (_tmp0_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT, (guint) 800);
#line 276 "../src/game-window.vala"
	_tmp1_ = self->priv->headerbar;
#line 276 "../src/game-window.vala"
	game_header_bar_new_game (_tmp1_);
#line 277 "../src/game-window.vala"
	self->priv->back_action_disabled = FALSE;
#line 278 "../src/game-window.vala"
	game_window_show_new_game_screen (self);
#line 1044 "game-window.c"
}

static void
game_window_start_game_cb (GameWindow* self)
{
	GameView* _tmp0_;
	GameView* _tmp1_;
	GSimpleAction* _tmp2_;
	GameHeaderBar* _tmp3_;
	GameView* _tmp4_;
#line 281 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 283 "../src/game-window.vala"
	_tmp0_ = self->priv->game_view;
#line 283 "../src/game-window.vala"
	if (base_view_is_in_in_window_mode ((BaseView*) _tmp0_)) {
#line 284 "../src/game-window.vala"
		return;
#line 1063 "game-window.c"
	}
#line 286 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 286 "../src/game-window.vala"
	if (game_view_game_content_visible_if_true (_tmp1_)) {
#line 287 "../src/game-window.vala"
		return;
#line 1071 "game-window.c"
	}
#line 289 "../src/game-window.vala"
	self->priv->game_finished = FALSE;
#line 291 "../src/game-window.vala"
	_tmp2_ = self->priv->undo_action;
#line 291 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp2_, FALSE);
#line 294 "../src/game-window.vala"
	_tmp3_ = self->priv->headerbar;
#line 294 "../src/game-window.vala"
	game_header_bar_history_button_new_game (_tmp3_);
#line 296 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_PLAY_SIGNAL], 0);
#line 298 "../src/game-window.vala"
	_tmp4_ = self->priv->game_view;
#line 298 "../src/game-window.vala"
	game_view_configure_transition (_tmp4_, GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN, (guint) 1000);
#line 299 "../src/game-window.vala"
	game_window_show_view (self);
#line 1091 "game-window.c"
}

static void
game_window_class_init (GameWindowClass * klass,
                        gpointer klass_data)
{
#line 34 "../src/game-window.vala"
	game_window_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/game-window.vala"
	g_type_class_adjust_private_offset (klass, &GameWindow_private_offset);
#line 34 "../src/game-window.vala"
	((BaseWindowClass *) klass)->set_window_size = (void (*) (BaseWindow*, AdaptativeWidgetWindowSize)) game_window_real_set_window_size;
#line 34 "../src/game-window.vala"
	((BaseWindowClass *) klass)->escape_pressed = (gboolean (*) (BaseWindow*)) game_window_real_escape_pressed;
#line 34 "../src/game-window.vala"
	G_OBJECT_CLASS (klass)->finalize = game_window_finalize;
#line 34 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_PLAY_SIGNAL] = g_signal_new ("play", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 34 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_WAIT_SIGNAL] = g_signal_new ("wait", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 34 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_BACK_SIGNAL] = g_signal_new ("back", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 34 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_RESTART_SIGNAL] = g_signal_new ("restart", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 34 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_UNDO_SIGNAL] = g_signal_new ("undo", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 34 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_REDO_SIGNAL] = g_signal_new ("redo", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 34 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_HINT_SIGNAL] = g_signal_new ("hint", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1122 "game-window.c"
}

static void
game_window_adaptative_widget_interface_init (AdaptativeWidgetIface * iface,
                                              gpointer iface_data)
{
#line 34 "../src/game-window.vala"
	game_window_adaptative_widget_parent_iface = g_type_interface_peek_parent (iface);
#line 34 "../src/game-window.vala"
	iface->set_window_size = (void (*) (AdaptativeWidget*, AdaptativeWidgetWindowSize)) game_window_real_set_window_size;
#line 1133 "game-window.c"
}

static void
game_window_instance_init (GameWindow * self,
                           gpointer klass)
{
#line 34 "../src/game-window.vala"
	self->priv = game_window_get_instance_private (self);
#line 36 "../src/game-window.vala"
	self->priv->game_finished = FALSE;
#line 158 "../src/game-window.vala"
	self->priv->back_action_disabled = TRUE;
#line 1146 "game-window.c"
}

static void
game_window_finalize (GObject * obj)
{
	GameWindow * self;
#line 34 "../src/game-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_WINDOW, GameWindow);
#line 39 "../src/game-window.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 40 "../src/game-window.vala"
	_g_object_unref0 (self->priv->game_view);
#line 41 "../src/game-window.vala"
	_g_object_unref0 (self->priv->new_game_screen);
#line 154 "../src/game-window.vala"
	_g_object_unref0 (self->priv->undo_action);
#line 155 "../src/game-window.vala"
	_g_object_unref0 (self->priv->redo_action);
#line 34 "../src/game-window.vala"
	G_OBJECT_CLASS (game_window_parent_class)->finalize (obj);
#line 1167 "game-window.c"
}

GType
game_window_get_type (void)
{
	static volatile gsize game_window_type_id__volatile = 0;
	if (g_once_init_enter (&game_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameWindow), 0, (GInstanceInitFunc) game_window_instance_init, NULL };
		static const GInterfaceInfo adaptative_widget_info = { (GInterfaceInitFunc) game_window_adaptative_widget_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType game_window_type_id;
		game_window_type_id = g_type_register_static (TYPE_BASE_WINDOW, "GameWindow", &g_define_type_info, 0);
		g_type_add_interface_static (game_window_type_id, TYPE_ADAPTATIVE_WIDGET, &adaptative_widget_info);
		GameWindow_private_offset = g_type_add_instance_private (game_window_type_id, sizeof (GameWindowPrivate));
		g_once_init_leave (&game_window_type_id__volatile, game_window_type_id);
	}
	return game_window_type_id__volatile;
}

