/* game.c generated by valac 0.45.91, the Vala compiler
 * generated from game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2010-2013 Robert Ancell
   Copyright 2013-2014 Michael Catanzaro
   Copyright 2014-2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

typedef enum  {
	MAIN_LINE_TOP,
	MAIN_LINE_LEFT,
	MAIN_LINE_RIGHT,
	MAIN_LINE_BOTTOM,
	MAIN_LINE_TOPLEFT,
	MAIN_LINE_TOPRIGHT
} MainLine;

#define TYPE_MAIN_LINE (main_line_get_type ())

#define TYPE_GAME_STATE_STRUCT (game_state_struct_get_type ())
typedef struct _GameStateStruct GameStateStruct;
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_POSSIBLE_MOVE (possible_move_get_type ())
typedef struct _PossibleMove PossibleMove;

#define TYPE_GAME_STATE_OBJECT (game_state_object_get_type ())
#define GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_STATE_OBJECT, GameStateObject))
#define GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))
#define IS_GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_STATE_OBJECT))
#define IS_GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_STATE_OBJECT))
#define GAME_STATE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))

typedef struct _GameStateObject GameStateObject;
typedef struct _GameStateObjectClass GameStateObjectClass;
typedef struct _GameStateObjectPrivate GameStateObjectPrivate;
enum  {
	GAME_STATE_OBJECT_0_PROPERTY,
	GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY,
	GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY,
	GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY,
	GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY,
	GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY,
	GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY,
	GAME_STATE_OBJECT_NUM_PROPERTIES
};
static GParamSpec* game_state_object_properties[GAME_STATE_OBJECT_NUM_PROPERTIES];

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;
enum  {
	GAME_0_PROPERTY,
	GAME_NUMBER_OF_MOVES_PROPERTY,
	GAME_SIZE_PROPERTY,
	GAME_CURRENT_STATE_PROPERTY,
	GAME_ALTERNATIVE_START_PROPERTY,
	GAME_INITIAL_NUMBER_OF_TILES_PROPERTY,
	GAME_IS_COMPLETE_PROPERTY,
	GAME_N_LIGHT_TILES_PROPERTY,
	GAME_N_DARK_TILES_PROPERTY,
	GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY,
	GAME_CURRENT_COLOR_PROPERTY,
	GAME_NUM_PROPERTIES
};
static GParamSpec* game_properties[GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GAME_TURN_ENDED_SIGNAL,
	GAME_COMPLETENESS_UPDATED_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GameStateStruct {
	Player current_color;
	Player opponent_color;
	guint8 size;
	guint8 n_current_tiles;
	guint8 n_opponent_tiles;
	guint8 n_tiles;
	gboolean current_player_can_move;
	gboolean is_complete;
	Player* tiles;
	gint tiles_length1;
	gint tiles_length2;
	guint8* neighbor_tiles;
	gint neighbor_tiles_length1;
	gint neighbor_tiles_length2;
	guint8 x_saved;
	guint8 y_saved;
	guint8* empty_neighbors;
	gint empty_neighbors_length1;
	gint empty_neighbors_length2;
};

struct _PossibleMove {
	guint8 x;
	guint8 y;
	guint8 n_tiles;
	guint8 n_tiles_n;
	guint8 n_tiles_ne;
	guint8 n_tiles_e;
	guint8 n_tiles_se;
	guint8 n_tiles_s;
	guint8 n_tiles_so;
	guint8 n_tiles_o;
	guint8 n_tiles_no;
};

struct _GameStateObject {
	GObject parent_instance;
	GameStateObjectPrivate * priv;
};

struct _GameStateObjectClass {
	GObjectClass parent_class;
};

struct _GameStateObjectPrivate {
	GameStateStruct _game_state_struct;
};

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GamePrivate {
	GListStore* undo_stack;
	guint8 _size;
	GameStateObject* _current_state;
	gboolean _alternative_start;
	guint8 _initial_number_of_tiles;
	guint8* neighbor_tiles;
	gint neighbor_tiles_length1;
	gint neighbor_tiles_length2;
	GSList* possible_moves;
};

static gint GameStateObject_private_offset;
static gpointer game_state_object_parent_class = NULL;
static gint Game_private_offset;
static gpointer game_parent_class = NULL;

GType main_line_get_type (void) G_GNUC_CONST;
GType game_state_struct_get_type (void) G_GNUC_CONST;
GType player_get_type (void) G_GNUC_CONST;
GameStateStruct* game_state_struct_dup (const GameStateStruct* self);
void game_state_struct_free (GameStateStruct* self);
void game_state_struct_copy (const GameStateStruct* self,
                             GameStateStruct* dest);
void game_state_struct_destroy (GameStateStruct* self);
gchar* game_state_struct_to_string (GameStateStruct *self);
gchar* player_to_string (Player self);
void game_state_struct_init_copy_and_pass (GameStateStruct *self,
                                           GameStateStruct* game);
Player player_flip_color (Player p);
static Player* _vala_array_dup5 (Player* self,
                          int length);
static guint8* _vala_array_dup6 (guint8* self,
                          int length);
GType possible_move_get_type (void) G_GNUC_CONST;
PossibleMove* possible_move_dup (const PossibleMove* self);
void possible_move_free (PossibleMove* self);
void game_state_struct_init_copy_and_move (GameStateStruct *self,
                                           GameStateStruct* game,
                                           PossibleMove* move);
static Player* _vala_array_dup7 (Player* self,
                          int length);
static inline void game_state_struct_flip_tiles (Player** tiles,
                                   gint* tiles_length1,
                                   gint* tiles_length2,
                                   guint8 x,
                                   guint8 y,
                                   Player color,
                                   gint8 x_step,
                                   gint8 y_step,
                                   guint8 count);
static guint8* _vala_array_dup8 (guint8* self,
                          int length);
static inline void game_state_struct_update_empty_neighbors (GameStateStruct *self,
                                               guint8 x,
                                               guint8 y);
static void game_state_struct_update_who_can_move (GameStateStruct *self);
void game_state_struct_init_from_grid (GameStateStruct *self,
                                       guint8 _size,
                                       Player* _tiles,
                                       gint _tiles_length1,
                                       gint _tiles_length2,
                                       Player color,
                                       guint8* _neighbor_tiles,
                                       gint _neighbor_tiles_length1,
                                       gint _neighbor_tiles_length2);
static Player* _vala_array_dup9 (Player* self,
                          int length);
static inline void game_state_struct_add_tile_of_color (GameStateStruct *self,
                                          Player color);
static inline void game_state_struct_init_empty_neighbors (GameStateStruct *self);
gboolean game_state_struct_is_current_color (GameStateStruct *self,
                                             guint8 x,
                                             guint8 y);
gboolean game_state_struct_is_empty_tile (GameStateStruct *self,
                                          guint8 x,
                                          guint8 y);
static inline gboolean game_state_struct_is_valid_location_signed (GameStateStruct *self,
                                                     gint8 x,
                                                     gint8 y);
static inline gboolean game_state_struct_is_unplayable_basic (GameStateStruct *self,
                                                guint8 x,
                                                guint8 y);
static inline gboolean game_state_struct_can_place (GameStateStruct *self,
                                      guint8 x,
                                      guint8 y,
                                      Player color);
void game_state_struct_get_possible_moves (GameStateStruct *self,
                                           GSList* * moves);
static void _possible_move_free0_ (gpointer var);
static inline void _g_slist_free__possible_move_free0_ (GSList* self);
static inline gboolean game_state_struct_place_tile (GameStateStruct *self,
                                       guint8 x,
                                       guint8 y,
                                       Player color,
                                       PossibleMove* move);
gboolean game_state_struct_test_placing_tile (GameStateStruct *self,
                                              guint8 x,
                                              guint8 y,
                                              PossibleMove* move);
void possible_move_init (PossibleMove *self,
                         guint8 x,
                         guint8 y);
static inline guint8 game_state_struct_can_flip_tiles (GameStateStruct *self,
                                         guint8 x,
                                         guint8 y,
                                         Player color,
                                         gint8 x_step,
                                         gint8 y_step);
guint8 game_state_struct_get_empty_neighbors (GameStateStruct *self,
                                              guint8 x,
                                              guint8 y);
static inline guint8 game_state_struct_is_empty (GameStateStruct *self,
                                   gint8 x,
                                   gint8 y);
Player* game_state_struct_get_mainline (GameStateStruct *self,
                                        MainLine mainline_id,
                                        gint* result_length1);
static Player* _vala_array_dup10 (Player* self,
                           int length);
static guint8* _vala_array_dup11 (guint8* self,
                           int length);
GType game_state_object_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameStateObject, g_object_unref)
gchar* game_state_object_to_string (GameStateObject* self);
void game_state_object_get_game_state_struct (GameStateObject* self,
                                              GameStateStruct * result);
GameStateObject* game_state_object_new_copy_and_pass (GameStateObject* game);
GameStateObject* game_state_object_construct_copy_and_pass (GType object_type,
                                                            GameStateObject* game);
GameStateObject* game_state_object_new_copy_and_move (GameStateObject* game,
                                                      PossibleMove* move);
GameStateObject* game_state_object_construct_copy_and_move (GType object_type,
                                                            GameStateObject* game,
                                                            PossibleMove* move);
GameStateObject* game_state_object_new_from_grid (guint8 size,
                                                  Player* tiles,
                                                  gint tiles_length1,
                                                  gint tiles_length2,
                                                  Player color,
                                                  guint8* neighbor_tiles,
                                                  gint neighbor_tiles_length1,
                                                  gint neighbor_tiles_length2);
GameStateObject* game_state_object_construct_from_grid (GType object_type,
                                                        guint8 size,
                                                        Player* tiles,
                                                        gint tiles_length1,
                                                        gint tiles_length2,
                                                        Player color,
                                                        guint8* neighbor_tiles,
                                                        gint neighbor_tiles_length1,
                                                        gint neighbor_tiles_length2);
Player game_state_object_get_owner (GameStateObject* self,
                                    guint8 x,
                                    guint8 y);
void game_state_object_get_possible_moves (GameStateObject* self,
                                           GSList* * moves);
gboolean game_state_object_test_placing_tile (GameStateObject* self,
                                              guint8 x,
                                              guint8 y,
                                              PossibleMove* move);
GameStateObject* game_state_object_new (void);
GameStateObject* game_state_object_construct (GType object_type);
Player game_state_object_get_current_color (GameStateObject* self);
guint8 game_state_object_get_n_light_tiles (GameStateObject* self);
guint8 game_state_object_get_n_dark_tiles (GameStateObject* self);
gboolean game_state_object_get_current_player_can_move (GameStateObject* self);
gboolean game_state_object_get_is_complete (GameStateObject* self);
static void game_state_object_finalize (GObject * obj);
static void _vala_game_state_object_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
GType game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
Game* game_new (gboolean _alternative_start,
                guint8 _size);
Game* game_construct (GType object_type,
                      gboolean _alternative_start,
                      guint8 _size);
static void game_init_neighbor_tiles (guint8 size,
                               guint8** neighbor_tiles,
                               gint* neighbor_tiles_length1,
                               gint* neighbor_tiles_length2);
Game* game_new_from_strings (gchar** setup,
                             gint setup_length1,
                             Player to_move,
                             guint8 _size);
Game* game_construct_from_strings (GType object_type,
                                   gchar** setup,
                                   gint setup_length1,
                                   Player to_move,
                                   guint8 _size);
Player player_from_char (gchar c);
gchar* game_to_string (Game* self);
Player game_get_owner (Game* self,
                       guint8 x,
                       guint8 y);
GameStateObject* game_get_current_state (Game* self);
gboolean game_place_tile (Game* self,
                          guint8 x,
                          guint8 y);
void game_set_current_state (Game* self,
                             GameStateObject* value);
static void game_end_of_turn (Game* self,
                       gboolean undoing,
                       gboolean no_draw);
gboolean game_pass (Game* self);
gboolean game_get_current_player_can_move (Game* self);
static inline void game_update_possible_moves (Game* self);
void game_undo (Game* self,
                guint8 count);
guint8 game_get_number_of_moves (Game* self);
guint8* game_copy_neighbor_tiles (Game* self,
                                  gint* result_length1,
                                  gint* result_length2);
static guint8* _vala_array_dup12 (guint8* self,
                           int length);
gboolean game_test_placing_tile (Game* self,
                                 guint8 x,
                                 guint8 y,
                                 PossibleMove* move);
void game_get_possible_moves (Game* self,
                              GSList* * moves);
static PossibleMove* __lambda15_ (Game* self,
                           PossibleMove* a);
static gpointer ___lambda15__gcopy_func (gconstpointer src,
                                  gpointer self);
guint8 game_get_size (Game* self);
static void game_set_size (Game* self,
                    guint8 value);
gboolean game_get_alternative_start (Game* self);
static void game_set_alternative_start (Game* self,
                                 gboolean value);
guint8 game_get_initial_number_of_tiles (Game* self);
static void game_set_initial_number_of_tiles (Game* self,
                                       guint8 value);
gboolean game_get_is_complete (Game* self);
guint8 game_get_n_light_tiles (Game* self);
guint8 game_get_n_dark_tiles (Game* self);
Player game_get_current_color (Game* self);
static void g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static GObject * game_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties);
static void game_finalize (GObject * obj);
static void _vala_game_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_game_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);

GType
main_line_get_type (void)
{
	static volatile gsize main_line_type_id__volatile = 0;
	if (g_once_init_enter (&main_line_type_id__volatile)) {
		static const GEnumValue values[] = {{MAIN_LINE_TOP, "MAIN_LINE_TOP", "top"}, {MAIN_LINE_LEFT, "MAIN_LINE_LEFT", "left"}, {MAIN_LINE_RIGHT, "MAIN_LINE_RIGHT", "right"}, {MAIN_LINE_BOTTOM, "MAIN_LINE_BOTTOM", "bottom"}, {MAIN_LINE_TOPLEFT, "MAIN_LINE_TOPLEFT", "topleft"}, {MAIN_LINE_TOPRIGHT, "MAIN_LINE_TOPRIGHT", "topright"}, {0, NULL, NULL}};
		GType main_line_type_id;
		main_line_type_id = g_enum_register_static ("MainLine", values);
		g_once_init_leave (&main_line_type_id__volatile, main_line_type_id);
	}
	return main_line_type_id__volatile;
}

gchar*
game_state_struct_to_string (GameStateStruct *self)
{
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
#line 51 "../src/game.vala"
	_tmp0_ = g_strdup ("\n");
#line 51 "../src/game.vala"
	s = _tmp0_;
#line 458 "game.c"
	{
		guint8 y = 0U;
#line 53 "../src/game.vala"
		y = (guint8) 0;
#line 463 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 53 "../src/game.vala"
			_tmp1_ = TRUE;
#line 53 "../src/game.vala"
			while (TRUE) {
#line 470 "game.c"
				const gchar* _tmp13_;
				gchar* _tmp14_;
#line 53 "../src/game.vala"
				if (!_tmp1_) {
#line 475 "game.c"
					guint8 _tmp2_;
#line 53 "../src/game.vala"
					_tmp2_ = y;
#line 53 "../src/game.vala"
					y = _tmp2_ + 1;
#line 481 "game.c"
				}
#line 53 "../src/game.vala"
				_tmp1_ = FALSE;
#line 53 "../src/game.vala"
				if (!(y < (*self).size)) {
#line 53 "../src/game.vala"
					break;
#line 489 "game.c"
				}
				{
					guint8 x = 0U;
#line 55 "../src/game.vala"
					x = (guint8) 0;
#line 495 "game.c"
					{
						gboolean _tmp3_ = FALSE;
#line 55 "../src/game.vala"
						_tmp3_ = TRUE;
#line 55 "../src/game.vala"
						while (TRUE) {
#line 502 "game.c"
							const gchar* _tmp5_;
							Player* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							Player _tmp7_;
							gchar* _tmp8_;
							gchar* _tmp9_;
							gchar* _tmp10_;
							gchar* _tmp11_;
							gchar* _tmp12_;
#line 55 "../src/game.vala"
							if (!_tmp3_) {
#line 515 "game.c"
								guint8 _tmp4_;
#line 55 "../src/game.vala"
								_tmp4_ = x;
#line 55 "../src/game.vala"
								x = _tmp4_ + 1;
#line 521 "game.c"
							}
#line 55 "../src/game.vala"
							_tmp3_ = FALSE;
#line 55 "../src/game.vala"
							if (!(x < (*self).size)) {
#line 55 "../src/game.vala"
								break;
#line 529 "game.c"
							}
#line 56 "../src/game.vala"
							_tmp5_ = s;
#line 56 "../src/game.vala"
							_tmp6_ = (*self).tiles;
#line 56 "../src/game.vala"
							_tmp6__length1 = (*self).tiles_length1;
#line 56 "../src/game.vala"
							_tmp6__length2 = (*self).tiles_length2;
#line 56 "../src/game.vala"
							_tmp7_ = _tmp6_[(x * _tmp6__length2) + y];
#line 56 "../src/game.vala"
							_tmp8_ = player_to_string (_tmp7_);
#line 56 "../src/game.vala"
							_tmp9_ = _tmp8_;
#line 56 "../src/game.vala"
							_tmp10_ = g_strconcat (" ", _tmp9_, NULL);
#line 56 "../src/game.vala"
							_tmp11_ = _tmp10_;
#line 56 "../src/game.vala"
							_tmp12_ = g_strconcat (_tmp5_, _tmp11_, NULL);
#line 56 "../src/game.vala"
							_g_free0 (s);
#line 56 "../src/game.vala"
							s = _tmp12_;
#line 56 "../src/game.vala"
							_g_free0 (_tmp11_);
#line 56 "../src/game.vala"
							_g_free0 (_tmp9_);
#line 559 "game.c"
						}
					}
				}
#line 57 "../src/game.vala"
				_tmp13_ = s;
#line 57 "../src/game.vala"
				_tmp14_ = g_strconcat (_tmp13_, "\n", NULL);
#line 57 "../src/game.vala"
				_g_free0 (s);
#line 57 "../src/game.vala"
				s = _tmp14_;
#line 571 "game.c"
			}
		}
	}
#line 60 "../src/game.vala"
	result = s;
#line 60 "../src/game.vala"
	return result;
#line 579 "game.c"
}

static Player*
_vala_array_dup5 (Player* self,
                  int length)
{
#line 76 "../src/game.vala"
	return g_memdup (self, length * sizeof (Player));
#line 588 "game.c"
}

static guint8*
_vala_array_dup6 (guint8* self,
                  int length)
{
#line 84 "../src/game.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 597 "game.c"
}

void
game_state_struct_init_copy_and_pass (GameStateStruct *self,
                                      GameStateStruct* game)
{
	GameStateStruct _tmp0_;
	Player _tmp1_;
	Player _tmp2_;
	GameStateStruct _tmp3_;
	GameStateStruct _tmp4_;
	guint8* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	GameStateStruct _tmp6_;
	Player* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	Player* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	GameStateStruct _tmp9_;
	GameStateStruct _tmp10_;
	GameStateStruct _tmp11_;
	guint8* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	guint8* _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
#line 63 "../src/game.vala"
	g_return_if_fail (game != NULL);
#line 63 "../src/game.vala"
	memset (self, 0, sizeof (GameStateStruct));
#line 68 "../src/game.vala"
	_tmp0_ = *game;
#line 68 "../src/game.vala"
	_tmp1_ = _tmp0_.current_color;
#line 68 "../src/game.vala"
	(*self).opponent_color = _tmp1_;
#line 69 "../src/game.vala"
	_tmp2_ = (*self).opponent_color;
#line 69 "../src/game.vala"
	(*self).current_color = player_flip_color (_tmp2_);
#line 72 "../src/game.vala"
	_tmp3_ = *game;
#line 72 "../src/game.vala"
	(*self).size = _tmp3_.size;
#line 73 "../src/game.vala"
	_tmp4_ = *game;
#line 73 "../src/game.vala"
	_tmp5_ = _tmp4_.neighbor_tiles;
#line 73 "../src/game.vala"
	_tmp5__length1 = _tmp4_.neighbor_tiles_length1;
#line 73 "../src/game.vala"
	_tmp5__length2 = _tmp4_.neighbor_tiles_length2;
#line 73 "../src/game.vala"
	(*self).neighbor_tiles = _tmp5_;
#line 73 "../src/game.vala"
	(*self).neighbor_tiles_length1 = _tmp5__length1;
#line 73 "../src/game.vala"
	(*self).neighbor_tiles_length2 = _tmp5__length2;
#line 76 "../src/game.vala"
	_tmp6_ = *game;
#line 76 "../src/game.vala"
	_tmp7_ = _tmp6_.tiles;
#line 76 "../src/game.vala"
	_tmp7__length1 = _tmp6_.tiles_length1;
#line 76 "../src/game.vala"
	_tmp7__length2 = _tmp6_.tiles_length2;
#line 76 "../src/game.vala"
	_tmp8_ = (_tmp7_ != NULL) ? _vala_array_dup5 (_tmp7_, _tmp7__length1 * _tmp7__length2) : ((gpointer) _tmp7_);
#line 76 "../src/game.vala"
	_tmp8__length1 = _tmp7__length1;
#line 76 "../src/game.vala"
	_tmp8__length2 = _tmp7__length2;
#line 76 "../src/game.vala"
	(*self).tiles = (g_free ((*self).tiles), NULL);
#line 76 "../src/game.vala"
	(*self).tiles = _tmp8_;
#line 76 "../src/game.vala"
	(*self).tiles_length1 = _tmp8__length1;
#line 76 "../src/game.vala"
	(*self).tiles_length2 = _tmp8__length2;
#line 79 "../src/game.vala"
	_tmp9_ = *game;
#line 79 "../src/game.vala"
	(*self).n_current_tiles = _tmp9_.n_opponent_tiles;
#line 80 "../src/game.vala"
	_tmp10_ = *game;
#line 80 "../src/game.vala"
	(*self).n_opponent_tiles = _tmp10_.n_current_tiles;
#line 81 "../src/game.vala"
	(*self).n_tiles = (*self).n_current_tiles + (*self).n_opponent_tiles;
#line 84 "../src/game.vala"
	_tmp11_ = *game;
#line 84 "../src/game.vala"
	_tmp12_ = _tmp11_.empty_neighbors;
#line 84 "../src/game.vala"
	_tmp12__length1 = _tmp11_.empty_neighbors_length1;
#line 84 "../src/game.vala"
	_tmp12__length2 = _tmp11_.empty_neighbors_length2;
#line 84 "../src/game.vala"
	_tmp13_ = (_tmp12_ != NULL) ? _vala_array_dup6 (_tmp12_, _tmp12__length1 * _tmp12__length2) : ((gpointer) _tmp12_);
#line 84 "../src/game.vala"
	_tmp13__length1 = _tmp12__length1;
#line 84 "../src/game.vala"
	_tmp13__length2 = _tmp12__length2;
#line 84 "../src/game.vala"
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
#line 84 "../src/game.vala"
	(*self).empty_neighbors = _tmp13_;
#line 84 "../src/game.vala"
	(*self).empty_neighbors_length1 = _tmp13__length1;
#line 84 "../src/game.vala"
	(*self).empty_neighbors_length2 = _tmp13__length2;
#line 87 "../src/game.vala"
	(*self).current_player_can_move = TRUE;
#line 88 "../src/game.vala"
	(*self).is_complete = FALSE;
#line 89 "../src/game.vala"
	(*self).x_saved = (guint8) 0;
#line 90 "../src/game.vala"
	(*self).y_saved = (guint8) 0;
#line 722 "game.c"
}

static Player*
_vala_array_dup7 (Player* self,
                  int length)
{
#line 104 "../src/game.vala"
	return g_memdup (self, length * sizeof (Player));
#line 731 "game.c"
}

static guint8*
_vala_array_dup8 (guint8* self,
                  int length)
{
#line 121 "../src/game.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 740 "game.c"
}

void
game_state_struct_init_copy_and_move (GameStateStruct *self,
                                      GameStateStruct* game,
                                      PossibleMove* move)
{
	GameStateStruct _tmp0_;
	Player _tmp1_;
	Player _tmp2_;
	GameStateStruct _tmp3_;
	GameStateStruct _tmp4_;
	guint8* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	GameStateStruct _tmp6_;
	Player* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	Player* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	PossibleMove _tmp9_;
	PossibleMove _tmp10_;
	Player _tmp11_;
	PossibleMove _tmp12_;
	PossibleMove _tmp13_;
	PossibleMove _tmp14_;
	Player _tmp15_;
	PossibleMove _tmp16_;
	PossibleMove _tmp17_;
	PossibleMove _tmp18_;
	Player _tmp19_;
	PossibleMove _tmp20_;
	PossibleMove _tmp21_;
	PossibleMove _tmp22_;
	Player _tmp23_;
	PossibleMove _tmp24_;
	PossibleMove _tmp25_;
	PossibleMove _tmp26_;
	Player _tmp27_;
	PossibleMove _tmp28_;
	PossibleMove _tmp29_;
	PossibleMove _tmp30_;
	Player _tmp31_;
	PossibleMove _tmp32_;
	PossibleMove _tmp33_;
	PossibleMove _tmp34_;
	Player _tmp35_;
	PossibleMove _tmp36_;
	PossibleMove _tmp37_;
	PossibleMove _tmp38_;
	Player _tmp39_;
	PossibleMove _tmp40_;
	PossibleMove _tmp41_;
	PossibleMove _tmp42_;
	Player _tmp43_;
	GameStateStruct _tmp44_;
	PossibleMove _tmp45_;
	GameStateStruct _tmp46_;
	PossibleMove _tmp47_;
	GameStateStruct _tmp48_;
	guint8* _tmp49_;
	gint _tmp49__length1;
	gint _tmp49__length2;
	guint8* _tmp50_;
	gint _tmp50__length1;
	gint _tmp50__length2;
	PossibleMove _tmp51_;
	PossibleMove _tmp52_;
#line 93 "../src/game.vala"
	g_return_if_fail (game != NULL);
#line 93 "../src/game.vala"
	g_return_if_fail (move != NULL);
#line 93 "../src/game.vala"
	memset (self, 0, sizeof (GameStateStruct));
#line 96 "../src/game.vala"
	_tmp0_ = *game;
#line 96 "../src/game.vala"
	_tmp1_ = _tmp0_.current_color;
#line 96 "../src/game.vala"
	(*self).opponent_color = _tmp1_;
#line 97 "../src/game.vala"
	_tmp2_ = (*self).opponent_color;
#line 97 "../src/game.vala"
	(*self).current_color = player_flip_color (_tmp2_);
#line 100 "../src/game.vala"
	_tmp3_ = *game;
#line 100 "../src/game.vala"
	(*self).size = _tmp3_.size;
#line 101 "../src/game.vala"
	_tmp4_ = *game;
#line 101 "../src/game.vala"
	_tmp5_ = _tmp4_.neighbor_tiles;
#line 101 "../src/game.vala"
	_tmp5__length1 = _tmp4_.neighbor_tiles_length1;
#line 101 "../src/game.vala"
	_tmp5__length2 = _tmp4_.neighbor_tiles_length2;
#line 101 "../src/game.vala"
	(*self).neighbor_tiles = _tmp5_;
#line 101 "../src/game.vala"
	(*self).neighbor_tiles_length1 = _tmp5__length1;
#line 101 "../src/game.vala"
	(*self).neighbor_tiles_length2 = _tmp5__length2;
#line 104 "../src/game.vala"
	_tmp6_ = *game;
#line 104 "../src/game.vala"
	_tmp7_ = _tmp6_.tiles;
#line 104 "../src/game.vala"
	_tmp7__length1 = _tmp6_.tiles_length1;
#line 104 "../src/game.vala"
	_tmp7__length2 = _tmp6_.tiles_length2;
#line 104 "../src/game.vala"
	_tmp8_ = (_tmp7_ != NULL) ? _vala_array_dup7 (_tmp7_, _tmp7__length1 * _tmp7__length2) : ((gpointer) _tmp7_);
#line 104 "../src/game.vala"
	_tmp8__length1 = _tmp7__length1;
#line 104 "../src/game.vala"
	_tmp8__length2 = _tmp7__length2;
#line 104 "../src/game.vala"
	(*self).tiles = (g_free ((*self).tiles), NULL);
#line 104 "../src/game.vala"
	(*self).tiles = _tmp8_;
#line 104 "../src/game.vala"
	(*self).tiles_length1 = _tmp8__length1;
#line 104 "../src/game.vala"
	(*self).tiles_length2 = _tmp8__length2;
#line 105 "../src/game.vala"
	_tmp9_ = *move;
#line 105 "../src/game.vala"
	_tmp10_ = *move;
#line 105 "../src/game.vala"
	_tmp11_ = (*self).opponent_color;
#line 105 "../src/game.vala"
	_tmp12_ = *move;
#line 105 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp9_.x, _tmp10_.y, _tmp11_, (gint8) 0, (gint8) -1, _tmp12_.n_tiles_n);
#line 106 "../src/game.vala"
	_tmp13_ = *move;
#line 106 "../src/game.vala"
	_tmp14_ = *move;
#line 106 "../src/game.vala"
	_tmp15_ = (*self).opponent_color;
#line 106 "../src/game.vala"
	_tmp16_ = *move;
#line 106 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp13_.x, _tmp14_.y, _tmp15_, (gint8) 1, (gint8) -1, _tmp16_.n_tiles_ne);
#line 107 "../src/game.vala"
	_tmp17_ = *move;
#line 107 "../src/game.vala"
	_tmp18_ = *move;
#line 107 "../src/game.vala"
	_tmp19_ = (*self).opponent_color;
#line 107 "../src/game.vala"
	_tmp20_ = *move;
#line 107 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp17_.x, _tmp18_.y, _tmp19_, (gint8) 1, (gint8) 0, _tmp20_.n_tiles_e);
#line 108 "../src/game.vala"
	_tmp21_ = *move;
#line 108 "../src/game.vala"
	_tmp22_ = *move;
#line 108 "../src/game.vala"
	_tmp23_ = (*self).opponent_color;
#line 108 "../src/game.vala"
	_tmp24_ = *move;
#line 108 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp21_.x, _tmp22_.y, _tmp23_, (gint8) 1, (gint8) 1, _tmp24_.n_tiles_se);
#line 109 "../src/game.vala"
	_tmp25_ = *move;
#line 109 "../src/game.vala"
	_tmp26_ = *move;
#line 109 "../src/game.vala"
	_tmp27_ = (*self).opponent_color;
#line 109 "../src/game.vala"
	_tmp28_ = *move;
#line 109 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp25_.x, _tmp26_.y, _tmp27_, (gint8) 0, (gint8) 1, _tmp28_.n_tiles_s);
#line 110 "../src/game.vala"
	_tmp29_ = *move;
#line 110 "../src/game.vala"
	_tmp30_ = *move;
#line 110 "../src/game.vala"
	_tmp31_ = (*self).opponent_color;
#line 110 "../src/game.vala"
	_tmp32_ = *move;
#line 110 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp29_.x, _tmp30_.y, _tmp31_, (gint8) -1, (gint8) 1, _tmp32_.n_tiles_so);
#line 111 "../src/game.vala"
	_tmp33_ = *move;
#line 111 "../src/game.vala"
	_tmp34_ = *move;
#line 111 "../src/game.vala"
	_tmp35_ = (*self).opponent_color;
#line 111 "../src/game.vala"
	_tmp36_ = *move;
#line 111 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp33_.x, _tmp34_.y, _tmp35_, (gint8) -1, (gint8) 0, _tmp36_.n_tiles_o);
#line 112 "../src/game.vala"
	_tmp37_ = *move;
#line 112 "../src/game.vala"
	_tmp38_ = *move;
#line 112 "../src/game.vala"
	_tmp39_ = (*self).opponent_color;
#line 112 "../src/game.vala"
	_tmp40_ = *move;
#line 112 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp37_.x, _tmp38_.y, _tmp39_, (gint8) -1, (gint8) -1, _tmp40_.n_tiles_no);
#line 113 "../src/game.vala"
	_tmp41_ = *move;
#line 113 "../src/game.vala"
	_tmp42_ = *move;
#line 113 "../src/game.vala"
	_tmp43_ = (*self).opponent_color;
#line 113 "../src/game.vala"
	(*self).tiles[(_tmp41_.x * (*self).tiles_length2) + _tmp42_.y] = _tmp43_;
#line 116 "../src/game.vala"
	_tmp44_ = *game;
#line 116 "../src/game.vala"
	_tmp45_ = *move;
#line 116 "../src/game.vala"
	(*self).n_current_tiles = _tmp44_.n_opponent_tiles - _tmp45_.n_tiles;
#line 117 "../src/game.vala"
	_tmp46_ = *game;
#line 117 "../src/game.vala"
	_tmp47_ = *move;
#line 117 "../src/game.vala"
	(*self).n_opponent_tiles = (guint8) ((_tmp46_.n_current_tiles + _tmp47_.n_tiles) + 1);
#line 118 "../src/game.vala"
	(*self).n_tiles = (*self).n_current_tiles + (*self).n_opponent_tiles;
#line 121 "../src/game.vala"
	_tmp48_ = *game;
#line 121 "../src/game.vala"
	_tmp49_ = _tmp48_.empty_neighbors;
#line 121 "../src/game.vala"
	_tmp49__length1 = _tmp48_.empty_neighbors_length1;
#line 121 "../src/game.vala"
	_tmp49__length2 = _tmp48_.empty_neighbors_length2;
#line 121 "../src/game.vala"
	_tmp50_ = (_tmp49_ != NULL) ? _vala_array_dup8 (_tmp49_, _tmp49__length1 * _tmp49__length2) : ((gpointer) _tmp49_);
#line 121 "../src/game.vala"
	_tmp50__length1 = _tmp49__length1;
#line 121 "../src/game.vala"
	_tmp50__length2 = _tmp49__length2;
#line 121 "../src/game.vala"
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
#line 121 "../src/game.vala"
	(*self).empty_neighbors = _tmp50_;
#line 121 "../src/game.vala"
	(*self).empty_neighbors_length1 = _tmp50__length1;
#line 121 "../src/game.vala"
	(*self).empty_neighbors_length2 = _tmp50__length2;
#line 122 "../src/game.vala"
	_tmp51_ = *move;
#line 122 "../src/game.vala"
	_tmp52_ = *move;
#line 122 "../src/game.vala"
	game_state_struct_update_empty_neighbors (&(*self), _tmp51_.x, _tmp52_.y);
#line 125 "../src/game.vala"
	game_state_struct_update_who_can_move (&(*self));
#line 999 "game.c"
}

static inline void
game_state_struct_flip_tiles (Player** tiles,
                              gint* tiles_length1,
                              gint* tiles_length2,
                              guint8 x,
                              guint8 y,
                              Player color,
                              gint8 x_step,
                              gint8 y_step,
                              guint8 count)
{
	{
		gboolean _tmp0_ = FALSE;
#line 129 "../src/game.vala"
		_tmp0_ = TRUE;
#line 129 "../src/game.vala"
		while (TRUE) {
#line 129 "../src/game.vala"
			if (!_tmp0_) {
#line 1021 "game.c"
				guint8 _tmp1_;
#line 129 "../src/game.vala"
				_tmp1_ = count;
#line 129 "../src/game.vala"
				count = _tmp1_ - 1;
#line 1027 "game.c"
			}
#line 129 "../src/game.vala"
			_tmp0_ = FALSE;
#line 129 "../src/game.vala"
			if (!(((gint) count) > 0)) {
#line 129 "../src/game.vala"
				break;
#line 1035 "game.c"
			}
#line 131 "../src/game.vala"
			(*tiles)[((((gint8) x) + (((gint8) count) * x_step)) * (*tiles_length2)) + (((gint8) y) + (((gint8) count) * y_step))] = color;
#line 1039 "game.c"
		}
	}
}

static Player*
_vala_array_dup9 (Player* self,
                  int length)
{
#line 147 "../src/game.vala"
	return g_memdup (self, length * sizeof (Player));
#line 1050 "game.c"
}

void
game_state_struct_init_from_grid (GameStateStruct *self,
                                  guint8 _size,
                                  Player* _tiles,
                                  gint _tiles_length1,
                                  gint _tiles_length2,
                                  Player color,
                                  guint8* _neighbor_tiles,
                                  gint _neighbor_tiles_length1,
                                  gint _neighbor_tiles_length2)
{
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 136 "../src/game.vala"
	memset (self, 0, sizeof (GameStateStruct));
#line 139 "../src/game.vala"
	(*self).current_color = color;
#line 140 "../src/game.vala"
	(*self).opponent_color = player_flip_color (color);
#line 143 "../src/game.vala"
	(*self).size = _size;
#line 144 "../src/game.vala"
	(*self).neighbor_tiles = _neighbor_tiles;
#line 144 "../src/game.vala"
	(*self).neighbor_tiles_length1 = _neighbor_tiles_length1;
#line 144 "../src/game.vala"
	(*self).neighbor_tiles_length2 = _neighbor_tiles_length2;
#line 147 "../src/game.vala"
	_tmp0_ = (_tiles != NULL) ? _vala_array_dup9 (_tiles, _tiles_length1 * _tiles_length2) : ((gpointer) _tiles);
#line 147 "../src/game.vala"
	_tmp0__length1 = _tiles_length1;
#line 147 "../src/game.vala"
	_tmp0__length2 = _tiles_length2;
#line 147 "../src/game.vala"
	(*self).tiles = (g_free ((*self).tiles), NULL);
#line 147 "../src/game.vala"
	(*self).tiles = _tmp0_;
#line 147 "../src/game.vala"
	(*self).tiles_length1 = _tmp0__length1;
#line 147 "../src/game.vala"
	(*self).tiles_length2 = _tmp0__length2;
#line 150 "../src/game.vala"
	(*self).n_current_tiles = (guint8) 0;
#line 151 "../src/game.vala"
	(*self).n_opponent_tiles = (guint8) 0;
#line 1099 "game.c"
	{
		guint8 x = 0U;
#line 152 "../src/game.vala"
		x = (guint8) 0;
#line 1104 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 152 "../src/game.vala"
			_tmp1_ = TRUE;
#line 152 "../src/game.vala"
			while (TRUE) {
#line 152 "../src/game.vala"
				if (!_tmp1_) {
#line 1113 "game.c"
					guint8 _tmp2_;
#line 152 "../src/game.vala"
					_tmp2_ = x;
#line 152 "../src/game.vala"
					x = _tmp2_ + 1;
#line 1119 "game.c"
				}
#line 152 "../src/game.vala"
				_tmp1_ = FALSE;
#line 152 "../src/game.vala"
				if (!(x < _size)) {
#line 152 "../src/game.vala"
					break;
#line 1127 "game.c"
				}
				{
					guint8 y = 0U;
#line 153 "../src/game.vala"
					y = (guint8) 0;
#line 1133 "game.c"
					{
						gboolean _tmp3_ = FALSE;
#line 153 "../src/game.vala"
						_tmp3_ = TRUE;
#line 153 "../src/game.vala"
						while (TRUE) {
#line 1140 "game.c"
							Player _tmp5_;
#line 153 "../src/game.vala"
							if (!_tmp3_) {
#line 1144 "game.c"
								guint8 _tmp4_;
#line 153 "../src/game.vala"
								_tmp4_ = y;
#line 153 "../src/game.vala"
								y = _tmp4_ + 1;
#line 1150 "game.c"
							}
#line 153 "../src/game.vala"
							_tmp3_ = FALSE;
#line 153 "../src/game.vala"
							if (!(y < _size)) {
#line 153 "../src/game.vala"
								break;
#line 1158 "game.c"
							}
#line 154 "../src/game.vala"
							_tmp5_ = _tiles[(x * _tiles_length2) + y];
#line 154 "../src/game.vala"
							game_state_struct_add_tile_of_color (&(*self), _tmp5_);
#line 1164 "game.c"
						}
					}
				}
			}
		}
	}
#line 155 "../src/game.vala"
	(*self).n_tiles = (*self).n_current_tiles + (*self).n_opponent_tiles;
#line 158 "../src/game.vala"
	game_state_struct_init_empty_neighbors (&(*self));
#line 161 "../src/game.vala"
	game_state_struct_update_who_can_move (&(*self));
#line 1177 "game.c"
}

static inline void
game_state_struct_add_tile_of_color (GameStateStruct *self,
                                     Player color)
{
	Player _tmp0_;
#line 165 "../src/game.vala"
	_tmp0_ = (*self).current_color;
#line 165 "../src/game.vala"
	if (color == _tmp0_) {
#line 1189 "game.c"
		guint8 _tmp1_;
#line 166 "../src/game.vala"
		_tmp1_ = (*self).n_current_tiles;
#line 166 "../src/game.vala"
		(*self).n_current_tiles = _tmp1_ + 1;
#line 1195 "game.c"
	} else {
#line 167 "../src/game.vala"
		if (color != PLAYER_NONE) {
#line 1199 "game.c"
			guint8 _tmp2_;
#line 168 "../src/game.vala"
			_tmp2_ = (*self).n_opponent_tiles;
#line 168 "../src/game.vala"
			(*self).n_opponent_tiles = _tmp2_ + 1;
#line 1205 "game.c"
		}
	}
}

inline gboolean
game_state_struct_is_current_color (GameStateStruct *self,
                                    guint8 x,
                                    guint8 y)
{
	gboolean result = FALSE;
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
	Player _tmp2_;
#line 178 "../src/game.vala"
	_tmp0_ = (*self).tiles;
#line 178 "../src/game.vala"
	_tmp0__length1 = (*self).tiles_length1;
#line 178 "../src/game.vala"
	_tmp0__length2 = (*self).tiles_length2;
#line 178 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 178 "../src/game.vala"
	_tmp2_ = (*self).current_color;
#line 178 "../src/game.vala"
	result = _tmp1_ == _tmp2_;
#line 178 "../src/game.vala"
	return result;
#line 1235 "game.c"
}

inline gboolean
game_state_struct_is_empty_tile (GameStateStruct *self,
                                 guint8 x,
                                 guint8 y)
{
	gboolean result = FALSE;
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
#line 184 "../src/game.vala"
	_tmp0_ = (*self).tiles;
#line 184 "../src/game.vala"
	_tmp0__length1 = (*self).tiles_length1;
#line 184 "../src/game.vala"
	_tmp0__length2 = (*self).tiles_length2;
#line 184 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 184 "../src/game.vala"
	result = _tmp1_ == PLAYER_NONE;
#line 184 "../src/game.vala"
	return result;
#line 1260 "game.c"
}

static inline gboolean
game_state_struct_is_valid_location_signed (GameStateStruct *self,
                                            gint8 x,
                                            gint8 y)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 189 "../src/game.vala"
	if (((gint) x) >= 0) {
#line 189 "../src/game.vala"
		_tmp2_ = ((guint8) x) < (*self).size;
#line 1276 "game.c"
	} else {
#line 189 "../src/game.vala"
		_tmp2_ = FALSE;
#line 1280 "game.c"
	}
#line 189 "../src/game.vala"
	if (_tmp2_) {
#line 190 "../src/game.vala"
		_tmp1_ = ((gint) y) >= 0;
#line 1286 "game.c"
	} else {
#line 189 "../src/game.vala"
		_tmp1_ = FALSE;
#line 1290 "game.c"
	}
#line 189 "../src/game.vala"
	if (_tmp1_) {
#line 190 "../src/game.vala"
		_tmp0_ = ((guint8) y) < (*self).size;
#line 1296 "game.c"
	} else {
#line 189 "../src/game.vala"
		_tmp0_ = FALSE;
#line 1300 "game.c"
	}
#line 189 "../src/game.vala"
	result = _tmp0_;
#line 189 "../src/game.vala"
	return result;
#line 1306 "game.c"
}

static void
game_state_struct_update_who_can_move (GameStateStruct *self)
{
	Player enemy = 0;
	Player _tmp0_;
	gboolean opponent_can_move = FALSE;
#line 207 "../src/game.vala"
	_tmp0_ = (*self).current_color;
#line 207 "../src/game.vala"
	enemy = player_flip_color (_tmp0_);
#line 208 "../src/game.vala"
	opponent_can_move = FALSE;
#line 1321 "game.c"
	{
		gboolean _tmp1_ = FALSE;
#line 209 "../src/game.vala"
		(*self).x_saved = (guint8) 0;
#line 209 "../src/game.vala"
		_tmp1_ = TRUE;
#line 209 "../src/game.vala"
		while (TRUE) {
#line 209 "../src/game.vala"
			if (!_tmp1_) {
#line 1332 "game.c"
				guint8 _tmp2_;
#line 209 "../src/game.vala"
				_tmp2_ = (*self).x_saved;
#line 209 "../src/game.vala"
				(*self).x_saved = _tmp2_ + 1;
#line 1338 "game.c"
			}
#line 209 "../src/game.vala"
			_tmp1_ = FALSE;
#line 209 "../src/game.vala"
			if (!((*self).x_saved < (*self).size)) {
#line 209 "../src/game.vala"
				break;
#line 1346 "game.c"
			}
			{
				gboolean _tmp3_ = FALSE;
#line 211 "../src/game.vala"
				(*self).y_saved = (guint8) 0;
#line 211 "../src/game.vala"
				_tmp3_ = TRUE;
#line 211 "../src/game.vala"
				while (TRUE) {
#line 1356 "game.c"
					Player _tmp5_;
					Player _tmp6_;
#line 211 "../src/game.vala"
					if (!_tmp3_) {
#line 1361 "game.c"
						guint8 _tmp4_;
#line 211 "../src/game.vala"
						_tmp4_ = (*self).y_saved;
#line 211 "../src/game.vala"
						(*self).y_saved = _tmp4_ + 1;
#line 1367 "game.c"
					}
#line 211 "../src/game.vala"
					_tmp3_ = FALSE;
#line 211 "../src/game.vala"
					if (!((*self).y_saved < (*self).size)) {
#line 211 "../src/game.vala"
						break;
#line 1375 "game.c"
					}
#line 213 "../src/game.vala"
					if (game_state_struct_is_unplayable_basic (&(*self), (*self).x_saved, (*self).y_saved)) {
#line 214 "../src/game.vala"
						continue;
#line 1381 "game.c"
					}
#line 215 "../src/game.vala"
					_tmp5_ = (*self).current_color;
#line 215 "../src/game.vala"
					if (game_state_struct_can_place (&(*self), (*self).x_saved, (*self).y_saved, _tmp5_)) {
#line 217 "../src/game.vala"
						(*self).current_player_can_move = TRUE;
#line 218 "../src/game.vala"
						(*self).is_complete = FALSE;
#line 219 "../src/game.vala"
						return;
#line 1393 "game.c"
					}
#line 221 "../src/game.vala"
					if (opponent_can_move) {
#line 222 "../src/game.vala"
						continue;
#line 1399 "game.c"
					}
#line 223 "../src/game.vala"
					_tmp6_ = enemy;
#line 223 "../src/game.vala"
					if (game_state_struct_can_place (&(*self), (*self).x_saved, (*self).y_saved, _tmp6_)) {
#line 225 "../src/game.vala"
						opponent_can_move = TRUE;
#line 226 "../src/game.vala"
						(*self).is_complete = FALSE;
#line 1409 "game.c"
					}
				}
			}
		}
	}
#line 230 "../src/game.vala"
	(*self).current_player_can_move = FALSE;
#line 231 "../src/game.vala"
	if (!opponent_can_move) {
#line 232 "../src/game.vala"
		(*self).is_complete = TRUE;
#line 1421 "game.c"
	}
}

static void
_possible_move_free0_ (gpointer var)
{
#line 237 "../src/game.vala"
	(var == NULL) ? NULL : (var = (possible_move_free (var), NULL));
#line 1430 "game.c"
}

static inline void
_g_slist_free__possible_move_free0_ (GSList* self)
{
#line 237 "../src/game.vala"
	g_slist_free_full (self, (GDestroyNotify) _possible_move_free0_);
#line 1438 "game.c"
}

static gpointer
_possible_move_dup0 (gpointer self)
{
#line 248 "../src/game.vala"
	return self ? possible_move_dup (self) : NULL;
#line 1446 "game.c"
}

void
game_state_struct_get_possible_moves (GameStateStruct *self,
                                      GSList* * moves)
{
	GSList* _vala_moves = NULL;
	guint8 x = 0U;
	guint8 y = 0U;
#line 237 "../src/game.vala"
	(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 237 "../src/game.vala"
	_vala_moves = NULL;
#line 240 "../src/game.vala"
	x = (*self).x_saved;
#line 241 "../src/game.vala"
	y = (*self).y_saved;
#line 1464 "game.c"
	{
		gboolean _tmp0_ = FALSE;
#line 242 "../src/game.vala"
		_tmp0_ = TRUE;
#line 242 "../src/game.vala"
		while (TRUE) {
#line 242 "../src/game.vala"
			if (!_tmp0_) {
#line 1473 "game.c"
				guint8 _tmp1_;
#line 242 "../src/game.vala"
				_tmp1_ = x;
#line 242 "../src/game.vala"
				x = _tmp1_ + 1;
#line 1479 "game.c"
			}
#line 242 "../src/game.vala"
			_tmp0_ = FALSE;
#line 242 "../src/game.vala"
			if (!(x < (*self).size)) {
#line 242 "../src/game.vala"
				break;
#line 1487 "game.c"
			}
			{
				gboolean _tmp2_ = FALSE;
#line 244 "../src/game.vala"
				_tmp2_ = TRUE;
#line 244 "../src/game.vala"
				while (TRUE) {
#line 1495 "game.c"
					PossibleMove move = {0};
					Player _tmp4_;
					PossibleMove _tmp5_ = {0};
					gboolean _tmp6_;
#line 244 "../src/game.vala"
					if (!_tmp2_) {
#line 1502 "game.c"
						guint8 _tmp3_;
#line 244 "../src/game.vala"
						_tmp3_ = y;
#line 244 "../src/game.vala"
						y = _tmp3_ + 1;
#line 1508 "game.c"
					}
#line 244 "../src/game.vala"
					_tmp2_ = FALSE;
#line 244 "../src/game.vala"
					if (!(y < (*self).size)) {
#line 244 "../src/game.vala"
						break;
#line 1516 "game.c"
					}
#line 247 "../src/game.vala"
					_tmp4_ = (*self).current_color;
#line 247 "../src/game.vala"
					_tmp6_ = game_state_struct_place_tile (&(*self), x, y, _tmp4_, &_tmp5_);
#line 247 "../src/game.vala"
					move = _tmp5_;
#line 247 "../src/game.vala"
					if (_tmp6_) {
#line 1526 "game.c"
						PossibleMove _tmp7_;
						PossibleMove* _tmp8_;
#line 248 "../src/game.vala"
						_tmp7_ = move;
#line 248 "../src/game.vala"
						_tmp8_ = _possible_move_dup0 (&_tmp7_);
#line 248 "../src/game.vala"
						_vala_moves = g_slist_prepend (_vala_moves, _tmp8_);
#line 1535 "game.c"
					}
				}
			}
#line 250 "../src/game.vala"
			y = (guint8) 0;
#line 1541 "game.c"
		}
	}
#line 235 "../src/game.vala"
	if (moves) {
#line 235 "../src/game.vala"
		*moves = _vala_moves;
#line 1548 "game.c"
	} else {
#line 235 "../src/game.vala"
		(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 1552 "game.c"
	}
}

inline gboolean
game_state_struct_test_placing_tile (GameStateStruct *self,
                                     guint8 x,
                                     guint8 y,
                                     PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	gboolean result = FALSE;
	Player _tmp0_;
	PossibleMove _tmp1_ = {0};
	gboolean _tmp2_;
#line 260 "../src/game.vala"
	_tmp0_ = (*self).current_color;
#line 260 "../src/game.vala"
	_tmp2_ = game_state_struct_place_tile (&(*self), x, y, _tmp0_, &_tmp1_);
#line 260 "../src/game.vala"
	_vala_move = _tmp1_;
#line 260 "../src/game.vala"
	result = _tmp2_;
#line 260 "../src/game.vala"
	if (move) {
#line 260 "../src/game.vala"
		*move = _vala_move;
#line 1579 "game.c"
	}
#line 260 "../src/game.vala"
	return result;
#line 1583 "game.c"
}

static inline gboolean
game_state_struct_is_unplayable_basic (GameStateStruct *self,
                                       guint8 x,
                                       guint8 y)
{
	gboolean result = FALSE;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	guint8 _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	guint8 _tmp3_;
	Player* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	Player _tmp5_;
#line 265 "../src/game.vala"
	_tmp0_ = (*self).empty_neighbors;
#line 265 "../src/game.vala"
	_tmp0__length1 = (*self).empty_neighbors_length1;
#line 265 "../src/game.vala"
	_tmp0__length2 = (*self).empty_neighbors_length2;
#line 265 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 265 "../src/game.vala"
	_tmp2_ = (*self).neighbor_tiles;
#line 265 "../src/game.vala"
	_tmp2__length1 = (*self).neighbor_tiles_length1;
#line 265 "../src/game.vala"
	_tmp2__length2 = (*self).neighbor_tiles_length2;
#line 265 "../src/game.vala"
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
#line 265 "../src/game.vala"
	if (_tmp1_ == _tmp3_) {
#line 266 "../src/game.vala"
		result = TRUE;
#line 266 "../src/game.vala"
		return result;
#line 1626 "game.c"
	}
#line 267 "../src/game.vala"
	_tmp4_ = (*self).tiles;
#line 267 "../src/game.vala"
	_tmp4__length1 = (*self).tiles_length1;
#line 267 "../src/game.vala"
	_tmp4__length2 = (*self).tiles_length2;
#line 267 "../src/game.vala"
	_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
#line 267 "../src/game.vala"
	if (_tmp5_ != PLAYER_NONE) {
#line 268 "../src/game.vala"
		result = TRUE;
#line 268 "../src/game.vala"
		return result;
#line 1642 "game.c"
	}
#line 269 "../src/game.vala"
	result = FALSE;
#line 269 "../src/game.vala"
	return result;
#line 1648 "game.c"
}

static inline gboolean
game_state_struct_place_tile (GameStateStruct *self,
                              guint8 x,
                              guint8 y,
                              Player color,
                              PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	gboolean result = FALSE;
	PossibleMove _tmp0_;
	PossibleMove _tmp1_;
	PossibleMove _tmp2_;
	PossibleMove _tmp3_;
	PossibleMove _tmp4_;
	PossibleMove _tmp5_;
	PossibleMove _tmp6_;
	PossibleMove _tmp7_;
	PossibleMove _tmp8_;
#line 275 "../src/game.vala"
	possible_move_init (&_vala_move, x, y);
#line 277 "../src/game.vala"
	if (game_state_struct_is_unplayable_basic (&(*self), x, y)) {
#line 278 "../src/game.vala"
		result = FALSE;
#line 278 "../src/game.vala"
		if (move) {
#line 278 "../src/game.vala"
			*move = _vala_move;
#line 1679 "game.c"
		}
#line 278 "../src/game.vala"
		return result;
#line 1683 "game.c"
	}
#line 280 "../src/game.vala"
	_vala_move.n_tiles_n = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) -1);
#line 281 "../src/game.vala"
	_vala_move.n_tiles_ne = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) -1);
#line 282 "../src/game.vala"
	_vala_move.n_tiles_e = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 0);
#line 283 "../src/game.vala"
	_vala_move.n_tiles_se = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 1);
#line 284 "../src/game.vala"
	_vala_move.n_tiles_s = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) 1);
#line 285 "../src/game.vala"
	_vala_move.n_tiles_so = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 1);
#line 286 "../src/game.vala"
	_vala_move.n_tiles_o = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 0);
#line 287 "../src/game.vala"
	_vala_move.n_tiles_no = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) -1);
#line 289 "../src/game.vala"
	_tmp0_ = _vala_move;
#line 289 "../src/game.vala"
	_tmp1_ = _vala_move;
#line 289 "../src/game.vala"
	_tmp2_ = _vala_move;
#line 289 "../src/game.vala"
	_tmp3_ = _vala_move;
#line 289 "../src/game.vala"
	_tmp4_ = _vala_move;
#line 289 "../src/game.vala"
	_tmp5_ = _vala_move;
#line 289 "../src/game.vala"
	_tmp6_ = _vala_move;
#line 289 "../src/game.vala"
	_tmp7_ = _vala_move;
#line 289 "../src/game.vala"
	_vala_move.n_tiles = ((((((_tmp0_.n_tiles_n + _tmp1_.n_tiles_ne) + _tmp2_.n_tiles_e) + _tmp3_.n_tiles_se) + _tmp4_.n_tiles_s) + _tmp5_.n_tiles_so) + _tmp6_.n_tiles_o) + _tmp7_.n_tiles_no;
#line 293 "../src/game.vala"
	_tmp8_ = _vala_move;
#line 293 "../src/game.vala"
	result = ((gint) _tmp8_.n_tiles) != 0;
#line 293 "../src/game.vala"
	if (move) {
#line 293 "../src/game.vala"
		*move = _vala_move;
#line 1727 "game.c"
	}
#line 293 "../src/game.vala"
	return result;
#line 1731 "game.c"
}

/**
     * can_place:
     * @x: the x coordinate of the tile to test
     * @y: the y coordinate of the tile to test
     * @color: the player color to test
     *
     * You should test is_unplayable_basic() before launching this.
     *
     * This method is faster than place_tile(), as it returns early
     * when some turnable tiles are found in one of the directions.
     *
     * Returns: %true if the given @color can be play there
     */
static inline gboolean
game_state_struct_can_place (GameStateStruct *self,
                             guint8 x,
                             guint8 y,
                             Player color)
{
	gboolean result = FALSE;
#line 312 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) -1)) > 0) {
#line 312 "../src/game.vala"
		result = TRUE;
#line 312 "../src/game.vala"
		return result;
#line 1760 "game.c"
	}
#line 313 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 1)) > 0) {
#line 313 "../src/game.vala"
		result = TRUE;
#line 313 "../src/game.vala"
		return result;
#line 1768 "game.c"
	}
#line 314 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 1)) > 0) {
#line 314 "../src/game.vala"
		result = TRUE;
#line 314 "../src/game.vala"
		return result;
#line 1776 "game.c"
	}
#line 315 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) -1)) > 0) {
#line 315 "../src/game.vala"
		result = TRUE;
#line 315 "../src/game.vala"
		return result;
#line 1784 "game.c"
	}
#line 316 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 0)) > 0) {
#line 316 "../src/game.vala"
		result = TRUE;
#line 316 "../src/game.vala"
		return result;
#line 1792 "game.c"
	}
#line 317 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 0)) > 0) {
#line 317 "../src/game.vala"
		result = TRUE;
#line 317 "../src/game.vala"
		return result;
#line 1800 "game.c"
	}
#line 318 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) 1)) > 0) {
#line 318 "../src/game.vala"
		result = TRUE;
#line 318 "../src/game.vala"
		return result;
#line 1808 "game.c"
	}
#line 319 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) -1)) > 0) {
#line 319 "../src/game.vala"
		result = TRUE;
#line 319 "../src/game.vala"
		return result;
#line 1816 "game.c"
	}
#line 320 "../src/game.vala"
	result = FALSE;
#line 320 "../src/game.vala"
	return result;
#line 1822 "game.c"
}

/**
     * can_flip_tiles:
     * @x: the x coordinate to start with
     * @y: the y coordinate to start with
     * @color: the player color to test
     * @x_step: the step on the x direction, %1, %0 or %-1
     * @y_step: the step on the y direction, %1, %0 or %-1
     *
     * Returns: the number of turnable tiles in the given direction
     */
static inline guint8
game_state_struct_can_flip_tiles (GameStateStruct *self,
                                  guint8 x,
                                  guint8 y,
                                  Player color,
                                  gint8 x_step,
                                  gint8 y_step)
{
	guint8 result = 0U;
	Player enemy = 0;
	gint8 enemy_count = 0;
	gboolean is_valid_location = FALSE;
	gint8 xt = 0;
	gint8 yt = 0;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
#line 335 "../src/game.vala"
	enemy = player_flip_color (color);
#line 338 "../src/game.vala"
	enemy_count = (gint8) -1;
#line 339 "../src/game.vala"
	is_valid_location = FALSE;
#line 340 "../src/game.vala"
	xt = (gint8) x;
#line 341 "../src/game.vala"
	yt = (gint8) y;
#line 1861 "game.c"
	{
		gboolean _tmp0_ = FALSE;
#line 342 "../src/game.vala"
		_tmp0_ = TRUE;
#line 342 "../src/game.vala"
		while (TRUE) {
#line 1868 "game.c"
			gint8 _tmp5_;
#line 342 "../src/game.vala"
			if (!_tmp0_) {
#line 1872 "game.c"
				gboolean _tmp1_ = FALSE;
#line 348 "../src/game.vala"
				if (is_valid_location) {
#line 1876 "game.c"
					Player* _tmp2_;
					gint _tmp2__length1;
					gint _tmp2__length2;
					Player _tmp3_;
					Player _tmp4_;
#line 348 "../src/game.vala"
					_tmp2_ = (*self).tiles;
#line 348 "../src/game.vala"
					_tmp2__length1 = (*self).tiles_length1;
#line 348 "../src/game.vala"
					_tmp2__length2 = (*self).tiles_length2;
#line 348 "../src/game.vala"
					_tmp3_ = _tmp2_[(xt * _tmp2__length2) + yt];
#line 348 "../src/game.vala"
					_tmp4_ = enemy;
#line 348 "../src/game.vala"
					_tmp1_ = _tmp3_ == _tmp4_;
#line 1894 "game.c"
				} else {
#line 348 "../src/game.vala"
					_tmp1_ = FALSE;
#line 1898 "game.c"
				}
#line 348 "../src/game.vala"
				if (!_tmp1_) {
#line 348 "../src/game.vala"
					break;
#line 1904 "game.c"
				}
			}
#line 342 "../src/game.vala"
			_tmp0_ = FALSE;
#line 343 "../src/game.vala"
			_tmp5_ = enemy_count;
#line 343 "../src/game.vala"
			enemy_count = _tmp5_ + 1;
#line 344 "../src/game.vala"
			xt += x_step;
#line 345 "../src/game.vala"
			yt += y_step;
#line 346 "../src/game.vala"
			is_valid_location = game_state_struct_is_valid_location_signed (&(*self), xt, yt);
#line 1919 "game.c"
		}
	}
#line 351 "../src/game.vala"
	if (((gint) enemy_count) <= 0) {
#line 351 "../src/game.vala"
		_tmp7_ = TRUE;
#line 1926 "game.c"
	} else {
#line 351 "../src/game.vala"
		_tmp7_ = !is_valid_location;
#line 1930 "game.c"
	}
#line 351 "../src/game.vala"
	if (_tmp7_) {
#line 351 "../src/game.vala"
		_tmp6_ = TRUE;
#line 1936 "game.c"
	} else {
		Player* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		Player _tmp9_;
#line 351 "../src/game.vala"
		_tmp8_ = (*self).tiles;
#line 351 "../src/game.vala"
		_tmp8__length1 = (*self).tiles_length1;
#line 351 "../src/game.vala"
		_tmp8__length2 = (*self).tiles_length2;
#line 351 "../src/game.vala"
		_tmp9_ = _tmp8_[(xt * _tmp8__length2) + yt];
#line 351 "../src/game.vala"
		_tmp6_ = _tmp9_ != color;
#line 1952 "game.c"
	}
#line 351 "../src/game.vala"
	if (_tmp6_) {
#line 352 "../src/game.vala"
		result = (guint8) 0;
#line 352 "../src/game.vala"
		return result;
#line 1960 "game.c"
	}
#line 354 "../src/game.vala"
	result = (guint8) enemy_count;
#line 354 "../src/game.vala"
	return result;
#line 1966 "game.c"
}

guint8
game_state_struct_get_empty_neighbors (GameStateStruct *self,
                                       guint8 x,
                                       guint8 y)
{
	guint8 result = 0U;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	guint8 _tmp1_;
#line 365 "../src/game.vala"
	_tmp0_ = (*self).empty_neighbors;
#line 365 "../src/game.vala"
	_tmp0__length1 = (*self).empty_neighbors_length1;
#line 365 "../src/game.vala"
	_tmp0__length2 = (*self).empty_neighbors_length2;
#line 365 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 365 "../src/game.vala"
	result = _tmp1_;
#line 365 "../src/game.vala"
	return result;
#line 1991 "game.c"
}

static inline void
game_state_struct_init_empty_neighbors (GameStateStruct *self)
{
	guint8* _tmp0_;
	gint8 _size = 0;
	gint8 xmm = 0;
	gint8 ymm = 0;
	gint8 xpp = 0;
	gint8 ypp = 0;
	gboolean xmm_is_valid = FALSE;
	gboolean xpp_is_valid = FALSE;
#line 370 "../src/game.vala"
	_tmp0_ = g_new0 (guint8, (*self).size * (*self).size);
#line 370 "../src/game.vala"
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
#line 370 "../src/game.vala"
	(*self).empty_neighbors = _tmp0_;
#line 370 "../src/game.vala"
	(*self).empty_neighbors_length1 = (*self).size;
#line 370 "../src/game.vala"
	(*self).empty_neighbors_length2 = (*self).size;
#line 371 "../src/game.vala"
	_size = (gint8) (*self).size;
#line 2017 "game.c"
	{
		gint8 x = 0;
#line 377 "../src/game.vala"
		x = (gint8) 0;
#line 2022 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 377 "../src/game.vala"
			_tmp1_ = TRUE;
#line 377 "../src/game.vala"
			while (TRUE) {
#line 377 "../src/game.vala"
				if (!_tmp1_) {
#line 2031 "game.c"
					gint8 _tmp2_;
#line 377 "../src/game.vala"
					_tmp2_ = x;
#line 377 "../src/game.vala"
					x = _tmp2_ + 1;
#line 2037 "game.c"
				}
#line 377 "../src/game.vala"
				_tmp1_ = FALSE;
#line 377 "../src/game.vala"
				if (!(x < _size)) {
#line 377 "../src/game.vala"
					break;
#line 2045 "game.c"
				}
#line 379 "../src/game.vala"
				xmm = (gint8) (x - 1);
#line 380 "../src/game.vala"
				xpp = (gint8) (x + 1);
#line 381 "../src/game.vala"
				xmm_is_valid = ((gint) xmm) >= 0;
#line 382 "../src/game.vala"
				xpp_is_valid = ((guint8) xpp) < (*self).size;
#line 2055 "game.c"
				{
					gint8 y = 0;
#line 384 "../src/game.vala"
					y = (gint8) 0;
#line 2060 "game.c"
					{
						gboolean _tmp3_ = FALSE;
#line 384 "../src/game.vala"
						_tmp3_ = TRUE;
#line 384 "../src/game.vala"
						while (TRUE) {
#line 2067 "game.c"
							guint8 empty_neighbors_x_y = 0U;
#line 384 "../src/game.vala"
							if (!_tmp3_) {
#line 2071 "game.c"
								gint8 _tmp4_;
#line 384 "../src/game.vala"
								_tmp4_ = y;
#line 384 "../src/game.vala"
								y = _tmp4_ + 1;
#line 2077 "game.c"
							}
#line 384 "../src/game.vala"
							_tmp3_ = FALSE;
#line 384 "../src/game.vala"
							if (!(y < _size)) {
#line 384 "../src/game.vala"
								break;
#line 2085 "game.c"
							}
#line 386 "../src/game.vala"
							ymm = (gint8) (y - 1);
#line 387 "../src/game.vala"
							ypp = (gint8) (y + 1);
#line 389 "../src/game.vala"
							empty_neighbors_x_y = game_state_struct_is_empty (&(*self), x, ymm) + game_state_struct_is_empty (&(*self), x, ypp);
#line 391 "../src/game.vala"
							if (xmm_is_valid) {
#line 392 "../src/game.vala"
								empty_neighbors_x_y += (game_state_struct_is_empty (&(*self), xmm, y) + game_state_struct_is_empty (&(*self), xmm, ymm)) + game_state_struct_is_empty (&(*self), xmm, ypp);
#line 2097 "game.c"
							}
#line 395 "../src/game.vala"
							if (xpp_is_valid) {
#line 396 "../src/game.vala"
								empty_neighbors_x_y += (game_state_struct_is_empty (&(*self), xpp, y) + game_state_struct_is_empty (&(*self), xpp, ymm)) + game_state_struct_is_empty (&(*self), xpp, ypp);
#line 2103 "game.c"
							}
#line 400 "../src/game.vala"
							(*self).empty_neighbors[(x * (*self).empty_neighbors_length2) + y] = empty_neighbors_x_y;
#line 2107 "game.c"
						}
					}
				}
			}
		}
	}
}

static inline guint8
game_state_struct_is_empty (GameStateStruct *self,
                            gint8 x,
                            gint8 y)
{
	guint8 result = 0U;
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
#line 407 "../src/game.vala"
	if (!game_state_struct_is_valid_location_signed (&(*self), x, y)) {
#line 408 "../src/game.vala"
		result = (guint8) 0;
#line 408 "../src/game.vala"
		return result;
#line 2132 "game.c"
	}
#line 409 "../src/game.vala"
	_tmp0_ = (*self).tiles;
#line 409 "../src/game.vala"
	_tmp0__length1 = (*self).tiles_length1;
#line 409 "../src/game.vala"
	_tmp0__length2 = (*self).tiles_length2;
#line 409 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 409 "../src/game.vala"
	if (_tmp1_ != PLAYER_NONE) {
#line 410 "../src/game.vala"
		result = (guint8) 0;
#line 410 "../src/game.vala"
		return result;
#line 2148 "game.c"
	}
#line 412 "../src/game.vala"
	result = (guint8) 1;
#line 412 "../src/game.vala"
	return result;
#line 2154 "game.c"
}

static inline void
game_state_struct_update_empty_neighbors (GameStateStruct *self,
                                          guint8 x,
                                          guint8 y)
{
	gint8 xmm = 0;
	gint8 ymm = 0;
	gint8 xpp = 0;
	gint8 ypp = 0;
	gboolean ymm_is_valid = FALSE;
	gboolean ypp_is_valid = FALSE;
#line 417 "../src/game.vala"
	xmm = (gint8) (((gint8) x) - 1);
#line 418 "../src/game.vala"
	ymm = (gint8) (((gint8) y) - 1);
#line 419 "../src/game.vala"
	xpp = (gint8) (xmm + 2);
#line 420 "../src/game.vala"
	ypp = (gint8) (ymm + 2);
#line 422 "../src/game.vala"
	ymm_is_valid = ((gint) ymm) >= 0;
#line 423 "../src/game.vala"
	ypp_is_valid = ((guint8) ypp) < (*self).size;
#line 425 "../src/game.vala"
	if (((gint) xmm) >= 0) {
#line 427 "../src/game.vala"
		(*self).empty_neighbors[(xmm * (*self).empty_neighbors_length2) + y] -= (guint8) 1;
#line 428 "../src/game.vala"
		if (ymm_is_valid) {
#line 428 "../src/game.vala"
			(*self).empty_neighbors[(xmm * (*self).empty_neighbors_length2) + ymm] -= (guint8) 1;
#line 2188 "game.c"
		}
#line 429 "../src/game.vala"
		if (ypp_is_valid) {
#line 429 "../src/game.vala"
			(*self).empty_neighbors[(xmm * (*self).empty_neighbors_length2) + ypp] -= (guint8) 1;
#line 2194 "game.c"
		}
	}
#line 431 "../src/game.vala"
	if (ymm_is_valid) {
#line 431 "../src/game.vala"
		(*self).empty_neighbors[(x * (*self).empty_neighbors_length2) + ymm] -= (guint8) 1;
#line 2201 "game.c"
	}
#line 432 "../src/game.vala"
	if (ypp_is_valid) {
#line 432 "../src/game.vala"
		(*self).empty_neighbors[(x * (*self).empty_neighbors_length2) + ypp] -= (guint8) 1;
#line 2207 "game.c"
	}
#line 433 "../src/game.vala"
	if (((guint8) xpp) < (*self).size) {
#line 435 "../src/game.vala"
		(*self).empty_neighbors[(xpp * (*self).empty_neighbors_length2) + y] -= (guint8) 1;
#line 436 "../src/game.vala"
		if (ymm_is_valid) {
#line 436 "../src/game.vala"
			(*self).empty_neighbors[(xpp * (*self).empty_neighbors_length2) + ymm] -= (guint8) 1;
#line 2217 "game.c"
		}
#line 437 "../src/game.vala"
		if (ypp_is_valid) {
#line 437 "../src/game.vala"
			(*self).empty_neighbors[(xpp * (*self).empty_neighbors_length2) + ypp] -= (guint8) 1;
#line 2223 "game.c"
		}
	}
}

Player*
game_state_struct_get_mainline (GameStateStruct *self,
                                MainLine mainline_id,
                                gint* result_length1)
{
	Player* result = NULL;
	Player* mainline = NULL;
	Player* _tmp0_;
	gint mainline_length1;
	gint _mainline_size_;
	Player* _tmp31_;
	gint _tmp31__length1;
#line 447 "../src/game.vala"
	_tmp0_ = g_new0 (Player, (*self).size);
#line 447 "../src/game.vala"
	mainline = _tmp0_;
#line 447 "../src/game.vala"
	mainline_length1 = (*self).size;
#line 447 "../src/game.vala"
	_mainline_size_ = mainline_length1;
#line 448 "../src/game.vala"
	switch (mainline_id) {
#line 448 "../src/game.vala"
		case MAIN_LINE_TOP:
#line 2252 "game.c"
		{
			{
				guint8 i = 0U;
#line 450 "../src/game.vala"
				i = (guint8) 0;
#line 2258 "game.c"
				{
					gboolean _tmp1_ = FALSE;
#line 450 "../src/game.vala"
					_tmp1_ = TRUE;
#line 450 "../src/game.vala"
					while (TRUE) {
#line 2265 "game.c"
						Player* _tmp3_;
						gint _tmp3__length1;
						Player* _tmp4_;
						gint _tmp4__length1;
						gint _tmp4__length2;
						Player _tmp5_;
#line 450 "../src/game.vala"
						if (!_tmp1_) {
#line 2274 "game.c"
							guint8 _tmp2_;
#line 450 "../src/game.vala"
							_tmp2_ = i;
#line 450 "../src/game.vala"
							i = _tmp2_ + 1;
#line 2280 "game.c"
						}
#line 450 "../src/game.vala"
						_tmp1_ = FALSE;
#line 450 "../src/game.vala"
						if (!(i < (*self).size)) {
#line 450 "../src/game.vala"
							break;
#line 2288 "game.c"
						}
#line 450 "../src/game.vala"
						_tmp3_ = mainline;
#line 450 "../src/game.vala"
						_tmp3__length1 = mainline_length1;
#line 450 "../src/game.vala"
						_tmp4_ = (*self).tiles;
#line 450 "../src/game.vala"
						_tmp4__length1 = (*self).tiles_length1;
#line 450 "../src/game.vala"
						_tmp4__length2 = (*self).tiles_length2;
#line 450 "../src/game.vala"
						_tmp5_ = _tmp4_[(i * _tmp4__length2) + 0];
#line 450 "../src/game.vala"
						_tmp3_[i] = _tmp5_;
#line 2304 "game.c"
					}
				}
			}
#line 450 "../src/game.vala"
			break;
#line 2310 "game.c"
		}
#line 448 "../src/game.vala"
		case MAIN_LINE_LEFT:
#line 2314 "game.c"
		{
			{
				guint8 i = 0U;
#line 451 "../src/game.vala"
				i = (guint8) 0;
#line 2320 "game.c"
				{
					gboolean _tmp6_ = FALSE;
#line 451 "../src/game.vala"
					_tmp6_ = TRUE;
#line 451 "../src/game.vala"
					while (TRUE) {
#line 2327 "game.c"
						Player* _tmp8_;
						gint _tmp8__length1;
						Player* _tmp9_;
						gint _tmp9__length1;
						gint _tmp9__length2;
						Player _tmp10_;
#line 451 "../src/game.vala"
						if (!_tmp6_) {
#line 2336 "game.c"
							guint8 _tmp7_;
#line 451 "../src/game.vala"
							_tmp7_ = i;
#line 451 "../src/game.vala"
							i = _tmp7_ + 1;
#line 2342 "game.c"
						}
#line 451 "../src/game.vala"
						_tmp6_ = FALSE;
#line 451 "../src/game.vala"
						if (!(i < (*self).size)) {
#line 451 "../src/game.vala"
							break;
#line 2350 "game.c"
						}
#line 451 "../src/game.vala"
						_tmp8_ = mainline;
#line 451 "../src/game.vala"
						_tmp8__length1 = mainline_length1;
#line 451 "../src/game.vala"
						_tmp9_ = (*self).tiles;
#line 451 "../src/game.vala"
						_tmp9__length1 = (*self).tiles_length1;
#line 451 "../src/game.vala"
						_tmp9__length2 = (*self).tiles_length2;
#line 451 "../src/game.vala"
						_tmp10_ = _tmp9_[(0 * _tmp9__length2) + i];
#line 451 "../src/game.vala"
						_tmp8_[i] = _tmp10_;
#line 2366 "game.c"
					}
				}
			}
#line 451 "../src/game.vala"
			break;
#line 2372 "game.c"
		}
#line 448 "../src/game.vala"
		case MAIN_LINE_RIGHT:
#line 2376 "game.c"
		{
			{
				guint8 i = 0U;
#line 452 "../src/game.vala"
				i = (guint8) 0;
#line 2382 "game.c"
				{
					gboolean _tmp11_ = FALSE;
#line 452 "../src/game.vala"
					_tmp11_ = TRUE;
#line 452 "../src/game.vala"
					while (TRUE) {
#line 2389 "game.c"
						Player* _tmp13_;
						gint _tmp13__length1;
						Player* _tmp14_;
						gint _tmp14__length1;
						gint _tmp14__length2;
						Player _tmp15_;
#line 452 "../src/game.vala"
						if (!_tmp11_) {
#line 2398 "game.c"
							guint8 _tmp12_;
#line 452 "../src/game.vala"
							_tmp12_ = i;
#line 452 "../src/game.vala"
							i = _tmp12_ + 1;
#line 2404 "game.c"
						}
#line 452 "../src/game.vala"
						_tmp11_ = FALSE;
#line 452 "../src/game.vala"
						if (!(i < (*self).size)) {
#line 452 "../src/game.vala"
							break;
#line 2412 "game.c"
						}
#line 452 "../src/game.vala"
						_tmp13_ = mainline;
#line 452 "../src/game.vala"
						_tmp13__length1 = mainline_length1;
#line 452 "../src/game.vala"
						_tmp14_ = (*self).tiles;
#line 452 "../src/game.vala"
						_tmp14__length1 = (*self).tiles_length1;
#line 452 "../src/game.vala"
						_tmp14__length2 = (*self).tiles_length2;
#line 452 "../src/game.vala"
						_tmp15_ = _tmp14_[(((*self).size - 1) * _tmp14__length2) + i];
#line 452 "../src/game.vala"
						_tmp13_[i] = _tmp15_;
#line 2428 "game.c"
					}
				}
			}
#line 452 "../src/game.vala"
			break;
#line 2434 "game.c"
		}
#line 448 "../src/game.vala"
		case MAIN_LINE_BOTTOM:
#line 2438 "game.c"
		{
			{
				guint8 i = 0U;
#line 453 "../src/game.vala"
				i = (guint8) 0;
#line 2444 "game.c"
				{
					gboolean _tmp16_ = FALSE;
#line 453 "../src/game.vala"
					_tmp16_ = TRUE;
#line 453 "../src/game.vala"
					while (TRUE) {
#line 2451 "game.c"
						Player* _tmp18_;
						gint _tmp18__length1;
						Player* _tmp19_;
						gint _tmp19__length1;
						gint _tmp19__length2;
						Player _tmp20_;
#line 453 "../src/game.vala"
						if (!_tmp16_) {
#line 2460 "game.c"
							guint8 _tmp17_;
#line 453 "../src/game.vala"
							_tmp17_ = i;
#line 453 "../src/game.vala"
							i = _tmp17_ + 1;
#line 2466 "game.c"
						}
#line 453 "../src/game.vala"
						_tmp16_ = FALSE;
#line 453 "../src/game.vala"
						if (!(i < (*self).size)) {
#line 453 "../src/game.vala"
							break;
#line 2474 "game.c"
						}
#line 453 "../src/game.vala"
						_tmp18_ = mainline;
#line 453 "../src/game.vala"
						_tmp18__length1 = mainline_length1;
#line 453 "../src/game.vala"
						_tmp19_ = (*self).tiles;
#line 453 "../src/game.vala"
						_tmp19__length1 = (*self).tiles_length1;
#line 453 "../src/game.vala"
						_tmp19__length2 = (*self).tiles_length2;
#line 453 "../src/game.vala"
						_tmp20_ = _tmp19_[(i * _tmp19__length2) + ((*self).size - 1)];
#line 453 "../src/game.vala"
						_tmp18_[i] = _tmp20_;
#line 2490 "game.c"
					}
				}
			}
#line 453 "../src/game.vala"
			break;
#line 2496 "game.c"
		}
#line 448 "../src/game.vala"
		case MAIN_LINE_TOPLEFT:
#line 2500 "game.c"
		{
			{
				guint8 i = 0U;
#line 454 "../src/game.vala"
				i = (guint8) 0;
#line 2506 "game.c"
				{
					gboolean _tmp21_ = FALSE;
#line 454 "../src/game.vala"
					_tmp21_ = TRUE;
#line 454 "../src/game.vala"
					while (TRUE) {
#line 2513 "game.c"
						Player* _tmp23_;
						gint _tmp23__length1;
						Player* _tmp24_;
						gint _tmp24__length1;
						gint _tmp24__length2;
						Player _tmp25_;
#line 454 "../src/game.vala"
						if (!_tmp21_) {
#line 2522 "game.c"
							guint8 _tmp22_;
#line 454 "../src/game.vala"
							_tmp22_ = i;
#line 454 "../src/game.vala"
							i = _tmp22_ + 1;
#line 2528 "game.c"
						}
#line 454 "../src/game.vala"
						_tmp21_ = FALSE;
#line 454 "../src/game.vala"
						if (!(i < (*self).size)) {
#line 454 "../src/game.vala"
							break;
#line 2536 "game.c"
						}
#line 454 "../src/game.vala"
						_tmp23_ = mainline;
#line 454 "../src/game.vala"
						_tmp23__length1 = mainline_length1;
#line 454 "../src/game.vala"
						_tmp24_ = (*self).tiles;
#line 454 "../src/game.vala"
						_tmp24__length1 = (*self).tiles_length1;
#line 454 "../src/game.vala"
						_tmp24__length2 = (*self).tiles_length2;
#line 454 "../src/game.vala"
						_tmp25_ = _tmp24_[(i * _tmp24__length2) + i];
#line 454 "../src/game.vala"
						_tmp23_[i] = _tmp25_;
#line 2552 "game.c"
					}
				}
			}
#line 454 "../src/game.vala"
			break;
#line 2558 "game.c"
		}
#line 448 "../src/game.vala"
		case MAIN_LINE_TOPRIGHT:
#line 2562 "game.c"
		{
			{
				guint8 i = 0U;
#line 455 "../src/game.vala"
				i = (guint8) 0;
#line 2568 "game.c"
				{
					gboolean _tmp26_ = FALSE;
#line 455 "../src/game.vala"
					_tmp26_ = TRUE;
#line 455 "../src/game.vala"
					while (TRUE) {
#line 2575 "game.c"
						Player* _tmp28_;
						gint _tmp28__length1;
						Player* _tmp29_;
						gint _tmp29__length1;
						gint _tmp29__length2;
						Player _tmp30_;
#line 455 "../src/game.vala"
						if (!_tmp26_) {
#line 2584 "game.c"
							guint8 _tmp27_;
#line 455 "../src/game.vala"
							_tmp27_ = i;
#line 455 "../src/game.vala"
							i = _tmp27_ + 1;
#line 2590 "game.c"
						}
#line 455 "../src/game.vala"
						_tmp26_ = FALSE;
#line 455 "../src/game.vala"
						if (!(i < (*self).size)) {
#line 455 "../src/game.vala"
							break;
#line 2598 "game.c"
						}
#line 455 "../src/game.vala"
						_tmp28_ = mainline;
#line 455 "../src/game.vala"
						_tmp28__length1 = mainline_length1;
#line 455 "../src/game.vala"
						_tmp29_ = (*self).tiles;
#line 455 "../src/game.vala"
						_tmp29__length1 = (*self).tiles_length1;
#line 455 "../src/game.vala"
						_tmp29__length2 = (*self).tiles_length2;
#line 455 "../src/game.vala"
						_tmp30_ = _tmp29_[((((*self).size - 1) - i) * _tmp29__length2) + i];
#line 455 "../src/game.vala"
						_tmp28_[i] = _tmp30_;
#line 2614 "game.c"
					}
				}
			}
#line 455 "../src/game.vala"
			break;
#line 2620 "game.c"
		}
		default:
		{
#line 456 "../src/game.vala"
			g_assert_not_reached ();
#line 2626 "game.c"
		}
	}
#line 458 "../src/game.vala"
	_tmp31_ = mainline;
#line 458 "../src/game.vala"
	_tmp31__length1 = mainline_length1;
#line 458 "../src/game.vala"
	if (result_length1) {
#line 458 "../src/game.vala"
		*result_length1 = _tmp31__length1;
#line 2637 "game.c"
	}
#line 458 "../src/game.vala"
	result = _tmp31_;
#line 458 "../src/game.vala"
	return result;
#line 2643 "game.c"
}

static Player*
_vala_array_dup10 (Player* self,
                   int length)
{
#line 33 "../src/game.vala"
	return g_memdup (self, length * sizeof (Player));
#line 2652 "game.c"
}

static guint8*
_vala_array_dup11 (guint8* self,
                   int length)
{
#line 33 "../src/game.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 2661 "game.c"
}

void
game_state_struct_copy (const GameStateStruct* self,
                        GameStateStruct* dest)
{
	Player _tmp0_;
	Player _tmp1_;
	Player* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	Player* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	guint8* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	guint8* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	guint8* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
#line 33 "../src/game.vala"
	_tmp0_ = (*self).current_color;
#line 33 "../src/game.vala"
	(*dest).current_color = _tmp0_;
#line 33 "../src/game.vala"
	_tmp1_ = (*self).opponent_color;
#line 33 "../src/game.vala"
	(*dest).opponent_color = _tmp1_;
#line 33 "../src/game.vala"
	(*dest).size = (*self).size;
#line 33 "../src/game.vala"
	(*dest).n_current_tiles = (*self).n_current_tiles;
#line 33 "../src/game.vala"
	(*dest).n_opponent_tiles = (*self).n_opponent_tiles;
#line 33 "../src/game.vala"
	(*dest).n_tiles = (*self).n_tiles;
#line 33 "../src/game.vala"
	(*dest).current_player_can_move = (*self).current_player_can_move;
#line 33 "../src/game.vala"
	(*dest).is_complete = (*self).is_complete;
#line 33 "../src/game.vala"
	_tmp2_ = (*self).tiles;
#line 33 "../src/game.vala"
	_tmp2__length1 = (*self).tiles_length1;
#line 33 "../src/game.vala"
	_tmp2__length2 = (*self).tiles_length2;
#line 33 "../src/game.vala"
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup10 (_tmp2_, _tmp2__length1 * _tmp2__length2) : ((gpointer) _tmp2_);
#line 33 "../src/game.vala"
	_tmp3__length1 = _tmp2__length1;
#line 33 "../src/game.vala"
	_tmp3__length2 = _tmp2__length2;
#line 33 "../src/game.vala"
	(*dest).tiles = (g_free ((*dest).tiles), NULL);
#line 33 "../src/game.vala"
	(*dest).tiles = _tmp3_;
#line 33 "../src/game.vala"
	(*dest).tiles_length1 = _tmp3__length1;
#line 33 "../src/game.vala"
	(*dest).tiles_length2 = _tmp3__length2;
#line 33 "../src/game.vala"
	_tmp4_ = (*self).neighbor_tiles;
#line 33 "../src/game.vala"
	_tmp4__length1 = (*self).neighbor_tiles_length1;
#line 33 "../src/game.vala"
	_tmp4__length2 = (*self).neighbor_tiles_length2;
#line 33 "../src/game.vala"
	(*dest).neighbor_tiles = _tmp4_;
#line 33 "../src/game.vala"
	(*dest).neighbor_tiles_length1 = _tmp4__length1;
#line 33 "../src/game.vala"
	(*dest).neighbor_tiles_length2 = _tmp4__length2;
#line 33 "../src/game.vala"
	(*dest).x_saved = (*self).x_saved;
#line 33 "../src/game.vala"
	(*dest).y_saved = (*self).y_saved;
#line 33 "../src/game.vala"
	_tmp5_ = (*self).empty_neighbors;
#line 33 "../src/game.vala"
	_tmp5__length1 = (*self).empty_neighbors_length1;
#line 33 "../src/game.vala"
	_tmp5__length2 = (*self).empty_neighbors_length2;
#line 33 "../src/game.vala"
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup11 (_tmp5_, _tmp5__length1 * _tmp5__length2) : ((gpointer) _tmp5_);
#line 33 "../src/game.vala"
	_tmp6__length1 = _tmp5__length1;
#line 33 "../src/game.vala"
	_tmp6__length2 = _tmp5__length2;
#line 33 "../src/game.vala"
	(*dest).empty_neighbors = (g_free ((*dest).empty_neighbors), NULL);
#line 33 "../src/game.vala"
	(*dest).empty_neighbors = _tmp6_;
#line 33 "../src/game.vala"
	(*dest).empty_neighbors_length1 = _tmp6__length1;
#line 33 "../src/game.vala"
	(*dest).empty_neighbors_length2 = _tmp6__length2;
#line 2761 "game.c"
}

void
game_state_struct_destroy (GameStateStruct* self)
{
#line 46 "../src/game.vala"
	(*self).tiles = (g_free ((*self).tiles), NULL);
#line 361 "../src/game.vala"
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
#line 2771 "game.c"
}

GameStateStruct*
game_state_struct_dup (const GameStateStruct* self)
{
	GameStateStruct* dup;
#line 33 "../src/game.vala"
	dup = g_new0 (GameStateStruct, 1);
#line 33 "../src/game.vala"
	game_state_struct_copy (self, dup);
#line 33 "../src/game.vala"
	return dup;
#line 2784 "game.c"
}

void
game_state_struct_free (GameStateStruct* self)
{
#line 33 "../src/game.vala"
	game_state_struct_destroy (self);
#line 33 "../src/game.vala"
	g_free (self);
#line 2794 "game.c"
}

GType
game_state_struct_get_type (void)
{
	static volatile gsize game_state_struct_type_id__volatile = 0;
	if (g_once_init_enter (&game_state_struct_type_id__volatile)) {
		GType game_state_struct_type_id;
		game_state_struct_type_id = g_boxed_type_register_static ("GameStateStruct", (GBoxedCopyFunc) game_state_struct_dup, (GBoxedFreeFunc) game_state_struct_free);
		g_once_init_leave (&game_state_struct_type_id__volatile, game_state_struct_type_id);
	}
	return game_state_struct_type_id__volatile;
}

static inline gpointer
game_state_object_get_instance_private (GameStateObject* self)
{
	return G_STRUCT_MEMBER_P (self, GameStateObject_private_offset);
}

gchar*
game_state_object_to_string (GameStateObject* self)
{
	gchar* result = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	gchar* _tmp2_;
#line 487 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 489 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 489 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 489 "../src/game.vala"
	_tmp2_ = game_state_struct_to_string (&_tmp1_);
#line 489 "../src/game.vala"
	result = _tmp2_;
#line 489 "../src/game.vala"
	return result;
#line 2834 "game.c"
}

GameStateObject*
game_state_object_construct_copy_and_pass (GType object_type,
                                           GameStateObject* game)
{
	GameStateObject * self = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
#line 496 "../src/game.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 496 "../src/game.vala"
	self = (GameStateObject*) g_object_new (object_type, NULL);
#line 498 "../src/game.vala"
	game_state_object_get_game_state_struct (game, &_tmp0_);
#line 498 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 498 "../src/game.vala"
	game_state_struct_destroy (&self->priv->_game_state_struct);
#line 498 "../src/game.vala"
	game_state_struct_init_copy_and_pass (&self->priv->_game_state_struct, &_tmp1_);
#line 496 "../src/game.vala"
	return self;
#line 2858 "game.c"
}

GameStateObject*
game_state_object_new_copy_and_pass (GameStateObject* game)
{
#line 496 "../src/game.vala"
	return game_state_object_construct_copy_and_pass (TYPE_GAME_STATE_OBJECT, game);
#line 2866 "game.c"
}

GameStateObject*
game_state_object_construct_copy_and_move (GType object_type,
                                           GameStateObject* game,
                                           PossibleMove* move)
{
	GameStateObject * self = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	PossibleMove _tmp2_;
#line 501 "../src/game.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 501 "../src/game.vala"
	g_return_val_if_fail (move != NULL, NULL);
#line 501 "../src/game.vala"
	self = (GameStateObject*) g_object_new (object_type, NULL);
#line 503 "../src/game.vala"
	game_state_object_get_game_state_struct (game, &_tmp0_);
#line 503 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 503 "../src/game.vala"
	_tmp2_ = *move;
#line 503 "../src/game.vala"
	game_state_struct_destroy (&self->priv->_game_state_struct);
#line 503 "../src/game.vala"
	game_state_struct_init_copy_and_move (&self->priv->_game_state_struct, &_tmp1_, &_tmp2_);
#line 501 "../src/game.vala"
	return self;
#line 2896 "game.c"
}

GameStateObject*
game_state_object_new_copy_and_move (GameStateObject* game,
                                     PossibleMove* move)
{
#line 501 "../src/game.vala"
	return game_state_object_construct_copy_and_move (TYPE_GAME_STATE_OBJECT, game, move);
#line 2905 "game.c"
}

GameStateObject*
game_state_object_construct_from_grid (GType object_type,
                                       guint8 size,
                                       Player* tiles,
                                       gint tiles_length1,
                                       gint tiles_length2,
                                       Player color,
                                       guint8* neighbor_tiles,
                                       gint neighbor_tiles_length1,
                                       gint neighbor_tiles_length2)
{
	GameStateObject * self = NULL;
#line 506 "../src/game.vala"
	self = (GameStateObject*) g_object_new (object_type, NULL);
#line 508 "../src/game.vala"
	game_state_struct_destroy (&self->priv->_game_state_struct);
#line 508 "../src/game.vala"
	game_state_struct_init_from_grid (&self->priv->_game_state_struct, size, tiles, tiles_length1, tiles_length2, color, neighbor_tiles, neighbor_tiles_length1, neighbor_tiles_length2);
#line 506 "../src/game.vala"
	return self;
#line 2928 "game.c"
}

GameStateObject*
game_state_object_new_from_grid (guint8 size,
                                 Player* tiles,
                                 gint tiles_length1,
                                 gint tiles_length2,
                                 Player color,
                                 guint8* neighbor_tiles,
                                 gint neighbor_tiles_length1,
                                 gint neighbor_tiles_length2)
{
#line 506 "../src/game.vala"
	return game_state_object_construct_from_grid (TYPE_GAME_STATE_OBJECT, size, tiles, tiles_length1, tiles_length2, color, neighbor_tiles, neighbor_tiles_length1, neighbor_tiles_length2);
#line 2943 "game.c"
}

Player
game_state_object_get_owner (GameStateObject* self,
                             guint8 x,
                             guint8 y)
{
	Player result = 0;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	Player* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	Player _tmp3_;
#line 515 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 518 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 518 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 518 "../src/game.vala"
	_tmp2_ = _tmp1_.tiles;
#line 518 "../src/game.vala"
	_tmp2__length1 = _tmp1_.tiles_length1;
#line 518 "../src/game.vala"
	_tmp2__length2 = _tmp1_.tiles_length2;
#line 518 "../src/game.vala"
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
#line 518 "../src/game.vala"
	result = _tmp3_;
#line 518 "../src/game.vala"
	return result;
#line 2976 "game.c"
}

void
game_state_object_get_possible_moves (GameStateObject* self,
                                      GSList* * moves)
{
	GSList* _vala_moves = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	GSList* _tmp2_ = NULL;
#line 525 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 527 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 527 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 527 "../src/game.vala"
	game_state_struct_get_possible_moves (&_tmp1_, &_tmp2_);
#line 527 "../src/game.vala"
	(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 527 "../src/game.vala"
	_vala_moves = _tmp2_;
#line 525 "../src/game.vala"
	if (moves) {
#line 525 "../src/game.vala"
		*moves = _vala_moves;
#line 3003 "game.c"
	} else {
#line 525 "../src/game.vala"
		(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 3007 "game.c"
	}
}

gboolean
game_state_object_test_placing_tile (GameStateObject* self,
                                     guint8 x,
                                     guint8 y,
                                     PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	gboolean result = FALSE;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	PossibleMove _tmp2_ = {0};
	gboolean _tmp3_;
#line 530 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 532 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 532 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 532 "../src/game.vala"
	_tmp3_ = game_state_struct_test_placing_tile (&_tmp1_, x, y, &_tmp2_);
#line 532 "../src/game.vala"
	_vala_move = _tmp2_;
#line 532 "../src/game.vala"
	result = _tmp3_;
#line 532 "../src/game.vala"
	if (move) {
#line 532 "../src/game.vala"
		*move = _vala_move;
#line 3039 "game.c"
	}
#line 532 "../src/game.vala"
	return result;
#line 3043 "game.c"
}

GameStateObject*
game_state_object_construct (GType object_type)
{
	GameStateObject * self = NULL;
#line 462 "../src/game.vala"
	self = (GameStateObject*) g_object_new (object_type, NULL);
#line 462 "../src/game.vala"
	return self;
#line 3054 "game.c"
}

GameStateObject*
game_state_object_new (void)
{
#line 462 "../src/game.vala"
	return game_state_object_construct (TYPE_GAME_STATE_OBJECT);
#line 3062 "game.c"
}

void
game_state_object_get_game_state_struct (GameStateObject* self,
                                         GameStateStruct * result)
{
	GameStateStruct _tmp0_;
#line 465 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 465 "../src/game.vala"
	_tmp0_ = self->priv->_game_state_struct;
#line 465 "../src/game.vala"
	*result = _tmp0_;
#line 465 "../src/game.vala"
	return;
#line 3078 "game.c"
}

Player
game_state_object_get_current_color (GameStateObject* self)
{
	Player result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	Player _tmp2_;
#line 467 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 467 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 467 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 467 "../src/game.vala"
	_tmp2_ = _tmp1_.current_color;
#line 467 "../src/game.vala"
	result = _tmp2_;
#line 467 "../src/game.vala"
	return result;
#line 3100 "game.c"
}

guint8
game_state_object_get_n_light_tiles (GameStateObject* self)
{
	guint8 result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	Player _tmp2_;
	GameStateStruct _tmp5_ = {0};
	GameStateStruct _tmp6_;
#line 469 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 470 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 470 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 470 "../src/game.vala"
	_tmp2_ = _tmp1_.current_color;
#line 470 "../src/game.vala"
	if (_tmp2_ == PLAYER_LIGHT) {
#line 3122 "game.c"
		GameStateStruct _tmp3_ = {0};
		GameStateStruct _tmp4_;
#line 471 "../src/game.vala"
		game_state_object_get_game_state_struct (self, &_tmp3_);
#line 471 "../src/game.vala"
		_tmp4_ = _tmp3_;
#line 471 "../src/game.vala"
		result = _tmp4_.n_current_tiles;
#line 471 "../src/game.vala"
		return result;
#line 3133 "game.c"
	}
#line 473 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp5_);
#line 473 "../src/game.vala"
	_tmp6_ = _tmp5_;
#line 473 "../src/game.vala"
	result = _tmp6_.n_opponent_tiles;
#line 473 "../src/game.vala"
	return result;
#line 3143 "game.c"
}

guint8
game_state_object_get_n_dark_tiles (GameStateObject* self)
{
	guint8 result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	Player _tmp2_;
	GameStateStruct _tmp5_ = {0};
	GameStateStruct _tmp6_;
#line 476 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 477 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 477 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 477 "../src/game.vala"
	_tmp2_ = _tmp1_.current_color;
#line 477 "../src/game.vala"
	if (_tmp2_ == PLAYER_DARK) {
#line 3165 "game.c"
		GameStateStruct _tmp3_ = {0};
		GameStateStruct _tmp4_;
#line 478 "../src/game.vala"
		game_state_object_get_game_state_struct (self, &_tmp3_);
#line 478 "../src/game.vala"
		_tmp4_ = _tmp3_;
#line 478 "../src/game.vala"
		result = _tmp4_.n_current_tiles;
#line 478 "../src/game.vala"
		return result;
#line 3176 "game.c"
	}
#line 480 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp5_);
#line 480 "../src/game.vala"
	_tmp6_ = _tmp5_;
#line 480 "../src/game.vala"
	result = _tmp6_.n_opponent_tiles;
#line 480 "../src/game.vala"
	return result;
#line 3186 "game.c"
}

gboolean
game_state_object_get_current_player_can_move (GameStateObject* self)
{
	gboolean result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
#line 484 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 484 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 484 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 484 "../src/game.vala"
	result = _tmp1_.current_player_can_move;
#line 484 "../src/game.vala"
	return result;
#line 3205 "game.c"
}

gboolean
game_state_object_get_is_complete (GameStateObject* self)
{
	gboolean result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
#line 485 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 485 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 485 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 485 "../src/game.vala"
	result = _tmp1_.is_complete;
#line 485 "../src/game.vala"
	return result;
#line 3224 "game.c"
}

static void
game_state_object_class_init (GameStateObjectClass * klass,
                              gpointer klass_data)
{
#line 462 "../src/game.vala"
	game_state_object_parent_class = g_type_class_peek_parent (klass);
#line 462 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &GameStateObject_private_offset);
#line 462 "../src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_state_object_get_property;
#line 462 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_state_object_finalize;
#line 462 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY] = g_param_spec_boxed ("game-state-struct", "game-state-struct", "game-state-struct", TYPE_GAME_STATE_STRUCT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 462 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY] = g_param_spec_enum ("current-color", "current-color", "current-color", TYPE_PLAYER, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 462 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY] = g_param_spec_uchar ("n-light-tiles", "n-light-tiles", "n-light-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 462 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY] = g_param_spec_uchar ("n-dark-tiles", "n-dark-tiles", "n-dark-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 462 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY] = g_param_spec_boolean ("current-player-can-move", "current-player-can-move", "current-player-can-move", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 462 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY] = g_param_spec_boolean ("is-complete", "is-complete", "is-complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 3251 "game.c"
}

static void
game_state_object_instance_init (GameStateObject * self,
                                 gpointer klass)
{
#line 462 "../src/game.vala"
	self->priv = game_state_object_get_instance_private (self);
#line 3260 "game.c"
}

static void
game_state_object_finalize (GObject * obj)
{
	GameStateObject * self;
#line 462 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_STATE_OBJECT, GameStateObject);
#line 464 "../src/game.vala"
	game_state_struct_destroy (&self->priv->_game_state_struct);
#line 462 "../src/game.vala"
	G_OBJECT_CLASS (game_state_object_parent_class)->finalize (obj);
#line 3273 "game.c"
}

GType
game_state_object_get_type (void)
{
	static volatile gsize game_state_object_type_id__volatile = 0;
	if (g_once_init_enter (&game_state_object_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameStateObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_state_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameStateObject), 0, (GInstanceInitFunc) game_state_object_instance_init, NULL };
		GType game_state_object_type_id;
		game_state_object_type_id = g_type_register_static (G_TYPE_OBJECT, "GameStateObject", &g_define_type_info, 0);
		GameStateObject_private_offset = g_type_add_instance_private (game_state_object_type_id, sizeof (GameStateObjectPrivate));
		g_once_init_leave (&game_state_object_type_id__volatile, game_state_object_type_id);
	}
	return game_state_object_type_id__volatile;
}

static void
_vala_game_state_object_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	GameStateObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_STATE_OBJECT, GameStateObject);
#line 462 "../src/game.vala"
	switch (property_id) {
#line 462 "../src/game.vala"
		case GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY:
#line 3302 "game.c"
		{
			GameStateStruct boxed;
#line 462 "../src/game.vala"
			game_state_object_get_game_state_struct (self, &boxed);
#line 462 "../src/game.vala"
			g_value_set_boxed (value, &boxed);
#line 3309 "game.c"
		}
#line 462 "../src/game.vala"
		break;
#line 462 "../src/game.vala"
		case GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY:
#line 462 "../src/game.vala"
		g_value_set_enum (value, game_state_object_get_current_color (self));
#line 462 "../src/game.vala"
		break;
#line 462 "../src/game.vala"
		case GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY:
#line 462 "../src/game.vala"
		g_value_set_uchar (value, game_state_object_get_n_light_tiles (self));
#line 462 "../src/game.vala"
		break;
#line 462 "../src/game.vala"
		case GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY:
#line 462 "../src/game.vala"
		g_value_set_uchar (value, game_state_object_get_n_dark_tiles (self));
#line 462 "../src/game.vala"
		break;
#line 462 "../src/game.vala"
		case GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY:
#line 462 "../src/game.vala"
		g_value_set_boolean (value, game_state_object_get_current_player_can_move (self));
#line 462 "../src/game.vala"
		break;
#line 462 "../src/game.vala"
		case GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY:
#line 462 "../src/game.vala"
		g_value_set_boolean (value, game_state_object_get_is_complete (self));
#line 462 "../src/game.vala"
		break;
#line 3343 "game.c"
		default:
#line 462 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 462 "../src/game.vala"
		break;
#line 3349 "game.c"
	}
}

static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}

Game*
game_construct (GType object_type,
                gboolean _alternative_start,
                guint8 _size)
{
	Game * self = NULL;
	gboolean even_board = FALSE;
	Player* tiles = NULL;
	Player* _tmp0_;
	gint tiles_length1;
	gint tiles_length2;
	guint8 _initial_number_of_tiles = 0U;
	guint8* _neighbor_tiles = NULL;
	gint _neighbor_tiles_length1 = 0;
	gint _neighbor_tiles_length2 = 0;
	guint8* _tmp23_ = NULL;
	gint _tmp24_ = 0;
	gint _tmp25_ = 0;
	GameStateObject* _current_state = NULL;
	Player* _tmp26_;
	gint _tmp26__length1;
	gint _tmp26__length2;
	guint8* _tmp27_;
	gint _tmp27__length1;
	gint _tmp27__length2;
	GameStateObject* _tmp28_;
	guint8* _tmp29_;
	gint _tmp29__length1;
	gint _tmp29__length2;
#line 568 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) >= 4, "_size >= 4", NULL);
#line 568 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) <= 16, "_size <= 16", NULL);
#line 572 "../src/game.vala"
	even_board = (_size % 2) == 0;
#line 574 "../src/game.vala"
	_tmp0_ = g_new0 (Player, _size * _size);
#line 574 "../src/game.vala"
	tiles = _tmp0_;
#line 574 "../src/game.vala"
	tiles_length1 = _size;
#line 574 "../src/game.vala"
	tiles_length2 = _size;
#line 3402 "game.c"
	{
		guint8 x = 0U;
#line 576 "../src/game.vala"
		x = (guint8) 0;
#line 3407 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 576 "../src/game.vala"
			_tmp1_ = TRUE;
#line 576 "../src/game.vala"
			while (TRUE) {
#line 576 "../src/game.vala"
				if (!_tmp1_) {
#line 3416 "game.c"
					guint8 _tmp2_;
#line 576 "../src/game.vala"
					_tmp2_ = x;
#line 576 "../src/game.vala"
					x = _tmp2_ + 1;
#line 3422 "game.c"
				}
#line 576 "../src/game.vala"
				_tmp1_ = FALSE;
#line 576 "../src/game.vala"
				if (!(x < _size)) {
#line 576 "../src/game.vala"
					break;
#line 3430 "game.c"
				}
				{
					guint8 y = 0U;
#line 577 "../src/game.vala"
					y = (guint8) 0;
#line 3436 "game.c"
					{
						gboolean _tmp3_ = FALSE;
#line 577 "../src/game.vala"
						_tmp3_ = TRUE;
#line 577 "../src/game.vala"
						while (TRUE) {
#line 3443 "game.c"
							Player* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
#line 577 "../src/game.vala"
							if (!_tmp3_) {
#line 3449 "game.c"
								guint8 _tmp4_;
#line 577 "../src/game.vala"
								_tmp4_ = y;
#line 577 "../src/game.vala"
								y = _tmp4_ + 1;
#line 3455 "game.c"
							}
#line 577 "../src/game.vala"
							_tmp3_ = FALSE;
#line 577 "../src/game.vala"
							if (!(y < _size)) {
#line 577 "../src/game.vala"
								break;
#line 3463 "game.c"
							}
#line 578 "../src/game.vala"
							_tmp5_ = tiles;
#line 578 "../src/game.vala"
							_tmp5__length1 = tiles_length1;
#line 578 "../src/game.vala"
							_tmp5__length2 = tiles_length2;
#line 578 "../src/game.vala"
							_tmp5_[(x * _tmp5__length2) + y] = PLAYER_NONE;
#line 3473 "game.c"
						}
					}
				}
			}
		}
	}
#line 581 "../src/game.vala"
	if (even_board) {
#line 3482 "game.c"
		guint8 half_size = 0U;
		Player _tmp6_ = 0;
		Player* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		Player* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		Player _tmp9_ = 0;
		Player* _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		Player* _tmp11_;
		gint _tmp11__length1;
		gint _tmp11__length2;
#line 584 "../src/game.vala"
		half_size = (guint8) (_size / 2);
#line 585 "../src/game.vala"
		_initial_number_of_tiles = (guint8) 4;
#line 586 "../src/game.vala"
		if (_alternative_start) {
#line 586 "../src/game.vala"
			_tmp6_ = PLAYER_DARK;
#line 3506 "game.c"
		} else {
#line 586 "../src/game.vala"
			_tmp6_ = PLAYER_LIGHT;
#line 3510 "game.c"
		}
#line 586 "../src/game.vala"
		_tmp7_ = tiles;
#line 586 "../src/game.vala"
		_tmp7__length1 = tiles_length1;
#line 586 "../src/game.vala"
		_tmp7__length2 = tiles_length2;
#line 586 "../src/game.vala"
		_tmp7_[((half_size - 1) * _tmp7__length2) + (half_size - 1)] = _tmp6_;
#line 587 "../src/game.vala"
		_tmp8_ = tiles;
#line 587 "../src/game.vala"
		_tmp8__length1 = tiles_length1;
#line 587 "../src/game.vala"
		_tmp8__length2 = tiles_length2;
#line 587 "../src/game.vala"
		_tmp8_[((half_size - 1) * _tmp8__length2) + half_size] = PLAYER_DARK;
#line 588 "../src/game.vala"
		if (_alternative_start) {
#line 588 "../src/game.vala"
			_tmp9_ = PLAYER_LIGHT;
#line 3532 "game.c"
		} else {
#line 588 "../src/game.vala"
			_tmp9_ = PLAYER_DARK;
#line 3536 "game.c"
		}
#line 588 "../src/game.vala"
		_tmp10_ = tiles;
#line 588 "../src/game.vala"
		_tmp10__length1 = tiles_length1;
#line 588 "../src/game.vala"
		_tmp10__length2 = tiles_length2;
#line 588 "../src/game.vala"
		_tmp10_[(half_size * _tmp10__length2) + (half_size - 1)] = _tmp9_;
#line 589 "../src/game.vala"
		_tmp11_ = tiles;
#line 589 "../src/game.vala"
		_tmp11__length1 = tiles_length1;
#line 589 "../src/game.vala"
		_tmp11__length2 = tiles_length2;
#line 589 "../src/game.vala"
		_tmp11_[(half_size * _tmp11__length2) + half_size] = PLAYER_LIGHT;
#line 3554 "game.c"
	} else {
		guint8 mid_board = 0U;
		Player* _tmp12_;
		gint _tmp12__length1;
		gint _tmp12__length2;
		Player _tmp13_ = 0;
		Player* _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		Player _tmp15_ = 0;
		Player* _tmp16_;
		gint _tmp16__length1;
		gint _tmp16__length2;
		Player* _tmp17_;
		gint _tmp17__length1;
		gint _tmp17__length2;
		Player _tmp18_ = 0;
		Player* _tmp19_;
		gint _tmp19__length1;
		gint _tmp19__length2;
		Player _tmp20_ = 0;
		Player* _tmp21_;
		gint _tmp21__length1;
		gint _tmp21__length2;
		Player* _tmp22_;
		gint _tmp22__length1;
		gint _tmp22__length2;
#line 594 "../src/game.vala"
		mid_board = (guint8) ((_size - 1) / 2);
#line 595 "../src/game.vala"
		_initial_number_of_tiles = (guint8) 7;
#line 596 "../src/game.vala"
		_tmp12_ = tiles;
#line 596 "../src/game.vala"
		_tmp12__length1 = tiles_length1;
#line 596 "../src/game.vala"
		_tmp12__length2 = tiles_length2;
#line 596 "../src/game.vala"
		_tmp12_[(mid_board * _tmp12__length2) + mid_board] = PLAYER_DARK;
#line 597 "../src/game.vala"
		if (_alternative_start) {
#line 597 "../src/game.vala"
			_tmp13_ = PLAYER_LIGHT;
#line 3598 "game.c"
		} else {
#line 597 "../src/game.vala"
			_tmp13_ = PLAYER_DARK;
#line 3602 "game.c"
		}
#line 597 "../src/game.vala"
		_tmp14_ = tiles;
#line 597 "../src/game.vala"
		_tmp14__length1 = tiles_length1;
#line 597 "../src/game.vala"
		_tmp14__length2 = tiles_length2;
#line 597 "../src/game.vala"
		_tmp14_[((mid_board + 1) * _tmp14__length2) + (mid_board - 1)] = _tmp13_;
#line 598 "../src/game.vala"
		if (_alternative_start) {
#line 598 "../src/game.vala"
			_tmp15_ = PLAYER_LIGHT;
#line 3616 "game.c"
		} else {
#line 598 "../src/game.vala"
			_tmp15_ = PLAYER_DARK;
#line 3620 "game.c"
		}
#line 598 "../src/game.vala"
		_tmp16_ = tiles;
#line 598 "../src/game.vala"
		_tmp16__length1 = tiles_length1;
#line 598 "../src/game.vala"
		_tmp16__length2 = tiles_length2;
#line 598 "../src/game.vala"
		_tmp16_[((mid_board - 1) * _tmp16__length2) + (mid_board + 1)] = _tmp15_;
#line 599 "../src/game.vala"
		_tmp17_ = tiles;
#line 599 "../src/game.vala"
		_tmp17__length1 = tiles_length1;
#line 599 "../src/game.vala"
		_tmp17__length2 = tiles_length2;
#line 599 "../src/game.vala"
		_tmp17_[(mid_board * _tmp17__length2) + (mid_board - 1)] = PLAYER_LIGHT;
#line 600 "../src/game.vala"
		if (_alternative_start) {
#line 600 "../src/game.vala"
			_tmp18_ = PLAYER_DARK;
#line 3642 "game.c"
		} else {
#line 600 "../src/game.vala"
			_tmp18_ = PLAYER_LIGHT;
#line 3646 "game.c"
		}
#line 600 "../src/game.vala"
		_tmp19_ = tiles;
#line 600 "../src/game.vala"
		_tmp19__length1 = tiles_length1;
#line 600 "../src/game.vala"
		_tmp19__length2 = tiles_length2;
#line 600 "../src/game.vala"
		_tmp19_[((mid_board - 1) * _tmp19__length2) + mid_board] = _tmp18_;
#line 601 "../src/game.vala"
		if (_alternative_start) {
#line 601 "../src/game.vala"
			_tmp20_ = PLAYER_DARK;
#line 3660 "game.c"
		} else {
#line 601 "../src/game.vala"
			_tmp20_ = PLAYER_LIGHT;
#line 3664 "game.c"
		}
#line 601 "../src/game.vala"
		_tmp21_ = tiles;
#line 601 "../src/game.vala"
		_tmp21__length1 = tiles_length1;
#line 601 "../src/game.vala"
		_tmp21__length2 = tiles_length2;
#line 601 "../src/game.vala"
		_tmp21_[((mid_board + 1) * _tmp21__length2) + mid_board] = _tmp20_;
#line 602 "../src/game.vala"
		_tmp22_ = tiles;
#line 602 "../src/game.vala"
		_tmp22__length1 = tiles_length1;
#line 602 "../src/game.vala"
		_tmp22__length2 = tiles_length2;
#line 602 "../src/game.vala"
		_tmp22_[(mid_board * _tmp22__length2) + (mid_board + 1)] = PLAYER_LIGHT;
#line 3682 "game.c"
	}
#line 606 "../src/game.vala"
	game_init_neighbor_tiles (_size, &_tmp23_, &_tmp24_, &_tmp25_);
#line 606 "../src/game.vala"
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
#line 606 "../src/game.vala"
	_neighbor_tiles = _tmp23_;
#line 606 "../src/game.vala"
	_neighbor_tiles_length1 = _tmp24_;
#line 606 "../src/game.vala"
	_neighbor_tiles_length2 = _tmp25_;
#line 607 "../src/game.vala"
	_tmp26_ = tiles;
#line 607 "../src/game.vala"
	_tmp26__length1 = tiles_length1;
#line 607 "../src/game.vala"
	_tmp26__length2 = tiles_length2;
#line 607 "../src/game.vala"
	_tmp27_ = _neighbor_tiles;
#line 607 "../src/game.vala"
	_tmp27__length1 = _neighbor_tiles_length1;
#line 607 "../src/game.vala"
	_tmp27__length2 = _neighbor_tiles_length2;
#line 607 "../src/game.vala"
	_tmp28_ = game_state_object_new_from_grid (_size, _tmp26_, _tmp26__length1, _tmp26__length2, PLAYER_DARK, _tmp27_, _tmp27__length1, _tmp27__length2);
#line 607 "../src/game.vala"
	_current_state = _tmp28_;
#line 609 "../src/game.vala"
	self = (Game*) g_object_new (object_type, "size", _size, "current-state", _current_state, "alternative-start", _alternative_start, "initial-number-of-tiles", _initial_number_of_tiles, NULL);
#line 613 "../src/game.vala"
	_tmp29_ = _neighbor_tiles;
#line 613 "../src/game.vala"
	_tmp29__length1 = _neighbor_tiles_length1;
#line 613 "../src/game.vala"
	_tmp29__length2 = _neighbor_tiles_length2;
#line 613 "../src/game.vala"
	_neighbor_tiles = NULL;
#line 613 "../src/game.vala"
	_neighbor_tiles_length1 = 0;
#line 613 "../src/game.vala"
	_neighbor_tiles_length2 = 0;
#line 613 "../src/game.vala"
	self->priv->neighbor_tiles = (g_free (self->priv->neighbor_tiles), NULL);
#line 613 "../src/game.vala"
	self->priv->neighbor_tiles = _tmp29_;
#line 613 "../src/game.vala"
	self->priv->neighbor_tiles_length1 = _tmp29__length1;
#line 613 "../src/game.vala"
	self->priv->neighbor_tiles_length2 = _tmp29__length2;
#line 568 "../src/game.vala"
	_g_object_unref0 (_current_state);
#line 568 "../src/game.vala"
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
#line 568 "../src/game.vala"
	tiles = (g_free (tiles), NULL);
#line 568 "../src/game.vala"
	return self;
#line 3740 "game.c"
}

Game*
game_new (gboolean _alternative_start,
          guint8 _size)
{
#line 568 "../src/game.vala"
	return game_construct (TYPE_GAME, _alternative_start, _size);
#line 3749 "game.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 3766 "game.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
#line 1148 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1149 "glib-2.0.vapi"
		separator = "";
#line 3780 "game.c"
	}
#line 1151 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 3784 "game.c"
		gboolean _tmp1_ = FALSE;
#line 1151 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1151 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 3790 "game.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1151 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 3795 "game.c"
				const gchar* _tmp3_;
#line 1151 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1151 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 3801 "game.c"
			} else {
#line 1151 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 3805 "game.c"
			}
#line 1151 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 3809 "game.c"
		}
#line 1151 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 3813 "game.c"
	} else {
#line 1151 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 3817 "game.c"
	}
#line 1151 "glib-2.0.vapi"
	if (_tmp0_) {
#line 3821 "game.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		void* ptr = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		void* _tmp21_;
		const gchar* _tmp31_;
#line 1153 "glib-2.0.vapi"
		len = (gsize) 1;
#line 3835 "game.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
			i = 0;
#line 1154 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1154 "glib-2.0.vapi"
			while (TRUE) {
#line 3844 "game.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1154 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 3851 "game.c"
					gint _tmp5_;
#line 1154 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1154 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 3857 "game.c"
				}
#line 1154 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 3865 "game.c"
				} else {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 3869 "game.c"
				}
#line 1154 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1154 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 3875 "game.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1154 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 3880 "game.c"
						const gchar* _tmp9_;
#line 1154 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1154 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 3886 "game.c"
					} else {
#line 1154 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 3890 "game.c"
					}
#line 1154 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 3894 "game.c"
				}
#line 1154 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1154 "glib-2.0.vapi"
					break;
#line 3900 "game.c"
				}
#line 1155 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1155 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 3906 "game.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1155 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1155 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1155 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1155 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 3918 "game.c"
				} else {
#line 1155 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 3922 "game.c"
				}
#line 1155 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 3926 "game.c"
			}
		}
#line 1157 "glib-2.0.vapi"
		if (i == 0) {
#line 3931 "game.c"
			gchar* _tmp15_;
#line 1158 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1158 "glib-2.0.vapi"
			result = _tmp15_;
#line 1158 "glib-2.0.vapi"
			return result;
#line 3939 "game.c"
		}
#line 1160 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1161 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1161 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1161 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1163 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1163 "glib-2.0.vapi"
		res = _tmp18_;
#line 1164 "glib-2.0.vapi"
		_tmp19_ = res;
#line 1164 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1164 "glib-2.0.vapi"
		_tmp21_ = g_stpcpy ((void*) _tmp19_, (const gchar*) _tmp20_);
#line 1164 "glib-2.0.vapi"
		ptr = _tmp21_;
#line 3961 "game.c"
		{
			gboolean _tmp22_ = FALSE;
#line 1165 "glib-2.0.vapi"
			i = 1;
#line 1165 "glib-2.0.vapi"
			_tmp22_ = TRUE;
#line 1165 "glib-2.0.vapi"
			while (TRUE) {
#line 3970 "game.c"
				void* _tmp24_;
				void* _tmp25_;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_;
				void* _tmp29_;
				void* _tmp30_;
#line 1165 "glib-2.0.vapi"
				if (!_tmp22_) {
#line 3979 "game.c"
					gint _tmp23_;
#line 1165 "glib-2.0.vapi"
					_tmp23_ = i;
#line 1165 "glib-2.0.vapi"
					i = _tmp23_ + 1;
#line 3985 "game.c"
				}
#line 1165 "glib-2.0.vapi"
				_tmp22_ = FALSE;
#line 1165 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1165 "glib-2.0.vapi"
					break;
#line 3993 "game.c"
				}
#line 1166 "glib-2.0.vapi"
				_tmp24_ = ptr;
#line 1166 "glib-2.0.vapi"
				_tmp25_ = g_stpcpy (_tmp24_, (const gchar*) separator);
#line 1166 "glib-2.0.vapi"
				ptr = _tmp25_;
#line 1167 "glib-2.0.vapi"
				_tmp27_ = str_array[i];
#line 1167 "glib-2.0.vapi"
				if (_tmp27_ != NULL) {
#line 4005 "game.c"
					const gchar* _tmp28_;
#line 1167 "glib-2.0.vapi"
					_tmp28_ = str_array[i];
#line 1167 "glib-2.0.vapi"
					_tmp26_ = (const gchar*) _tmp28_;
#line 4011 "game.c"
				} else {
#line 1167 "glib-2.0.vapi"
					_tmp26_ = "";
#line 4015 "game.c"
				}
#line 1167 "glib-2.0.vapi"
				_tmp29_ = ptr;
#line 1167 "glib-2.0.vapi"
				_tmp30_ = g_stpcpy (_tmp29_, _tmp26_);
#line 1167 "glib-2.0.vapi"
				ptr = _tmp30_;
#line 4023 "game.c"
			}
		}
#line 1170 "glib-2.0.vapi"
		_tmp31_ = res;
#line 1170 "glib-2.0.vapi"
		res = NULL;
#line 1170 "glib-2.0.vapi"
		result = (gchar*) _tmp31_;
#line 1170 "glib-2.0.vapi"
		return result;
#line 4034 "game.c"
	} else {
		gchar* _tmp32_;
#line 1172 "glib-2.0.vapi"
		_tmp32_ = g_strdup ("");
#line 1172 "glib-2.0.vapi"
		result = _tmp32_;
#line 1172 "glib-2.0.vapi"
		return result;
#line 4043 "game.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1307 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1308 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1309 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1309 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1310 "glib-2.0.vapi"
	result = _result_;
#line 1310 "glib-2.0.vapi"
	return result;
#line 4068 "game.c"
}

Game*
game_construct_from_strings (GType object_type,
                             gchar** setup,
                             gint setup_length1,
                             Player to_move,
                             guint8 _size)
{
	Game * self = NULL;
	Player* tiles = NULL;
	Player* _tmp0_;
	gint tiles_length1;
	gint tiles_length2;
	guint8* _neighbor_tiles = NULL;
	gint _neighbor_tiles_length1 = 0;
	gint _neighbor_tiles_length2 = 0;
	guint8* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	GameStateObject* _current_state = NULL;
	Player* _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
	guint8* _tmp14_;
	gint _tmp14__length1;
	gint _tmp14__length2;
	GameStateObject* _tmp15_;
	gint _tmp16_ = 0;
	GameStateObject* _tmp17_;
	guint8* _tmp18_;
	gint _tmp18__length1;
	gint _tmp18__length2;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
#line 616 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) >= 4, "_size >= 4", NULL);
#line 616 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) <= 16, "_size <= 16", NULL);
#line 616 "../src/game.vala"
	_vala_return_val_if_fail (to_move != PLAYER_NONE, "to_move != Player.NONE", NULL);
#line 616 "../src/game.vala"
	_vala_return_val_if_fail (setup_length1 == ((gint) _size), "setup.length == _size", NULL);
#line 622 "../src/game.vala"
	_tmp0_ = g_new0 (Player, _size * _size);
#line 622 "../src/game.vala"
	tiles = _tmp0_;
#line 622 "../src/game.vala"
	tiles_length1 = _size;
#line 622 "../src/game.vala"
	tiles_length2 = _size;
#line 4126 "game.c"
	{
		guint8 y = 0U;
#line 624 "../src/game.vala"
		y = (guint8) 0;
#line 4131 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 624 "../src/game.vala"
			_tmp1_ = TRUE;
#line 624 "../src/game.vala"
			while (TRUE) {
#line 4138 "game.c"
				const gchar* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 624 "../src/game.vala"
				if (!_tmp1_) {
#line 4144 "game.c"
					guint8 _tmp2_;
#line 624 "../src/game.vala"
					_tmp2_ = y;
#line 624 "../src/game.vala"
					y = _tmp2_ + 1;
#line 4150 "game.c"
				}
#line 624 "../src/game.vala"
				_tmp1_ = FALSE;
#line 624 "../src/game.vala"
				if (!(y < _size)) {
#line 624 "../src/game.vala"
					break;
#line 4158 "game.c"
				}
#line 626 "../src/game.vala"
				_tmp3_ = setup[y];
#line 626 "../src/game.vala"
				_tmp4_ = strlen (_tmp3_);
#line 626 "../src/game.vala"
				_tmp5_ = _tmp4_;
#line 626 "../src/game.vala"
				if (_tmp5_ != (_size * 2)) {
#line 627 "../src/game.vala"
					g_warn_if_reached ();
#line 4170 "game.c"
				}
				{
					guint8 x = 0U;
#line 628 "../src/game.vala"
					x = (guint8) 0;
#line 4176 "game.c"
					{
						gboolean _tmp6_ = FALSE;
#line 628 "../src/game.vala"
						_tmp6_ = TRUE;
#line 628 "../src/game.vala"
						while (TRUE) {
#line 4183 "game.c"
							Player* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							const gchar* _tmp9_;
#line 628 "../src/game.vala"
							if (!_tmp6_) {
#line 4190 "game.c"
								guint8 _tmp7_;
#line 628 "../src/game.vala"
								_tmp7_ = x;
#line 628 "../src/game.vala"
								x = _tmp7_ + 1;
#line 4196 "game.c"
							}
#line 628 "../src/game.vala"
							_tmp6_ = FALSE;
#line 628 "../src/game.vala"
							if (!(x < _size)) {
#line 628 "../src/game.vala"
								break;
#line 4204 "game.c"
							}
#line 629 "../src/game.vala"
							_tmp8_ = tiles;
#line 629 "../src/game.vala"
							_tmp8__length1 = tiles_length1;
#line 629 "../src/game.vala"
							_tmp8__length2 = tiles_length2;
#line 629 "../src/game.vala"
							_tmp9_ = setup[y];
#line 629 "../src/game.vala"
							_tmp8_[(x * _tmp8__length2) + y] = player_from_char (string_get (_tmp9_, (glong) ((x * 2) + 1)));
#line 4216 "game.c"
						}
					}
				}
			}
		}
	}
#line 633 "../src/game.vala"
	game_init_neighbor_tiles (_size, &_tmp10_, &_tmp11_, &_tmp12_);
#line 633 "../src/game.vala"
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
#line 633 "../src/game.vala"
	_neighbor_tiles = _tmp10_;
#line 633 "../src/game.vala"
	_neighbor_tiles_length1 = _tmp11_;
#line 633 "../src/game.vala"
	_neighbor_tiles_length2 = _tmp12_;
#line 634 "../src/game.vala"
	_tmp13_ = tiles;
#line 634 "../src/game.vala"
	_tmp13__length1 = tiles_length1;
#line 634 "../src/game.vala"
	_tmp13__length2 = tiles_length2;
#line 634 "../src/game.vala"
	_tmp14_ = _neighbor_tiles;
#line 634 "../src/game.vala"
	_tmp14__length1 = _neighbor_tiles_length1;
#line 634 "../src/game.vala"
	_tmp14__length2 = _neighbor_tiles_length2;
#line 634 "../src/game.vala"
	_tmp15_ = game_state_object_new_from_grid (_size, _tmp13_, _tmp13__length1, _tmp13__length2, to_move, _tmp14_, _tmp14__length1, _tmp14__length2);
#line 634 "../src/game.vala"
	_current_state = _tmp15_;
#line 639 "../src/game.vala"
	if ((_size % 2) == 0) {
#line 639 "../src/game.vala"
		_tmp16_ = 4;
#line 4253 "game.c"
	} else {
#line 639 "../src/game.vala"
		_tmp16_ = 7;
#line 4257 "game.c"
	}
#line 636 "../src/game.vala"
	_tmp17_ = _current_state;
#line 636 "../src/game.vala"
	self = (Game*) g_object_new (object_type, "size", _size, "current-state", _tmp17_, "alternative-start", FALSE, "initial-number-of-tiles", _tmp16_, NULL);
#line 640 "../src/game.vala"
	_tmp18_ = _neighbor_tiles;
#line 640 "../src/game.vala"
	_tmp18__length1 = _neighbor_tiles_length1;
#line 640 "../src/game.vala"
	_tmp18__length2 = _neighbor_tiles_length2;
#line 640 "../src/game.vala"
	_neighbor_tiles = NULL;
#line 640 "../src/game.vala"
	_neighbor_tiles_length1 = 0;
#line 640 "../src/game.vala"
	_neighbor_tiles_length2 = 0;
#line 640 "../src/game.vala"
	self->priv->neighbor_tiles = (g_free (self->priv->neighbor_tiles), NULL);
#line 640 "../src/game.vala"
	self->priv->neighbor_tiles = _tmp18_;
#line 640 "../src/game.vala"
	self->priv->neighbor_tiles_length1 = _tmp18__length1;
#line 640 "../src/game.vala"
	self->priv->neighbor_tiles_length2 = _tmp18__length2;
#line 642 "../src/game.vala"
	_tmp19_ = _vala_g_strjoinv ("\n", (gchar**) setup, (gint) ((setup_length1 * sizeof (gchar*)) / sizeof (gchar*)));
#line 642 "../src/game.vala"
	_tmp20_ = _tmp19_;
#line 642 "../src/game.vala"
	_tmp21_ = string_strip (_tmp20_);
#line 642 "../src/game.vala"
	_tmp22_ = _tmp21_;
#line 642 "../src/game.vala"
	_tmp23_ = game_to_string (self);
#line 642 "../src/game.vala"
	_tmp24_ = _tmp23_;
#line 642 "../src/game.vala"
	_tmp25_ = string_strip (_tmp24_);
#line 642 "../src/game.vala"
	_tmp26_ = _tmp25_;
#line 642 "../src/game.vala"
	g_warn_if_fail (g_strcmp0 (_tmp22_, _tmp26_) == 0);
#line 642 "../src/game.vala"
	_g_free0 (_tmp26_);
#line 642 "../src/game.vala"
	_g_free0 (_tmp24_);
#line 642 "../src/game.vala"
	_g_free0 (_tmp22_);
#line 642 "../src/game.vala"
	_g_free0 (_tmp20_);
#line 616 "../src/game.vala"
	_g_object_unref0 (_current_state);
#line 616 "../src/game.vala"
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
#line 616 "../src/game.vala"
	tiles = (g_free (tiles), NULL);
#line 616 "../src/game.vala"
	return self;
#line 4317 "game.c"
}

Game*
game_new_from_strings (gchar** setup,
                       gint setup_length1,
                       Player to_move,
                       guint8 _size)
{
#line 616 "../src/game.vala"
	return game_construct_from_strings (TYPE_GAME, setup, setup_length1, to_move, _size);
#line 4328 "game.c"
}

Player
game_get_owner (Game* self,
                guint8 x,
                guint8 y)
{
	Player result = 0;
	GameStateObject* _tmp0_;
#line 649 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 651 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 651 "../src/game.vala"
	result = game_state_object_get_owner (_tmp0_, x, y);
#line 651 "../src/game.vala"
	return result;
#line 4346 "game.c"
}

gchar*
game_to_string (Game* self)
{
	gchar* result = NULL;
	GameStateObject* _tmp0_;
	gchar* _tmp1_;
#line 662 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 664 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 664 "../src/game.vala"
	_tmp1_ = game_state_object_to_string (_tmp0_);
#line 664 "../src/game.vala"
	result = _tmp1_;
#line 664 "../src/game.vala"
	return result;
#line 4365 "game.c"
}

gboolean
game_place_tile (Game* self,
                 guint8 x,
                 guint8 y)
{
	gboolean result = FALSE;
	PossibleMove move = {0};
	GameStateObject* _tmp0_;
	PossibleMove _tmp1_ = {0};
	gboolean _tmp2_;
	GameStateObject* _tmp3_;
	PossibleMove _tmp4_;
	GameStateObject* _tmp5_;
	GameStateObject* _tmp6_;
	GListStore* _tmp7_;
	GameStateObject* _tmp8_;
#line 671 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 674 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 674 "../src/game.vala"
	_tmp2_ = game_state_object_test_placing_tile (_tmp0_, x, y, &_tmp1_);
#line 674 "../src/game.vala"
	move = _tmp1_;
#line 674 "../src/game.vala"
	if (!_tmp2_) {
#line 675 "../src/game.vala"
		result = FALSE;
#line 675 "../src/game.vala"
		return result;
#line 4398 "game.c"
	}
#line 677 "../src/game.vala"
	_tmp3_ = self->priv->_current_state;
#line 677 "../src/game.vala"
	_tmp4_ = move;
#line 677 "../src/game.vala"
	_tmp5_ = game_state_object_new_copy_and_move (_tmp3_, &_tmp4_);
#line 677 "../src/game.vala"
	_tmp6_ = _tmp5_;
#line 677 "../src/game.vala"
	game_set_current_state (self, _tmp6_);
#line 677 "../src/game.vala"
	_g_object_unref0 (_tmp6_);
#line 678 "../src/game.vala"
	_tmp7_ = self->priv->undo_stack;
#line 678 "../src/game.vala"
	_tmp8_ = self->priv->_current_state;
#line 678 "../src/game.vala"
	g_list_store_append (_tmp7_, (GObject*) _tmp8_);
#line 679 "../src/game.vala"
	game_end_of_turn (self, FALSE, FALSE);
#line 680 "../src/game.vala"
	result = TRUE;
#line 680 "../src/game.vala"
	return result;
#line 4424 "game.c"
}

gboolean
game_pass (Game* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GameStateObject* _tmp2_;
	GameStateObject* _tmp3_;
	GameStateObject* _tmp4_;
	GListStore* _tmp5_;
	GameStateObject* _tmp6_;
#line 683 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 685 "../src/game.vala"
	_tmp0_ = game_get_current_player_can_move (self);
#line 685 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 685 "../src/game.vala"
	if (_tmp1_) {
#line 686 "../src/game.vala"
		result = FALSE;
#line 686 "../src/game.vala"
		return result;
#line 4450 "game.c"
	}
#line 688 "../src/game.vala"
	_tmp2_ = self->priv->_current_state;
#line 688 "../src/game.vala"
	_tmp3_ = game_state_object_new_copy_and_pass (_tmp2_);
#line 688 "../src/game.vala"
	_tmp4_ = _tmp3_;
#line 688 "../src/game.vala"
	game_set_current_state (self, _tmp4_);
#line 688 "../src/game.vala"
	_g_object_unref0 (_tmp4_);
#line 689 "../src/game.vala"
	_tmp5_ = self->priv->undo_stack;
#line 689 "../src/game.vala"
	_tmp6_ = self->priv->_current_state;
#line 689 "../src/game.vala"
	g_list_store_append (_tmp5_, (GObject*) _tmp6_);
#line 690 "../src/game.vala"
	game_end_of_turn (self, FALSE, TRUE);
#line 691 "../src/game.vala"
	result = TRUE;
#line 691 "../src/game.vala"
	return result;
#line 4474 "game.c"
}

static void
game_end_of_turn (Game* self,
                  gboolean undoing,
                  gboolean no_draw)
{
	GameStateObject* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 694 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 696 "../src/game.vala"
	game_update_possible_moves (self);
#line 697 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 697 "../src/game.vala"
	_tmp1_ = game_state_object_get_is_complete (_tmp0_);
#line 697 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 697 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_COMPLETENESS_UPDATED_SIGNAL], 0, _tmp2_);
#line 698 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_TURN_ENDED_SIGNAL], 0, undoing, no_draw);
#line 4499 "game.c"
}

void
game_undo (Game* self,
           guint8 count)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint undo_stack_n_items = 0U;
	GListStore* _tmp2_;
	GObject* tmp_current_state = NULL;
	GListStore* _tmp3_;
	GObject* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GObject* _tmp6_;
	GObject* _tmp8_;
	GListStore* _tmp9_;
	gboolean _tmp10_ = FALSE;
#line 705 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 705 "../src/game.vala"
	_vala_return_if_fail ((((gint) count) == 1) || (((gint) count) == 2), "count == 1 || count == 2");
#line 705 "../src/game.vala"
	_tmp0_ = game_get_number_of_moves (self);
#line 705 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 705 "../src/game.vala"
	_vala_return_if_fail (_tmp1_ >= count, "number_of_moves >= count");
#line 709 "../src/game.vala"
	_tmp2_ = self->priv->undo_stack;
#line 709 "../src/game.vala"
	undo_stack_n_items = g_list_model_get_n_items ((GListModel*) _tmp2_);
#line 710 "../src/game.vala"
	_tmp3_ = self->priv->undo_stack;
#line 710 "../src/game.vala"
	_tmp4_ = g_list_model_get_object ((GListModel*) _tmp3_, undo_stack_n_items - 2);
#line 710 "../src/game.vala"
	tmp_current_state = _tmp4_;
#line 711 "../src/game.vala"
	_tmp6_ = tmp_current_state;
#line 711 "../src/game.vala"
	if (_tmp6_ == NULL) {
#line 711 "../src/game.vala"
		_tmp5_ = TRUE;
#line 4544 "game.c"
	} else {
		GObject* _tmp7_;
#line 711 "../src/game.vala"
		_tmp7_ = tmp_current_state;
#line 711 "../src/game.vala"
		_tmp5_ = !IS_GAME_STATE_OBJECT (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, G_TYPE_OBJECT, GObject));
#line 4551 "game.c"
	}
#line 711 "../src/game.vala"
	if (_tmp5_) {
#line 712 "../src/game.vala"
		g_assert_not_reached ();
#line 4557 "game.c"
	}
#line 713 "../src/game.vala"
	_tmp8_ = tmp_current_state;
#line 713 "../src/game.vala"
	game_set_current_state (self, G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, G_TYPE_OBJECT, GObject), TYPE_GAME_STATE_OBJECT, GameStateObject));
#line 717 "../src/game.vala"
	_tmp9_ = self->priv->undo_stack;
#line 717 "../src/game.vala"
	g_list_store_remove (_tmp9_, undo_stack_n_items - 1);
#line 719 "../src/game.vala"
	if (((gint) count) == 1) {
#line 4569 "game.c"
		gboolean _tmp11_;
		gboolean _tmp12_;
#line 719 "../src/game.vala"
		_tmp11_ = game_get_current_player_can_move (self);
#line 719 "../src/game.vala"
		_tmp12_ = _tmp11_;
#line 719 "../src/game.vala"
		_tmp10_ = _tmp12_;
#line 4578 "game.c"
	} else {
#line 719 "../src/game.vala"
		_tmp10_ = FALSE;
#line 4582 "game.c"
	}
#line 719 "../src/game.vala"
	if (_tmp10_) {
#line 720 "../src/game.vala"
		game_end_of_turn (self, TRUE, FALSE);
#line 4588 "game.c"
	} else {
#line 721 "../src/game.vala"
		if (((gint) count) == 2) {
#line 723 "../src/game.vala"
			game_end_of_turn (self, TRUE, TRUE);
#line 724 "../src/game.vala"
			game_undo (self, (guint8) (count - 1));
#line 4596 "game.c"
		}
	}
#line 705 "../src/game.vala"
	_g_object_unref0 (tmp_current_state);
#line 4601 "game.c"
}

static guint8*
_vala_array_dup12 (guint8* self,
                   int length)
{
#line 736 "../src/game.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 4610 "game.c"
}

guint8*
game_copy_neighbor_tiles (Game* self,
                          gint* result_length1,
                          gint* result_length2)
{
	guint8* result = NULL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
#line 734 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 736 "../src/game.vala"
	_tmp0_ = self->priv->neighbor_tiles;
#line 736 "../src/game.vala"
	_tmp0__length1 = self->priv->neighbor_tiles_length1;
#line 736 "../src/game.vala"
	_tmp0__length2 = self->priv->neighbor_tiles_length2;
#line 736 "../src/game.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup12 (_tmp0_, _tmp0__length1 * _tmp0__length2) : ((gpointer) _tmp0_);
#line 736 "../src/game.vala"
	_tmp1__length1 = _tmp0__length1;
#line 736 "../src/game.vala"
	_tmp1__length2 = _tmp0__length2;
#line 736 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 736 "../src/game.vala"
	_tmp2__length1 = _tmp1__length1;
#line 736 "../src/game.vala"
	_tmp2__length2 = _tmp1__length2;
#line 736 "../src/game.vala"
	if (result_length1) {
#line 736 "../src/game.vala"
		*result_length1 = _tmp2__length1;
#line 4652 "game.c"
	}
#line 736 "../src/game.vala"
	if (result_length2) {
#line 736 "../src/game.vala"
		*result_length2 = _tmp2__length2;
#line 4658 "game.c"
	}
#line 736 "../src/game.vala"
	result = _tmp2_;
#line 736 "../src/game.vala"
	return result;
#line 4664 "game.c"
}

static void
game_init_neighbor_tiles (guint8 size,
                          guint8** neighbor_tiles,
                          gint* neighbor_tiles_length1,
                          gint* neighbor_tiles_length2)
{
	guint8* _vala_neighbor_tiles = NULL;
	gint _vala_neighbor_tiles_length1 = 0;
	gint _vala_neighbor_tiles_length2 = 0;
	guint8* _tmp0_;
	guint8 max = 0U;
	guint8* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	guint8* _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	guint8* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	guint8* _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
#line 741 "../src/game.vala"
	_tmp0_ = g_new0 (guint8, size * size);
#line 741 "../src/game.vala"
	_vala_neighbor_tiles = (g_free (_vala_neighbor_tiles), NULL);
#line 741 "../src/game.vala"
	_vala_neighbor_tiles = _tmp0_;
#line 741 "../src/game.vala"
	_vala_neighbor_tiles_length1 = size;
#line 741 "../src/game.vala"
	_vala_neighbor_tiles_length2 = size;
#line 742 "../src/game.vala"
	max = (guint8) (size - 1);
#line 4702 "game.c"
	{
		guint8 i = 0U;
#line 744 "../src/game.vala"
		i = (guint8) 1;
#line 4707 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 744 "../src/game.vala"
			_tmp1_ = TRUE;
#line 744 "../src/game.vala"
			while (TRUE) {
#line 4714 "game.c"
				guint8* _tmp3_;
				gint _tmp3__length1;
				gint _tmp3__length2;
				guint8* _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				guint8* _tmp5_;
				gint _tmp5__length1;
				gint _tmp5__length2;
				guint8* _tmp6_;
				gint _tmp6__length1;
				gint _tmp6__length2;
#line 744 "../src/game.vala"
				if (!_tmp1_) {
#line 4729 "game.c"
					guint8 _tmp2_;
#line 744 "../src/game.vala"
					_tmp2_ = i;
#line 744 "../src/game.vala"
					i = _tmp2_ + 1;
#line 4735 "game.c"
				}
#line 744 "../src/game.vala"
				_tmp1_ = FALSE;
#line 744 "../src/game.vala"
				if (!(i < max)) {
#line 744 "../src/game.vala"
					break;
#line 4743 "game.c"
				}
#line 747 "../src/game.vala"
				_tmp3_ = _vala_neighbor_tiles;
#line 747 "../src/game.vala"
				_tmp3__length1 = _vala_neighbor_tiles_length1;
#line 747 "../src/game.vala"
				_tmp3__length2 = _vala_neighbor_tiles_length2;
#line 747 "../src/game.vala"
				_tmp3_[(i * _tmp3__length2) + 0] = (guint8) 5;
#line 748 "../src/game.vala"
				_tmp4_ = _vala_neighbor_tiles;
#line 748 "../src/game.vala"
				_tmp4__length1 = _vala_neighbor_tiles_length1;
#line 748 "../src/game.vala"
				_tmp4__length2 = _vala_neighbor_tiles_length2;
#line 748 "../src/game.vala"
				_tmp4_[(i * _tmp4__length2) + max] = (guint8) 5;
#line 749 "../src/game.vala"
				_tmp5_ = _vala_neighbor_tiles;
#line 749 "../src/game.vala"
				_tmp5__length1 = _vala_neighbor_tiles_length1;
#line 749 "../src/game.vala"
				_tmp5__length2 = _vala_neighbor_tiles_length2;
#line 749 "../src/game.vala"
				_tmp5_[(0 * _tmp5__length2) + i] = (guint8) 5;
#line 750 "../src/game.vala"
				_tmp6_ = _vala_neighbor_tiles;
#line 750 "../src/game.vala"
				_tmp6__length1 = _vala_neighbor_tiles_length1;
#line 750 "../src/game.vala"
				_tmp6__length2 = _vala_neighbor_tiles_length2;
#line 750 "../src/game.vala"
				_tmp6_[(max * _tmp6__length2) + i] = (guint8) 5;
#line 4777 "game.c"
				{
					guint8 j = 0U;
#line 753 "../src/game.vala"
					j = (guint8) 1;
#line 4782 "game.c"
					{
						gboolean _tmp7_ = FALSE;
#line 753 "../src/game.vala"
						_tmp7_ = TRUE;
#line 753 "../src/game.vala"
						while (TRUE) {
#line 4789 "game.c"
							guint8* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
#line 753 "../src/game.vala"
							if (!_tmp7_) {
#line 4795 "game.c"
								guint8 _tmp8_;
#line 753 "../src/game.vala"
								_tmp8_ = j;
#line 753 "../src/game.vala"
								j = _tmp8_ + 1;
#line 4801 "game.c"
							}
#line 753 "../src/game.vala"
							_tmp7_ = FALSE;
#line 753 "../src/game.vala"
							if (!(j < max)) {
#line 753 "../src/game.vala"
								break;
#line 4809 "game.c"
							}
#line 754 "../src/game.vala"
							_tmp9_ = _vala_neighbor_tiles;
#line 754 "../src/game.vala"
							_tmp9__length1 = _vala_neighbor_tiles_length1;
#line 754 "../src/game.vala"
							_tmp9__length2 = _vala_neighbor_tiles_length2;
#line 754 "../src/game.vala"
							_tmp9_[(i * _tmp9__length2) + j] = (guint8) 8;
#line 4819 "game.c"
						}
					}
				}
			}
		}
	}
#line 758 "../src/game.vala"
	_tmp10_ = _vala_neighbor_tiles;
#line 758 "../src/game.vala"
	_tmp10__length1 = _vala_neighbor_tiles_length1;
#line 758 "../src/game.vala"
	_tmp10__length2 = _vala_neighbor_tiles_length2;
#line 758 "../src/game.vala"
	_tmp10_[(0 * _tmp10__length2) + 0] = (guint8) 3;
#line 759 "../src/game.vala"
	_tmp11_ = _vala_neighbor_tiles;
#line 759 "../src/game.vala"
	_tmp11__length1 = _vala_neighbor_tiles_length1;
#line 759 "../src/game.vala"
	_tmp11__length2 = _vala_neighbor_tiles_length2;
#line 759 "../src/game.vala"
	_tmp11_[(0 * _tmp11__length2) + max] = (guint8) 3;
#line 760 "../src/game.vala"
	_tmp12_ = _vala_neighbor_tiles;
#line 760 "../src/game.vala"
	_tmp12__length1 = _vala_neighbor_tiles_length1;
#line 760 "../src/game.vala"
	_tmp12__length2 = _vala_neighbor_tiles_length2;
#line 760 "../src/game.vala"
	_tmp12_[(max * _tmp12__length2) + max] = (guint8) 3;
#line 761 "../src/game.vala"
	_tmp13_ = _vala_neighbor_tiles;
#line 761 "../src/game.vala"
	_tmp13__length1 = _vala_neighbor_tiles_length1;
#line 761 "../src/game.vala"
	_tmp13__length2 = _vala_neighbor_tiles_length2;
#line 761 "../src/game.vala"
	_tmp13_[(max * _tmp13__length2) + 0] = (guint8) 3;
#line 739 "../src/game.vala"
	if (neighbor_tiles) {
#line 739 "../src/game.vala"
		*neighbor_tiles = _vala_neighbor_tiles;
#line 4862 "game.c"
	} else {
#line 739 "../src/game.vala"
		_vala_neighbor_tiles = (g_free (_vala_neighbor_tiles), NULL);
#line 4866 "game.c"
	}
#line 739 "../src/game.vala"
	if (neighbor_tiles_length1) {
#line 739 "../src/game.vala"
		*neighbor_tiles_length1 = _vala_neighbor_tiles_length1;
#line 4872 "game.c"
	}
#line 739 "../src/game.vala"
	if (neighbor_tiles_length2) {
#line 739 "../src/game.vala"
		*neighbor_tiles_length2 = _vala_neighbor_tiles_length2;
#line 4878 "game.c"
	}
}

gboolean
game_test_placing_tile (Game* self,
                        guint8 x,
                        guint8 y,
                        PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	gboolean result = FALSE;
	GSList* test_move = NULL;
	GSList* _tmp0_;
	GSList* _tmp1_;
#line 770 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 772 "../src/game.vala"
	_tmp0_ = self->priv->possible_moves;
#line 772 "../src/game.vala"
	_tmp1_ = g_slist_nth (_tmp0_, (guint) 0);
#line 772 "../src/game.vala"
	test_move = _tmp1_;
#line 773 "../src/game.vala"
	while (TRUE) {
#line 4903 "game.c"
		GSList* _tmp2_;
		GSList* _tmp3_;
		gconstpointer _tmp4_;
		gboolean _tmp5_ = FALSE;
		PossibleMove _tmp6_;
		GSList* _tmp8_;
		GSList* _tmp9_;
#line 773 "../src/game.vala"
		_tmp2_ = test_move;
#line 773 "../src/game.vala"
		if (!(_tmp2_ != NULL)) {
#line 773 "../src/game.vala"
			break;
#line 4917 "game.c"
		}
#line 775 "../src/game.vala"
		_tmp3_ = test_move;
#line 775 "../src/game.vala"
		_tmp4_ = ((GSList*) _tmp3_)->data;
#line 775 "../src/game.vala"
		_vala_move = (PossibleMove) (*((PossibleMove*) _tmp4_));
#line 776 "../src/game.vala"
		_tmp6_ = _vala_move;
#line 776 "../src/game.vala"
		if (_tmp6_.x == x) {
#line 4929 "game.c"
			PossibleMove _tmp7_;
#line 776 "../src/game.vala"
			_tmp7_ = _vala_move;
#line 776 "../src/game.vala"
			_tmp5_ = _tmp7_.y == y;
#line 4935 "game.c"
		} else {
#line 776 "../src/game.vala"
			_tmp5_ = FALSE;
#line 4939 "game.c"
		}
#line 776 "../src/game.vala"
		if (_tmp5_) {
#line 777 "../src/game.vala"
			result = TRUE;
#line 777 "../src/game.vala"
			if (move) {
#line 777 "../src/game.vala"
				*move = _vala_move;
#line 4949 "game.c"
			}
#line 777 "../src/game.vala"
			return result;
#line 4953 "game.c"
		}
#line 778 "../src/game.vala"
		_tmp8_ = test_move;
#line 778 "../src/game.vala"
		_tmp9_ = ((GSList*) _tmp8_)->next;
#line 778 "../src/game.vala"
		test_move = _tmp9_;
#line 4961 "game.c"
	}
#line 780 "../src/game.vala"
	result = FALSE;
#line 780 "../src/game.vala"
	if (move) {
#line 780 "../src/game.vala"
		*move = _vala_move;
#line 4969 "game.c"
	}
#line 780 "../src/game.vala"
	return result;
#line 4973 "game.c"
}

static PossibleMove*
__lambda15_ (Game* self,
             PossibleMove* a)
{
	PossibleMove* result = NULL;
	PossibleMove* _tmp0_;
#line 788 "../src/game.vala"
	_tmp0_ = _possible_move_dup0 (a);
#line 788 "../src/game.vala"
	result = _tmp0_;
#line 788 "../src/game.vala"
	return result;
#line 4988 "game.c"
}

static gpointer
___lambda15__gcopy_func (gconstpointer src,
                         gpointer self)
{
	gpointer result;
	result = __lambda15_ ((Game*) self, (PossibleMove*) src);
#line 785 "../src/game.vala"
	return result;
#line 4999 "game.c"
}

void
game_get_possible_moves (Game* self,
                         GSList* * moves)
{
	GSList* _vala_moves = NULL;
	GSList* _tmp0_;
	GSList* _tmp1_;
#line 783 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 785 "../src/game.vala"
	_tmp0_ = self->priv->possible_moves;
#line 785 "../src/game.vala"
	_tmp1_ = g_slist_copy_deep (_tmp0_, ___lambda15__gcopy_func, self);
#line 785 "../src/game.vala"
	(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 785 "../src/game.vala"
	_vala_moves = _tmp1_;
#line 783 "../src/game.vala"
	if (moves) {
#line 783 "../src/game.vala"
		*moves = _vala_moves;
#line 5023 "game.c"
	} else {
#line 783 "../src/game.vala"
		(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 5027 "game.c"
	}
}

static inline void
game_update_possible_moves (Game* self)
{
	GameStateObject* _tmp0_;
	GSList* _tmp1_ = NULL;
#line 792 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 794 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 794 "../src/game.vala"
	game_state_object_get_possible_moves (_tmp0_, &_tmp1_);
#line 794 "../src/game.vala"
	(self->priv->possible_moves == NULL) ? NULL : (self->priv->possible_moves = (_g_slist_free__possible_move_free0_ (self->priv->possible_moves), NULL));
#line 794 "../src/game.vala"
	self->priv->possible_moves = _tmp1_;
#line 5046 "game.c"
}

guint8
game_get_number_of_moves (Game* self)
{
	guint8 result;
	guint n_items = 0U;
	GListStore* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 541 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 543 "../src/game.vala"
	_tmp0_ = self->priv->undo_stack;
#line 543 "../src/game.vala"
	n_items = g_list_model_get_n_items ((GListModel*) _tmp0_);
#line 544 "../src/game.vala"
	if (n_items == ((guint) 0)) {
#line 544 "../src/game.vala"
		_tmp1_ = TRUE;
#line 5066 "game.c"
	} else {
#line 544 "../src/game.vala"
		_tmp1_ = n_items >= ((guint) 256);
#line 5070 "game.c"
	}
#line 544 "../src/game.vala"
	if (_tmp1_) {
#line 545 "../src/game.vala"
		g_assert_not_reached ();
#line 5076 "game.c"
	}
#line 546 "../src/game.vala"
	result = (guint8) (n_items - 1);
#line 546 "../src/game.vala"
	return result;
#line 5082 "game.c"
}

guint8
game_get_size (Game* self)
{
	guint8 result;
#line 557 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 557 "../src/game.vala"
	result = self->priv->_size;
#line 557 "../src/game.vala"
	return result;
#line 5095 "game.c"
}

static void
game_set_size (Game* self,
               guint8 value)
{
#line 557 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 557 "../src/game.vala"
	self->priv->_size = value;
#line 5106 "game.c"
}

GameStateObject*
game_get_current_state (Game* self)
{
	GameStateObject* result;
	GameStateObject* _tmp0_;
#line 558 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 558 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 558 "../src/game.vala"
	result = _tmp0_;
#line 558 "../src/game.vala"
	return result;
#line 5122 "game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 558 "../src/game.vala"
	return self ? g_object_ref (self) : NULL;
#line 5130 "game.c"
}

void
game_set_current_state (Game* self,
                        GameStateObject* value)
{
	GameStateObject* _tmp0_;
#line 558 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 558 "../src/game.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 558 "../src/game.vala"
	_g_object_unref0 (self->priv->_current_state);
#line 558 "../src/game.vala"
	self->priv->_current_state = _tmp0_;
#line 5146 "game.c"
}

gboolean
game_get_alternative_start (Game* self)
{
	gboolean result;
#line 559 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 559 "../src/game.vala"
	result = self->priv->_alternative_start;
#line 559 "../src/game.vala"
	return result;
#line 5159 "game.c"
}

static void
game_set_alternative_start (Game* self,
                            gboolean value)
{
#line 559 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 559 "../src/game.vala"
	self->priv->_alternative_start = value;
#line 5170 "game.c"
}

guint8
game_get_initial_number_of_tiles (Game* self)
{
	guint8 result;
#line 560 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 560 "../src/game.vala"
	result = self->priv->_initial_number_of_tiles;
#line 560 "../src/game.vala"
	return result;
#line 5183 "game.c"
}

static void
game_set_initial_number_of_tiles (Game* self,
                                  guint8 value)
{
#line 560 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 560 "../src/game.vala"
	self->priv->_initial_number_of_tiles = value;
#line 5194 "game.c"
}

gboolean
game_get_is_complete (Game* self)
{
	gboolean result;
	GameStateObject* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 656 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 656 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 656 "../src/game.vala"
	_tmp1_ = game_state_object_get_is_complete (_tmp0_);
#line 656 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 656 "../src/game.vala"
	result = _tmp2_;
#line 656 "../src/game.vala"
	return result;
#line 5216 "game.c"
}

guint8
game_get_n_light_tiles (Game* self)
{
	guint8 result;
	GameStateObject* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
#line 657 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 657 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 657 "../src/game.vala"
	_tmp1_ = game_state_object_get_n_light_tiles (_tmp0_);
#line 657 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 657 "../src/game.vala"
	result = _tmp2_;
#line 657 "../src/game.vala"
	return result;
#line 5238 "game.c"
}

guint8
game_get_n_dark_tiles (Game* self)
{
	guint8 result;
	GameStateObject* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
#line 658 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 658 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 658 "../src/game.vala"
	_tmp1_ = game_state_object_get_n_dark_tiles (_tmp0_);
#line 658 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 658 "../src/game.vala"
	result = _tmp2_;
#line 658 "../src/game.vala"
	return result;
#line 5260 "game.c"
}

gboolean
game_get_current_player_can_move (Game* self)
{
	gboolean result;
	GameStateObject* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 659 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 659 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 659 "../src/game.vala"
	_tmp1_ = game_state_object_get_current_player_can_move (_tmp0_);
#line 659 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 659 "../src/game.vala"
	result = _tmp2_;
#line 659 "../src/game.vala"
	return result;
#line 5282 "game.c"
}

Player
game_get_current_color (Game* self)
{
	Player result;
	GameStateObject* _tmp0_;
	Player _tmp1_;
	Player _tmp2_;
#line 660 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 660 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 660 "../src/game.vala"
	_tmp1_ = game_state_object_get_current_color (_tmp0_);
#line 660 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 660 "../src/game.vala"
	result = _tmp2_;
#line 660 "../src/game.vala"
	return result;
#line 5304 "game.c"
}

static void
g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOOLEAN_BOOLEAN) (gpointer data1, gboolean arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOOLEAN_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 536 "../src/game.vala"
	g_return_if_fail (n_param_values == 3);
#line 536 "../src/game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 536 "../src/game.vala"
		data1 = closure->data;
#line 536 "../src/game.vala"
		data2 = param_values->data[0].v_pointer;
#line 5329 "game.c"
	} else {
#line 536 "../src/game.vala"
		data1 = param_values->data[0].v_pointer;
#line 536 "../src/game.vala"
		data2 = closure->data;
#line 5335 "game.c"
	}
#line 536 "../src/game.vala"
	callback = (GMarshalFunc_VOID__BOOLEAN_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 536 "../src/game.vala"
	callback (data1, g_value_get_boolean (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 5341 "game.c"
}

static GObject *
game_constructor (GType type,
                  guint n_construct_properties,
                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Game * self;
	GListStore* _tmp0_;
	GameStateObject* _tmp1_;
#line 562 "../src/game.vala"
	parent_class = G_OBJECT_CLASS (game_parent_class);
#line 562 "../src/game.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 562 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 564 "../src/game.vala"
	_tmp0_ = self->priv->undo_stack;
#line 564 "../src/game.vala"
	_tmp1_ = self->priv->_current_state;
#line 564 "../src/game.vala"
	g_list_store_append (_tmp0_, (GObject*) _tmp1_);
#line 565 "../src/game.vala"
	game_update_possible_moves (self);
#line 562 "../src/game.vala"
	return obj;
#line 5370 "game.c"
}

static void
game_class_init (GameClass * klass,
                 gpointer klass_data)
{
#line 536 "../src/game.vala"
	game_parent_class = g_type_class_peek_parent (klass);
#line 536 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
#line 536 "../src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
#line 536 "../src/game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
#line 536 "../src/game.vala"
	G_OBJECT_CLASS (klass)->constructor = game_constructor;
#line 536 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
#line 536 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_NUMBER_OF_MOVES_PROPERTY, game_properties[GAME_NUMBER_OF_MOVES_PROPERTY] = g_param_spec_uchar ("number-of-moves", "number-of-moves", "number-of-moves", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 536 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SIZE_PROPERTY, game_properties[GAME_SIZE_PROPERTY] = g_param_spec_uchar ("size", "size", "size", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 536 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_STATE_PROPERTY, game_properties[GAME_CURRENT_STATE_PROPERTY] = g_param_spec_object ("current-state", "current-state", "current-state", TYPE_GAME_STATE_OBJECT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT | G_PARAM_EXPLICIT_NOTIFY));
#line 536 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_ALTERNATIVE_START_PROPERTY, game_properties[GAME_ALTERNATIVE_START_PROPERTY] = g_param_spec_boolean ("alternative-start", "alternative-start", "alternative-start", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 536 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_INITIAL_NUMBER_OF_TILES_PROPERTY, game_properties[GAME_INITIAL_NUMBER_OF_TILES_PROPERTY] = g_param_spec_uchar ("initial-number-of-tiles", "initial-number-of-tiles", "initial-number-of-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 536 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_IS_COMPLETE_PROPERTY, game_properties[GAME_IS_COMPLETE_PROPERTY] = g_param_spec_boolean ("is-complete", "is-complete", "is-complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 536 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_LIGHT_TILES_PROPERTY, game_properties[GAME_N_LIGHT_TILES_PROPERTY] = g_param_spec_uchar ("n-light-tiles", "n-light-tiles", "n-light-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 536 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_DARK_TILES_PROPERTY, game_properties[GAME_N_DARK_TILES_PROPERTY] = g_param_spec_uchar ("n-dark-tiles", "n-dark-tiles", "n-dark-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 536 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY, game_properties[GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY] = g_param_spec_boolean ("current-player-can-move", "current-player-can-move", "current-player-can-move", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 536 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_COLOR_PROPERTY, game_properties[GAME_CURRENT_COLOR_PROPERTY] = g_param_spec_enum ("current-color", "current-color", "current-color", TYPE_PLAYER, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 536 "../src/game.vala"
	game_signals[GAME_TURN_ENDED_SIGNAL] = g_signal_new ("turn-ended", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN);
#line 536 "../src/game.vala"
	game_signals[GAME_COMPLETENESS_UPDATED_SIGNAL] = g_signal_new ("completeness-updated", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 5413 "game.c"
}

static void
game_instance_init (Game * self,
                    gpointer klass)
{
	GListStore* _tmp0_;
#line 536 "../src/game.vala"
	self->priv = game_get_instance_private (self);
#line 538 "../src/game.vala"
	_tmp0_ = g_list_store_new (TYPE_GAME_STATE_OBJECT);
#line 538 "../src/game.vala"
	self->priv->undo_stack = _tmp0_;
#line 5427 "game.c"
}

static void
game_finalize (GObject * obj)
{
	Game * self;
#line 536 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 538 "../src/game.vala"
	_g_object_unref0 (self->priv->undo_stack);
#line 558 "../src/game.vala"
	_g_object_unref0 (self->priv->_current_state);
#line 732 "../src/game.vala"
	self->priv->neighbor_tiles = (g_free (self->priv->neighbor_tiles), NULL);
#line 768 "../src/game.vala"
	(self->priv->possible_moves == NULL) ? NULL : (self->priv->possible_moves = (_g_slist_free__possible_move_free0_ (self->priv->possible_moves), NULL));
#line 536 "../src/game.vala"
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
#line 5446 "game.c"
}

GType
game_get_type (void)
{
	static volatile gsize game_type_id__volatile = 0;
	if (g_once_init_enter (&game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
		GType game_type_id;
		game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
		Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
		g_once_init_leave (&game_type_id__volatile, game_type_id);
	}
	return game_type_id__volatile;
}

static void
_vala_game_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 536 "../src/game.vala"
	switch (property_id) {
#line 536 "../src/game.vala"
		case GAME_NUMBER_OF_MOVES_PROPERTY:
#line 536 "../src/game.vala"
		g_value_set_uchar (value, game_get_number_of_moves (self));
#line 536 "../src/game.vala"
		break;
#line 536 "../src/game.vala"
		case GAME_SIZE_PROPERTY:
#line 536 "../src/game.vala"
		g_value_set_uchar (value, game_get_size (self));
#line 536 "../src/game.vala"
		break;
#line 536 "../src/game.vala"
		case GAME_CURRENT_STATE_PROPERTY:
#line 536 "../src/game.vala"
		g_value_set_object (value, game_get_current_state (self));
#line 536 "../src/game.vala"
		break;
#line 536 "../src/game.vala"
		case GAME_ALTERNATIVE_START_PROPERTY:
#line 536 "../src/game.vala"
		g_value_set_boolean (value, game_get_alternative_start (self));
#line 536 "../src/game.vala"
		break;
#line 536 "../src/game.vala"
		case GAME_INITIAL_NUMBER_OF_TILES_PROPERTY:
#line 536 "../src/game.vala"
		g_value_set_uchar (value, game_get_initial_number_of_tiles (self));
#line 536 "../src/game.vala"
		break;
#line 536 "../src/game.vala"
		case GAME_IS_COMPLETE_PROPERTY:
#line 536 "../src/game.vala"
		g_value_set_boolean (value, game_get_is_complete (self));
#line 536 "../src/game.vala"
		break;
#line 536 "../src/game.vala"
		case GAME_N_LIGHT_TILES_PROPERTY:
#line 536 "../src/game.vala"
		g_value_set_uchar (value, game_get_n_light_tiles (self));
#line 536 "../src/game.vala"
		break;
#line 536 "../src/game.vala"
		case GAME_N_DARK_TILES_PROPERTY:
#line 536 "../src/game.vala"
		g_value_set_uchar (value, game_get_n_dark_tiles (self));
#line 536 "../src/game.vala"
		break;
#line 536 "../src/game.vala"
		case GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY:
#line 536 "../src/game.vala"
		g_value_set_boolean (value, game_get_current_player_can_move (self));
#line 536 "../src/game.vala"
		break;
#line 536 "../src/game.vala"
		case GAME_CURRENT_COLOR_PROPERTY:
#line 536 "../src/game.vala"
		g_value_set_enum (value, game_get_current_color (self));
#line 536 "../src/game.vala"
		break;
#line 5533 "game.c"
		default:
#line 536 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 536 "../src/game.vala"
		break;
#line 5539 "game.c"
	}
}

static void
_vala_game_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 536 "../src/game.vala"
	switch (property_id) {
#line 536 "../src/game.vala"
		case GAME_SIZE_PROPERTY:
#line 536 "../src/game.vala"
		game_set_size (self, g_value_get_uchar (value));
#line 536 "../src/game.vala"
		break;
#line 536 "../src/game.vala"
		case GAME_CURRENT_STATE_PROPERTY:
#line 536 "../src/game.vala"
		game_set_current_state (self, g_value_get_object (value));
#line 536 "../src/game.vala"
		break;
#line 536 "../src/game.vala"
		case GAME_ALTERNATIVE_START_PROPERTY:
#line 536 "../src/game.vala"
		game_set_alternative_start (self, g_value_get_boolean (value));
#line 536 "../src/game.vala"
		break;
#line 536 "../src/game.vala"
		case GAME_INITIAL_NUMBER_OF_TILES_PROPERTY:
#line 536 "../src/game.vala"
		game_set_initial_number_of_tiles (self, g_value_get_uchar (value));
#line 536 "../src/game.vala"
		break;
#line 5577 "game.c"
		default:
#line 536 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 536 "../src/game.vala"
		break;
#line 5583 "game.c"
	}
}

