/* reversi-view.c generated by valac 0.45.91, the Vala compiler
 * generated from reversi-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2010-2013 Robert Ancell
   Copyright 2013-2014 Michael Catanzaro
   Copyright 2014-2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <librsvg/rsvg.h>

#define TYPE_REVERSI_VIEW (reversi_view_get_type ())
#define REVERSI_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_REVERSI_VIEW, ReversiView))
#define REVERSI_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_REVERSI_VIEW, ReversiViewClass))
#define IS_REVERSI_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_REVERSI_VIEW))
#define IS_REVERSI_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_REVERSI_VIEW))
#define REVERSI_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_REVERSI_VIEW, ReversiViewClass))

typedef struct _ReversiView ReversiView;
typedef struct _ReversiViewClass ReversiViewClass;
typedef struct _ReversiViewPrivate ReversiViewPrivate;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;

#define TYPE_IAGNO (iagno_get_type ())
#define IAGNO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IAGNO, Iagno))
#define IAGNO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IAGNO, IagnoClass))
#define IS_IAGNO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IAGNO))
#define IS_IAGNO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IAGNO))
#define IAGNO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IAGNO, IagnoClass))

typedef struct _Iagno Iagno;
typedef struct _IagnoClass IagnoClass;

#define TYPE_GAME_STATE_OBJECT (game_state_object_get_type ())
#define GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_STATE_OBJECT, GameStateObject))
#define GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))
#define IS_GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_STATE_OBJECT))
#define IS_GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_STATE_OBJECT))
#define GAME_STATE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))

typedef struct _GameStateObject GameStateObject;
typedef struct _GameStateObjectClass GameStateObjectClass;
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())
enum  {
	REVERSI_VIEW_0_PROPERTY,
	REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY,
	REVERSI_VIEW_SOUND_FLIP_PROPERTY,
	REVERSI_VIEW_SOUND_GAMEOVER_PROPERTY,
	REVERSI_VIEW_GAME_PROPERTY,
	REVERSI_VIEW_THEME_PROPERTY,
	REVERSI_VIEW_NUM_PROPERTIES
};
static GParamSpec* reversi_view_properties[REVERSI_VIEW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

#define TYPE_COMPUTER_PLAYER (computer_player_get_type ())
#define COMPUTER_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPUTER_PLAYER, ComputerPlayer))
#define COMPUTER_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPUTER_PLAYER, ComputerPlayerClass))
#define IS_COMPUTER_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPUTER_PLAYER))
#define IS_COMPUTER_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPUTER_PLAYER))
#define COMPUTER_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPUTER_PLAYER, ComputerPlayerClass))

typedef struct _ComputerPlayer ComputerPlayer;
typedef struct _ComputerPlayerClass ComputerPlayerClass;

#define TYPE_POSSIBLE_MOVE (possible_move_get_type ())
typedef struct _PossibleMove PossibleMove;
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
enum  {
	REVERSI_VIEW_MOVE_SIGNAL,
	REVERSI_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL,
	REVERSI_VIEW_NOTIFY_FINAL_ANIMATION_SIGNAL,
	REVERSI_VIEW_NUM_SIGNALS
};
static guint reversi_view_signals[REVERSI_VIEW_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ReversiView {
	GtkDrawingArea parent_instance;
	ReversiViewPrivate * priv;
};

struct _ReversiViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _ReversiViewPrivate {
	gboolean _show_turnable_tiles;
	gchar* pieces_file;
	gdouble background_red;
	gdouble background_green;
	gdouble background_blue;
	gint background_radius;
	gdouble texture_alpha;
	gboolean apply_texture;
	gdouble mark_red;
	gdouble mark_green;
	gdouble mark_blue;
	gint mark_width;
	gdouble border_red;
	gdouble border_green;
	gdouble border_blue;
	gint border_width;
	gdouble half_border_width;
	gdouble spacing_red;
	gdouble spacing_green;
	gdouble spacing_blue;
	gint spacing_width;
	gdouble highlight_hard_red;
	gdouble highlight_hard_green;
	gdouble highlight_hard_blue;
	gdouble highlight_hard_alpha;
	gdouble highlight_soft_red;
	gdouble highlight_soft_green;
	gdouble highlight_soft_blue;
	gdouble highlight_soft_alpha;
	gchar* _sound_flip;
	gchar* _sound_gameover;
	gint board_x;
	gint board_y;
	gboolean show_highlight;
	gboolean highlight_set;
	guint8 highlight_x;
	guint8 highlight_y;
	guint8 old_highlight_x;
	guint8 old_highlight_y;
	guint8 highlight_state;
	gboolean show_mouse_highlight;
	gboolean mouse_position_set;
	guint8 mouse_highlight_x;
	guint8 mouse_highlight_y;
	guint8 mouse_position_x;
	guint8 mouse_position_y;
	guint render_size;
	cairo_pattern_t* tiles_pattern;
	cairo_pattern_t* board_pattern;
	gboolean noise_pixbuf_loaded;
	gint* pixmaps;
	gint pixmaps_length1;
	gint pixmaps_length2;
	guint animate_timeout;
	gboolean game_is_set;
	guint8 game_size;
	Game* _game;
	Iagno* iagno_instance;
	gchar* _theme;
	gint paving_size;
	gint tile_size;
	gint board_size;
	gint* tile_xs;
	gint tile_xs_length1;
	gint tile_xs_length2;
	gint* tile_ys;
	gint tile_ys_length1;
	gint tile_ys_length2;
	gboolean last_state_set;
	GameStateObject* last_state;
	gboolean flip_final_result_now;
	Player winning_color;
	gint n_winning_tiles;
	Player losing_color;
	gint n_losing_tiles;
	GtkEventControllerMotion* motion_controller;
	gboolean mouse_is_in;
	guint timeout_id;
	guint8 playable_tiles_highlight_state;
	gboolean* possible_moves;
	gint possible_moves_length1;
	gint possible_moves_length2;
};

struct _PossibleMove {
	guint8 x;
	guint8 y;
	guint8 n_tiles;
	guint8 n_tiles_n;
	guint8 n_tiles_ne;
	guint8 n_tiles_e;
	guint8 n_tiles_se;
	guint8 n_tiles_s;
	guint8 n_tiles_so;
	guint8 n_tiles_o;
	guint8 n_tiles_no;
};

struct _Block7Data {
	int _ref_count_;
	ReversiView* self;
	gboolean is_final_animation;
};

struct _Block8Data {
	int _ref_count_;
	ReversiView* self;
	guint8 x;
	guint8 y;
};

static gint ReversiView_private_offset;
static gpointer reversi_view_parent_class = NULL;

GType reversi_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ReversiView, g_object_unref)
GType game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
GType iagno_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Iagno, g_object_unref)
GType game_state_object_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameStateObject, g_object_unref)
GType player_get_type (void) G_GNUC_CONST;
#define REVERSI_VIEW_HIGHLIGHT_MAX ((guint8) 5)
#define REVERSI_VIEW_PIXMAP_FLIP_DELAY 20
#define REVERSI_VIEW_HALF_PI G_PI_2
ReversiView* reversi_view_new (Iagno* iagno_instance);
ReversiView* reversi_view_construct (GType object_type,
                                     Iagno* iagno_instance);
void reversi_view_theme_changed (ReversiView* self);
const gchar* reversi_view_get_theme (ReversiView* self);
void reversi_view_set_theme (ReversiView* self,
                             const gchar* value);
static void reversi_view_set_default_theme (ReversiView* self,
                                     GKeyFile* * key);
static void reversi_view_load_theme (ReversiView* self,
                              GKeyFile* key);
static void reversi_view_set_sound_flip (ReversiView* self,
                                  const gchar* value);
static void reversi_view_set_sound_gameover (ReversiView* self,
                                      const gchar* value);
static inline void reversi_view_calculate (ReversiView* self);
static gboolean reversi_view_real_draw (GtkWidget* base,
                                 cairo_t* cr);
static inline void reversi_view_init_patterns (ReversiView* self,
                                 cairo_t* cr);
static inline void reversi_view_draw_highlight (ReversiView* self,
                                  cairo_t* cr);
static inline void reversi_view_add_highlights (ReversiView* self,
                                  cairo_t* cr);
static inline void reversi_view_draw_playables (ReversiView* self,
                                  cairo_t* cr);
static void reversi_view_load_image (ReversiView* self,
                              cairo_t* c,
                              gint width,
                              gint height);
static inline void reversi_view_draw_board_background (ReversiView* self,
                                         cairo_t* cr);
static inline void reversi_view_draw_tiles_background (ReversiView* self,
                                         cairo_t* cr,
                                         cairo_pattern_t* * noise_pattern);
static inline void reversi_view_draw_tile_background (ReversiView* self,
                                        cairo_t* cr,
                                        cairo_pattern_t* * noise_pattern,
                                        gint tile_x,
                                        gint tile_y);
static void reversi_view_rounded_square (ReversiView* self,
                                  cairo_t* cr,
                                  gdouble x,
                                  gdouble y,
                                  gint size,
                                  gdouble width,
                                  gdouble radius_percent);
Game* reversi_view_get_game (ReversiView* self);
gboolean game_get_is_complete (Game* self);
Player iagno_get_player_one (Iagno* self);
Player game_get_current_color (Game* self);
GType computer_player_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ComputerPlayer, g_object_unref)
ComputerPlayer* iagno_get_computer (Iagno* self);
static inline void reversi_view_draw_tile_highlight (ReversiView* self,
                                       cairo_t* cr,
                                       guint8 x,
                                       guint8 y);
GType possible_move_get_type (void) G_GNUC_CONST;
PossibleMove* possible_move_dup (const PossibleMove* self);
void possible_move_free (PossibleMove* self);
gboolean game_test_placing_tile (Game* self,
                                 guint8 x,
                                 guint8 y,
                                 PossibleMove* move);
static void reversi_view_queue_draw_tile (ReversiView* self,
                                   guint8 x,
                                   guint8 y);
static void reversi_view_highlight_tile (ReversiView* self,
                                  cairo_t* cr,
                                  guint8 x,
                                  guint8 y,
                                  guint8 intensity,
                                  gboolean soft_highlight);
static gboolean reversi_view_get_show_turnable_tiles (ReversiView* self);
static inline void reversi_view_highlight_turnable_tiles (ReversiView* self,
                                            cairo_t* cr,
                                            guint8 x,
                                            guint8 y,
                                            gint8 x_step,
                                            gint8 y_step,
                                            guint8 count);
static void reversi_view_init_possible_moves (ReversiView* self);
static inline void reversi_view_add_highlight (ReversiView* self,
                                 cairo_t* cr,
                                 guint8 x,
                                 guint8 y,
                                 guint8 intensity);
static inline void reversi_view_draw_playable (ReversiView* self,
                                 cairo_t* cr,
                                 gint pixmap,
                                 gint tile_x,
                                 gint tile_y);
static inline void reversi_view_update_highlight_after_undo (ReversiView* self);
static void reversi_view_get_missing_tile (ReversiView* self,
                                    guint8* x,
                                    guint8* y);
static void reversi_view_set_square (ReversiView* self,
                              guint8 x,
                              guint8 y,
                              gint pixmap,
                              gboolean is_final_animation,
                              gboolean force_redraw);
static gint reversi_view_get_pixmap (Player color);
Player game_get_owner (Game* self,
                       guint8 x,
                       guint8 y);
Player game_state_object_get_owner (GameStateObject* self,
                                    guint8 x,
                                    guint8 y);
static void reversi_view_turn_ended_cb (ReversiView* self,
                                 gboolean undoing,
                                 gboolean no_draw);
static inline void reversi_view_update_squares (ReversiView* self);
GameStateObject* game_get_current_state (Game* self);
static inline void reversi_view_update_square (ReversiView* self,
                                 guint8 x,
                                 guint8 y);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static gboolean ____lambda17_ (Block7Data* _data7_);
static void reversi_view_flip_final_result_tile (ReversiView* self,
                                          guint8 x,
                                          guint8 y);
static void _reversi_view_on_motion (ReversiView* self,
                              guint8 x,
                              guint8 y,
                              gboolean force_redraw);
static gboolean _____lambda17__gsource_func (gpointer self);
static void reversi_view_game_is_complete_cb (ReversiView* self);
guint8 game_get_n_light_tiles (Game* self);
guint8 game_get_n_dark_tiles (Game* self);
static gboolean ___lambda16_ (ReversiView* self);
static void reversi_view_set_winner_and_loser_variables (ReversiView* self);
static gboolean ____lambda16__gsource_func (gpointer self);
gboolean reversi_view_undo_final_animation (ReversiView* self);
static void reversi_view_init_mouse (ReversiView* self);
static void reversi_view_on_motion (ReversiView* self,
                             GtkEventControllerMotion* _motion_controller,
                             gdouble event_x,
                             gdouble event_y);
static void _reversi_view_on_motion_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
static gboolean reversi_view_real_enter_notify_event (GtkWidget* base,
                                               GdkEventCrossing* event);
static gboolean reversi_view_pointer_is_in_board (ReversiView* self,
                                           gdouble pos_x,
                                           gdouble pos_y,
                                           guint8* x,
                                           guint8* y);
static void reversi_view_on_cursor_moving_in (ReversiView* self,
                                       guint8 x,
                                       guint8 y);
static gboolean reversi_view_real_leave_notify_event (GtkWidget* base,
                                               GdkEventCrossing* event);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static gboolean ______lambda18_ (Block8Data* _data8_);
static gboolean _______lambda18__gsource_func (gpointer self);
static gboolean reversi_view_real_button_press_event (GtkWidget* base,
                                               GdkEventButton* event);
static inline void reversi_view_move_if_possible (ReversiView* self,
                                    guint8 x,
                                    guint8 y);
static gboolean reversi_view_real_key_press_event (GtkWidget* base,
                                            GdkEventKey* event);
static inline void reversi_view_highlight_playable_tiles (ReversiView* self);
void game_get_possible_moves (Game* self,
                              GSList* * moves);
static void _possible_move_free0_ (gpointer var);
static inline void _g_slist_free__possible_move_free0_ (GSList* self);
static void __lambda19_ (ReversiView* self,
                  PossibleMove* move);
static void ___lambda19__gfunc (gconstpointer data,
                         gpointer self);
void reversi_view_set_show_turnable_tiles (ReversiView* self,
                                           gboolean value);
const gchar* reversi_view_get_sound_flip (ReversiView* self);
const gchar* reversi_view_get_sound_gameover (ReversiView* self);
void reversi_view_set_game (ReversiView* self,
                            Game* value);
guint8 game_get_size (Game* self);
static void _reversi_view_game_is_complete_cb_game_completeness_updated (Game* _sender,
                                                                  gboolean completeness,
                                                                  gpointer self);
static void _reversi_view_turn_ended_cb_game_turn_ended (Game* _sender,
                                                  gboolean undoing,
                                                  gboolean no_draw,
                                                  gpointer self);
gboolean game_get_alternative_start (Game* self);
static void g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static GObject * reversi_view_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void reversi_view_finalize (GObject * obj);
static void _vala_reversi_view_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_reversi_view_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
reversi_view_get_instance_private (ReversiView* self)
{
	return G_STRUCT_MEMBER_P (self, ReversiView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 169 "../src/reversi-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 488 "reversi-view.c"
}

ReversiView*
reversi_view_construct (GType object_type,
                        Iagno* iagno_instance)
{
	ReversiView * self = NULL;
	Iagno* _tmp0_;
#line 167 "../src/reversi-view.vala"
	g_return_val_if_fail (iagno_instance != NULL, NULL);
#line 167 "../src/reversi-view.vala"
	self = (ReversiView*) g_object_new (object_type, NULL);
#line 169 "../src/reversi-view.vala"
	_tmp0_ = _g_object_ref0 (iagno_instance);
#line 169 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->iagno_instance);
#line 169 "../src/reversi-view.vala"
	self->priv->iagno_instance = _tmp0_;
#line 167 "../src/reversi-view.vala"
	return self;
#line 509 "reversi-view.c"
}

ReversiView*
reversi_view_new (Iagno* iagno_instance)
{
#line 167 "../src/reversi-view.vala"
	return reversi_view_construct (TYPE_REVERSI_VIEW, iagno_instance);
#line 517 "reversi-view.c"
}

void
reversi_view_theme_changed (ReversiView* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 176 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 178 "../src/reversi-view.vala"
	_tmp1_ = reversi_view_get_theme (self);
#line 178 "../src/reversi-view.vala"
	_tmp2_ = _tmp1_;
#line 178 "../src/reversi-view.vala"
	if (_tmp2_ == NULL) {
#line 178 "../src/reversi-view.vala"
		_tmp0_ = TRUE;
#line 536 "reversi-view.c"
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 178 "../src/reversi-view.vala"
		_tmp3_ = reversi_view_get_theme (self);
#line 178 "../src/reversi-view.vala"
		_tmp4_ = _tmp3_;
#line 178 "../src/reversi-view.vala"
		_tmp0_ = g_strcmp0 ((const gchar*) _tmp4_, "default") == 0;
#line 546 "reversi-view.c"
	}
#line 178 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 179 "../src/reversi-view.vala"
		reversi_view_set_theme (self, "default");
#line 552 "reversi-view.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 572 "reversi-view.c"
}

static void
reversi_view_set_default_theme (ReversiView* self,
                                GKeyFile* * key)
{
	GtkSettings* defaults = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	gchar* filename = NULL;
	gboolean _tmp2_ = FALSE;
	GtkSettings* _tmp3_;
	gchar* filepath = NULL;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	GError* _inner_error0_ = NULL;
#line 216 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 216 "../src/reversi-view.vala"
	g_return_if_fail (*key != NULL);
#line 218 "../src/reversi-view.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 218 "../src/reversi-view.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 218 "../src/reversi-view.vala"
	defaults = _tmp1_;
#line 221 "../src/reversi-view.vala"
	_tmp3_ = defaults;
#line 221 "../src/reversi-view.vala"
	if (_tmp3_ != NULL) {
#line 603 "reversi-view.c"
		GtkSettings* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 221 "../src/reversi-view.vala"
		_tmp4_ = defaults;
#line 221 "../src/reversi-view.vala"
		g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_settings_get_type (), GtkSettings), "gtk-theme-name", &_tmp5_, NULL);
#line 221 "../src/reversi-view.vala"
		_tmp6_ = _tmp5_;
#line 221 "../src/reversi-view.vala"
		_tmp7_ = _tmp6_;
#line 221 "../src/reversi-view.vala"
		_tmp2_ = string_contains (_tmp7_, "HighContrast");
#line 221 "../src/reversi-view.vala"
		_g_free0 (_tmp7_);
#line 620 "reversi-view.c"
	} else {
#line 221 "../src/reversi-view.vala"
		_tmp2_ = FALSE;
#line 624 "reversi-view.c"
	}
#line 221 "../src/reversi-view.vala"
	if (_tmp2_) {
#line 628 "reversi-view.c"
		gchar* _tmp8_;
#line 222 "../src/reversi-view.vala"
		_tmp8_ = g_strdup ("high_contrast.theme");
#line 222 "../src/reversi-view.vala"
		_g_free0 (filename);
#line 222 "../src/reversi-view.vala"
		filename = _tmp8_;
#line 636 "reversi-view.c"
	} else {
		gboolean _tmp9_ = FALSE;
		GtkSettings* _tmp10_;
#line 223 "../src/reversi-view.vala"
		_tmp10_ = defaults;
#line 223 "../src/reversi-view.vala"
		if (_tmp10_ != NULL) {
#line 644 "reversi-view.c"
			gboolean _tmp11_ = FALSE;
			GtkSettings* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 223 "../src/reversi-view.vala"
			_tmp12_ = defaults;
#line 223 "../src/reversi-view.vala"
			g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_settings_get_type (), GtkSettings), "gtk-application-prefer-dark-theme", &_tmp13_, NULL);
#line 223 "../src/reversi-view.vala"
			_tmp14_ = _tmp13_;
#line 223 "../src/reversi-view.vala"
			if (_tmp14_ == TRUE) {
#line 223 "../src/reversi-view.vala"
				_tmp11_ = TRUE;
#line 659 "reversi-view.c"
			} else {
				GtkSettings* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
#line 224 "../src/reversi-view.vala"
				_tmp15_ = defaults;
#line 224 "../src/reversi-view.vala"
				g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_settings_get_type (), GtkSettings), "gtk-theme-name", &_tmp16_, NULL);
#line 224 "../src/reversi-view.vala"
				_tmp17_ = _tmp16_;
#line 224 "../src/reversi-view.vala"
				_tmp18_ = _tmp17_;
#line 224 "../src/reversi-view.vala"
				_tmp11_ = g_strcmp0 (_tmp18_, "Adwaita-dark") == 0;
#line 224 "../src/reversi-view.vala"
				_g_free0 (_tmp18_);
#line 677 "reversi-view.c"
			}
#line 223 "../src/reversi-view.vala"
			_tmp9_ = _tmp11_;
#line 681 "reversi-view.c"
		} else {
#line 223 "../src/reversi-view.vala"
			_tmp9_ = FALSE;
#line 685 "reversi-view.c"
		}
#line 223 "../src/reversi-view.vala"
		if (_tmp9_) {
#line 689 "reversi-view.c"
			gchar* _tmp19_;
#line 225 "../src/reversi-view.vala"
			_tmp19_ = g_strdup ("adwaita.theme");
#line 225 "../src/reversi-view.vala"
			_g_free0 (filename);
#line 225 "../src/reversi-view.vala"
			filename = _tmp19_;
#line 697 "reversi-view.c"
		} else {
			gchar* _tmp20_;
#line 227 "../src/reversi-view.vala"
			_tmp20_ = g_strdup ("classic.theme");
#line 227 "../src/reversi-view.vala"
			_g_free0 (filename);
#line 227 "../src/reversi-view.vala"
			filename = _tmp20_;
#line 706 "reversi-view.c"
		}
	}
#line 229 "../src/reversi-view.vala"
	_tmp21_ = filename;
#line 229 "../src/reversi-view.vala"
	_tmp22_ = g_build_filename (DATA_DIRECTORY, "themes", "key", _tmp21_, NULL);
#line 229 "../src/reversi-view.vala"
	filepath = _tmp22_;
#line 715 "reversi-view.c"
	{
#line 232 "../src/reversi-view.vala"
		g_key_file_load_from_file (*key, filepath, G_KEY_FILE_NONE, &_inner_error0_);
#line 232 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 721 "reversi-view.c"
			goto __catch7_g_error;
		}
	}
	goto __finally7;
	__catch7_g_error:
	{
#line 230 "../src/reversi-view.vala"
		g_clear_error (&_inner_error0_);
#line 230 "../src/reversi-view.vala"
		_inner_error0_ = NULL;
#line 234 "../src/reversi-view.vala"
		g_assert_not_reached ();
#line 734 "reversi-view.c"
	}
	__finally7:
#line 230 "../src/reversi-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 230 "../src/reversi-view.vala"
		_g_free0 (filepath);
#line 230 "../src/reversi-view.vala"
		_g_free0 (filename);
#line 230 "../src/reversi-view.vala"
		_g_object_unref0 (defaults);
#line 230 "../src/reversi-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 230 "../src/reversi-view.vala"
		g_clear_error (&_inner_error0_);
#line 230 "../src/reversi-view.vala"
		return;
#line 751 "reversi-view.c"
	}
#line 216 "../src/reversi-view.vala"
	_g_free0 (filepath);
#line 216 "../src/reversi-view.vala"
	_g_free0 (filename);
#line 216 "../src/reversi-view.vala"
	_g_object_unref0 (defaults);
#line 759 "reversi-view.c"
}

static void
reversi_view_load_theme (ReversiView* self,
                         GKeyFile* key)
{
	GError* _inner_error0_ = NULL;
#line 237 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/reversi-view.vala"
	g_return_if_fail (key != NULL);
#line 771 "reversi-view.c"
	{
		gchar* svg_path = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gboolean _tmp9_;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		gint _tmp15_ = 0;
		gdouble _tmp16_ = 0.0;
		gboolean _tmp17_ = FALSE;
		gdouble _tmp18_ = 0.0;
		gdouble _tmp19_ = 0.0;
		gdouble _tmp20_ = 0.0;
		gint _tmp21_ = 0;
		gdouble _tmp22_ = 0.0;
		gdouble _tmp23_ = 0.0;
		gdouble _tmp24_ = 0.0;
		gint _tmp25_ = 0;
		gdouble _tmp26_ = 0.0;
		gdouble _tmp27_ = 0.0;
		gdouble _tmp28_ = 0.0;
		gint _tmp29_ = 0;
		gdouble _tmp30_ = 0.0;
		gdouble _tmp31_ = 0.0;
		gdouble _tmp32_ = 0.0;
		gdouble _tmp33_ = 0.0;
		gdouble _tmp34_ = 0.0;
		gdouble _tmp35_ = 0.0;
		gdouble _tmp36_ = 0.0;
		gdouble _tmp37_ = 0.0;
		gchar* _tmp38_ = NULL;
		gchar* _tmp39_;
		gchar* _tmp40_ = NULL;
		gchar* _tmp41_;
#line 241 "../src/reversi-view.vala"
		_tmp0_ = g_build_filename (DATA_DIRECTORY, "themes", "svg", NULL);
#line 241 "../src/reversi-view.vala"
		svg_path = _tmp0_;
#line 242 "../src/reversi-view.vala"
		_tmp2_ = g_key_file_get_string (key, "Pieces", "File", &_inner_error0_);
#line 242 "../src/reversi-view.vala"
		_tmp1_ = _tmp2_;
#line 242 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 242 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 242 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 828 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 242 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 242 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 242 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 242 "../src/reversi-view.vala"
			return;
#line 839 "reversi-view.c"
		}
#line 242 "../src/reversi-view.vala"
		_tmp3_ = svg_path;
#line 242 "../src/reversi-view.vala"
		_tmp4_ = g_build_filename (_tmp3_, _tmp1_, NULL);
#line 242 "../src/reversi-view.vala"
		_g_free0 (self->priv->pieces_file);
#line 242 "../src/reversi-view.vala"
		self->priv->pieces_file = _tmp4_;
#line 243 "../src/reversi-view.vala"
		_tmp5_ = self->priv->pieces_file;
#line 243 "../src/reversi-view.vala"
		_tmp6_ = g_path_get_dirname (_tmp5_);
#line 243 "../src/reversi-view.vala"
		_tmp7_ = _tmp6_;
#line 243 "../src/reversi-view.vala"
		_tmp8_ = svg_path;
#line 243 "../src/reversi-view.vala"
		_tmp9_ = g_strcmp0 (_tmp7_, _tmp8_) != 0;
#line 243 "../src/reversi-view.vala"
		_g_free0 (_tmp7_);
#line 243 "../src/reversi-view.vala"
		if (_tmp9_) {
#line 863 "reversi-view.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 244 "../src/reversi-view.vala"
			_tmp10_ = svg_path;
#line 244 "../src/reversi-view.vala"
			_tmp11_ = g_build_filename (_tmp10_, "black_and_white.svg", NULL);
#line 244 "../src/reversi-view.vala"
			_g_free0 (self->priv->pieces_file);
#line 244 "../src/reversi-view.vala"
			self->priv->pieces_file = _tmp11_;
#line 874 "reversi-view.c"
		}
#line 246 "../src/reversi-view.vala"
		_tmp12_ = g_key_file_get_double (key, "Background", "Red", &_inner_error0_);
#line 246 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 246 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 246 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 246 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 886 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 246 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 246 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 246 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 246 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 246 "../src/reversi-view.vala"
			return;
#line 899 "reversi-view.c"
		}
#line 246 "../src/reversi-view.vala"
		self->priv->background_red = _tmp12_;
#line 247 "../src/reversi-view.vala"
		_tmp13_ = g_key_file_get_double (key, "Background", "Green", &_inner_error0_);
#line 247 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 247 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 247 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 247 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 913 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 247 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 247 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 247 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 247 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 247 "../src/reversi-view.vala"
			return;
#line 926 "reversi-view.c"
		}
#line 247 "../src/reversi-view.vala"
		self->priv->background_green = _tmp13_;
#line 248 "../src/reversi-view.vala"
		_tmp14_ = g_key_file_get_double (key, "Background", "Blue", &_inner_error0_);
#line 248 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 248 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 248 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 248 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 940 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 248 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 248 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 248 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 248 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 248 "../src/reversi-view.vala"
			return;
#line 953 "reversi-view.c"
		}
#line 248 "../src/reversi-view.vala"
		self->priv->background_blue = _tmp14_;
#line 249 "../src/reversi-view.vala"
		_tmp15_ = g_key_file_get_integer (key, "Background", "Radius", &_inner_error0_);
#line 249 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 249 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 249 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 249 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 967 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 249 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 249 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 249 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 249 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 249 "../src/reversi-view.vala"
			return;
#line 980 "reversi-view.c"
		}
#line 249 "../src/reversi-view.vala"
		self->priv->background_radius = _tmp15_;
#line 251 "../src/reversi-view.vala"
		_tmp16_ = g_key_file_get_double (key, "Background", "TextureAlpha", &_inner_error0_);
#line 251 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 251 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 251 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 251 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 994 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 251 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 251 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 251 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 251 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 251 "../src/reversi-view.vala"
			return;
#line 1007 "reversi-view.c"
		}
#line 251 "../src/reversi-view.vala"
		self->priv->texture_alpha = _tmp16_;
#line 252 "../src/reversi-view.vala"
		if (self->priv->texture_alpha > 0.0) {
#line 252 "../src/reversi-view.vala"
			_tmp17_ = self->priv->texture_alpha <= 1.0;
#line 1015 "reversi-view.c"
		} else {
#line 252 "../src/reversi-view.vala"
			_tmp17_ = FALSE;
#line 1019 "reversi-view.c"
		}
#line 252 "../src/reversi-view.vala"
		self->priv->apply_texture = _tmp17_;
#line 254 "../src/reversi-view.vala"
		_tmp18_ = g_key_file_get_double (key, "Mark", "Red", &_inner_error0_);
#line 254 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 254 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 254 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 254 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1033 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 254 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 254 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 254 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 254 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 254 "../src/reversi-view.vala"
			return;
#line 1046 "reversi-view.c"
		}
#line 254 "../src/reversi-view.vala"
		self->priv->mark_red = _tmp18_;
#line 255 "../src/reversi-view.vala"
		_tmp19_ = g_key_file_get_double (key, "Mark", "Green", &_inner_error0_);
#line 255 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 255 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 255 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 255 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1060 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 255 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 255 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 255 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 255 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 255 "../src/reversi-view.vala"
			return;
#line 1073 "reversi-view.c"
		}
#line 255 "../src/reversi-view.vala"
		self->priv->mark_green = _tmp19_;
#line 256 "../src/reversi-view.vala"
		_tmp20_ = g_key_file_get_double (key, "Mark", "Blue", &_inner_error0_);
#line 256 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 256 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 256 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 256 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1087 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 256 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 256 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 256 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 256 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 256 "../src/reversi-view.vala"
			return;
#line 1100 "reversi-view.c"
		}
#line 256 "../src/reversi-view.vala"
		self->priv->mark_blue = _tmp20_;
#line 257 "../src/reversi-view.vala"
		_tmp21_ = g_key_file_get_integer (key, "Mark", "Width", &_inner_error0_);
#line 257 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 257 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 257 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 257 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1114 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 257 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 257 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 257 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 257 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 257 "../src/reversi-view.vala"
			return;
#line 1127 "reversi-view.c"
		}
#line 257 "../src/reversi-view.vala"
		self->priv->mark_width = _tmp21_;
#line 259 "../src/reversi-view.vala"
		_tmp22_ = g_key_file_get_double (key, "Border", "Red", &_inner_error0_);
#line 259 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 259 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 259 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 259 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1141 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 259 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 259 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 259 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 259 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 259 "../src/reversi-view.vala"
			return;
#line 1154 "reversi-view.c"
		}
#line 259 "../src/reversi-view.vala"
		self->priv->border_red = _tmp22_;
#line 260 "../src/reversi-view.vala"
		_tmp23_ = g_key_file_get_double (key, "Border", "Green", &_inner_error0_);
#line 260 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 260 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 260 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 260 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1168 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 260 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 260 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 260 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 260 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 260 "../src/reversi-view.vala"
			return;
#line 1181 "reversi-view.c"
		}
#line 260 "../src/reversi-view.vala"
		self->priv->border_green = _tmp23_;
#line 261 "../src/reversi-view.vala"
		_tmp24_ = g_key_file_get_double (key, "Border", "Blue", &_inner_error0_);
#line 261 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 261 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 261 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 261 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1195 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 261 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 261 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 261 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 261 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 261 "../src/reversi-view.vala"
			return;
#line 1208 "reversi-view.c"
		}
#line 261 "../src/reversi-view.vala"
		self->priv->border_blue = _tmp24_;
#line 262 "../src/reversi-view.vala"
		_tmp25_ = g_key_file_get_integer (key, "Border", "Width", &_inner_error0_);
#line 262 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 262 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 262 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 262 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1222 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 262 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 262 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 262 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 262 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 262 "../src/reversi-view.vala"
			return;
#line 1235 "reversi-view.c"
		}
#line 262 "../src/reversi-view.vala"
		self->priv->border_width = _tmp25_;
#line 263 "../src/reversi-view.vala"
		self->priv->half_border_width = ((gdouble) self->priv->border_width) / 2.0;
#line 265 "../src/reversi-view.vala"
		_tmp26_ = g_key_file_get_double (key, "Spacing", "Red", &_inner_error0_);
#line 265 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 265 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 265 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 265 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1251 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 265 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 265 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 265 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 265 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 265 "../src/reversi-view.vala"
			return;
#line 1264 "reversi-view.c"
		}
#line 265 "../src/reversi-view.vala"
		self->priv->spacing_red = _tmp26_;
#line 266 "../src/reversi-view.vala"
		_tmp27_ = g_key_file_get_double (key, "Spacing", "Green", &_inner_error0_);
#line 266 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 266 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 266 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 266 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1278 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 266 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 266 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 266 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 266 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 266 "../src/reversi-view.vala"
			return;
#line 1291 "reversi-view.c"
		}
#line 266 "../src/reversi-view.vala"
		self->priv->spacing_green = _tmp27_;
#line 267 "../src/reversi-view.vala"
		_tmp28_ = g_key_file_get_double (key, "Spacing", "Blue", &_inner_error0_);
#line 267 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 267 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 267 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 267 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1305 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 267 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 267 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 267 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 267 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 267 "../src/reversi-view.vala"
			return;
#line 1318 "reversi-view.c"
		}
#line 267 "../src/reversi-view.vala"
		self->priv->spacing_blue = _tmp28_;
#line 268 "../src/reversi-view.vala"
		_tmp29_ = g_key_file_get_integer (key, "Spacing", "Width", &_inner_error0_);
#line 268 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 268 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 268 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 268 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1332 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 268 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 268 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 268 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 268 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 268 "../src/reversi-view.vala"
			return;
#line 1345 "reversi-view.c"
		}
#line 268 "../src/reversi-view.vala"
		self->priv->spacing_width = _tmp29_;
#line 270 "../src/reversi-view.vala"
		_tmp30_ = g_key_file_get_double (key, "Highlight hard", "Red", &_inner_error0_);
#line 270 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 270 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 270 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 270 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1359 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 270 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 270 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 270 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 270 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 270 "../src/reversi-view.vala"
			return;
#line 1372 "reversi-view.c"
		}
#line 270 "../src/reversi-view.vala"
		self->priv->highlight_hard_red = _tmp30_;
#line 271 "../src/reversi-view.vala"
		_tmp31_ = g_key_file_get_double (key, "Highlight hard", "Green", &_inner_error0_);
#line 271 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 271 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 271 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1386 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 271 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 271 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 271 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 271 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 271 "../src/reversi-view.vala"
			return;
#line 1399 "reversi-view.c"
		}
#line 271 "../src/reversi-view.vala"
		self->priv->highlight_hard_green = _tmp31_;
#line 272 "../src/reversi-view.vala"
		_tmp32_ = g_key_file_get_double (key, "Highlight hard", "Blue", &_inner_error0_);
#line 272 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 272 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 272 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 272 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1413 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 272 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 272 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 272 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 272 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 272 "../src/reversi-view.vala"
			return;
#line 1426 "reversi-view.c"
		}
#line 272 "../src/reversi-view.vala"
		self->priv->highlight_hard_blue = _tmp32_;
#line 273 "../src/reversi-view.vala"
		_tmp33_ = g_key_file_get_double (key, "Highlight hard", "Alpha", &_inner_error0_);
#line 273 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 273 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 273 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 273 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1440 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 273 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 273 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 273 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 273 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 273 "../src/reversi-view.vala"
			return;
#line 1453 "reversi-view.c"
		}
#line 273 "../src/reversi-view.vala"
		self->priv->highlight_hard_alpha = _tmp33_;
#line 275 "../src/reversi-view.vala"
		_tmp34_ = g_key_file_get_double (key, "Highlight soft", "Red", &_inner_error0_);
#line 275 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 275 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 275 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 275 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1467 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 275 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 275 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 275 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 275 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 275 "../src/reversi-view.vala"
			return;
#line 1480 "reversi-view.c"
		}
#line 275 "../src/reversi-view.vala"
		self->priv->highlight_soft_red = _tmp34_;
#line 276 "../src/reversi-view.vala"
		_tmp35_ = g_key_file_get_double (key, "Highlight soft", "Green", &_inner_error0_);
#line 276 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 276 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 276 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 276 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1494 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 276 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 276 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 276 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 276 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 276 "../src/reversi-view.vala"
			return;
#line 1507 "reversi-view.c"
		}
#line 276 "../src/reversi-view.vala"
		self->priv->highlight_soft_green = _tmp35_;
#line 277 "../src/reversi-view.vala"
		_tmp36_ = g_key_file_get_double (key, "Highlight soft", "Blue", &_inner_error0_);
#line 277 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 277 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 277 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 277 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1521 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 277 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 277 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 277 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 277 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 277 "../src/reversi-view.vala"
			return;
#line 1534 "reversi-view.c"
		}
#line 277 "../src/reversi-view.vala"
		self->priv->highlight_soft_blue = _tmp36_;
#line 278 "../src/reversi-view.vala"
		_tmp37_ = g_key_file_get_double (key, "Highlight soft", "Alpha", &_inner_error0_);
#line 278 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 278 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 278 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 278 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1548 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 278 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 278 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 278 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 278 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 278 "../src/reversi-view.vala"
			return;
#line 1561 "reversi-view.c"
		}
#line 278 "../src/reversi-view.vala"
		self->priv->highlight_soft_alpha = _tmp37_;
#line 282 "../src/reversi-view.vala"
		_tmp39_ = g_key_file_get_string (key, "Sound", "Flip", &_inner_error0_);
#line 282 "../src/reversi-view.vala"
		_tmp38_ = _tmp39_;
#line 282 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 282 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 282 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 282 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1577 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 282 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 282 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 282 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 282 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 282 "../src/reversi-view.vala"
			return;
#line 1590 "reversi-view.c"
		}
#line 282 "../src/reversi-view.vala"
		reversi_view_set_sound_flip (self, _tmp38_);
#line 283 "../src/reversi-view.vala"
		_tmp41_ = g_key_file_get_string (key, "Sound", "GameOver", &_inner_error0_);
#line 283 "../src/reversi-view.vala"
		_tmp40_ = _tmp41_;
#line 283 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 283 "../src/reversi-view.vala"
			_g_free0 (_tmp38_);
#line 283 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 283 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 283 "../src/reversi-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1608 "reversi-view.c"
				goto __catch8_g_key_file_error;
			}
#line 283 "../src/reversi-view.vala"
			_g_free0 (_tmp38_);
#line 283 "../src/reversi-view.vala"
			_g_free0 (_tmp1_);
#line 283 "../src/reversi-view.vala"
			_g_free0 (svg_path);
#line 283 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 283 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 283 "../src/reversi-view.vala"
			return;
#line 1623 "reversi-view.c"
		}
#line 283 "../src/reversi-view.vala"
		reversi_view_set_sound_gameover (self, _tmp40_);
#line 239 "../src/reversi-view.vala"
		_g_free0 (_tmp40_);
#line 239 "../src/reversi-view.vala"
		_g_free0 (_tmp38_);
#line 239 "../src/reversi-view.vala"
		_g_free0 (_tmp1_);
#line 239 "../src/reversi-view.vala"
		_g_free0 (svg_path);
#line 1635 "reversi-view.c"
	}
	goto __finally8;
	__catch8_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp42_;
		const gchar* _tmp43_;
#line 239 "../src/reversi-view.vala"
		e = _inner_error0_;
#line 239 "../src/reversi-view.vala"
		_inner_error0_ = NULL;
#line 287 "../src/reversi-view.vala"
		_tmp42_ = e;
#line 287 "../src/reversi-view.vala"
		_tmp43_ = _tmp42_->message;
#line 287 "../src/reversi-view.vala"
		g_warning ("reversi-view.vala:287: Errors when loading theme: %s", _tmp43_);
#line 239 "../src/reversi-view.vala"
		_g_error_free0 (e);
#line 1655 "reversi-view.c"
	}
	__finally8:
#line 239 "../src/reversi-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 239 "../src/reversi-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 239 "../src/reversi-view.vala"
		g_clear_error (&_inner_error0_);
#line 239 "../src/reversi-view.vala"
		return;
#line 1666 "reversi-view.c"
	}
}

static inline void
reversi_view_calculate (ReversiView* self)
{
	gint allocated_width = 0;
	gint allocated_height = 0;
	gint size = 0;
#line 301 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 301 "../src/reversi-view.vala"
	_vala_return_if_fail (self->priv->game_is_set, "game_is_set");
#line 304 "../src/reversi-view.vala"
	allocated_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 305 "../src/reversi-view.vala"
	allocated_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 306 "../src/reversi-view.vala"
	size = MIN (allocated_width, allocated_height);
#line 307 "../src/reversi-view.vala"
	self->priv->paving_size = ((size - (2 * self->priv->border_width)) + self->priv->spacing_width) / self->priv->game_size;
#line 308 "../src/reversi-view.vala"
	self->priv->tile_size = self->priv->paving_size - self->priv->spacing_width;
#line 309 "../src/reversi-view.vala"
	self->priv->board_size = ((self->priv->paving_size * self->priv->game_size) - self->priv->spacing_width) + (2 * self->priv->border_width);
#line 310 "../src/reversi-view.vala"
	self->priv->board_x = ((allocated_width - self->priv->board_size) / 2) + self->priv->border_width;
#line 311 "../src/reversi-view.vala"
	self->priv->board_y = ((allocated_height - self->priv->board_size) / 2) + self->priv->border_width;
#line 1696 "reversi-view.c"
	{
		guint8 x = 0U;
#line 313 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 1701 "reversi-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 313 "../src/reversi-view.vala"
			_tmp0_ = TRUE;
#line 313 "../src/reversi-view.vala"
			while (TRUE) {
#line 313 "../src/reversi-view.vala"
				if (!_tmp0_) {
#line 1710 "reversi-view.c"
					guint8 _tmp1_;
#line 313 "../src/reversi-view.vala"
					_tmp1_ = x;
#line 313 "../src/reversi-view.vala"
					x = _tmp1_ + 1;
#line 1716 "reversi-view.c"
				}
#line 313 "../src/reversi-view.vala"
				_tmp0_ = FALSE;
#line 313 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 313 "../src/reversi-view.vala"
					break;
#line 1724 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 315 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 1730 "reversi-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 315 "../src/reversi-view.vala"
						_tmp2_ = TRUE;
#line 315 "../src/reversi-view.vala"
						while (TRUE) {
#line 1737 "reversi-view.c"
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
#line 315 "../src/reversi-view.vala"
							if (!_tmp2_) {
#line 1746 "reversi-view.c"
								guint8 _tmp3_;
#line 315 "../src/reversi-view.vala"
								_tmp3_ = y;
#line 315 "../src/reversi-view.vala"
								y = _tmp3_ + 1;
#line 1752 "reversi-view.c"
							}
#line 315 "../src/reversi-view.vala"
							_tmp2_ = FALSE;
#line 315 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 315 "../src/reversi-view.vala"
								break;
#line 1760 "reversi-view.c"
							}
#line 317 "../src/reversi-view.vala"
							_tmp4_ = self->priv->tile_xs;
#line 317 "../src/reversi-view.vala"
							_tmp4__length1 = self->priv->tile_xs_length1;
#line 317 "../src/reversi-view.vala"
							_tmp4__length2 = self->priv->tile_xs_length2;
#line 317 "../src/reversi-view.vala"
							_tmp4_[(x * _tmp4__length2) + y] = self->priv->paving_size * ((gint) x);
#line 318 "../src/reversi-view.vala"
							_tmp5_ = self->priv->tile_ys;
#line 318 "../src/reversi-view.vala"
							_tmp5__length1 = self->priv->tile_ys_length1;
#line 318 "../src/reversi-view.vala"
							_tmp5__length2 = self->priv->tile_ys_length2;
#line 318 "../src/reversi-view.vala"
							_tmp5_[(x * _tmp5__length2) + y] = self->priv->paving_size * ((gint) y);
#line 1778 "reversi-view.c"
						}
					}
				}
			}
		}
	}
}

static gboolean
reversi_view_real_draw (GtkWidget* base,
                        cairo_t* cr)
{
	ReversiView * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp4_;
#line 323 "../src/reversi-view.vala"
	self = (ReversiView*) base;
#line 323 "../src/reversi-view.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 325 "../src/reversi-view.vala"
	if (!self->priv->game_is_set) {
#line 326 "../src/reversi-view.vala"
		result = FALSE;
#line 326 "../src/reversi-view.vala"
		return result;
#line 1807 "reversi-view.c"
	}
#line 329 "../src/reversi-view.vala"
	reversi_view_calculate (self);
#line 331 "../src/reversi-view.vala"
	_tmp2_ = self->priv->board_pattern;
#line 331 "../src/reversi-view.vala"
	if (_tmp2_ == NULL) {
#line 331 "../src/reversi-view.vala"
		_tmp1_ = TRUE;
#line 1817 "reversi-view.c"
	} else {
		cairo_pattern_t* _tmp3_;
#line 331 "../src/reversi-view.vala"
		_tmp3_ = self->priv->tiles_pattern;
#line 331 "../src/reversi-view.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 1824 "reversi-view.c"
	}
#line 331 "../src/reversi-view.vala"
	if (_tmp1_) {
#line 331 "../src/reversi-view.vala"
		_tmp0_ = TRUE;
#line 1830 "reversi-view.c"
	} else {
#line 331 "../src/reversi-view.vala"
		_tmp0_ = self->priv->render_size != ((guint) self->priv->tile_size);
#line 1834 "reversi-view.c"
	}
#line 331 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 332 "../src/reversi-view.vala"
		reversi_view_init_patterns (self, cr);
#line 1840 "reversi-view.c"
	}
#line 335 "../src/reversi-view.vala"
	cairo_translate (cr, (gdouble) (self->priv->board_x - self->priv->border_width), (gdouble) (self->priv->board_y - self->priv->border_width));
#line 337 "../src/reversi-view.vala"
	_tmp4_ = self->priv->board_pattern;
#line 337 "../src/reversi-view.vala"
	cairo_set_source (cr, (cairo_pattern_t*) _tmp4_);
#line 338 "../src/reversi-view.vala"
	cairo_rectangle (cr, (gdouble) 0, (gdouble) 0, (gdouble) self->priv->board_size, (gdouble) self->priv->board_size);
#line 339 "../src/reversi-view.vala"
	cairo_fill (cr);
#line 342 "../src/reversi-view.vala"
	cairo_translate (cr, (gdouble) self->priv->border_width, (gdouble) self->priv->border_width);
#line 344 "../src/reversi-view.vala"
	reversi_view_draw_highlight (self, cr);
#line 345 "../src/reversi-view.vala"
	reversi_view_add_highlights (self, cr);
#line 346 "../src/reversi-view.vala"
	reversi_view_draw_playables (self, cr);
#line 348 "../src/reversi-view.vala"
	result = FALSE;
#line 348 "../src/reversi-view.vala"
	return result;
#line 1864 "reversi-view.c"
}

static inline void
reversi_view_init_patterns (ReversiView* self,
                            cairo_t* cr)
{
	cairo_surface_t* surface = NULL;
	cairo_t* context = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp2_;
	cairo_t* _tmp3_;
	cairo_t* _tmp4_;
	cairo_surface_t* _tmp5_;
	cairo_pattern_t* _tmp6_;
	GdkPixbuf* noise_pixbuf = NULL;
	cairo_pattern_t* noise_pattern = NULL;
	cairo_surface_t* _tmp22_;
	cairo_surface_t* _tmp23_;
	cairo_surface_t* _tmp24_;
	cairo_t* _tmp25_;
	cairo_t* _tmp26_;
	cairo_t* _tmp27_;
	cairo_surface_t* _tmp28_;
	cairo_pattern_t* _tmp29_;
	GError* _inner_error0_ = NULL;
#line 351 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 351 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 353 "../src/reversi-view.vala"
	self->priv->render_size = (guint) self->priv->tile_size;
#line 359 "../src/reversi-view.vala"
	_tmp0_ = cairo_get_target (cr);
#line 359 "../src/reversi-view.vala"
	_tmp1_ = cairo_surface_create_similar (_tmp0_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->tile_size * 8, self->priv->tile_size * 4);
#line 359 "../src/reversi-view.vala"
	_cairo_surface_destroy0 (surface);
#line 359 "../src/reversi-view.vala"
	surface = _tmp1_;
#line 361 "../src/reversi-view.vala"
	_tmp2_ = surface;
#line 361 "../src/reversi-view.vala"
	_tmp3_ = cairo_create (_tmp2_);
#line 361 "../src/reversi-view.vala"
	_cairo_destroy0 (context);
#line 361 "../src/reversi-view.vala"
	context = _tmp3_;
#line 362 "../src/reversi-view.vala"
	_tmp4_ = context;
#line 362 "../src/reversi-view.vala"
	reversi_view_load_image (self, _tmp4_, self->priv->tile_size * 8, self->priv->tile_size * 4);
#line 363 "../src/reversi-view.vala"
	_tmp5_ = surface;
#line 363 "../src/reversi-view.vala"
	_tmp6_ = cairo_pattern_create_for_surface (_tmp5_);
#line 363 "../src/reversi-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 363 "../src/reversi-view.vala"
	self->priv->tiles_pattern = _tmp6_;
#line 366 "../src/reversi-view.vala"
	noise_pixbuf = NULL;
#line 367 "../src/reversi-view.vala"
	noise_pattern = NULL;
#line 369 "../src/reversi-view.vala"
	if (self->priv->apply_texture) {
#line 1931 "reversi-view.c"
		GdkPixbuf* _tmp12_;
		{
			GdkPixbuf* _tmp7_ = NULL;
			GdkPixbuf* _tmp8_;
			GdkPixbuf* _tmp9_;
#line 373 "../src/reversi-view.vala"
			_tmp8_ = gdk_pixbuf_new_from_resource_at_scale ("/org/gnome/Reversi/ui/noise.png", self->priv->tile_size, self->priv->tile_size, FALSE, &_inner_error0_);
#line 373 "../src/reversi-view.vala"
			_tmp7_ = _tmp8_;
#line 373 "../src/reversi-view.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1943 "reversi-view.c"
				goto __catch9_g_error;
			}
#line 373 "../src/reversi-view.vala"
			_tmp9_ = _tmp7_;
#line 373 "../src/reversi-view.vala"
			_tmp7_ = NULL;
#line 373 "../src/reversi-view.vala"
			_g_object_unref0 (noise_pixbuf);
#line 373 "../src/reversi-view.vala"
			noise_pixbuf = _tmp9_;
#line 371 "../src/reversi-view.vala"
			_g_object_unref0 (_tmp7_);
#line 1956 "reversi-view.c"
		}
		goto __finally9;
		__catch9_g_error:
		{
			GError* e = NULL;
			GError* _tmp10_;
			const gchar* _tmp11_;
#line 371 "../src/reversi-view.vala"
			e = _inner_error0_;
#line 371 "../src/reversi-view.vala"
			_inner_error0_ = NULL;
#line 377 "../src/reversi-view.vala"
			_tmp10_ = e;
#line 377 "../src/reversi-view.vala"
			_tmp11_ = _tmp10_->message;
#line 377 "../src/reversi-view.vala"
			g_warning ("reversi-view.vala:377: %s", _tmp11_);
#line 371 "../src/reversi-view.vala"
			_g_error_free0 (e);
#line 1976 "reversi-view.c"
		}
		__finally9:
#line 371 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 371 "../src/reversi-view.vala"
			_cairo_pattern_destroy0 (noise_pattern);
#line 371 "../src/reversi-view.vala"
			_g_object_unref0 (noise_pixbuf);
#line 371 "../src/reversi-view.vala"
			_cairo_destroy0 (context);
#line 371 "../src/reversi-view.vala"
			_cairo_surface_destroy0 (surface);
#line 371 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 371 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 371 "../src/reversi-view.vala"
			return;
#line 1995 "reversi-view.c"
		}
#line 378 "../src/reversi-view.vala"
		_tmp12_ = noise_pixbuf;
#line 378 "../src/reversi-view.vala"
		self->priv->noise_pixbuf_loaded = _tmp12_ != NULL;
#line 379 "../src/reversi-view.vala"
		if (self->priv->noise_pixbuf_loaded) {
#line 2003 "reversi-view.c"
			cairo_surface_t* _tmp13_;
			cairo_surface_t* _tmp14_;
			cairo_surface_t* _tmp15_;
			cairo_t* _tmp16_;
			cairo_t* _tmp17_;
			GdkPixbuf* _tmp18_;
			cairo_t* _tmp19_;
			cairo_surface_t* _tmp20_;
			cairo_pattern_t* _tmp21_;
#line 381 "../src/reversi-view.vala"
			_tmp13_ = cairo_get_target (cr);
#line 381 "../src/reversi-view.vala"
			_tmp14_ = cairo_surface_create_similar (_tmp13_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->tile_size, self->priv->tile_size);
#line 381 "../src/reversi-view.vala"
			_cairo_surface_destroy0 (surface);
#line 381 "../src/reversi-view.vala"
			surface = _tmp14_;
#line 383 "../src/reversi-view.vala"
			_tmp15_ = surface;
#line 383 "../src/reversi-view.vala"
			_tmp16_ = cairo_create (_tmp15_);
#line 383 "../src/reversi-view.vala"
			_cairo_destroy0 (context);
#line 383 "../src/reversi-view.vala"
			context = _tmp16_;
#line 384 "../src/reversi-view.vala"
			_tmp17_ = context;
#line 384 "../src/reversi-view.vala"
			_tmp18_ = noise_pixbuf;
#line 384 "../src/reversi-view.vala"
			gdk_cairo_set_source_pixbuf (_tmp17_, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gdk_pixbuf_get_type (), GdkPixbuf), (gdouble) 0, (gdouble) 0);
#line 385 "../src/reversi-view.vala"
			_tmp19_ = context;
#line 385 "../src/reversi-view.vala"
			cairo_paint_with_alpha (_tmp19_, self->priv->texture_alpha);
#line 388 "../src/reversi-view.vala"
			_tmp20_ = surface;
#line 388 "../src/reversi-view.vala"
			_tmp21_ = cairo_pattern_create_for_surface (_tmp20_);
#line 388 "../src/reversi-view.vala"
			_cairo_pattern_destroy0 (noise_pattern);
#line 388 "../src/reversi-view.vala"
			noise_pattern = _tmp21_;
#line 2047 "reversi-view.c"
		}
	}
#line 394 "../src/reversi-view.vala"
	_tmp22_ = cairo_get_target (cr);
#line 394 "../src/reversi-view.vala"
	_tmp23_ = cairo_surface_create_similar (_tmp22_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->board_size, self->priv->board_size);
#line 394 "../src/reversi-view.vala"
	_cairo_surface_destroy0 (surface);
#line 394 "../src/reversi-view.vala"
	surface = _tmp23_;
#line 396 "../src/reversi-view.vala"
	_tmp24_ = surface;
#line 396 "../src/reversi-view.vala"
	_tmp25_ = cairo_create (_tmp24_);
#line 396 "../src/reversi-view.vala"
	_cairo_destroy0 (context);
#line 396 "../src/reversi-view.vala"
	context = _tmp25_;
#line 398 "../src/reversi-view.vala"
	_tmp26_ = context;
#line 398 "../src/reversi-view.vala"
	reversi_view_draw_board_background (self, _tmp26_);
#line 399 "../src/reversi-view.vala"
	_tmp27_ = context;
#line 399 "../src/reversi-view.vala"
	reversi_view_draw_tiles_background (self, _tmp27_, &noise_pattern);
#line 401 "../src/reversi-view.vala"
	_tmp28_ = surface;
#line 401 "../src/reversi-view.vala"
	_tmp29_ = cairo_pattern_create_for_surface (_tmp28_);
#line 401 "../src/reversi-view.vala"
	_cairo_pattern_destroy0 (self->priv->board_pattern);
#line 401 "../src/reversi-view.vala"
	self->priv->board_pattern = _tmp29_;
#line 351 "../src/reversi-view.vala"
	_cairo_pattern_destroy0 (noise_pattern);
#line 351 "../src/reversi-view.vala"
	_g_object_unref0 (noise_pixbuf);
#line 351 "../src/reversi-view.vala"
	_cairo_destroy0 (context);
#line 351 "../src/reversi-view.vala"
	_cairo_surface_destroy0 (surface);
#line 2090 "reversi-view.c"
}

static inline void
reversi_view_draw_board_background (ReversiView* self,
                                    cairo_t* cr)
{
#line 404 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 404 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 406 "../src/reversi-view.vala"
	cairo_set_source_rgba (cr, self->priv->spacing_red, self->priv->spacing_green, self->priv->spacing_blue, 1.0);
#line 407 "../src/reversi-view.vala"
	cairo_rectangle (cr, self->priv->half_border_width, self->priv->half_border_width, (gdouble) (self->priv->board_size - self->priv->border_width), (gdouble) (self->priv->board_size - self->priv->border_width));
#line 408 "../src/reversi-view.vala"
	cairo_fill_preserve (cr);
#line 409 "../src/reversi-view.vala"
	cairo_set_source_rgba (cr, self->priv->border_red, self->priv->border_green, self->priv->border_blue, 1.0);
#line 410 "../src/reversi-view.vala"
	cairo_set_line_width (cr, (gdouble) self->priv->border_width);
#line 411 "../src/reversi-view.vala"
	cairo_stroke (cr);
#line 2113 "reversi-view.c"
}

static inline void
reversi_view_draw_tiles_background (ReversiView* self,
                                    cairo_t* cr,
                                    cairo_pattern_t* * noise_pattern)
{
#line 414 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 414 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 416 "../src/reversi-view.vala"
	cairo_translate (cr, (gdouble) self->priv->border_width, (gdouble) self->priv->border_width);
#line 2127 "reversi-view.c"
	{
		guint8 x = 0U;
#line 418 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 2132 "reversi-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 418 "../src/reversi-view.vala"
			_tmp0_ = TRUE;
#line 418 "../src/reversi-view.vala"
			while (TRUE) {
#line 418 "../src/reversi-view.vala"
				if (!_tmp0_) {
#line 2141 "reversi-view.c"
					guint8 _tmp1_;
#line 418 "../src/reversi-view.vala"
					_tmp1_ = x;
#line 418 "../src/reversi-view.vala"
					x = _tmp1_ + 1;
#line 2147 "reversi-view.c"
				}
#line 418 "../src/reversi-view.vala"
				_tmp0_ = FALSE;
#line 418 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 418 "../src/reversi-view.vala"
					break;
#line 2155 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 419 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 2161 "reversi-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 419 "../src/reversi-view.vala"
						_tmp2_ = TRUE;
#line 419 "../src/reversi-view.vala"
						while (TRUE) {
#line 2168 "reversi-view.c"
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint _tmp5_;
							gint* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							gint _tmp7_;
#line 419 "../src/reversi-view.vala"
							if (!_tmp2_) {
#line 2179 "reversi-view.c"
								guint8 _tmp3_;
#line 419 "../src/reversi-view.vala"
								_tmp3_ = y;
#line 419 "../src/reversi-view.vala"
								y = _tmp3_ + 1;
#line 2185 "reversi-view.c"
							}
#line 419 "../src/reversi-view.vala"
							_tmp2_ = FALSE;
#line 419 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 419 "../src/reversi-view.vala"
								break;
#line 2193 "reversi-view.c"
							}
#line 420 "../src/reversi-view.vala"
							_tmp4_ = self->priv->tile_xs;
#line 420 "../src/reversi-view.vala"
							_tmp4__length1 = self->priv->tile_xs_length1;
#line 420 "../src/reversi-view.vala"
							_tmp4__length2 = self->priv->tile_xs_length2;
#line 420 "../src/reversi-view.vala"
							_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
#line 420 "../src/reversi-view.vala"
							_tmp6_ = self->priv->tile_ys;
#line 420 "../src/reversi-view.vala"
							_tmp6__length1 = self->priv->tile_ys_length1;
#line 420 "../src/reversi-view.vala"
							_tmp6__length2 = self->priv->tile_ys_length2;
#line 420 "../src/reversi-view.vala"
							_tmp7_ = _tmp6_[(x * _tmp6__length2) + y];
#line 420 "../src/reversi-view.vala"
							reversi_view_draw_tile_background (self, cr, noise_pattern, _tmp5_, _tmp7_);
#line 2213 "reversi-view.c"
						}
					}
				}
			}
		}
	}
}

static inline void
reversi_view_draw_tile_background (ReversiView* self,
                                   cairo_t* cr,
                                   cairo_pattern_t* * noise_pattern,
                                   gint tile_x,
                                   gint tile_y)
{
	gboolean _tmp0_ = FALSE;
#line 422 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 422 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 424 "../src/reversi-view.vala"
	cairo_set_source_rgba (cr, self->priv->background_red, self->priv->background_green, self->priv->background_blue, 1.0);
#line 425 "../src/reversi-view.vala"
	reversi_view_rounded_square (self, cr, (gdouble) tile_x, (gdouble) tile_y, self->priv->tile_size, (gdouble) 0, (gdouble) self->priv->background_radius);
#line 426 "../src/reversi-view.vala"
	if (self->priv->apply_texture) {
#line 426 "../src/reversi-view.vala"
		_tmp0_ = self->priv->noise_pixbuf_loaded;
#line 2242 "reversi-view.c"
	} else {
#line 426 "../src/reversi-view.vala"
		_tmp0_ = FALSE;
#line 2246 "reversi-view.c"
	}
#line 426 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 2250 "reversi-view.c"
		cairo_matrix_t matrix = {0};
		cairo_matrix_t _tmp1_;
#line 428 "../src/reversi-view.vala"
		cairo_fill_preserve (cr);
#line 430 "../src/reversi-view.vala"
		cairo_matrix_init_identity (&matrix);
#line 431 "../src/reversi-view.vala"
		cairo_matrix_translate (&matrix, (gdouble) (-tile_x), (gdouble) (-tile_y));
#line 432 "../src/reversi-view.vala"
		_tmp1_ = matrix;
#line 432 "../src/reversi-view.vala"
		cairo_pattern_set_matrix ((cairo_pattern_t*) (*noise_pattern), &_tmp1_);
#line 433 "../src/reversi-view.vala"
		cairo_set_source (cr, (cairo_pattern_t*) (*noise_pattern));
#line 2265 "reversi-view.c"
	}
#line 435 "../src/reversi-view.vala"
	cairo_fill (cr);
#line 2269 "reversi-view.c"
}

static inline void
reversi_view_draw_highlight (ReversiView* self,
                             cairo_t* cr)
{
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean display_mouse_highlight = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean display_keybd_highlight = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean display_ghost_highlight = FALSE;
#line 438 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 438 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 440 "../src/reversi-view.vala"
	_tmp0_ = reversi_view_get_game (self);
#line 440 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_;
#line 440 "../src/reversi-view.vala"
	_tmp2_ = game_get_is_complete (_tmp1_);
#line 440 "../src/reversi-view.vala"
	_tmp3_ = _tmp2_;
#line 440 "../src/reversi-view.vala"
	if (_tmp3_) {
#line 441 "../src/reversi-view.vala"
		return;
#line 2306 "reversi-view.c"
	}
#line 443 "../src/reversi-view.vala"
	if (!self->priv->show_highlight) {
#line 2310 "reversi-view.c"
		gboolean _tmp6_ = FALSE;
#line 444 "../src/reversi-view.vala"
		if (self->priv->show_mouse_highlight) {
#line 444 "../src/reversi-view.vala"
			_tmp6_ = TRUE;
#line 2316 "reversi-view.c"
		} else {
#line 444 "../src/reversi-view.vala"
			_tmp6_ = ((gint) self->priv->highlight_state) != 0;
#line 2320 "reversi-view.c"
		}
#line 444 "../src/reversi-view.vala"
		_tmp5_ = _tmp6_;
#line 2324 "reversi-view.c"
	} else {
#line 443 "../src/reversi-view.vala"
		_tmp5_ = FALSE;
#line 2328 "reversi-view.c"
	}
#line 443 "../src/reversi-view.vala"
	if (_tmp5_) {
#line 2332 "reversi-view.c"
		gboolean _tmp7_ = FALSE;
		Iagno* _tmp8_;
		Player _tmp9_;
		Player _tmp10_;
		Game* _tmp11_;
		Game* _tmp12_;
		Player _tmp13_;
		Player _tmp14_;
#line 446 "../src/reversi-view.vala"
		_tmp8_ = self->priv->iagno_instance;
#line 446 "../src/reversi-view.vala"
		_tmp9_ = iagno_get_player_one (_tmp8_);
#line 446 "../src/reversi-view.vala"
		_tmp10_ = _tmp9_;
#line 446 "../src/reversi-view.vala"
		_tmp11_ = reversi_view_get_game (self);
#line 446 "../src/reversi-view.vala"
		_tmp12_ = _tmp11_;
#line 446 "../src/reversi-view.vala"
		_tmp13_ = game_get_current_color (_tmp12_);
#line 446 "../src/reversi-view.vala"
		_tmp14_ = _tmp13_;
#line 446 "../src/reversi-view.vala"
		if (_tmp10_ == _tmp14_) {
#line 446 "../src/reversi-view.vala"
			_tmp7_ = TRUE;
#line 2359 "reversi-view.c"
		} else {
			Iagno* _tmp15_;
			ComputerPlayer* _tmp16_;
			ComputerPlayer* _tmp17_;
#line 446 "../src/reversi-view.vala"
			_tmp15_ = self->priv->iagno_instance;
#line 446 "../src/reversi-view.vala"
			_tmp16_ = iagno_get_computer (_tmp15_);
#line 446 "../src/reversi-view.vala"
			_tmp17_ = _tmp16_;
#line 446 "../src/reversi-view.vala"
			_tmp7_ = _tmp17_ == NULL;
#line 2372 "reversi-view.c"
		}
#line 446 "../src/reversi-view.vala"
		_tmp4_ = _tmp7_;
#line 2376 "reversi-view.c"
	} else {
#line 443 "../src/reversi-view.vala"
		_tmp4_ = FALSE;
#line 2380 "reversi-view.c"
	}
#line 443 "../src/reversi-view.vala"
	display_mouse_highlight = _tmp4_;
#line 448 "../src/reversi-view.vala"
	if (self->priv->show_highlight) {
#line 449 "../src/reversi-view.vala"
		_tmp18_ = !self->priv->show_mouse_highlight;
#line 2388 "reversi-view.c"
	} else {
#line 448 "../src/reversi-view.vala"
		_tmp18_ = FALSE;
#line 2392 "reversi-view.c"
	}
#line 448 "../src/reversi-view.vala"
	display_keybd_highlight = _tmp18_;
#line 452 "../src/reversi-view.vala"
	if (!self->priv->show_highlight) {
#line 453 "../src/reversi-view.vala"
		_tmp22_ = !self->priv->show_mouse_highlight;
#line 2400 "reversi-view.c"
	} else {
#line 452 "../src/reversi-view.vala"
		_tmp22_ = FALSE;
#line 2404 "reversi-view.c"
	}
#line 452 "../src/reversi-view.vala"
	if (_tmp22_) {
#line 454 "../src/reversi-view.vala"
		_tmp21_ = ((gint) self->priv->highlight_state) != 0;
#line 2410 "reversi-view.c"
	} else {
#line 452 "../src/reversi-view.vala"
		_tmp21_ = FALSE;
#line 2414 "reversi-view.c"
	}
#line 452 "../src/reversi-view.vala"
	if (_tmp21_) {
#line 455 "../src/reversi-view.vala"
		_tmp20_ = self->priv->old_highlight_x != G_MAXUINT8;
#line 2420 "reversi-view.c"
	} else {
#line 452 "../src/reversi-view.vala"
		_tmp20_ = FALSE;
#line 2424 "reversi-view.c"
	}
#line 452 "../src/reversi-view.vala"
	if (_tmp20_) {
#line 456 "../src/reversi-view.vala"
		_tmp19_ = self->priv->old_highlight_y != G_MAXUINT8;
#line 2430 "reversi-view.c"
	} else {
#line 452 "../src/reversi-view.vala"
		_tmp19_ = FALSE;
#line 2434 "reversi-view.c"
	}
#line 452 "../src/reversi-view.vala"
	display_ghost_highlight = _tmp19_;
#line 458 "../src/reversi-view.vala"
	if (display_ghost_highlight) {
#line 459 "../src/reversi-view.vala"
		reversi_view_draw_tile_highlight (self, cr, self->priv->old_highlight_x, self->priv->old_highlight_y);
#line 2442 "reversi-view.c"
	} else {
#line 460 "../src/reversi-view.vala"
		if (display_mouse_highlight) {
#line 461 "../src/reversi-view.vala"
			reversi_view_draw_tile_highlight (self, cr, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 2448 "reversi-view.c"
		} else {
#line 462 "../src/reversi-view.vala"
			if (display_keybd_highlight) {
#line 463 "../src/reversi-view.vala"
				reversi_view_draw_tile_highlight (self, cr, self->priv->highlight_x, self->priv->highlight_y);
#line 2454 "reversi-view.c"
			}
		}
	}
}

static inline void
reversi_view_draw_tile_highlight (ReversiView* self,
                                  cairo_t* cr,
                                  guint8 x,
                                  guint8 y)
{
	PossibleMove move = {0};
	gboolean test_placing_tile = FALSE;
	Game* _tmp0_;
	Game* _tmp1_;
	PossibleMove _tmp2_ = {0};
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean highlight_on = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
#line 465 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 465 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 468 "../src/reversi-view.vala"
	_tmp0_ = reversi_view_get_game (self);
#line 468 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_;
#line 468 "../src/reversi-view.vala"
	_tmp3_ = game_test_placing_tile (_tmp1_, x, y, &_tmp2_);
#line 468 "../src/reversi-view.vala"
	move = _tmp2_;
#line 468 "../src/reversi-view.vala"
	test_placing_tile = _tmp3_;
#line 469 "../src/reversi-view.vala"
	if (self->priv->show_highlight) {
#line 469 "../src/reversi-view.vala"
		_tmp4_ = TRUE;
#line 2495 "reversi-view.c"
	} else {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 469 "../src/reversi-view.vala"
		if (self->priv->mouse_is_in) {
#line 469 "../src/reversi-view.vala"
			_tmp6_ = self->priv->show_mouse_highlight;
#line 2503 "reversi-view.c"
		} else {
#line 469 "../src/reversi-view.vala"
			_tmp6_ = FALSE;
#line 2507 "reversi-view.c"
		}
#line 469 "../src/reversi-view.vala"
		if (_tmp6_) {
#line 469 "../src/reversi-view.vala"
			_tmp5_ = test_placing_tile;
#line 2513 "reversi-view.c"
		} else {
#line 469 "../src/reversi-view.vala"
			_tmp5_ = FALSE;
#line 2517 "reversi-view.c"
		}
#line 469 "../src/reversi-view.vala"
		_tmp4_ = _tmp5_;
#line 2521 "reversi-view.c"
	}
#line 469 "../src/reversi-view.vala"
	highlight_on = _tmp4_;
#line 472 "../src/reversi-view.vala"
	if (highlight_on) {
#line 472 "../src/reversi-view.vala"
		_tmp7_ = self->priv->highlight_state != REVERSI_VIEW_HIGHLIGHT_MAX;
#line 2529 "reversi-view.c"
	} else {
#line 472 "../src/reversi-view.vala"
		_tmp7_ = FALSE;
#line 2533 "reversi-view.c"
	}
#line 472 "../src/reversi-view.vala"
	if (_tmp7_) {
#line 2537 "reversi-view.c"
		guint8 _tmp8_;
#line 474 "../src/reversi-view.vala"
		_tmp8_ = self->priv->highlight_state;
#line 474 "../src/reversi-view.vala"
		self->priv->highlight_state = _tmp8_ + 1;
#line 475 "../src/reversi-view.vala"
		reversi_view_queue_draw_tile (self, x, y);
#line 2545 "reversi-view.c"
	} else {
		gboolean _tmp9_ = FALSE;
#line 477 "../src/reversi-view.vala"
		if (!highlight_on) {
#line 477 "../src/reversi-view.vala"
			_tmp9_ = ((gint) self->priv->highlight_state) != 0;
#line 2552 "reversi-view.c"
		} else {
#line 477 "../src/reversi-view.vala"
			_tmp9_ = FALSE;
#line 2556 "reversi-view.c"
		}
#line 477 "../src/reversi-view.vala"
		if (_tmp9_) {
#line 2560 "reversi-view.c"
			guint8 _tmp10_;
			gboolean _tmp11_ = FALSE;
#line 483 "../src/reversi-view.vala"
			_tmp10_ = self->priv->highlight_state;
#line 483 "../src/reversi-view.vala"
			self->priv->highlight_state = _tmp10_ - 1;
#line 484 "../src/reversi-view.vala"
			reversi_view_queue_draw_tile (self, x, y);
#line 485 "../src/reversi-view.vala"
			if (self->priv->old_highlight_x != x) {
#line 485 "../src/reversi-view.vala"
				_tmp11_ = TRUE;
#line 2573 "reversi-view.c"
			} else {
#line 485 "../src/reversi-view.vala"
				_tmp11_ = self->priv->old_highlight_y != y;
#line 2577 "reversi-view.c"
			}
#line 485 "../src/reversi-view.vala"
			if (_tmp11_) {
#line 487 "../src/reversi-view.vala"
				return;
#line 2583 "reversi-view.c"
			}
		}
	}
#line 489 "../src/reversi-view.vala"
	reversi_view_highlight_tile (self, cr, x, y, self->priv->highlight_state, FALSE);
#line 490 "../src/reversi-view.vala"
	if (test_placing_tile) {
#line 2591 "reversi-view.c"
		gboolean _tmp14_;
#line 491 "../src/reversi-view.vala"
		_tmp14_ = self->priv->_show_turnable_tiles;
#line 491 "../src/reversi-view.vala"
		_tmp13_ = _tmp14_;
#line 2597 "reversi-view.c"
	} else {
#line 490 "../src/reversi-view.vala"
		_tmp13_ = FALSE;
#line 2601 "reversi-view.c"
	}
#line 490 "../src/reversi-view.vala"
	if (_tmp13_) {
#line 2605 "reversi-view.c"
		gboolean _tmp15_ = FALSE;
		Iagno* _tmp16_;
		ComputerPlayer* _tmp17_;
		ComputerPlayer* _tmp18_;
#line 492 "../src/reversi-view.vala"
		_tmp16_ = self->priv->iagno_instance;
#line 492 "../src/reversi-view.vala"
		_tmp17_ = iagno_get_computer (_tmp16_);
#line 492 "../src/reversi-view.vala"
		_tmp18_ = _tmp17_;
#line 492 "../src/reversi-view.vala"
		if (_tmp18_ != NULL) {
#line 2618 "reversi-view.c"
			Iagno* _tmp19_;
			Player _tmp20_;
			Player _tmp21_;
			Game* _tmp22_;
			Game* _tmp23_;
			Player _tmp24_;
			Player _tmp25_;
#line 492 "../src/reversi-view.vala"
			_tmp19_ = self->priv->iagno_instance;
#line 492 "../src/reversi-view.vala"
			_tmp20_ = iagno_get_player_one (_tmp19_);
#line 492 "../src/reversi-view.vala"
			_tmp21_ = _tmp20_;
#line 492 "../src/reversi-view.vala"
			_tmp22_ = reversi_view_get_game (self);
#line 492 "../src/reversi-view.vala"
			_tmp23_ = _tmp22_;
#line 492 "../src/reversi-view.vala"
			_tmp24_ = game_get_current_color (_tmp23_);
#line 492 "../src/reversi-view.vala"
			_tmp25_ = _tmp24_;
#line 492 "../src/reversi-view.vala"
			_tmp15_ = _tmp21_ != _tmp25_;
#line 2642 "reversi-view.c"
		} else {
#line 492 "../src/reversi-view.vala"
			_tmp15_ = FALSE;
#line 2646 "reversi-view.c"
		}
#line 492 "../src/reversi-view.vala"
		_tmp12_ = !_tmp15_;
#line 2650 "reversi-view.c"
	} else {
#line 490 "../src/reversi-view.vala"
		_tmp12_ = FALSE;
#line 2654 "reversi-view.c"
	}
#line 490 "../src/reversi-view.vala"
	if (_tmp12_) {
#line 2658 "reversi-view.c"
		PossibleMove _tmp26_;
		PossibleMove _tmp27_;
		PossibleMove _tmp28_;
		PossibleMove _tmp29_;
		PossibleMove _tmp30_;
		PossibleMove _tmp31_;
		PossibleMove _tmp32_;
		PossibleMove _tmp33_;
		PossibleMove _tmp34_;
		PossibleMove _tmp35_;
		PossibleMove _tmp36_;
		PossibleMove _tmp37_;
		PossibleMove _tmp38_;
		PossibleMove _tmp39_;
		PossibleMove _tmp40_;
		PossibleMove _tmp41_;
		PossibleMove _tmp42_;
		PossibleMove _tmp43_;
		PossibleMove _tmp44_;
		PossibleMove _tmp45_;
		PossibleMove _tmp46_;
		PossibleMove _tmp47_;
		PossibleMove _tmp48_;
		PossibleMove _tmp49_;
#line 494 "../src/reversi-view.vala"
		_tmp26_ = move;
#line 494 "../src/reversi-view.vala"
		_tmp27_ = move;
#line 494 "../src/reversi-view.vala"
		_tmp28_ = move;
#line 494 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp26_.x, _tmp27_.y, (gint8) 0, (gint8) -1, _tmp28_.n_tiles_n);
#line 495 "../src/reversi-view.vala"
		_tmp29_ = move;
#line 495 "../src/reversi-view.vala"
		_tmp30_ = move;
#line 495 "../src/reversi-view.vala"
		_tmp31_ = move;
#line 495 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp29_.x, _tmp30_.y, (gint8) 1, (gint8) -1, _tmp31_.n_tiles_ne);
#line 496 "../src/reversi-view.vala"
		_tmp32_ = move;
#line 496 "../src/reversi-view.vala"
		_tmp33_ = move;
#line 496 "../src/reversi-view.vala"
		_tmp34_ = move;
#line 496 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp32_.x, _tmp33_.y, (gint8) 1, (gint8) 0, _tmp34_.n_tiles_e);
#line 497 "../src/reversi-view.vala"
		_tmp35_ = move;
#line 497 "../src/reversi-view.vala"
		_tmp36_ = move;
#line 497 "../src/reversi-view.vala"
		_tmp37_ = move;
#line 497 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp35_.x, _tmp36_.y, (gint8) 1, (gint8) 1, _tmp37_.n_tiles_se);
#line 498 "../src/reversi-view.vala"
		_tmp38_ = move;
#line 498 "../src/reversi-view.vala"
		_tmp39_ = move;
#line 498 "../src/reversi-view.vala"
		_tmp40_ = move;
#line 498 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp38_.x, _tmp39_.y, (gint8) 0, (gint8) 1, _tmp40_.n_tiles_s);
#line 499 "../src/reversi-view.vala"
		_tmp41_ = move;
#line 499 "../src/reversi-view.vala"
		_tmp42_ = move;
#line 499 "../src/reversi-view.vala"
		_tmp43_ = move;
#line 499 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp41_.x, _tmp42_.y, (gint8) -1, (gint8) 1, _tmp43_.n_tiles_so);
#line 500 "../src/reversi-view.vala"
		_tmp44_ = move;
#line 500 "../src/reversi-view.vala"
		_tmp45_ = move;
#line 500 "../src/reversi-view.vala"
		_tmp46_ = move;
#line 500 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp44_.x, _tmp45_.y, (gint8) -1, (gint8) 0, _tmp46_.n_tiles_o);
#line 501 "../src/reversi-view.vala"
		_tmp47_ = move;
#line 501 "../src/reversi-view.vala"
		_tmp48_ = move;
#line 501 "../src/reversi-view.vala"
		_tmp49_ = move;
#line 501 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp47_.x, _tmp48_.y, (gint8) -1, (gint8) -1, _tmp49_.n_tiles_no);
#line 2747 "reversi-view.c"
	}
}

static inline void
reversi_view_highlight_turnable_tiles (ReversiView* self,
                                       cairo_t* cr,
                                       guint8 x,
                                       guint8 y,
                                       gint8 x_step,
                                       gint8 y_step,
                                       guint8 count)
{
#line 504 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 504 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 2764 "reversi-view.c"
	{
		gboolean _tmp0_ = FALSE;
#line 506 "../src/reversi-view.vala"
		_tmp0_ = TRUE;
#line 506 "../src/reversi-view.vala"
		while (TRUE) {
#line 2771 "reversi-view.c"
			gint8 _x = 0;
			gint8 _y = 0;
#line 506 "../src/reversi-view.vala"
			if (!_tmp0_) {
#line 2776 "reversi-view.c"
				guint8 _tmp1_;
#line 506 "../src/reversi-view.vala"
				_tmp1_ = count;
#line 506 "../src/reversi-view.vala"
				count = _tmp1_ - 1;
#line 2782 "reversi-view.c"
			}
#line 506 "../src/reversi-view.vala"
			_tmp0_ = FALSE;
#line 506 "../src/reversi-view.vala"
			if (!(((gint) count) > 0)) {
#line 506 "../src/reversi-view.vala"
				break;
#line 2790 "reversi-view.c"
			}
#line 508 "../src/reversi-view.vala"
			_x = ((gint8) x) + (((gint8) count) * x_step);
#line 509 "../src/reversi-view.vala"
			_y = ((gint8) y) + (((gint8) count) * y_step);
#line 510 "../src/reversi-view.vala"
			reversi_view_queue_draw_tile (self, (guint8) _x, (guint8) _y);
#line 511 "../src/reversi-view.vala"
			reversi_view_highlight_tile (self, cr, (guint8) _x, (guint8) _y, self->priv->highlight_state, TRUE);
#line 2800 "reversi-view.c"
		}
	}
}

static inline void
reversi_view_add_highlights (ReversiView* self,
                             cairo_t* cr)
{
	gboolean _tmp0_ = FALSE;
	Iagno* _tmp1_;
	ComputerPlayer* _tmp2_;
	ComputerPlayer* _tmp3_;
	gboolean decreasing = FALSE;
	guint8 intensity = 0U;
	gboolean _tmp15_ = FALSE;
#line 515 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 515 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 517 "../src/reversi-view.vala"
	if (((gint) self->priv->playable_tiles_highlight_state) == 0) {
#line 518 "../src/reversi-view.vala"
		return;
#line 2824 "reversi-view.c"
	}
#line 519 "../src/reversi-view.vala"
	_tmp1_ = self->priv->iagno_instance;
#line 519 "../src/reversi-view.vala"
	_tmp2_ = iagno_get_computer (_tmp1_);
#line 519 "../src/reversi-view.vala"
	_tmp3_ = _tmp2_;
#line 519 "../src/reversi-view.vala"
	if (_tmp3_ != NULL) {
#line 2834 "reversi-view.c"
		Iagno* _tmp4_;
		Player _tmp5_;
		Player _tmp6_;
		Game* _tmp7_;
		Game* _tmp8_;
		Player _tmp9_;
		Player _tmp10_;
#line 519 "../src/reversi-view.vala"
		_tmp4_ = self->priv->iagno_instance;
#line 519 "../src/reversi-view.vala"
		_tmp5_ = iagno_get_player_one (_tmp4_);
#line 519 "../src/reversi-view.vala"
		_tmp6_ = _tmp5_;
#line 519 "../src/reversi-view.vala"
		_tmp7_ = reversi_view_get_game (self);
#line 519 "../src/reversi-view.vala"
		_tmp8_ = _tmp7_;
#line 519 "../src/reversi-view.vala"
		_tmp9_ = game_get_current_color (_tmp8_);
#line 519 "../src/reversi-view.vala"
		_tmp10_ = _tmp9_;
#line 519 "../src/reversi-view.vala"
		_tmp0_ = _tmp6_ != _tmp10_;
#line 2858 "reversi-view.c"
	} else {
#line 519 "../src/reversi-view.vala"
		_tmp0_ = FALSE;
#line 2862 "reversi-view.c"
	}
#line 519 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 521 "../src/reversi-view.vala"
		reversi_view_init_possible_moves (self);
#line 522 "../src/reversi-view.vala"
		return;
#line 2870 "reversi-view.c"
	}
#line 525 "../src/reversi-view.vala"
	decreasing = self->priv->playable_tiles_highlight_state > REVERSI_VIEW_HIGHLIGHT_MAX;
#line 527 "../src/reversi-view.vala"
	if (decreasing) {
#line 528 "../src/reversi-view.vala"
		intensity = (guint8) (((2 * REVERSI_VIEW_HIGHLIGHT_MAX) + 1) - self->priv->playable_tiles_highlight_state);
#line 2878 "reversi-view.c"
	} else {
#line 530 "../src/reversi-view.vala"
		intensity = self->priv->playable_tiles_highlight_state;
#line 2882 "reversi-view.c"
	}
	{
		guint8 x = 0U;
#line 532 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 2888 "reversi-view.c"
		{
			gboolean _tmp11_ = FALSE;
#line 532 "../src/reversi-view.vala"
			_tmp11_ = TRUE;
#line 532 "../src/reversi-view.vala"
			while (TRUE) {
#line 532 "../src/reversi-view.vala"
				if (!_tmp11_) {
#line 2897 "reversi-view.c"
					guint8 _tmp12_;
#line 532 "../src/reversi-view.vala"
					_tmp12_ = x;
#line 532 "../src/reversi-view.vala"
					x = _tmp12_ + 1;
#line 2903 "reversi-view.c"
				}
#line 532 "../src/reversi-view.vala"
				_tmp11_ = FALSE;
#line 532 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 532 "../src/reversi-view.vala"
					break;
#line 2911 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 533 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 2917 "reversi-view.c"
					{
						gboolean _tmp13_ = FALSE;
#line 533 "../src/reversi-view.vala"
						_tmp13_ = TRUE;
#line 533 "../src/reversi-view.vala"
						while (TRUE) {
#line 533 "../src/reversi-view.vala"
							if (!_tmp13_) {
#line 2926 "reversi-view.c"
								guint8 _tmp14_;
#line 533 "../src/reversi-view.vala"
								_tmp14_ = y;
#line 533 "../src/reversi-view.vala"
								y = _tmp14_ + 1;
#line 2932 "reversi-view.c"
							}
#line 533 "../src/reversi-view.vala"
							_tmp13_ = FALSE;
#line 533 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 533 "../src/reversi-view.vala"
								break;
#line 2940 "reversi-view.c"
							}
#line 534 "../src/reversi-view.vala"
							reversi_view_add_highlight (self, cr, x, y, intensity);
#line 2944 "reversi-view.c"
						}
					}
				}
			}
		}
	}
#line 536 "../src/reversi-view.vala"
	if (decreasing) {
#line 536 "../src/reversi-view.vala"
		_tmp15_ = ((gint) intensity) == 1;
#line 2955 "reversi-view.c"
	} else {
#line 536 "../src/reversi-view.vala"
		_tmp15_ = FALSE;
#line 2959 "reversi-view.c"
	}
#line 536 "../src/reversi-view.vala"
	if (_tmp15_) {
#line 537 "../src/reversi-view.vala"
		reversi_view_init_possible_moves (self);
#line 2965 "reversi-view.c"
	} else {
		guint8 _tmp16_;
#line 539 "../src/reversi-view.vala"
		_tmp16_ = self->priv->playable_tiles_highlight_state;
#line 539 "../src/reversi-view.vala"
		self->priv->playable_tiles_highlight_state = _tmp16_ + 1;
#line 2972 "reversi-view.c"
	}
}

static inline void
reversi_view_add_highlight (ReversiView* self,
                            cairo_t* cr,
                            guint8 x,
                            guint8 y,
                            guint8 intensity)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gboolean _tmp1_;
#line 541 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 541 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 543 "../src/reversi-view.vala"
	_tmp0_ = self->priv->possible_moves;
#line 543 "../src/reversi-view.vala"
	_tmp0__length1 = self->priv->possible_moves_length1;
#line 543 "../src/reversi-view.vala"
	_tmp0__length2 = self->priv->possible_moves_length2;
#line 543 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 543 "../src/reversi-view.vala"
	if (_tmp1_ == FALSE) {
#line 544 "../src/reversi-view.vala"
		return;
#line 3003 "reversi-view.c"
	}
#line 546 "../src/reversi-view.vala"
	reversi_view_queue_draw_tile (self, x, y);
#line 547 "../src/reversi-view.vala"
	reversi_view_highlight_tile (self, cr, x, y, intensity, TRUE);
#line 3009 "reversi-view.c"
}

static inline void
reversi_view_draw_playables (ReversiView* self,
                             cairo_t* cr)
{
#line 550 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 550 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 3020 "reversi-view.c"
	{
		guint8 x = 0U;
#line 552 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 3025 "reversi-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 552 "../src/reversi-view.vala"
			_tmp0_ = TRUE;
#line 552 "../src/reversi-view.vala"
			while (TRUE) {
#line 552 "../src/reversi-view.vala"
				if (!_tmp0_) {
#line 3034 "reversi-view.c"
					guint8 _tmp1_;
#line 552 "../src/reversi-view.vala"
					_tmp1_ = x;
#line 552 "../src/reversi-view.vala"
					x = _tmp1_ + 1;
#line 3040 "reversi-view.c"
				}
#line 552 "../src/reversi-view.vala"
				_tmp0_ = FALSE;
#line 552 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 552 "../src/reversi-view.vala"
					break;
#line 3048 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 553 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 3054 "reversi-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 553 "../src/reversi-view.vala"
						_tmp2_ = TRUE;
#line 553 "../src/reversi-view.vala"
						while (TRUE) {
#line 3061 "reversi-view.c"
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint _tmp5_;
							gint* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							gint _tmp7_;
							gint* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							gint _tmp9_;
#line 553 "../src/reversi-view.vala"
							if (!_tmp2_) {
#line 3076 "reversi-view.c"
								guint8 _tmp3_;
#line 553 "../src/reversi-view.vala"
								_tmp3_ = y;
#line 553 "../src/reversi-view.vala"
								y = _tmp3_ + 1;
#line 3082 "reversi-view.c"
							}
#line 553 "../src/reversi-view.vala"
							_tmp2_ = FALSE;
#line 553 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 553 "../src/reversi-view.vala"
								break;
#line 3090 "reversi-view.c"
							}
#line 554 "../src/reversi-view.vala"
							_tmp4_ = self->priv->pixmaps;
#line 554 "../src/reversi-view.vala"
							_tmp4__length1 = self->priv->pixmaps_length1;
#line 554 "../src/reversi-view.vala"
							_tmp4__length2 = self->priv->pixmaps_length2;
#line 554 "../src/reversi-view.vala"
							_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
#line 554 "../src/reversi-view.vala"
							_tmp6_ = self->priv->tile_xs;
#line 554 "../src/reversi-view.vala"
							_tmp6__length1 = self->priv->tile_xs_length1;
#line 554 "../src/reversi-view.vala"
							_tmp6__length2 = self->priv->tile_xs_length2;
#line 554 "../src/reversi-view.vala"
							_tmp7_ = _tmp6_[(x * _tmp6__length2) + y];
#line 554 "../src/reversi-view.vala"
							_tmp8_ = self->priv->tile_ys;
#line 554 "../src/reversi-view.vala"
							_tmp8__length1 = self->priv->tile_ys_length1;
#line 554 "../src/reversi-view.vala"
							_tmp8__length2 = self->priv->tile_ys_length2;
#line 554 "../src/reversi-view.vala"
							_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
#line 554 "../src/reversi-view.vala"
							reversi_view_draw_playable (self, cr, _tmp5_, _tmp7_, _tmp9_);
#line 3118 "reversi-view.c"
						}
					}
				}
			}
		}
	}
}

static inline void
reversi_view_draw_playable (ReversiView* self,
                            cairo_t* cr,
                            gint pixmap,
                            gint tile_x,
                            gint tile_y)
{
	cairo_matrix_t matrix = {0};
	cairo_pattern_t* _tmp0_;
	cairo_matrix_t _tmp1_;
	cairo_pattern_t* _tmp2_;
#line 556 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 556 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 558 "../src/reversi-view.vala"
	if (pixmap == 0) {
#line 559 "../src/reversi-view.vala"
		return;
#line 3146 "reversi-view.c"
	}
#line 561 "../src/reversi-view.vala"
	cairo_matrix_init_identity (&matrix);
#line 562 "../src/reversi-view.vala"
	cairo_matrix_translate (&matrix, (gdouble) (((pixmap % 8) * self->priv->tile_size) - tile_x), (gdouble) (((pixmap / 8) * self->priv->tile_size) - tile_y));
#line 564 "../src/reversi-view.vala"
	_tmp0_ = self->priv->tiles_pattern;
#line 564 "../src/reversi-view.vala"
	_tmp1_ = matrix;
#line 564 "../src/reversi-view.vala"
	cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp0_, &_tmp1_);
#line 565 "../src/reversi-view.vala"
	_tmp2_ = self->priv->tiles_pattern;
#line 565 "../src/reversi-view.vala"
	cairo_set_source (cr, (cairo_pattern_t*) _tmp2_);
#line 566 "../src/reversi-view.vala"
	cairo_rectangle (cr, (gdouble) tile_x, (gdouble) tile_y, (gdouble) self->priv->tile_size, (gdouble) self->priv->tile_size);
#line 567 "../src/reversi-view.vala"
	cairo_fill (cr);
#line 3166 "reversi-view.c"
}

static void
reversi_view_rounded_square (ReversiView* self,
                             cairo_t* cr,
                             gdouble x,
                             gdouble y,
                             gint size,
                             gdouble width,
                             gdouble radius_percent)
{
	gdouble radius_border = 0.0;
	gdouble radius_arc = 0.0;
	gdouble x1 = 0.0;
	gdouble y1 = 0.0;
	gdouble x2 = 0.0;
	gdouble y2 = 0.0;
#line 575 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 575 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 577 "../src/reversi-view.vala"
	if (radius_percent <= ((gdouble) 0)) {
#line 579 "../src/reversi-view.vala"
		cairo_rectangle (cr, x + (width / 2.0), y + (width / 2.0), size + width, size + width);
#line 580 "../src/reversi-view.vala"
		return;
#line 3194 "reversi-view.c"
	}
#line 583 "../src/reversi-view.vala"
	if (radius_percent > ((gdouble) 50)) {
#line 584 "../src/reversi-view.vala"
		radius_percent = (gdouble) 50;
#line 3200 "reversi-view.c"
	}
#line 585 "../src/reversi-view.vala"
	radius_border = (radius_percent * size) / 100.0;
#line 586 "../src/reversi-view.vala"
	radius_arc = radius_border - (width / 2.0);
#line 587 "../src/reversi-view.vala"
	x1 = x + radius_border;
#line 588 "../src/reversi-view.vala"
	y1 = y + radius_border;
#line 589 "../src/reversi-view.vala"
	x2 = (x + size) - radius_border;
#line 590 "../src/reversi-view.vala"
	y2 = (y + size) - radius_border;
#line 592 "../src/reversi-view.vala"
	cairo_arc (cr, x1, y1, radius_arc, G_PI, -REVERSI_VIEW_HALF_PI);
#line 593 "../src/reversi-view.vala"
	cairo_arc (cr, x2, y1, radius_arc, -REVERSI_VIEW_HALF_PI, (gdouble) 0);
#line 594 "../src/reversi-view.vala"
	cairo_arc (cr, x2, y2, radius_arc, (gdouble) 0, REVERSI_VIEW_HALF_PI);
#line 595 "../src/reversi-view.vala"
	cairo_arc (cr, x1, y2, radius_arc, REVERSI_VIEW_HALF_PI, G_PI);
#line 596 "../src/reversi-view.vala"
	cairo_arc (cr, x1, y1, radius_arc, G_PI, -REVERSI_VIEW_HALF_PI);
#line 3224 "reversi-view.c"
}

static void
reversi_view_load_image (ReversiView* self,
                         cairo_t* c,
                         gint width,
                         gint height)
{
	GError* _inner_error0_ = NULL;
#line 599 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 599 "../src/reversi-view.vala"
	g_return_if_fail (c != NULL);
#line 3238 "reversi-view.c"
	{
		RsvgHandle* h = NULL;
		const gchar* _tmp0_;
		RsvgHandle* _tmp1_;
		cairo_matrix_t m = {0};
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		cairo_matrix_t _tmp6_;
#line 603 "../src/reversi-view.vala"
		_tmp0_ = self->priv->pieces_file;
#line 603 "../src/reversi-view.vala"
		_tmp1_ = rsvg_handle_new_from_file (_tmp0_, &_inner_error0_);
#line 603 "../src/reversi-view.vala"
		h = _tmp1_;
#line 603 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3257 "reversi-view.c"
			goto __catch10_g_error;
		}
#line 605 "../src/reversi-view.vala"
		cairo_matrix_init_identity (&m);
#line 606 "../src/reversi-view.vala"
		g_object_get (h, "width", &_tmp2_, NULL);
#line 606 "../src/reversi-view.vala"
		_tmp3_ = _tmp2_;
#line 606 "../src/reversi-view.vala"
		g_object_get (h, "height", &_tmp4_, NULL);
#line 606 "../src/reversi-view.vala"
		_tmp5_ = _tmp4_;
#line 606 "../src/reversi-view.vala"
		cairo_matrix_scale (&m, ((gdouble) width) / _tmp3_, ((gdouble) height) / _tmp5_);
#line 607 "../src/reversi-view.vala"
		_tmp6_ = m;
#line 607 "../src/reversi-view.vala"
		cairo_set_matrix (c, &_tmp6_);
#line 608 "../src/reversi-view.vala"
		rsvg_handle_render_cairo (h, c);
#line 610 "../src/reversi-view.vala"
		_g_object_unref0 (h);
#line 610 "../src/reversi-view.vala"
		return;
#line 3282 "reversi-view.c"
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
#line 601 "../src/reversi-view.vala"
		e = _inner_error0_;
#line 601 "../src/reversi-view.vala"
		_inner_error0_ = NULL;
#line 601 "../src/reversi-view.vala"
		_g_error_free0 (e);
#line 3294 "reversi-view.c"
	}
	__finally10:
#line 601 "../src/reversi-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 601 "../src/reversi-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 601 "../src/reversi-view.vala"
		g_clear_error (&_inner_error0_);
#line 601 "../src/reversi-view.vala"
		return;
#line 3305 "reversi-view.c"
	}
	{
		GdkPixbuf* p = NULL;
		const gchar* _tmp7_;
		GdkPixbuf* _tmp8_;
		GdkPixbuf* _tmp9_;
#line 619 "../src/reversi-view.vala"
		_tmp7_ = self->priv->pieces_file;
#line 619 "../src/reversi-view.vala"
		_tmp8_ = gdk_pixbuf_new_from_file_at_scale (_tmp7_, width, height, FALSE, &_inner_error0_);
#line 619 "../src/reversi-view.vala"
		p = _tmp8_;
#line 619 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3320 "reversi-view.c"
			goto __catch11_g_error;
		}
#line 620 "../src/reversi-view.vala"
		_tmp9_ = p;
#line 620 "../src/reversi-view.vala"
		gdk_cairo_set_source_pixbuf (c, _tmp9_, (gdouble) 0, (gdouble) 0);
#line 621 "../src/reversi-view.vala"
		cairo_paint (c);
#line 617 "../src/reversi-view.vala"
		_g_object_unref0 (p);
#line 3331 "reversi-view.c"
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 617 "../src/reversi-view.vala"
		e = _inner_error0_;
#line 617 "../src/reversi-view.vala"
		_inner_error0_ = NULL;
#line 625 "../src/reversi-view.vala"
		_tmp10_ = self->priv->pieces_file;
#line 625 "../src/reversi-view.vala"
		_tmp11_ = e;
#line 625 "../src/reversi-view.vala"
		_tmp12_ = _tmp11_->message;
#line 625 "../src/reversi-view.vala"
		g_warning ("reversi-view.vala:625: Failed to load theme image %s: %s", _tmp10_, _tmp12_);
#line 617 "../src/reversi-view.vala"
		_g_error_free0 (e);
#line 3354 "reversi-view.c"
	}
	__finally11:
#line 617 "../src/reversi-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 617 "../src/reversi-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 617 "../src/reversi-view.vala"
		g_clear_error (&_inner_error0_);
#line 617 "../src/reversi-view.vala"
		return;
#line 3365 "reversi-view.c"
	}
}

static void
reversi_view_highlight_tile (ReversiView* self,
                             cairo_t* cr,
                             guint8 x,
                             guint8 y,
                             guint8 intensity,
                             gboolean soft_highlight)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint _tmp3_;
#line 629 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 629 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 631 "../src/reversi-view.vala"
	if (soft_highlight) {
#line 632 "../src/reversi-view.vala"
		cairo_set_source_rgba (cr, self->priv->highlight_soft_red, self->priv->highlight_soft_green, self->priv->highlight_soft_blue, self->priv->highlight_soft_alpha);
#line 3393 "reversi-view.c"
	} else {
#line 634 "../src/reversi-view.vala"
		cairo_set_source_rgba (cr, self->priv->highlight_hard_red, self->priv->highlight_hard_green, self->priv->highlight_hard_blue, self->priv->highlight_hard_alpha);
#line 3397 "reversi-view.c"
	}
#line 635 "../src/reversi-view.vala"
	_tmp0_ = self->priv->tile_xs;
#line 635 "../src/reversi-view.vala"
	_tmp0__length1 = self->priv->tile_xs_length1;
#line 635 "../src/reversi-view.vala"
	_tmp0__length2 = self->priv->tile_xs_length2;
#line 635 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 635 "../src/reversi-view.vala"
	_tmp2_ = self->priv->tile_ys;
#line 635 "../src/reversi-view.vala"
	_tmp2__length1 = self->priv->tile_ys_length1;
#line 635 "../src/reversi-view.vala"
	_tmp2__length2 = self->priv->tile_ys_length2;
#line 635 "../src/reversi-view.vala"
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
#line 635 "../src/reversi-view.vala"
	reversi_view_rounded_square (self, cr, (gdouble) (_tmp1_ + ((self->priv->tile_size * (REVERSI_VIEW_HIGHLIGHT_MAX - intensity)) / (2 * REVERSI_VIEW_HIGHLIGHT_MAX))), (gdouble) (_tmp3_ + ((self->priv->tile_size * (REVERSI_VIEW_HIGHLIGHT_MAX - intensity)) / (2 * REVERSI_VIEW_HIGHLIGHT_MAX))), (self->priv->tile_size * intensity) / REVERSI_VIEW_HIGHLIGHT_MAX, (gdouble) 0, (gdouble) self->priv->background_radius);
#line 642 "../src/reversi-view.vala"
	cairo_fill (cr);
#line 3419 "reversi-view.c"
}

static void
reversi_view_queue_draw_tile (ReversiView* self,
                              guint8 x,
                              guint8 y)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint _tmp3_;
#line 645 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 645 "../src/reversi-view.vala"
	_vala_return_if_fail (x < self->priv->game_size, "x < game_size");
#line 645 "../src/reversi-view.vala"
	_vala_return_if_fail (y < self->priv->game_size, "y < game_size");
#line 649 "../src/reversi-view.vala"
	_tmp0_ = self->priv->tile_xs;
#line 649 "../src/reversi-view.vala"
	_tmp0__length1 = self->priv->tile_xs_length1;
#line 649 "../src/reversi-view.vala"
	_tmp0__length2 = self->priv->tile_xs_length2;
#line 649 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 649 "../src/reversi-view.vala"
	_tmp2_ = self->priv->tile_ys;
#line 649 "../src/reversi-view.vala"
	_tmp2__length1 = self->priv->tile_ys_length1;
#line 649 "../src/reversi-view.vala"
	_tmp2__length2 = self->priv->tile_ys_length2;
#line 649 "../src/reversi-view.vala"
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
#line 649 "../src/reversi-view.vala"
	gtk_widget_queue_draw_area ((GtkWidget*) self, self->priv->board_x + _tmp1_, self->priv->board_y + _tmp3_, self->priv->tile_size, self->priv->tile_size);
#line 3459 "reversi-view.c"
}

static inline void
reversi_view_update_highlight_after_undo (ReversiView* self)
{
	guint8 x = 0U;
	guint8 y = 0U;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 662 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 662 "../src/reversi-view.vala"
	_vala_return_if_fail (self->priv->last_state_set, "last_state_set");
#line 668 "../src/reversi-view.vala"
	reversi_view_get_missing_tile (self, &_tmp0_, &_tmp1_);
#line 668 "../src/reversi-view.vala"
	x = _tmp0_;
#line 668 "../src/reversi-view.vala"
	y = _tmp1_;
#line 671 "../src/reversi-view.vala"
	if (self->priv->show_highlight) {
#line 671 "../src/reversi-view.vala"
		_tmp3_ = TRUE;
#line 3485 "reversi-view.c"
	} else {
#line 671 "../src/reversi-view.vala"
		_tmp3_ = self->priv->show_mouse_highlight;
#line 3489 "reversi-view.c"
	}
#line 671 "../src/reversi-view.vala"
	if (_tmp3_) {
#line 671 "../src/reversi-view.vala"
		_tmp2_ = TRUE;
#line 3495 "reversi-view.c"
	} else {
#line 671 "../src/reversi-view.vala"
		_tmp2_ = ((gint) self->priv->highlight_state) != 0;
#line 3499 "reversi-view.c"
	}
#line 671 "../src/reversi-view.vala"
	if (_tmp2_) {
#line 3503 "reversi-view.c"
		Game* _tmp8_;
		Game* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 673 "../src/reversi-view.vala"
		self->priv->highlight_state = (guint8) 0;
#line 674 "../src/reversi-view.vala"
		if (self->priv->show_highlight) {
#line 3512 "reversi-view.c"
			Game* _tmp4_;
			Game* _tmp5_;
#line 675 "../src/reversi-view.vala"
			_tmp4_ = reversi_view_get_game (self);
#line 675 "../src/reversi-view.vala"
			_tmp5_ = _tmp4_;
#line 675 "../src/reversi-view.vala"
			reversi_view_set_square (self, self->priv->highlight_x, self->priv->highlight_y, reversi_view_get_pixmap (game_get_owner (_tmp5_, self->priv->highlight_x, self->priv->highlight_y)), FALSE, TRUE);
#line 3521 "reversi-view.c"
		}
#line 680 "../src/reversi-view.vala"
		if (self->priv->show_mouse_highlight) {
#line 3525 "reversi-view.c"
			Game* _tmp6_;
			Game* _tmp7_;
#line 681 "../src/reversi-view.vala"
			_tmp6_ = reversi_view_get_game (self);
#line 681 "../src/reversi-view.vala"
			_tmp7_ = _tmp6_;
#line 681 "../src/reversi-view.vala"
			reversi_view_set_square (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y, reversi_view_get_pixmap (game_get_owner (_tmp7_, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y)), FALSE, TRUE);
#line 3534 "reversi-view.c"
		}
#line 687 "../src/reversi-view.vala"
		_tmp8_ = reversi_view_get_game (self);
#line 687 "../src/reversi-view.vala"
		_tmp9_ = _tmp8_;
#line 687 "../src/reversi-view.vala"
		_tmp10_ = game_get_is_complete (_tmp9_);
#line 687 "../src/reversi-view.vala"
		_tmp11_ = _tmp10_;
#line 687 "../src/reversi-view.vala"
		if (!_tmp11_) {
#line 3546 "reversi-view.c"
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
#line 689 "../src/reversi-view.vala"
			if (self->priv->show_highlight) {
#line 690 "../src/reversi-view.vala"
				_tmp13_ = x == self->priv->highlight_x;
#line 3553 "reversi-view.c"
			} else {
#line 689 "../src/reversi-view.vala"
				_tmp13_ = FALSE;
#line 3557 "reversi-view.c"
			}
#line 689 "../src/reversi-view.vala"
			if (_tmp13_) {
#line 691 "../src/reversi-view.vala"
				_tmp12_ = y == self->priv->highlight_y;
#line 3563 "reversi-view.c"
			} else {
#line 689 "../src/reversi-view.vala"
				_tmp12_ = FALSE;
#line 3567 "reversi-view.c"
			}
#line 689 "../src/reversi-view.vala"
			if (_tmp12_) {
#line 692 "../src/reversi-view.vala"
				self->priv->highlight_state = REVERSI_VIEW_HIGHLIGHT_MAX;
#line 3573 "reversi-view.c"
			} else {
				gboolean _tmp14_ = FALSE;
				gboolean _tmp15_ = FALSE;
#line 693 "../src/reversi-view.vala"
				if (self->priv->show_mouse_highlight) {
#line 694 "../src/reversi-view.vala"
					_tmp15_ = x == self->priv->mouse_highlight_x;
#line 3581 "reversi-view.c"
				} else {
#line 693 "../src/reversi-view.vala"
					_tmp15_ = FALSE;
#line 3585 "reversi-view.c"
				}
#line 693 "../src/reversi-view.vala"
				if (_tmp15_) {
#line 695 "../src/reversi-view.vala"
					_tmp14_ = y == self->priv->mouse_highlight_y;
#line 3591 "reversi-view.c"
				} else {
#line 693 "../src/reversi-view.vala"
					_tmp14_ = FALSE;
#line 3595 "reversi-view.c"
				}
#line 693 "../src/reversi-view.vala"
				if (_tmp14_) {
#line 696 "../src/reversi-view.vala"
					self->priv->highlight_state = REVERSI_VIEW_HIGHLIGHT_MAX;
#line 3601 "reversi-view.c"
				} else {
#line 698 "../src/reversi-view.vala"
					self->priv->highlight_state = (guint8) 1;
#line 3605 "reversi-view.c"
				}
			}
		}
	}
#line 703 "../src/reversi-view.vala"
	self->priv->highlight_set = TRUE;
#line 704 "../src/reversi-view.vala"
	self->priv->highlight_x = x;
#line 705 "../src/reversi-view.vala"
	self->priv->highlight_y = y;
#line 706 "../src/reversi-view.vala"
	self->priv->mouse_highlight_x = x;
#line 707 "../src/reversi-view.vala"
	self->priv->mouse_highlight_y = y;
#line 708 "../src/reversi-view.vala"
	if (!self->priv->mouse_is_in) {
#line 709 "../src/reversi-view.vala"
		self->priv->show_highlight = TRUE;
#line 3624 "reversi-view.c"
	} else {
#line 710 "../src/reversi-view.vala"
		if (!self->priv->show_highlight) {
#line 711 "../src/reversi-view.vala"
			self->priv->show_mouse_highlight = TRUE;
#line 3630 "reversi-view.c"
		}
	}
}

static void
reversi_view_get_missing_tile (ReversiView* self,
                               guint8* x,
                               guint8* y)
{
	guint8 _vala_x = 0U;
	guint8 _vala_y = 0U;
#line 713 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 715 "../src/reversi-view.vala"
	_vala_y = (guint8) 0;
#line 3646 "reversi-view.c"
	{
		gboolean _tmp0_ = FALSE;
#line 717 "../src/reversi-view.vala"
		_vala_x = (guint8) 0;
#line 717 "../src/reversi-view.vala"
		_tmp0_ = TRUE;
#line 717 "../src/reversi-view.vala"
		while (TRUE) {
#line 717 "../src/reversi-view.vala"
			if (!_tmp0_) {
#line 3657 "reversi-view.c"
				guint8 _tmp1_;
#line 717 "../src/reversi-view.vala"
				_tmp1_ = _vala_x;
#line 717 "../src/reversi-view.vala"
				_vala_x = _tmp1_ + 1;
#line 3663 "reversi-view.c"
			}
#line 717 "../src/reversi-view.vala"
			_tmp0_ = FALSE;
#line 717 "../src/reversi-view.vala"
			if (!(_vala_x < self->priv->game_size)) {
#line 717 "../src/reversi-view.vala"
				break;
#line 3671 "reversi-view.c"
			}
			{
				gboolean _tmp2_ = FALSE;
#line 719 "../src/reversi-view.vala"
				_vala_y = (guint8) 0;
#line 719 "../src/reversi-view.vala"
				_tmp2_ = TRUE;
#line 719 "../src/reversi-view.vala"
				while (TRUE) {
#line 3681 "reversi-view.c"
					Game* _tmp4_;
					Game* _tmp5_;
					GameStateObject* _tmp6_;
					Game* _tmp7_;
					Game* _tmp8_;
					Player _tmp9_;
					Player _tmp10_;
#line 719 "../src/reversi-view.vala"
					if (!_tmp2_) {
#line 3691 "reversi-view.c"
						guint8 _tmp3_;
#line 719 "../src/reversi-view.vala"
						_tmp3_ = _vala_y;
#line 719 "../src/reversi-view.vala"
						_vala_y = _tmp3_ + 1;
#line 3697 "reversi-view.c"
					}
#line 719 "../src/reversi-view.vala"
					_tmp2_ = FALSE;
#line 719 "../src/reversi-view.vala"
					if (!(_vala_y < self->priv->game_size)) {
#line 719 "../src/reversi-view.vala"
						break;
#line 3705 "reversi-view.c"
					}
#line 721 "../src/reversi-view.vala"
					_tmp4_ = reversi_view_get_game (self);
#line 721 "../src/reversi-view.vala"
					_tmp5_ = _tmp4_;
#line 721 "../src/reversi-view.vala"
					if (game_get_owner (_tmp5_, _vala_x, _vala_y) != PLAYER_NONE) {
#line 722 "../src/reversi-view.vala"
						continue;
#line 3715 "reversi-view.c"
					}
#line 723 "../src/reversi-view.vala"
					_tmp6_ = self->priv->last_state;
#line 723 "../src/reversi-view.vala"
					_tmp7_ = reversi_view_get_game (self);
#line 723 "../src/reversi-view.vala"
					_tmp8_ = _tmp7_;
#line 723 "../src/reversi-view.vala"
					_tmp9_ = game_get_current_color (_tmp8_);
#line 723 "../src/reversi-view.vala"
					_tmp10_ = _tmp9_;
#line 723 "../src/reversi-view.vala"
					if (game_state_object_get_owner (_tmp6_, _vala_x, _vala_y) == _tmp10_) {
#line 724 "../src/reversi-view.vala"
						if (x) {
#line 724 "../src/reversi-view.vala"
							*x = _vala_x;
#line 3733 "reversi-view.c"
						}
#line 724 "../src/reversi-view.vala"
						if (y) {
#line 724 "../src/reversi-view.vala"
							*y = _vala_y;
#line 3739 "reversi-view.c"
						}
#line 724 "../src/reversi-view.vala"
						return;
#line 3743 "reversi-view.c"
					}
				}
			}
		}
	}
#line 727 "../src/reversi-view.vala"
	g_assert_not_reached ();
#line 713 "../src/reversi-view.vala"
	if (x) {
#line 713 "../src/reversi-view.vala"
		*x = _vala_x;
#line 3755 "reversi-view.c"
	}
#line 713 "../src/reversi-view.vala"
	if (y) {
#line 713 "../src/reversi-view.vala"
		*y = _vala_y;
#line 3761 "reversi-view.c"
	}
}

static void
reversi_view_turn_ended_cb (ReversiView* self,
                            gboolean undoing,
                            gboolean no_draw)
{
	Game* _tmp0_;
	Game* _tmp1_;
	GameStateObject* _tmp2_;
	GameStateObject* _tmp3_;
	GameStateObject* _tmp4_;
#line 730 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 732 "../src/reversi-view.vala"
	if (!no_draw) {
#line 734 "../src/reversi-view.vala"
		reversi_view_update_squares (self);
#line 735 "../src/reversi-view.vala"
		if (undoing) {
#line 736 "../src/reversi-view.vala"
			reversi_view_update_highlight_after_undo (self);
#line 3785 "reversi-view.c"
		}
	}
#line 739 "../src/reversi-view.vala"
	_tmp0_ = reversi_view_get_game (self);
#line 739 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_;
#line 739 "../src/reversi-view.vala"
	_tmp2_ = game_get_current_state (_tmp1_);
#line 739 "../src/reversi-view.vala"
	_tmp3_ = _tmp2_;
#line 739 "../src/reversi-view.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 739 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->last_state);
#line 739 "../src/reversi-view.vala"
	self->priv->last_state = _tmp4_;
#line 740 "../src/reversi-view.vala"
	self->priv->last_state_set = TRUE;
#line 3804 "reversi-view.c"
}

static inline void
reversi_view_update_squares (ReversiView* self)
{
#line 743 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 3812 "reversi-view.c"
	{
		guint8 x = 0U;
#line 745 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 3817 "reversi-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 745 "../src/reversi-view.vala"
			_tmp0_ = TRUE;
#line 745 "../src/reversi-view.vala"
			while (TRUE) {
#line 745 "../src/reversi-view.vala"
				if (!_tmp0_) {
#line 3826 "reversi-view.c"
					guint8 _tmp1_;
#line 745 "../src/reversi-view.vala"
					_tmp1_ = x;
#line 745 "../src/reversi-view.vala"
					x = _tmp1_ + 1;
#line 3832 "reversi-view.c"
				}
#line 745 "../src/reversi-view.vala"
				_tmp0_ = FALSE;
#line 745 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 745 "../src/reversi-view.vala"
					break;
#line 3840 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 746 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 3846 "reversi-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 746 "../src/reversi-view.vala"
						_tmp2_ = TRUE;
#line 746 "../src/reversi-view.vala"
						while (TRUE) {
#line 746 "../src/reversi-view.vala"
							if (!_tmp2_) {
#line 3855 "reversi-view.c"
								guint8 _tmp3_;
#line 746 "../src/reversi-view.vala"
								_tmp3_ = y;
#line 746 "../src/reversi-view.vala"
								y = _tmp3_ + 1;
#line 3861 "reversi-view.c"
							}
#line 746 "../src/reversi-view.vala"
							_tmp2_ = FALSE;
#line 746 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 746 "../src/reversi-view.vala"
								break;
#line 3869 "reversi-view.c"
							}
#line 747 "../src/reversi-view.vala"
							reversi_view_update_square (self, x, y);
#line 3873 "reversi-view.c"
						}
					}
				}
			}
		}
	}
}

static inline void
reversi_view_update_square (ReversiView* self,
                            guint8 x,
                            guint8 y)
{
	Game* _tmp0_;
	Game* _tmp1_;
#line 750 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 750 "../src/reversi-view.vala"
	_vala_return_if_fail (self->priv->game_is_set, "game_is_set");
#line 753 "../src/reversi-view.vala"
	_tmp0_ = reversi_view_get_game (self);
#line 753 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_;
#line 753 "../src/reversi-view.vala"
	reversi_view_set_square (self, x, y, reversi_view_get_pixmap (game_get_owner (_tmp1_, x, y)), FALSE, FALSE);
#line 3899 "reversi-view.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 756 "../src/reversi-view.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 756 "../src/reversi-view.vala"
	return _data7_;
#line 3909 "reversi-view.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 756 "../src/reversi-view.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 3919 "reversi-view.c"
		ReversiView* self;
#line 756 "../src/reversi-view.vala"
		self = _data7_->self;
#line 756 "../src/reversi-view.vala"
		_g_object_unref0 (self);
#line 756 "../src/reversi-view.vala"
		g_slice_free (Block7Data, _data7_);
#line 3927 "reversi-view.c"
	}
}

static gboolean
____lambda17_ (Block7Data* _data7_)
{
	ReversiView* self;
	gboolean result = FALSE;
	gboolean animating = FALSE;
#line 770 "../src/reversi-view.vala"
	self = _data7_->self;
#line 771 "../src/reversi-view.vala"
	animating = FALSE;
#line 3941 "reversi-view.c"
	{
		guint8 ix = 0U;
#line 773 "../src/reversi-view.vala"
		ix = (guint8) 0;
#line 3946 "reversi-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 773 "../src/reversi-view.vala"
			_tmp0_ = TRUE;
#line 773 "../src/reversi-view.vala"
			while (TRUE) {
#line 773 "../src/reversi-view.vala"
				if (!_tmp0_) {
#line 3955 "reversi-view.c"
					guint8 _tmp1_;
#line 773 "../src/reversi-view.vala"
					_tmp1_ = ix;
#line 773 "../src/reversi-view.vala"
					ix = _tmp1_ + 1;
#line 3961 "reversi-view.c"
				}
#line 773 "../src/reversi-view.vala"
				_tmp0_ = FALSE;
#line 773 "../src/reversi-view.vala"
				if (!(ix < self->priv->game_size)) {
#line 773 "../src/reversi-view.vala"
					break;
#line 3969 "reversi-view.c"
				}
				{
					guint8 iy = 0U;
#line 775 "../src/reversi-view.vala"
					iy = (guint8) 0;
#line 3975 "reversi-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 775 "../src/reversi-view.vala"
						_tmp2_ = TRUE;
#line 775 "../src/reversi-view.vala"
						while (TRUE) {
#line 3982 "reversi-view.c"
							gint old = 0;
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint _tmp5_;
							gboolean _tmp6_ = FALSE;
							gboolean _tmp7_ = FALSE;
							gint* _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							gint _tmp13_;
#line 775 "../src/reversi-view.vala"
							if (!_tmp2_) {
#line 3996 "reversi-view.c"
								guint8 _tmp3_;
#line 775 "../src/reversi-view.vala"
								_tmp3_ = iy;
#line 775 "../src/reversi-view.vala"
								iy = _tmp3_ + 1;
#line 4002 "reversi-view.c"
							}
#line 775 "../src/reversi-view.vala"
							_tmp2_ = FALSE;
#line 775 "../src/reversi-view.vala"
							if (!(iy < self->priv->game_size)) {
#line 775 "../src/reversi-view.vala"
								break;
#line 4010 "reversi-view.c"
							}
#line 777 "../src/reversi-view.vala"
							_tmp4_ = self->priv->pixmaps;
#line 777 "../src/reversi-view.vala"
							_tmp4__length1 = self->priv->pixmaps_length1;
#line 777 "../src/reversi-view.vala"
							_tmp4__length2 = self->priv->pixmaps_length2;
#line 777 "../src/reversi-view.vala"
							_tmp5_ = _tmp4_[(ix * _tmp4__length2) + iy];
#line 777 "../src/reversi-view.vala"
							old = _tmp5_;
#line 779 "../src/reversi-view.vala"
							if (_data7_->is_final_animation) {
#line 780 "../src/reversi-view.vala"
								_tmp7_ = self->priv->flip_final_result_now;
#line 4026 "reversi-view.c"
							} else {
#line 779 "../src/reversi-view.vala"
								_tmp7_ = FALSE;
#line 4030 "reversi-view.c"
							}
#line 779 "../src/reversi-view.vala"
							if (_tmp7_) {
#line 4034 "reversi-view.c"
								Game* _tmp8_;
								Game* _tmp9_;
								gboolean _tmp10_;
								gboolean _tmp11_;
#line 781 "../src/reversi-view.vala"
								_tmp8_ = reversi_view_get_game (self);
#line 781 "../src/reversi-view.vala"
								_tmp9_ = _tmp8_;
#line 781 "../src/reversi-view.vala"
								_tmp10_ = game_get_is_complete (_tmp9_);
#line 781 "../src/reversi-view.vala"
								_tmp11_ = _tmp10_;
#line 781 "../src/reversi-view.vala"
								_tmp6_ = _tmp11_;
#line 4049 "reversi-view.c"
							} else {
#line 779 "../src/reversi-view.vala"
								_tmp6_ = FALSE;
#line 4053 "reversi-view.c"
							}
#line 779 "../src/reversi-view.vala"
							if (_tmp6_) {
#line 782 "../src/reversi-view.vala"
								reversi_view_flip_final_result_tile (self, ix, iy);
#line 4059 "reversi-view.c"
							} else {
#line 784 "../src/reversi-view.vala"
								reversi_view_update_square (self, ix, iy);
#line 4063 "reversi-view.c"
							}
#line 786 "../src/reversi-view.vala"
							_tmp12_ = self->priv->pixmaps;
#line 786 "../src/reversi-view.vala"
							_tmp12__length1 = self->priv->pixmaps_length1;
#line 786 "../src/reversi-view.vala"
							_tmp12__length2 = self->priv->pixmaps_length2;
#line 786 "../src/reversi-view.vala"
							_tmp13_ = _tmp12_[(ix * _tmp12__length2) + iy];
#line 786 "../src/reversi-view.vala"
							if (_tmp13_ != old) {
#line 787 "../src/reversi-view.vala"
								animating = TRUE;
#line 4077 "reversi-view.c"
							}
						}
					}
				}
			}
		}
	}
#line 791 "../src/reversi-view.vala"
	if (animating) {
#line 792 "../src/reversi-view.vala"
		result = G_SOURCE_CONTINUE;
#line 792 "../src/reversi-view.vala"
		return result;
#line 4091 "reversi-view.c"
	} else {
#line 795 "../src/reversi-view.vala"
		self->priv->animate_timeout = (guint) 0;
#line 796 "../src/reversi-view.vala"
		if (!self->priv->show_highlight) {
#line 797 "../src/reversi-view.vala"
			_reversi_view_on_motion (self, self->priv->mouse_position_x, self->priv->mouse_position_y, TRUE);
#line 4099 "reversi-view.c"
		}
#line 798 "../src/reversi-view.vala"
		result = G_SOURCE_REMOVE;
#line 798 "../src/reversi-view.vala"
		return result;
#line 4105 "reversi-view.c"
	}
}

static gboolean
_____lambda17__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda17_ (self);
#line 770 "../src/reversi-view.vala"
	return result;
#line 4116 "reversi-view.c"
}

static void
reversi_view_set_square (ReversiView* self,
                         guint8 x,
                         guint8 y,
                         gint pixmap,
                         gboolean is_final_animation,
                         gboolean force_redraw)
{
	Block7Data* _data7_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 756 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 756 "../src/reversi-view.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 756 "../src/reversi-view.vala"
	_data7_->_ref_count_ = 1;
#line 756 "../src/reversi-view.vala"
	_data7_->self = g_object_ref (self);
#line 756 "../src/reversi-view.vala"
	_data7_->is_final_animation = is_final_animation;
#line 758 "../src/reversi-view.vala"
	if (!force_redraw) {
#line 4142 "reversi-view.c"
		gint* _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		gint _tmp2_;
#line 758 "../src/reversi-view.vala"
		_tmp1_ = self->priv->pixmaps;
#line 758 "../src/reversi-view.vala"
		_tmp1__length1 = self->priv->pixmaps_length1;
#line 758 "../src/reversi-view.vala"
		_tmp1__length2 = self->priv->pixmaps_length2;
#line 758 "../src/reversi-view.vala"
		_tmp2_ = _tmp1_[(x * _tmp1__length2) + y];
#line 758 "../src/reversi-view.vala"
		_tmp0_ = _tmp2_ == pixmap;
#line 4157 "reversi-view.c"
	} else {
#line 758 "../src/reversi-view.vala"
		_tmp0_ = FALSE;
#line 4161 "reversi-view.c"
	}
#line 758 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 759 "../src/reversi-view.vala"
		block7_data_unref (_data7_);
#line 759 "../src/reversi-view.vala"
		_data7_ = NULL;
#line 759 "../src/reversi-view.vala"
		return;
#line 4171 "reversi-view.c"
	}
#line 761 "../src/reversi-view.vala"
	if (pixmap == 0) {
#line 761 "../src/reversi-view.vala"
		_tmp3_ = TRUE;
#line 4177 "reversi-view.c"
	} else {
		gint* _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		gint _tmp5_;
#line 761 "../src/reversi-view.vala"
		_tmp4_ = self->priv->pixmaps;
#line 761 "../src/reversi-view.vala"
		_tmp4__length1 = self->priv->pixmaps_length1;
#line 761 "../src/reversi-view.vala"
		_tmp4__length2 = self->priv->pixmaps_length2;
#line 761 "../src/reversi-view.vala"
		_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
#line 761 "../src/reversi-view.vala"
		_tmp3_ = _tmp5_ == 0;
#line 4193 "reversi-view.c"
	}
#line 761 "../src/reversi-view.vala"
	if (_tmp3_) {
#line 4197 "reversi-view.c"
		gint* _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
#line 762 "../src/reversi-view.vala"
		_tmp6_ = self->priv->pixmaps;
#line 762 "../src/reversi-view.vala"
		_tmp6__length1 = self->priv->pixmaps_length1;
#line 762 "../src/reversi-view.vala"
		_tmp6__length2 = self->priv->pixmaps_length2;
#line 762 "../src/reversi-view.vala"
		_tmp6_[(x * _tmp6__length2) + y] = pixmap;
#line 4209 "reversi-view.c"
	} else {
		gint* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		gint _tmp8_;
#line 765 "../src/reversi-view.vala"
		_tmp7_ = self->priv->pixmaps;
#line 765 "../src/reversi-view.vala"
		_tmp7__length1 = self->priv->pixmaps_length1;
#line 765 "../src/reversi-view.vala"
		_tmp7__length2 = self->priv->pixmaps_length2;
#line 765 "../src/reversi-view.vala"
		_tmp8_ = _tmp7_[(x * _tmp7__length2) + y];
#line 765 "../src/reversi-view.vala"
		if (pixmap > _tmp8_) {
#line 4225 "reversi-view.c"
			gint* _tmp9_;
			gint _tmp9__length1;
			gint _tmp9__length2;
			gint _tmp10_;
#line 766 "../src/reversi-view.vala"
			_tmp9_ = self->priv->pixmaps;
#line 766 "../src/reversi-view.vala"
			_tmp9__length1 = self->priv->pixmaps_length1;
#line 766 "../src/reversi-view.vala"
			_tmp9__length2 = self->priv->pixmaps_length2;
#line 766 "../src/reversi-view.vala"
			_tmp10_ = _tmp9_[(x * _tmp9__length2) + y];
#line 766 "../src/reversi-view.vala"
			_tmp9_[(x * _tmp9__length2) + y] = _tmp10_ + 1;
#line 4240 "reversi-view.c"
		} else {
			gint* _tmp11_;
			gint _tmp11__length1;
			gint _tmp11__length2;
			gint _tmp12_;
#line 768 "../src/reversi-view.vala"
			_tmp11_ = self->priv->pixmaps;
#line 768 "../src/reversi-view.vala"
			_tmp11__length1 = self->priv->pixmaps_length1;
#line 768 "../src/reversi-view.vala"
			_tmp11__length2 = self->priv->pixmaps_length2;
#line 768 "../src/reversi-view.vala"
			_tmp12_ = _tmp11_[(x * _tmp11__length2) + y];
#line 768 "../src/reversi-view.vala"
			_tmp11_[(x * _tmp11__length2) + y] = _tmp12_ - 1;
#line 4256 "reversi-view.c"
		}
#line 769 "../src/reversi-view.vala"
		if (self->priv->animate_timeout == ((guint) 0)) {
#line 770 "../src/reversi-view.vala"
			self->priv->animate_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) REVERSI_VIEW_PIXMAP_FLIP_DELAY, _____lambda17__gsource_func, block7_data_ref (_data7_), block7_data_unref);
#line 4262 "reversi-view.c"
		}
	}
#line 802 "../src/reversi-view.vala"
	reversi_view_queue_draw_tile (self, x, y);
#line 756 "../src/reversi-view.vala"
	block7_data_unref (_data7_);
#line 756 "../src/reversi-view.vala"
	_data7_ = NULL;
#line 4271 "reversi-view.c"
}

static gint
reversi_view_get_pixmap (Player color)
{
	gint result = 0;
#line 807 "../src/reversi-view.vala"
	switch (color) {
#line 4280 "reversi-view.c"
		default:
#line 807 "../src/reversi-view.vala"
		case PLAYER_NONE:
#line 4284 "reversi-view.c"
		{
#line 811 "../src/reversi-view.vala"
			result = 0;
#line 811 "../src/reversi-view.vala"
			return result;
#line 4290 "reversi-view.c"
		}
#line 807 "../src/reversi-view.vala"
		case PLAYER_DARK:
#line 4294 "reversi-view.c"
		{
#line 813 "../src/reversi-view.vala"
			result = 1;
#line 813 "../src/reversi-view.vala"
			return result;
#line 4300 "reversi-view.c"
		}
#line 807 "../src/reversi-view.vala"
		case PLAYER_LIGHT:
#line 4304 "reversi-view.c"
		{
#line 815 "../src/reversi-view.vala"
			result = 31;
#line 815 "../src/reversi-view.vala"
			return result;
#line 4310 "reversi-view.c"
		}
	}
}

static gboolean
___lambda16_ (ReversiView* self)
{
	gboolean result = FALSE;
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 847 "../src/reversi-view.vala"
	_tmp0_ = reversi_view_get_game (self);
#line 847 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_;
#line 847 "../src/reversi-view.vala"
	_tmp2_ = game_get_is_complete (_tmp1_);
#line 847 "../src/reversi-view.vala"
	_tmp3_ = _tmp2_;
#line 847 "../src/reversi-view.vala"
	if (!_tmp3_) {
#line 848 "../src/reversi-view.vala"
		result = G_SOURCE_REMOVE;
#line 848 "../src/reversi-view.vala"
		return result;
#line 4337 "reversi-view.c"
	}
#line 850 "../src/reversi-view.vala"
	g_signal_emit (self, reversi_view_signals[REVERSI_VIEW_NOTIFY_FINAL_ANIMATION_SIGNAL], 0, FALSE);
#line 851 "../src/reversi-view.vala"
	reversi_view_set_winner_and_loser_variables (self);
#line 852 "../src/reversi-view.vala"
	self->priv->flip_final_result_now = TRUE;
#line 4345 "reversi-view.c"
	{
		guint8 x = 0U;
#line 853 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 4350 "reversi-view.c"
		{
			gboolean _tmp4_ = FALSE;
#line 853 "../src/reversi-view.vala"
			_tmp4_ = TRUE;
#line 853 "../src/reversi-view.vala"
			while (TRUE) {
#line 853 "../src/reversi-view.vala"
				if (!_tmp4_) {
#line 4359 "reversi-view.c"
					guint8 _tmp5_;
#line 853 "../src/reversi-view.vala"
					_tmp5_ = x;
#line 853 "../src/reversi-view.vala"
					x = _tmp5_ + 1;
#line 4365 "reversi-view.c"
				}
#line 853 "../src/reversi-view.vala"
				_tmp4_ = FALSE;
#line 853 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 853 "../src/reversi-view.vala"
					break;
#line 4373 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 854 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 4379 "reversi-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 854 "../src/reversi-view.vala"
						_tmp6_ = TRUE;
#line 854 "../src/reversi-view.vala"
						while (TRUE) {
#line 854 "../src/reversi-view.vala"
							if (!_tmp6_) {
#line 4388 "reversi-view.c"
								guint8 _tmp7_;
#line 854 "../src/reversi-view.vala"
								_tmp7_ = y;
#line 854 "../src/reversi-view.vala"
								y = _tmp7_ + 1;
#line 4394 "reversi-view.c"
							}
#line 854 "../src/reversi-view.vala"
							_tmp6_ = FALSE;
#line 854 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 854 "../src/reversi-view.vala"
								break;
#line 4402 "reversi-view.c"
							}
#line 855 "../src/reversi-view.vala"
							reversi_view_flip_final_result_tile (self, x, y);
#line 4406 "reversi-view.c"
						}
					}
				}
			}
		}
	}
#line 857 "../src/reversi-view.vala"
	result = G_SOURCE_REMOVE;
#line 857 "../src/reversi-view.vala"
	return result;
#line 4417 "reversi-view.c"
}

static gboolean
____lambda16__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda16_ ((ReversiView*) self);
#line 846 "../src/reversi-view.vala"
	return result;
#line 4427 "reversi-view.c"
}

static void
reversi_view_game_is_complete_cb (ReversiView* self)
{
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	Game* _tmp5_;
	Game* _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
#line 833 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 835 "../src/reversi-view.vala"
	_tmp0_ = reversi_view_get_game (self);
#line 835 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_;
#line 835 "../src/reversi-view.vala"
	_tmp2_ = game_get_is_complete (_tmp1_);
#line 835 "../src/reversi-view.vala"
	_tmp3_ = _tmp2_;
#line 835 "../src/reversi-view.vala"
	if (!_tmp3_) {
#line 836 "../src/reversi-view.vala"
		return;
#line 4456 "reversi-view.c"
	}
#line 838 "../src/reversi-view.vala"
	_tmp5_ = reversi_view_get_game (self);
#line 838 "../src/reversi-view.vala"
	_tmp6_ = _tmp5_;
#line 838 "../src/reversi-view.vala"
	_tmp7_ = game_get_n_light_tiles (_tmp6_);
#line 838 "../src/reversi-view.vala"
	_tmp8_ = _tmp7_;
#line 838 "../src/reversi-view.vala"
	if (((gint) _tmp8_) == 0) {
#line 838 "../src/reversi-view.vala"
		_tmp4_ = TRUE;
#line 4470 "reversi-view.c"
	} else {
		Game* _tmp9_;
		Game* _tmp10_;
		guint8 _tmp11_;
		guint8 _tmp12_;
#line 838 "../src/reversi-view.vala"
		_tmp9_ = reversi_view_get_game (self);
#line 838 "../src/reversi-view.vala"
		_tmp10_ = _tmp9_;
#line 838 "../src/reversi-view.vala"
		_tmp11_ = game_get_n_dark_tiles (_tmp10_);
#line 838 "../src/reversi-view.vala"
		_tmp12_ = _tmp11_;
#line 838 "../src/reversi-view.vala"
		_tmp4_ = ((gint) _tmp12_) == 0;
#line 4486 "reversi-view.c"
	}
#line 838 "../src/reversi-view.vala"
	if (_tmp4_) {
#line 839 "../src/reversi-view.vala"
		return;
#line 4492 "reversi-view.c"
	}
#line 845 "../src/reversi-view.vala"
	if (((gint) self->priv->game_size) >= 6) {
#line 846 "../src/reversi-view.vala"
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, ____lambda16__gsource_func, g_object_ref (self), g_object_unref);
#line 4498 "reversi-view.c"
	}
}

static void
reversi_view_flip_final_result_tile (ReversiView* self,
                                     guint8 x,
                                     guint8 y)
{
	gint pixmap = 0;
	guint8 n = 0U;
#line 861 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 864 "../src/reversi-view.vala"
	n = (y * self->priv->game_size) + x;
#line 865 "../src/reversi-view.vala"
	if (((gint) n) < self->priv->n_winning_tiles) {
#line 4515 "reversi-view.c"
		Player _tmp0_;
#line 866 "../src/reversi-view.vala"
		_tmp0_ = self->priv->winning_color;
#line 866 "../src/reversi-view.vala"
		pixmap = reversi_view_get_pixmap (_tmp0_);
#line 4521 "reversi-view.c"
	} else {
#line 867 "../src/reversi-view.vala"
		if (((gint) n) < (self->priv->n_winning_tiles + self->priv->n_losing_tiles)) {
#line 4525 "reversi-view.c"
			Player _tmp1_;
#line 868 "../src/reversi-view.vala"
			_tmp1_ = self->priv->losing_color;
#line 868 "../src/reversi-view.vala"
			pixmap = reversi_view_get_pixmap (_tmp1_);
#line 4531 "reversi-view.c"
		} else {
#line 870 "../src/reversi-view.vala"
			pixmap = reversi_view_get_pixmap (PLAYER_NONE);
#line 4535 "reversi-view.c"
		}
	}
#line 871 "../src/reversi-view.vala"
	reversi_view_set_square (self, x, y, pixmap, TRUE, FALSE);
#line 4540 "reversi-view.c"
}

static void
reversi_view_set_winner_and_loser_variables (ReversiView* self)
{
	Game* _tmp0_;
	Game* _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	Game* _tmp4_;
	Game* _tmp5_;
	guint8 _tmp6_;
	guint8 _tmp7_;
#line 874 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 876 "../src/reversi-view.vala"
	_tmp0_ = reversi_view_get_game (self);
#line 876 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_;
#line 876 "../src/reversi-view.vala"
	_tmp2_ = game_get_n_light_tiles (_tmp1_);
#line 876 "../src/reversi-view.vala"
	_tmp3_ = _tmp2_;
#line 876 "../src/reversi-view.vala"
	self->priv->n_winning_tiles = (gint) _tmp3_;
#line 877 "../src/reversi-view.vala"
	_tmp4_ = reversi_view_get_game (self);
#line 877 "../src/reversi-view.vala"
	_tmp5_ = _tmp4_;
#line 877 "../src/reversi-view.vala"
	_tmp6_ = game_get_n_dark_tiles (_tmp5_);
#line 877 "../src/reversi-view.vala"
	_tmp7_ = _tmp6_;
#line 877 "../src/reversi-view.vala"
	self->priv->n_losing_tiles = (gint) _tmp7_;
#line 878 "../src/reversi-view.vala"
	if (self->priv->n_losing_tiles > self->priv->n_winning_tiles) {
#line 4578 "reversi-view.c"
		gint t = 0;
#line 880 "../src/reversi-view.vala"
		self->priv->winning_color = PLAYER_DARK;
#line 881 "../src/reversi-view.vala"
		self->priv->losing_color = PLAYER_LIGHT;
#line 882 "../src/reversi-view.vala"
		t = self->priv->n_winning_tiles;
#line 883 "../src/reversi-view.vala"
		self->priv->n_winning_tiles = self->priv->n_losing_tiles;
#line 884 "../src/reversi-view.vala"
		self->priv->n_losing_tiles = t;
#line 4590 "reversi-view.c"
	} else {
#line 888 "../src/reversi-view.vala"
		self->priv->winning_color = PLAYER_LIGHT;
#line 889 "../src/reversi-view.vala"
		self->priv->losing_color = PLAYER_DARK;
#line 4596 "reversi-view.c"
	}
}

gboolean
reversi_view_undo_final_animation (ReversiView* self)
{
	gboolean result = FALSE;
#line 893 "../src/reversi-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 895 "../src/reversi-view.vala"
	if (!self->priv->flip_final_result_now) {
#line 896 "../src/reversi-view.vala"
		result = FALSE;
#line 896 "../src/reversi-view.vala"
		return result;
#line 4612 "reversi-view.c"
	}
#line 898 "../src/reversi-view.vala"
	g_signal_emit (self, reversi_view_signals[REVERSI_VIEW_NOTIFY_FINAL_ANIMATION_SIGNAL], 0, TRUE);
#line 899 "../src/reversi-view.vala"
	self->priv->flip_final_result_now = FALSE;
#line 900 "../src/reversi-view.vala"
	reversi_view_update_squares (self);
#line 902 "../src/reversi-view.vala"
	result = TRUE;
#line 902 "../src/reversi-view.vala"
	return result;
#line 4624 "reversi-view.c"
}

static void
_reversi_view_on_motion_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
#line 915 "../src/reversi-view.vala"
	reversi_view_on_motion ((ReversiView*) self, _sender, x, y);
#line 4635 "reversi-view.c"
}

static void
reversi_view_init_mouse (ReversiView* self)
{
	GtkEventControllerMotion* _tmp0_;
	GtkEventControllerMotion* _tmp1_;
#line 912 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 914 "../src/reversi-view.vala"
	_tmp0_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ((GtkWidget*) self);
#line 914 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 914 "../src/reversi-view.vala"
	self->priv->motion_controller = _tmp0_;
#line 915 "../src/reversi-view.vala"
	_tmp1_ = self->priv->motion_controller;
#line 915 "../src/reversi-view.vala"
	g_signal_connect_object (_tmp1_, "motion", (GCallback) _reversi_view_on_motion_gtk_event_controller_motion_motion, self, 0);
#line 4655 "reversi-view.c"
}

static gboolean
reversi_view_real_enter_notify_event (GtkWidget* base,
                                      GdkEventCrossing* event)
{
	ReversiView * self;
	gboolean result = FALSE;
	guint8 x = 0U;
	guint8 y = 0U;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
	gboolean _tmp2_;
#line 921 "../src/reversi-view.vala"
	self = (ReversiView*) base;
#line 921 "../src/reversi-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 925 "../src/reversi-view.vala"
	_tmp2_ = reversi_view_pointer_is_in_board (self, event->x, event->y, &_tmp0_, &_tmp1_);
#line 925 "../src/reversi-view.vala"
	x = _tmp0_;
#line 925 "../src/reversi-view.vala"
	y = _tmp1_;
#line 925 "../src/reversi-view.vala"
	if (_tmp2_) {
#line 927 "../src/reversi-view.vala"
		reversi_view_on_cursor_moving_in (self, x, y);
#line 4683 "reversi-view.c"
	} else {
#line 928 "../src/reversi-view.vala"
		if (self->priv->mouse_is_in) {
#line 929 "../src/reversi-view.vala"
			g_assert_not_reached ();
#line 4689 "reversi-view.c"
		}
	}
#line 930 "../src/reversi-view.vala"
	result = FALSE;
#line 930 "../src/reversi-view.vala"
	return result;
#line 4696 "reversi-view.c"
}

static void
reversi_view_on_cursor_moving_in (ReversiView* self,
                                  guint8 x,
                                  guint8 y)
{
#line 933 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 935 "../src/reversi-view.vala"
	self->priv->mouse_position_x = x;
#line 936 "../src/reversi-view.vala"
	self->priv->mouse_position_y = y;
#line 937 "../src/reversi-view.vala"
	self->priv->mouse_position_set = TRUE;
#line 938 "../src/reversi-view.vala"
	self->priv->mouse_is_in = TRUE;
#line 939 "../src/reversi-view.vala"
	_reversi_view_on_motion (self, x, y, TRUE);
#line 4716 "reversi-view.c"
}

static gboolean
reversi_view_real_leave_notify_event (GtkWidget* base,
                                      GdkEventCrossing* event)
{
	ReversiView * self;
	gboolean result = FALSE;
#line 943 "../src/reversi-view.vala"
	self = (ReversiView*) base;
#line 943 "../src/reversi-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 945 "../src/reversi-view.vala"
	self->priv->mouse_is_in = FALSE;
#line 946 "../src/reversi-view.vala"
	if (self->priv->mouse_position_set) {
#line 947 "../src/reversi-view.vala"
		reversi_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 4735 "reversi-view.c"
	}
#line 948 "../src/reversi-view.vala"
	result = FALSE;
#line 948 "../src/reversi-view.vala"
	return result;
#line 4741 "reversi-view.c"
}

static gboolean
reversi_view_pointer_is_in_board (ReversiView* self,
                                  gdouble pos_x,
                                  gdouble pos_y,
                                  guint8* x,
                                  guint8* y)
{
	guint8 _vala_x = 0U;
	guint8 _vala_y = 0U;
	gboolean result = FALSE;
	gint _x = 0;
	gint _y = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 951 "../src/reversi-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 953 "../src/reversi-view.vala"
	_x = (gint) floor ((pos_x - ((gdouble) self->priv->board_x)) / ((gdouble) self->priv->paving_size));
#line 954 "../src/reversi-view.vala"
	_y = (gint) floor ((pos_y - ((gdouble) self->priv->board_y)) / ((gdouble) self->priv->paving_size));
#line 955 "../src/reversi-view.vala"
	if (_x >= 0) {
#line 955 "../src/reversi-view.vala"
		_tmp2_ = _x < ((gint) self->priv->game_size);
#line 4769 "reversi-view.c"
	} else {
#line 955 "../src/reversi-view.vala"
		_tmp2_ = FALSE;
#line 4773 "reversi-view.c"
	}
#line 955 "../src/reversi-view.vala"
	if (_tmp2_) {
#line 956 "../src/reversi-view.vala"
		_tmp1_ = _y >= 0;
#line 4779 "reversi-view.c"
	} else {
#line 955 "../src/reversi-view.vala"
		_tmp1_ = FALSE;
#line 4783 "reversi-view.c"
	}
#line 955 "../src/reversi-view.vala"
	if (_tmp1_) {
#line 956 "../src/reversi-view.vala"
		_tmp0_ = _y < ((gint) self->priv->game_size);
#line 4789 "reversi-view.c"
	} else {
#line 955 "../src/reversi-view.vala"
		_tmp0_ = FALSE;
#line 4793 "reversi-view.c"
	}
#line 955 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 958 "../src/reversi-view.vala"
		_vala_x = (guint8) _x;
#line 959 "../src/reversi-view.vala"
		_vala_y = (guint8) _y;
#line 960 "../src/reversi-view.vala"
		result = TRUE;
#line 960 "../src/reversi-view.vala"
		if (x) {
#line 960 "../src/reversi-view.vala"
			*x = _vala_x;
#line 4807 "reversi-view.c"
		}
#line 960 "../src/reversi-view.vala"
		if (y) {
#line 960 "../src/reversi-view.vala"
			*y = _vala_y;
#line 4813 "reversi-view.c"
		}
#line 960 "../src/reversi-view.vala"
		return result;
#line 4817 "reversi-view.c"
	} else {
#line 964 "../src/reversi-view.vala"
		_vala_x = G_MAXUINT8;
#line 965 "../src/reversi-view.vala"
		_vala_y = G_MAXUINT8;
#line 966 "../src/reversi-view.vala"
		result = FALSE;
#line 966 "../src/reversi-view.vala"
		if (x) {
#line 966 "../src/reversi-view.vala"
			*x = _vala_x;
#line 4829 "reversi-view.c"
		}
#line 966 "../src/reversi-view.vala"
		if (y) {
#line 966 "../src/reversi-view.vala"
			*y = _vala_y;
#line 4835 "reversi-view.c"
		}
#line 966 "../src/reversi-view.vala"
		return result;
#line 4839 "reversi-view.c"
	}
#line 951 "../src/reversi-view.vala"
	if (x) {
#line 951 "../src/reversi-view.vala"
		*x = _vala_x;
#line 4845 "reversi-view.c"
	}
#line 951 "../src/reversi-view.vala"
	if (y) {
#line 951 "../src/reversi-view.vala"
		*y = _vala_y;
#line 4851 "reversi-view.c"
	}
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 971 "../src/reversi-view.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 971 "../src/reversi-view.vala"
	return _data8_;
#line 4862 "reversi-view.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 971 "../src/reversi-view.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 4872 "reversi-view.c"
		ReversiView* self;
#line 971 "../src/reversi-view.vala"
		self = _data8_->self;
#line 971 "../src/reversi-view.vala"
		_g_object_unref0 (self);
#line 971 "../src/reversi-view.vala"
		g_slice_free (Block8Data, _data8_);
#line 4880 "reversi-view.c"
	}
}

static gboolean
______lambda18_ (Block8Data* _data8_)
{
	ReversiView* self;
	gboolean result = FALSE;
#line 993 "../src/reversi-view.vala"
	self = _data8_->self;
#line 994 "../src/reversi-view.vala"
	if (self->priv->mouse_is_in) {
#line 995 "../src/reversi-view.vala"
		_reversi_view_on_motion (self, _data8_->x, _data8_->y, FALSE);
#line 4895 "reversi-view.c"
	}
#line 996 "../src/reversi-view.vala"
	self->priv->timeout_id = (guint) 0;
#line 997 "../src/reversi-view.vala"
	result = G_SOURCE_REMOVE;
#line 997 "../src/reversi-view.vala"
	return result;
#line 4903 "reversi-view.c"
}

static gboolean
_______lambda18__gsource_func (gpointer self)
{
	gboolean result;
	result = ______lambda18_ (self);
#line 993 "../src/reversi-view.vala"
	return result;
#line 4913 "reversi-view.c"
}

static void
reversi_view_on_motion (ReversiView* self,
                        GtkEventControllerMotion* _motion_controller,
                        gdouble event_x,
                        gdouble event_y)
{
	Block8Data* _data8_;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
	gboolean _tmp2_;
#line 971 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 971 "../src/reversi-view.vala"
	g_return_if_fail (_motion_controller != NULL);
#line 971 "../src/reversi-view.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 971 "../src/reversi-view.vala"
	_data8_->_ref_count_ = 1;
#line 971 "../src/reversi-view.vala"
	_data8_->self = g_object_ref (self);
#line 975 "../src/reversi-view.vala"
	_tmp2_ = reversi_view_pointer_is_in_board (self, event_x, event_y, &_tmp0_, &_tmp1_);
#line 975 "../src/reversi-view.vala"
	_data8_->x = _tmp0_;
#line 975 "../src/reversi-view.vala"
	_data8_->y = _tmp1_;
#line 975 "../src/reversi-view.vala"
	if (_tmp2_) {
#line 977 "../src/reversi-view.vala"
		if (!self->priv->mouse_is_in) {
#line 978 "../src/reversi-view.vala"
			reversi_view_on_cursor_moving_in (self, _data8_->x, _data8_->y);
#line 4948 "reversi-view.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 979 "../src/reversi-view.vala"
			if (_data8_->x != self->priv->mouse_position_x) {
#line 979 "../src/reversi-view.vala"
				_tmp3_ = TRUE;
#line 4955 "reversi-view.c"
			} else {
#line 979 "../src/reversi-view.vala"
				_tmp3_ = _data8_->y != self->priv->mouse_position_y;
#line 4959 "reversi-view.c"
			}
#line 979 "../src/reversi-view.vala"
			if (_tmp3_) {
#line 4963 "reversi-view.c"
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
#line 981 "../src/reversi-view.vala"
				self->priv->mouse_position_x = _data8_->x;
#line 982 "../src/reversi-view.vala"
				self->priv->mouse_position_y = _data8_->y;
#line 983 "../src/reversi-view.vala"
				self->priv->mouse_position_set = TRUE;
#line 984 "../src/reversi-view.vala"
				if (self->priv->show_highlight) {
#line 984 "../src/reversi-view.vala"
					_tmp5_ = TRUE;
#line 4976 "reversi-view.c"
				} else {
#line 985 "../src/reversi-view.vala"
					_tmp5_ = _data8_->x != self->priv->mouse_highlight_x;
#line 4980 "reversi-view.c"
				}
#line 984 "../src/reversi-view.vala"
				if (_tmp5_) {
#line 984 "../src/reversi-view.vala"
					_tmp4_ = TRUE;
#line 4986 "reversi-view.c"
				} else {
#line 986 "../src/reversi-view.vala"
					_tmp4_ = _data8_->y != self->priv->mouse_highlight_y;
#line 4990 "reversi-view.c"
				}
#line 984 "../src/reversi-view.vala"
				if (_tmp4_) {
#line 988 "../src/reversi-view.vala"
					if (self->priv->timeout_id != ((guint) 0)) {
#line 990 "../src/reversi-view.vala"
						g_source_remove (self->priv->timeout_id);
#line 991 "../src/reversi-view.vala"
						self->priv->timeout_id = (guint) 0;
#line 5000 "reversi-view.c"
					}
#line 993 "../src/reversi-view.vala"
					self->priv->timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _______lambda18__gsource_func, block8_data_ref (_data8_), block8_data_unref);
#line 5004 "reversi-view.c"
				}
			}
		}
	} else {
#line 1004 "../src/reversi-view.vala"
		self->priv->mouse_is_in = FALSE;
#line 1005 "../src/reversi-view.vala"
		self->priv->show_mouse_highlight = FALSE;
#line 1006 "../src/reversi-view.vala"
		if (self->priv->mouse_position_set) {
#line 1007 "../src/reversi-view.vala"
			reversi_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 5017 "reversi-view.c"
		}
	}
#line 971 "../src/reversi-view.vala"
	block8_data_unref (_data8_);
#line 971 "../src/reversi-view.vala"
	_data8_ = NULL;
#line 5024 "reversi-view.c"
}

static void
_reversi_view_on_motion (ReversiView* self,
                         guint8 x,
                         guint8 y,
                         gboolean force_redraw)
{
	gboolean _tmp0_ = FALSE;
	gboolean old_show_mouse_highlight = FALSE;
	PossibleMove move = {0};
	gboolean _tmp2_ = FALSE;
	gboolean _tmp7_ = FALSE;
	guint8 old_mouse_highlight_x = 0U;
	guint8 old_mouse_highlight_y = 0U;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
#line 1010 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1012 "../src/reversi-view.vala"
	if (!force_redraw) {
#line 5048 "reversi-view.c"
		gboolean _tmp1_ = FALSE;
#line 1013 "../src/reversi-view.vala"
		if (x != self->priv->mouse_position_x) {
#line 1013 "../src/reversi-view.vala"
			_tmp1_ = TRUE;
#line 5054 "reversi-view.c"
		} else {
#line 1014 "../src/reversi-view.vala"
			_tmp1_ = y != self->priv->mouse_position_y;
#line 5058 "reversi-view.c"
		}
#line 1013 "../src/reversi-view.vala"
		_tmp0_ = _tmp1_;
#line 5062 "reversi-view.c"
	} else {
#line 1012 "../src/reversi-view.vala"
		_tmp0_ = FALSE;
#line 5066 "reversi-view.c"
	}
#line 1012 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 1015 "../src/reversi-view.vala"
		return;
#line 5072 "reversi-view.c"
	}
#line 1017 "../src/reversi-view.vala"
	old_show_mouse_highlight = self->priv->show_mouse_highlight;
#line 1019 "../src/reversi-view.vala"
	if (self->priv->mouse_is_in) {
#line 5078 "reversi-view.c"
		Game* _tmp3_;
		Game* _tmp4_;
		PossibleMove _tmp5_ = {0};
		gboolean _tmp6_;
#line 1019 "../src/reversi-view.vala"
		_tmp3_ = reversi_view_get_game (self);
#line 1019 "../src/reversi-view.vala"
		_tmp4_ = _tmp3_;
#line 1019 "../src/reversi-view.vala"
		_tmp6_ = game_test_placing_tile (_tmp4_, x, y, &_tmp5_);
#line 1019 "../src/reversi-view.vala"
		move = _tmp5_;
#line 1019 "../src/reversi-view.vala"
		_tmp2_ = _tmp6_;
#line 5093 "reversi-view.c"
	} else {
#line 1019 "../src/reversi-view.vala"
		_tmp2_ = FALSE;
#line 5097 "reversi-view.c"
	}
#line 1019 "../src/reversi-view.vala"
	self->priv->show_mouse_highlight = _tmp2_;
#line 1021 "../src/reversi-view.vala"
	if (self->priv->show_mouse_highlight) {
#line 1022 "../src/reversi-view.vala"
		g_signal_emit (self, reversi_view_signals[REVERSI_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL], 0);
#line 5105 "reversi-view.c"
	}
#line 1024 "../src/reversi-view.vala"
	if (old_show_mouse_highlight) {
#line 1024 "../src/reversi-view.vala"
		_tmp7_ = !self->priv->show_mouse_highlight;
#line 5111 "reversi-view.c"
	} else {
#line 1024 "../src/reversi-view.vala"
		_tmp7_ = FALSE;
#line 5115 "reversi-view.c"
	}
#line 1024 "../src/reversi-view.vala"
	if (_tmp7_) {
#line 1026 "../src/reversi-view.vala"
		self->priv->old_highlight_x = G_MAXUINT8;
#line 1027 "../src/reversi-view.vala"
		self->priv->old_highlight_y = G_MAXUINT8;
#line 5123 "reversi-view.c"
	}
#line 1030 "../src/reversi-view.vala"
	old_mouse_highlight_x = self->priv->mouse_highlight_x;
#line 1031 "../src/reversi-view.vala"
	old_mouse_highlight_y = self->priv->mouse_highlight_y;
#line 1033 "../src/reversi-view.vala"
	self->priv->mouse_highlight_x = x;
#line 1034 "../src/reversi-view.vala"
	self->priv->mouse_highlight_y = y;
#line 1036 "../src/reversi-view.vala"
	if (old_mouse_highlight_x != G_MAXUINT8) {
#line 1036 "../src/reversi-view.vala"
		_tmp8_ = old_mouse_highlight_y != G_MAXUINT8;
#line 5137 "reversi-view.c"
	} else {
#line 1036 "../src/reversi-view.vala"
		_tmp8_ = FALSE;
#line 5141 "reversi-view.c"
	}
#line 1036 "../src/reversi-view.vala"
	if (_tmp8_) {
#line 1037 "../src/reversi-view.vala"
		reversi_view_queue_draw_tile (self, old_mouse_highlight_x, old_mouse_highlight_y);
#line 5147 "reversi-view.c"
	}
#line 1038 "../src/reversi-view.vala"
	if (self->priv->show_mouse_highlight) {
#line 1038 "../src/reversi-view.vala"
		_tmp9_ = self->priv->show_highlight;
#line 5153 "reversi-view.c"
	} else {
#line 1038 "../src/reversi-view.vala"
		_tmp9_ = FALSE;
#line 5157 "reversi-view.c"
	}
#line 1038 "../src/reversi-view.vala"
	if (_tmp9_) {
#line 5161 "reversi-view.c"
		gboolean _tmp10_ = FALSE;
#line 1040 "../src/reversi-view.vala"
		self->priv->show_highlight = FALSE;
#line 1041 "../src/reversi-view.vala"
		if (self->priv->highlight_x != x) {
#line 1041 "../src/reversi-view.vala"
			_tmp10_ = TRUE;
#line 5169 "reversi-view.c"
		} else {
#line 1041 "../src/reversi-view.vala"
			_tmp10_ = self->priv->highlight_y != y;
#line 5173 "reversi-view.c"
		}
#line 1041 "../src/reversi-view.vala"
		if (_tmp10_) {
#line 1042 "../src/reversi-view.vala"
			reversi_view_queue_draw_tile (self, self->priv->highlight_x, self->priv->highlight_y);
#line 5179 "reversi-view.c"
		}
	}
#line 1044 "../src/reversi-view.vala"
	if (self->priv->show_mouse_highlight) {
#line 1044 "../src/reversi-view.vala"
		_tmp12_ = TRUE;
#line 5186 "reversi-view.c"
	} else {
#line 1044 "../src/reversi-view.vala"
		_tmp12_ = force_redraw;
#line 5190 "reversi-view.c"
	}
#line 1044 "../src/reversi-view.vala"
	if (_tmp12_) {
#line 5194 "reversi-view.c"
		gboolean _tmp13_ = FALSE;
#line 1046 "../src/reversi-view.vala"
		if (self->priv->mouse_highlight_x != G_MAXUINT8) {
#line 1046 "../src/reversi-view.vala"
			_tmp13_ = self->priv->mouse_highlight_y != G_MAXUINT8;
#line 5200 "reversi-view.c"
		} else {
#line 1046 "../src/reversi-view.vala"
			_tmp13_ = FALSE;
#line 5204 "reversi-view.c"
		}
#line 1046 "../src/reversi-view.vala"
		_tmp11_ = _tmp13_;
#line 5208 "reversi-view.c"
	} else {
#line 1044 "../src/reversi-view.vala"
		_tmp11_ = FALSE;
#line 5212 "reversi-view.c"
	}
#line 1044 "../src/reversi-view.vala"
	if (_tmp11_) {
#line 1048 "../src/reversi-view.vala"
		reversi_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 5218 "reversi-view.c"
	}
}

static gboolean
reversi_view_real_button_press_event (GtkWidget* base,
                                      GdkEventButton* event)
{
	ReversiView * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 1052 "../src/reversi-view.vala"
	self = (ReversiView*) base;
#line 1052 "../src/reversi-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1054 "../src/reversi-view.vala"
	if (!self->priv->game_is_set) {
#line 1055 "../src/reversi-view.vala"
		result = FALSE;
#line 1055 "../src/reversi-view.vala"
		return result;
#line 5239 "reversi-view.c"
	}
#line 1057 "../src/reversi-view.vala"
	if (event->button == ((guint) GDK_BUTTON_PRIMARY)) {
#line 1057 "../src/reversi-view.vala"
		_tmp0_ = TRUE;
#line 5245 "reversi-view.c"
	} else {
#line 1057 "../src/reversi-view.vala"
		_tmp0_ = event->button == ((guint) GDK_BUTTON_SECONDARY);
#line 5249 "reversi-view.c"
	}
#line 1057 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 5253 "reversi-view.c"
		guint8 x = 0U;
		guint8 y = 0U;
		guint8 _tmp1_ = 0U;
		guint8 _tmp2_ = 0U;
		gboolean _tmp3_;
#line 1061 "../src/reversi-view.vala"
		_tmp3_ = reversi_view_pointer_is_in_board (self, event->x, event->y, &_tmp1_, &_tmp2_);
#line 1061 "../src/reversi-view.vala"
		x = _tmp1_;
#line 1061 "../src/reversi-view.vala"
		y = _tmp2_;
#line 1061 "../src/reversi-view.vala"
		if (_tmp3_) {
#line 1063 "../src/reversi-view.vala"
			self->priv->mouse_is_in = TRUE;
#line 1064 "../src/reversi-view.vala"
			self->priv->show_highlight = FALSE;
#line 1065 "../src/reversi-view.vala"
			self->priv->old_highlight_x = self->priv->highlight_x;
#line 1066 "../src/reversi-view.vala"
			self->priv->old_highlight_y = self->priv->highlight_y;
#line 1067 "../src/reversi-view.vala"
			gtk_widget_queue_draw ((GtkWidget*) self);
#line 1068 "../src/reversi-view.vala"
			self->priv->highlight_set = TRUE;
#line 1069 "../src/reversi-view.vala"
			self->priv->highlight_x = x;
#line 1070 "../src/reversi-view.vala"
			self->priv->highlight_y = y;
#line 1071 "../src/reversi-view.vala"
			reversi_view_move_if_possible (self, self->priv->highlight_x, self->priv->highlight_y);
#line 5285 "reversi-view.c"
		}
	}
#line 1075 "../src/reversi-view.vala"
	result = TRUE;
#line 1075 "../src/reversi-view.vala"
	return result;
#line 5292 "reversi-view.c"
}

static gboolean
reversi_view_real_key_press_event (GtkWidget* base,
                                   GdkEventKey* event)
{
	ReversiView * self;
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* key = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	GQuark _tmp65_ = 0U;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label0 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label1 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label2 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label3 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label4 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label5 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label6 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label7 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label8 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label9 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label10 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label11 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label12 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label13 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label14 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label15 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label16 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label17 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label18 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label19 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label20 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label21 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label22 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label23 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label24 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label25 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label26 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label27 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label28 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label29 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label30 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label31 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label32 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label33 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label34 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label35 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label36 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label37 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label38 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label39 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label40 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label41 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label42 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label43 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label44 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label45 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label46 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label47 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label48 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label49 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label50 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label51 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label52 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label53 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label54 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label55 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label56 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label57 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label58 = 0;
#line 1101 "../src/reversi-view.vala"
	static GQuark _tmp64_label59 = 0;
#line 5435 "reversi-view.c"
	gboolean _tmp92_ = FALSE;
	gboolean _tmp93_ = FALSE;
	const gchar* _tmp94_;
	const gchar* _tmp97_;
	gboolean _tmp98_ = FALSE;
	const gchar* _tmp99_;
#line 1078 "../src/reversi-view.vala"
	self = (ReversiView*) base;
#line 1078 "../src/reversi-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1080 "../src/reversi-view.vala"
	if (!self->priv->game_is_set) {
#line 1081 "../src/reversi-view.vala"
		result = FALSE;
#line 1081 "../src/reversi-view.vala"
		return result;
#line 5452 "reversi-view.c"
	}
#line 1083 "../src/reversi-view.vala"
	_tmp1_ = gdk_keyval_name (event->keyval);
#line 1083 "../src/reversi-view.vala"
	_tmp0_ = _tmp1_;
#line 1083 "../src/reversi-view.vala"
	if (_tmp0_ == NULL) {
#line 1083 "../src/reversi-view.vala"
		_tmp0_ = "";
#line 5462 "reversi-view.c"
	}
#line 1083 "../src/reversi-view.vala"
	_tmp2_ = g_strdup ((const gchar*) _tmp0_);
#line 1083 "../src/reversi-view.vala"
	key = _tmp2_;
#line 1085 "../src/reversi-view.vala"
	if (self->priv->show_highlight) {
#line 5470 "reversi-view.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_;
#line 1085 "../src/reversi-view.vala"
		_tmp6_ = key;
#line 1085 "../src/reversi-view.vala"
		if (g_strcmp0 (_tmp6_, "space") == 0) {
#line 1085 "../src/reversi-view.vala"
			_tmp5_ = TRUE;
#line 5480 "reversi-view.c"
		} else {
			const gchar* _tmp7_;
#line 1085 "../src/reversi-view.vala"
			_tmp7_ = key;
#line 1085 "../src/reversi-view.vala"
			_tmp5_ = g_strcmp0 (_tmp7_, "Return") == 0;
#line 5487 "reversi-view.c"
		}
#line 1085 "../src/reversi-view.vala"
		if (_tmp5_) {
#line 1085 "../src/reversi-view.vala"
			_tmp4_ = TRUE;
#line 5493 "reversi-view.c"
		} else {
			const gchar* _tmp8_;
#line 1085 "../src/reversi-view.vala"
			_tmp8_ = key;
#line 1085 "../src/reversi-view.vala"
			_tmp4_ = g_strcmp0 (_tmp8_, "KP_Enter") == 0;
#line 5500 "reversi-view.c"
		}
#line 1085 "../src/reversi-view.vala"
		_tmp3_ = _tmp4_;
#line 5504 "reversi-view.c"
	} else {
#line 1085 "../src/reversi-view.vala"
		_tmp3_ = FALSE;
#line 5508 "reversi-view.c"
	}
#line 1085 "../src/reversi-view.vala"
	if (_tmp3_) {
#line 1087 "../src/reversi-view.vala"
		reversi_view_move_if_possible (self, self->priv->highlight_x, self->priv->highlight_y);
#line 1088 "../src/reversi-view.vala"
		result = TRUE;
#line 1088 "../src/reversi-view.vala"
		_g_free0 (key);
#line 1088 "../src/reversi-view.vala"
		return result;
#line 5520 "reversi-view.c"
	}
#line 1091 "../src/reversi-view.vala"
	if (((gint) self->priv->game_size) <= 4) {
#line 5524 "reversi-view.c"
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		const gchar* _tmp18_;
#line 1091 "../src/reversi-view.vala"
		_tmp18_ = key;
#line 1091 "../src/reversi-view.vala"
		if (g_strcmp0 (_tmp18_, "e") == 0) {
#line 1091 "../src/reversi-view.vala"
			_tmp17_ = TRUE;
#line 5535 "reversi-view.c"
		} else {
			const gchar* _tmp19_;
#line 1091 "../src/reversi-view.vala"
			_tmp19_ = key;
#line 1091 "../src/reversi-view.vala"
			_tmp17_ = g_strcmp0 (_tmp19_, "E") == 0;
#line 5542 "reversi-view.c"
		}
#line 1091 "../src/reversi-view.vala"
		if (_tmp17_) {
#line 1091 "../src/reversi-view.vala"
			_tmp16_ = TRUE;
#line 5548 "reversi-view.c"
		} else {
			const gchar* _tmp20_;
#line 1091 "../src/reversi-view.vala"
			_tmp20_ = key;
#line 1091 "../src/reversi-view.vala"
			_tmp16_ = g_strcmp0 (_tmp20_, "5") == 0;
#line 5555 "reversi-view.c"
		}
#line 1091 "../src/reversi-view.vala"
		if (_tmp16_) {
#line 1091 "../src/reversi-view.vala"
			_tmp15_ = TRUE;
#line 5561 "reversi-view.c"
		} else {
			const gchar* _tmp21_;
#line 1091 "../src/reversi-view.vala"
			_tmp21_ = key;
#line 1091 "../src/reversi-view.vala"
			_tmp15_ = g_strcmp0 (_tmp21_, "KP_5") == 0;
#line 5568 "reversi-view.c"
		}
#line 1091 "../src/reversi-view.vala"
		_tmp14_ = _tmp15_;
#line 5572 "reversi-view.c"
	} else {
#line 1091 "../src/reversi-view.vala"
		_tmp14_ = FALSE;
#line 5576 "reversi-view.c"
	}
#line 1091 "../src/reversi-view.vala"
	if (_tmp14_) {
#line 1091 "../src/reversi-view.vala"
		_tmp13_ = TRUE;
#line 5582 "reversi-view.c"
	} else {
		gboolean _tmp22_ = FALSE;
#line 1092 "../src/reversi-view.vala"
		if (((gint) self->priv->game_size) <= 5) {
#line 5587 "reversi-view.c"
			gboolean _tmp23_ = FALSE;
			gboolean _tmp24_ = FALSE;
			gboolean _tmp25_ = FALSE;
			const gchar* _tmp26_;
#line 1092 "../src/reversi-view.vala"
			_tmp26_ = key;
#line 1092 "../src/reversi-view.vala"
			if (g_strcmp0 (_tmp26_, "f") == 0) {
#line 1092 "../src/reversi-view.vala"
				_tmp25_ = TRUE;
#line 5598 "reversi-view.c"
			} else {
				const gchar* _tmp27_;
#line 1092 "../src/reversi-view.vala"
				_tmp27_ = key;
#line 1092 "../src/reversi-view.vala"
				_tmp25_ = g_strcmp0 (_tmp27_, "F") == 0;
#line 5605 "reversi-view.c"
			}
#line 1092 "../src/reversi-view.vala"
			if (_tmp25_) {
#line 1092 "../src/reversi-view.vala"
				_tmp24_ = TRUE;
#line 5611 "reversi-view.c"
			} else {
				const gchar* _tmp28_;
#line 1092 "../src/reversi-view.vala"
				_tmp28_ = key;
#line 1092 "../src/reversi-view.vala"
				_tmp24_ = g_strcmp0 (_tmp28_, "6") == 0;
#line 5618 "reversi-view.c"
			}
#line 1092 "../src/reversi-view.vala"
			if (_tmp24_) {
#line 1092 "../src/reversi-view.vala"
				_tmp23_ = TRUE;
#line 5624 "reversi-view.c"
			} else {
				const gchar* _tmp29_;
#line 1092 "../src/reversi-view.vala"
				_tmp29_ = key;
#line 1092 "../src/reversi-view.vala"
				_tmp23_ = g_strcmp0 (_tmp29_, "KP_6") == 0;
#line 5631 "reversi-view.c"
			}
#line 1092 "../src/reversi-view.vala"
			_tmp22_ = _tmp23_;
#line 5635 "reversi-view.c"
		} else {
#line 1092 "../src/reversi-view.vala"
			_tmp22_ = FALSE;
#line 5639 "reversi-view.c"
		}
#line 1092 "../src/reversi-view.vala"
		_tmp13_ = _tmp22_;
#line 5643 "reversi-view.c"
	}
#line 1091 "../src/reversi-view.vala"
	if (_tmp13_) {
#line 1091 "../src/reversi-view.vala"
		_tmp12_ = TRUE;
#line 5649 "reversi-view.c"
	} else {
		gboolean _tmp30_ = FALSE;
#line 1093 "../src/reversi-view.vala"
		if (((gint) self->priv->game_size) <= 6) {
#line 5654 "reversi-view.c"
			gboolean _tmp31_ = FALSE;
			gboolean _tmp32_ = FALSE;
			gboolean _tmp33_ = FALSE;
			const gchar* _tmp34_;
#line 1093 "../src/reversi-view.vala"
			_tmp34_ = key;
#line 1093 "../src/reversi-view.vala"
			if (g_strcmp0 (_tmp34_, "g") == 0) {
#line 1093 "../src/reversi-view.vala"
				_tmp33_ = TRUE;
#line 5665 "reversi-view.c"
			} else {
				const gchar* _tmp35_;
#line 1093 "../src/reversi-view.vala"
				_tmp35_ = key;
#line 1093 "../src/reversi-view.vala"
				_tmp33_ = g_strcmp0 (_tmp35_, "G") == 0;
#line 5672 "reversi-view.c"
			}
#line 1093 "../src/reversi-view.vala"
			if (_tmp33_) {
#line 1093 "../src/reversi-view.vala"
				_tmp32_ = TRUE;
#line 5678 "reversi-view.c"
			} else {
				const gchar* _tmp36_;
#line 1093 "../src/reversi-view.vala"
				_tmp36_ = key;
#line 1093 "../src/reversi-view.vala"
				_tmp32_ = g_strcmp0 (_tmp36_, "7") == 0;
#line 5685 "reversi-view.c"
			}
#line 1093 "../src/reversi-view.vala"
			if (_tmp32_) {
#line 1093 "../src/reversi-view.vala"
				_tmp31_ = TRUE;
#line 5691 "reversi-view.c"
			} else {
				const gchar* _tmp37_;
#line 1093 "../src/reversi-view.vala"
				_tmp37_ = key;
#line 1093 "../src/reversi-view.vala"
				_tmp31_ = g_strcmp0 (_tmp37_, "KP_7") == 0;
#line 5698 "reversi-view.c"
			}
#line 1093 "../src/reversi-view.vala"
			_tmp30_ = _tmp31_;
#line 5702 "reversi-view.c"
		} else {
#line 1093 "../src/reversi-view.vala"
			_tmp30_ = FALSE;
#line 5706 "reversi-view.c"
		}
#line 1093 "../src/reversi-view.vala"
		_tmp12_ = _tmp30_;
#line 5710 "reversi-view.c"
	}
#line 1091 "../src/reversi-view.vala"
	if (_tmp12_) {
#line 1091 "../src/reversi-view.vala"
		_tmp11_ = TRUE;
#line 5716 "reversi-view.c"
	} else {
		gboolean _tmp38_ = FALSE;
#line 1094 "../src/reversi-view.vala"
		if (((gint) self->priv->game_size) <= 7) {
#line 5721 "reversi-view.c"
			gboolean _tmp39_ = FALSE;
			gboolean _tmp40_ = FALSE;
			gboolean _tmp41_ = FALSE;
			const gchar* _tmp42_;
#line 1094 "../src/reversi-view.vala"
			_tmp42_ = key;
#line 1094 "../src/reversi-view.vala"
			if (g_strcmp0 (_tmp42_, "h") == 0) {
#line 1094 "../src/reversi-view.vala"
				_tmp41_ = TRUE;
#line 5732 "reversi-view.c"
			} else {
				const gchar* _tmp43_;
#line 1094 "../src/reversi-view.vala"
				_tmp43_ = key;
#line 1094 "../src/reversi-view.vala"
				_tmp41_ = g_strcmp0 (_tmp43_, "H") == 0;
#line 5739 "reversi-view.c"
			}
#line 1094 "../src/reversi-view.vala"
			if (_tmp41_) {
#line 1094 "../src/reversi-view.vala"
				_tmp40_ = TRUE;
#line 5745 "reversi-view.c"
			} else {
				const gchar* _tmp44_;
#line 1094 "../src/reversi-view.vala"
				_tmp44_ = key;
#line 1094 "../src/reversi-view.vala"
				_tmp40_ = g_strcmp0 (_tmp44_, "8") == 0;
#line 5752 "reversi-view.c"
			}
#line 1094 "../src/reversi-view.vala"
			if (_tmp40_) {
#line 1094 "../src/reversi-view.vala"
				_tmp39_ = TRUE;
#line 5758 "reversi-view.c"
			} else {
				const gchar* _tmp45_;
#line 1094 "../src/reversi-view.vala"
				_tmp45_ = key;
#line 1094 "../src/reversi-view.vala"
				_tmp39_ = g_strcmp0 (_tmp45_, "KP_8") == 0;
#line 5765 "reversi-view.c"
			}
#line 1094 "../src/reversi-view.vala"
			_tmp38_ = _tmp39_;
#line 5769 "reversi-view.c"
		} else {
#line 1094 "../src/reversi-view.vala"
			_tmp38_ = FALSE;
#line 5773 "reversi-view.c"
		}
#line 1094 "../src/reversi-view.vala"
		_tmp11_ = _tmp38_;
#line 5777 "reversi-view.c"
	}
#line 1091 "../src/reversi-view.vala"
	if (_tmp11_) {
#line 1091 "../src/reversi-view.vala"
		_tmp10_ = TRUE;
#line 5783 "reversi-view.c"
	} else {
		gboolean _tmp46_ = FALSE;
#line 1095 "../src/reversi-view.vala"
		if (((gint) self->priv->game_size) <= 8) {
#line 5788 "reversi-view.c"
			gboolean _tmp47_ = FALSE;
			gboolean _tmp48_ = FALSE;
			gboolean _tmp49_ = FALSE;
			const gchar* _tmp50_;
#line 1095 "../src/reversi-view.vala"
			_tmp50_ = key;
#line 1095 "../src/reversi-view.vala"
			if (g_strcmp0 (_tmp50_, "i") == 0) {
#line 1095 "../src/reversi-view.vala"
				_tmp49_ = TRUE;
#line 5799 "reversi-view.c"
			} else {
				const gchar* _tmp51_;
#line 1095 "../src/reversi-view.vala"
				_tmp51_ = key;
#line 1095 "../src/reversi-view.vala"
				_tmp49_ = g_strcmp0 (_tmp51_, "I") == 0;
#line 5806 "reversi-view.c"
			}
#line 1095 "../src/reversi-view.vala"
			if (_tmp49_) {
#line 1095 "../src/reversi-view.vala"
				_tmp48_ = TRUE;
#line 5812 "reversi-view.c"
			} else {
				const gchar* _tmp52_;
#line 1095 "../src/reversi-view.vala"
				_tmp52_ = key;
#line 1095 "../src/reversi-view.vala"
				_tmp48_ = g_strcmp0 (_tmp52_, "9") == 0;
#line 5819 "reversi-view.c"
			}
#line 1095 "../src/reversi-view.vala"
			if (_tmp48_) {
#line 1095 "../src/reversi-view.vala"
				_tmp47_ = TRUE;
#line 5825 "reversi-view.c"
			} else {
				const gchar* _tmp53_;
#line 1095 "../src/reversi-view.vala"
				_tmp53_ = key;
#line 1095 "../src/reversi-view.vala"
				_tmp47_ = g_strcmp0 (_tmp53_, "KP_9") == 0;
#line 5832 "reversi-view.c"
			}
#line 1095 "../src/reversi-view.vala"
			_tmp46_ = _tmp47_;
#line 5836 "reversi-view.c"
		} else {
#line 1095 "../src/reversi-view.vala"
			_tmp46_ = FALSE;
#line 5840 "reversi-view.c"
		}
#line 1095 "../src/reversi-view.vala"
		_tmp10_ = _tmp46_;
#line 5844 "reversi-view.c"
	}
#line 1091 "../src/reversi-view.vala"
	if (_tmp10_) {
#line 1091 "../src/reversi-view.vala"
		_tmp9_ = TRUE;
#line 5850 "reversi-view.c"
	} else {
		gboolean _tmp54_ = FALSE;
#line 1096 "../src/reversi-view.vala"
		if (((gint) self->priv->game_size) <= 9) {
#line 5855 "reversi-view.c"
			gboolean _tmp55_ = FALSE;
			gboolean _tmp56_ = FALSE;
			gboolean _tmp57_ = FALSE;
			const gchar* _tmp58_;
#line 1096 "../src/reversi-view.vala"
			_tmp58_ = key;
#line 1096 "../src/reversi-view.vala"
			if (g_strcmp0 (_tmp58_, "j") == 0) {
#line 1096 "../src/reversi-view.vala"
				_tmp57_ = TRUE;
#line 5866 "reversi-view.c"
			} else {
				const gchar* _tmp59_;
#line 1096 "../src/reversi-view.vala"
				_tmp59_ = key;
#line 1096 "../src/reversi-view.vala"
				_tmp57_ = g_strcmp0 (_tmp59_, "J") == 0;
#line 5873 "reversi-view.c"
			}
#line 1096 "../src/reversi-view.vala"
			if (_tmp57_) {
#line 1096 "../src/reversi-view.vala"
				_tmp56_ = TRUE;
#line 5879 "reversi-view.c"
			} else {
				const gchar* _tmp60_;
#line 1096 "../src/reversi-view.vala"
				_tmp60_ = key;
#line 1096 "../src/reversi-view.vala"
				_tmp56_ = g_strcmp0 (_tmp60_, "0") == 0;
#line 5886 "reversi-view.c"
			}
#line 1096 "../src/reversi-view.vala"
			if (_tmp56_) {
#line 1096 "../src/reversi-view.vala"
				_tmp55_ = TRUE;
#line 5892 "reversi-view.c"
			} else {
				const gchar* _tmp61_;
#line 1096 "../src/reversi-view.vala"
				_tmp61_ = key;
#line 1096 "../src/reversi-view.vala"
				_tmp55_ = g_strcmp0 (_tmp61_, "KP_0") == 0;
#line 5899 "reversi-view.c"
			}
#line 1096 "../src/reversi-view.vala"
			_tmp54_ = _tmp55_;
#line 5903 "reversi-view.c"
		} else {
#line 1096 "../src/reversi-view.vala"
			_tmp54_ = FALSE;
#line 5907 "reversi-view.c"
		}
#line 1096 "../src/reversi-view.vala"
		_tmp9_ = _tmp54_;
#line 5911 "reversi-view.c"
	}
#line 1091 "../src/reversi-view.vala"
	if (_tmp9_) {
#line 1097 "../src/reversi-view.vala"
		result = FALSE;
#line 1097 "../src/reversi-view.vala"
		_g_free0 (key);
#line 1097 "../src/reversi-view.vala"
		return result;
#line 5921 "reversi-view.c"
	}
#line 1099 "../src/reversi-view.vala"
	self->priv->old_highlight_x = self->priv->highlight_x;
#line 1100 "../src/reversi-view.vala"
	self->priv->old_highlight_y = self->priv->highlight_y;
#line 1101 "../src/reversi-view.vala"
	_tmp62_ = key;
#line 1101 "../src/reversi-view.vala"
	_tmp63_ = _tmp62_;
#line 1101 "../src/reversi-view.vala"
	_tmp65_ = (NULL == _tmp63_) ? 0 : g_quark_from_string (_tmp63_);
#line 1101 "../src/reversi-view.vala"
	if ((_tmp65_ == ((0 != _tmp64_label0) ? _tmp64_label0 : (_tmp64_label0 = g_quark_from_static_string ("Left")))) || (_tmp65_ == ((0 != _tmp64_label1) ? _tmp64_label1 : (_tmp64_label1 = g_quark_from_static_string ("KP_Left"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 5937 "reversi-view.c"
			default:
			{
				gboolean _tmp66_ = FALSE;
#line 1105 "../src/reversi-view.vala"
				if (self->priv->mouse_position_set) {
#line 1105 "../src/reversi-view.vala"
					_tmp66_ = self->priv->show_mouse_highlight;
#line 5945 "reversi-view.c"
				} else {
#line 1105 "../src/reversi-view.vala"
					_tmp66_ = FALSE;
#line 5949 "reversi-view.c"
				}
#line 1105 "../src/reversi-view.vala"
				if (_tmp66_) {
#line 1105 "../src/reversi-view.vala"
					self->priv->highlight_x = self->priv->mouse_highlight_x;
#line 1105 "../src/reversi-view.vala"
					self->priv->highlight_y = self->priv->mouse_highlight_y;
#line 5957 "reversi-view.c"
				} else {
					gboolean _tmp67_ = FALSE;
#line 1106 "../src/reversi-view.vala"
					if (!self->priv->highlight_set) {
#line 5962 "reversi-view.c"
						Game* _tmp68_;
						Game* _tmp69_;
						Player _tmp70_;
						Player _tmp71_;
#line 1106 "../src/reversi-view.vala"
						_tmp68_ = reversi_view_get_game (self);
#line 1106 "../src/reversi-view.vala"
						_tmp69_ = _tmp68_;
#line 1106 "../src/reversi-view.vala"
						_tmp70_ = game_get_current_color (_tmp69_);
#line 1106 "../src/reversi-view.vala"
						_tmp71_ = _tmp70_;
#line 1106 "../src/reversi-view.vala"
						_tmp67_ = _tmp71_ == PLAYER_LIGHT;
#line 5977 "reversi-view.c"
					} else {
#line 1106 "../src/reversi-view.vala"
						_tmp67_ = FALSE;
#line 5981 "reversi-view.c"
					}
#line 1106 "../src/reversi-view.vala"
					if (_tmp67_) {
#line 1106 "../src/reversi-view.vala"
						self->priv->highlight_y = (guint8) (self->priv->game_size / 2);
#line 5987 "reversi-view.c"
					}
				}
#line 1107 "../src/reversi-view.vala"
				if (((gint) self->priv->highlight_x) > 0) {
#line 5992 "reversi-view.c"
					guint8 _tmp72_;
#line 1107 "../src/reversi-view.vala"
					_tmp72_ = self->priv->highlight_x;
#line 1107 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp72_ - 1;
#line 5998 "reversi-view.c"
				}
#line 1108 "../src/reversi-view.vala"
				break;
#line 6002 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label2) ? _tmp64_label2 : (_tmp64_label2 = g_quark_from_static_string ("Right")))) || (_tmp65_ == ((0 != _tmp64_label3) ? _tmp64_label3 : (_tmp64_label3 = g_quark_from_static_string ("KP_Right"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6008 "reversi-view.c"
			default:
			{
				gboolean _tmp73_ = FALSE;
#line 1111 "../src/reversi-view.vala"
				if (self->priv->mouse_position_set) {
#line 1111 "../src/reversi-view.vala"
					_tmp73_ = self->priv->show_mouse_highlight;
#line 6016 "reversi-view.c"
				} else {
#line 1111 "../src/reversi-view.vala"
					_tmp73_ = FALSE;
#line 6020 "reversi-view.c"
				}
#line 1111 "../src/reversi-view.vala"
				if (_tmp73_) {
#line 1111 "../src/reversi-view.vala"
					self->priv->highlight_x = self->priv->mouse_highlight_x;
#line 1111 "../src/reversi-view.vala"
					self->priv->highlight_y = self->priv->mouse_highlight_y;
#line 6028 "reversi-view.c"
				} else {
#line 1112 "../src/reversi-view.vala"
					if (!self->priv->highlight_set) {
#line 6032 "reversi-view.c"
						Game* _tmp74_;
						Game* _tmp75_;
						Player _tmp76_;
						Player _tmp77_;
#line 1114 "../src/reversi-view.vala"
						self->priv->highlight_x = (guint8) (self->priv->game_size / 2);
#line 1115 "../src/reversi-view.vala"
						_tmp74_ = reversi_view_get_game (self);
#line 1115 "../src/reversi-view.vala"
						_tmp75_ = _tmp74_;
#line 1115 "../src/reversi-view.vala"
						_tmp76_ = game_get_current_color (_tmp75_);
#line 1115 "../src/reversi-view.vala"
						_tmp77_ = _tmp76_;
#line 1115 "../src/reversi-view.vala"
						if (_tmp77_ == PLAYER_DARK) {
#line 1115 "../src/reversi-view.vala"
							self->priv->highlight_y = self->priv->highlight_x;
#line 6051 "reversi-view.c"
						}
					}
				}
#line 1117 "../src/reversi-view.vala"
				if (((gint) self->priv->highlight_x) < (self->priv->game_size - 1)) {
#line 6057 "reversi-view.c"
					guint8 _tmp78_;
#line 1117 "../src/reversi-view.vala"
					_tmp78_ = self->priv->highlight_x;
#line 1117 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp78_ + 1;
#line 6063 "reversi-view.c"
				}
#line 1118 "../src/reversi-view.vala"
				break;
#line 6067 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label4) ? _tmp64_label4 : (_tmp64_label4 = g_quark_from_static_string ("Up")))) || (_tmp65_ == ((0 != _tmp64_label5) ? _tmp64_label5 : (_tmp64_label5 = g_quark_from_static_string ("KP_Up"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6073 "reversi-view.c"
			default:
			{
				gboolean _tmp79_ = FALSE;
#line 1121 "../src/reversi-view.vala"
				if (self->priv->mouse_position_set) {
#line 1121 "../src/reversi-view.vala"
					_tmp79_ = self->priv->show_mouse_highlight;
#line 6081 "reversi-view.c"
				} else {
#line 1121 "../src/reversi-view.vala"
					_tmp79_ = FALSE;
#line 6085 "reversi-view.c"
				}
#line 1121 "../src/reversi-view.vala"
				if (_tmp79_) {
#line 1121 "../src/reversi-view.vala"
					self->priv->highlight_x = self->priv->mouse_highlight_x;
#line 1121 "../src/reversi-view.vala"
					self->priv->highlight_y = self->priv->mouse_highlight_y;
#line 6093 "reversi-view.c"
				} else {
					gboolean _tmp80_ = FALSE;
#line 1122 "../src/reversi-view.vala"
					if (!self->priv->highlight_set) {
#line 6098 "reversi-view.c"
						Game* _tmp81_;
						Game* _tmp82_;
						Player _tmp83_;
						Player _tmp84_;
#line 1122 "../src/reversi-view.vala"
						_tmp81_ = reversi_view_get_game (self);
#line 1122 "../src/reversi-view.vala"
						_tmp82_ = _tmp81_;
#line 1122 "../src/reversi-view.vala"
						_tmp83_ = game_get_current_color (_tmp82_);
#line 1122 "../src/reversi-view.vala"
						_tmp84_ = _tmp83_;
#line 1122 "../src/reversi-view.vala"
						_tmp80_ = _tmp84_ == PLAYER_LIGHT;
#line 6113 "reversi-view.c"
					} else {
#line 1122 "../src/reversi-view.vala"
						_tmp80_ = FALSE;
#line 6117 "reversi-view.c"
					}
#line 1122 "../src/reversi-view.vala"
					if (_tmp80_) {
#line 1122 "../src/reversi-view.vala"
						self->priv->highlight_x = (guint8) (self->priv->game_size / 2);
#line 6123 "reversi-view.c"
					}
				}
#line 1123 "../src/reversi-view.vala"
				if (((gint) self->priv->highlight_y) > 0) {
#line 6128 "reversi-view.c"
					guint8 _tmp85_;
#line 1123 "../src/reversi-view.vala"
					_tmp85_ = self->priv->highlight_y;
#line 1123 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp85_ - 1;
#line 6134 "reversi-view.c"
				}
#line 1124 "../src/reversi-view.vala"
				break;
#line 6138 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label6) ? _tmp64_label6 : (_tmp64_label6 = g_quark_from_static_string ("Down")))) || (_tmp65_ == ((0 != _tmp64_label7) ? _tmp64_label7 : (_tmp64_label7 = g_quark_from_static_string ("KP_Down"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6144 "reversi-view.c"
			default:
			{
				gboolean _tmp86_ = FALSE;
#line 1127 "../src/reversi-view.vala"
				if (self->priv->mouse_position_set) {
#line 1127 "../src/reversi-view.vala"
					_tmp86_ = self->priv->show_mouse_highlight;
#line 6152 "reversi-view.c"
				} else {
#line 1127 "../src/reversi-view.vala"
					_tmp86_ = FALSE;
#line 6156 "reversi-view.c"
				}
#line 1127 "../src/reversi-view.vala"
				if (_tmp86_) {
#line 1127 "../src/reversi-view.vala"
					self->priv->highlight_x = self->priv->mouse_highlight_x;
#line 1127 "../src/reversi-view.vala"
					self->priv->highlight_y = self->priv->mouse_highlight_y;
#line 6164 "reversi-view.c"
				} else {
#line 1128 "../src/reversi-view.vala"
					if (!self->priv->highlight_set) {
#line 6168 "reversi-view.c"
						Game* _tmp87_;
						Game* _tmp88_;
						Player _tmp89_;
						Player _tmp90_;
#line 1130 "../src/reversi-view.vala"
						self->priv->highlight_y = (guint8) (self->priv->game_size / 2);
#line 1131 "../src/reversi-view.vala"
						_tmp87_ = reversi_view_get_game (self);
#line 1131 "../src/reversi-view.vala"
						_tmp88_ = _tmp87_;
#line 1131 "../src/reversi-view.vala"
						_tmp89_ = game_get_current_color (_tmp88_);
#line 1131 "../src/reversi-view.vala"
						_tmp90_ = _tmp89_;
#line 1131 "../src/reversi-view.vala"
						if (_tmp90_ == PLAYER_DARK) {
#line 1131 "../src/reversi-view.vala"
							self->priv->highlight_x = self->priv->highlight_y;
#line 6187 "reversi-view.c"
						}
					}
				}
#line 1133 "../src/reversi-view.vala"
				if (((gint) self->priv->highlight_y) < (self->priv->game_size - 1)) {
#line 6193 "reversi-view.c"
					guint8 _tmp91_;
#line 1133 "../src/reversi-view.vala"
					_tmp91_ = self->priv->highlight_y;
#line 1133 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp91_ + 1;
#line 6199 "reversi-view.c"
				}
#line 1134 "../src/reversi-view.vala"
				break;
#line 6203 "reversi-view.c"
			}
		}
	} else if (((_tmp65_ == ((0 != _tmp64_label8) ? _tmp64_label8 : (_tmp64_label8 = g_quark_from_static_string ("space")))) || (_tmp65_ == ((0 != _tmp64_label9) ? _tmp64_label9 : (_tmp64_label9 = g_quark_from_static_string ("Return"))))) || (_tmp65_ == ((0 != _tmp64_label10) ? _tmp64_label10 : (_tmp64_label10 = g_quark_from_static_string ("KP_Enter"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6209 "reversi-view.c"
			default:
			{
#line 1139 "../src/reversi-view.vala"
				if (self->priv->show_mouse_highlight) {
#line 1141 "../src/reversi-view.vala"
					reversi_view_move_if_possible (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 1142 "../src/reversi-view.vala"
					result = TRUE;
#line 1142 "../src/reversi-view.vala"
					_g_free0 (key);
#line 1142 "../src/reversi-view.vala"
					return result;
#line 6222 "reversi-view.c"
				} else {
#line 1144 "../src/reversi-view.vala"
					if (self->priv->mouse_position_set) {
#line 1146 "../src/reversi-view.vala"
						self->priv->highlight_x = self->priv->mouse_position_x;
#line 1147 "../src/reversi-view.vala"
						self->priv->highlight_y = self->priv->mouse_position_y;
#line 6230 "reversi-view.c"
					}
				}
#line 1149 "../src/reversi-view.vala"
				break;
#line 6235 "reversi-view.c"
			}
		}
	} else if (_tmp65_ == ((0 != _tmp64_label11) ? _tmp64_label11 : (_tmp64_label11 = g_quark_from_static_string ("Escape")))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6241 "reversi-view.c"
			default:
			{
#line 1151 "../src/reversi-view.vala"
				break;
#line 6246 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label12) ? _tmp64_label12 : (_tmp64_label12 = g_quark_from_static_string ("a")))) || (_tmp65_ == ((0 != _tmp64_label13) ? _tmp64_label13 : (_tmp64_label13 = g_quark_from_static_string ("A"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6252 "reversi-view.c"
			default:
			{
#line 1153 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 0;
#line 1153 "../src/reversi-view.vala"
				break;
#line 6259 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label14) ? _tmp64_label14 : (_tmp64_label14 = g_quark_from_static_string ("b")))) || (_tmp65_ == ((0 != _tmp64_label15) ? _tmp64_label15 : (_tmp64_label15 = g_quark_from_static_string ("B"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6265 "reversi-view.c"
			default:
			{
#line 1154 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 1;
#line 1154 "../src/reversi-view.vala"
				break;
#line 6272 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label16) ? _tmp64_label16 : (_tmp64_label16 = g_quark_from_static_string ("c")))) || (_tmp65_ == ((0 != _tmp64_label17) ? _tmp64_label17 : (_tmp64_label17 = g_quark_from_static_string ("C"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6278 "reversi-view.c"
			default:
			{
#line 1155 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 2;
#line 1155 "../src/reversi-view.vala"
				break;
#line 6285 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label18) ? _tmp64_label18 : (_tmp64_label18 = g_quark_from_static_string ("d")))) || (_tmp65_ == ((0 != _tmp64_label19) ? _tmp64_label19 : (_tmp64_label19 = g_quark_from_static_string ("D"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6291 "reversi-view.c"
			default:
			{
#line 1156 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 3;
#line 1156 "../src/reversi-view.vala"
				break;
#line 6298 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label20) ? _tmp64_label20 : (_tmp64_label20 = g_quark_from_static_string ("e")))) || (_tmp65_ == ((0 != _tmp64_label21) ? _tmp64_label21 : (_tmp64_label21 = g_quark_from_static_string ("E"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6304 "reversi-view.c"
			default:
			{
#line 1157 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 4;
#line 1157 "../src/reversi-view.vala"
				break;
#line 6311 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label22) ? _tmp64_label22 : (_tmp64_label22 = g_quark_from_static_string ("f")))) || (_tmp65_ == ((0 != _tmp64_label23) ? _tmp64_label23 : (_tmp64_label23 = g_quark_from_static_string ("F"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6317 "reversi-view.c"
			default:
			{
#line 1158 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 5;
#line 1158 "../src/reversi-view.vala"
				break;
#line 6324 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label24) ? _tmp64_label24 : (_tmp64_label24 = g_quark_from_static_string ("g")))) || (_tmp65_ == ((0 != _tmp64_label25) ? _tmp64_label25 : (_tmp64_label25 = g_quark_from_static_string ("G"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6330 "reversi-view.c"
			default:
			{
#line 1159 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 6;
#line 1159 "../src/reversi-view.vala"
				break;
#line 6337 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label26) ? _tmp64_label26 : (_tmp64_label26 = g_quark_from_static_string ("h")))) || (_tmp65_ == ((0 != _tmp64_label27) ? _tmp64_label27 : (_tmp64_label27 = g_quark_from_static_string ("H"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6343 "reversi-view.c"
			default:
			{
#line 1160 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 7;
#line 1160 "../src/reversi-view.vala"
				break;
#line 6350 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label28) ? _tmp64_label28 : (_tmp64_label28 = g_quark_from_static_string ("i")))) || (_tmp65_ == ((0 != _tmp64_label29) ? _tmp64_label29 : (_tmp64_label29 = g_quark_from_static_string ("I"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6356 "reversi-view.c"
			default:
			{
#line 1161 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 8;
#line 1161 "../src/reversi-view.vala"
				break;
#line 6363 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label30) ? _tmp64_label30 : (_tmp64_label30 = g_quark_from_static_string ("j")))) || (_tmp65_ == ((0 != _tmp64_label31) ? _tmp64_label31 : (_tmp64_label31 = g_quark_from_static_string ("J"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6369 "reversi-view.c"
			default:
			{
#line 1162 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 9;
#line 1162 "../src/reversi-view.vala"
				break;
#line 6376 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label32) ? _tmp64_label32 : (_tmp64_label32 = g_quark_from_static_string ("1")))) || (_tmp65_ == ((0 != _tmp64_label33) ? _tmp64_label33 : (_tmp64_label33 = g_quark_from_static_string ("KP_1"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6382 "reversi-view.c"
			default:
			{
#line 1164 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 0;
#line 1164 "../src/reversi-view.vala"
				break;
#line 6389 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label34) ? _tmp64_label34 : (_tmp64_label34 = g_quark_from_static_string ("2")))) || (_tmp65_ == ((0 != _tmp64_label35) ? _tmp64_label35 : (_tmp64_label35 = g_quark_from_static_string ("KP_2"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6395 "reversi-view.c"
			default:
			{
#line 1165 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 1;
#line 1165 "../src/reversi-view.vala"
				break;
#line 6402 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label36) ? _tmp64_label36 : (_tmp64_label36 = g_quark_from_static_string ("3")))) || (_tmp65_ == ((0 != _tmp64_label37) ? _tmp64_label37 : (_tmp64_label37 = g_quark_from_static_string ("KP_3"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6408 "reversi-view.c"
			default:
			{
#line 1166 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 2;
#line 1166 "../src/reversi-view.vala"
				break;
#line 6415 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label38) ? _tmp64_label38 : (_tmp64_label38 = g_quark_from_static_string ("4")))) || (_tmp65_ == ((0 != _tmp64_label39) ? _tmp64_label39 : (_tmp64_label39 = g_quark_from_static_string ("KP_4"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6421 "reversi-view.c"
			default:
			{
#line 1167 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 3;
#line 1167 "../src/reversi-view.vala"
				break;
#line 6428 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label40) ? _tmp64_label40 : (_tmp64_label40 = g_quark_from_static_string ("5")))) || (_tmp65_ == ((0 != _tmp64_label41) ? _tmp64_label41 : (_tmp64_label41 = g_quark_from_static_string ("KP_5"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6434 "reversi-view.c"
			default:
			{
#line 1168 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 4;
#line 1168 "../src/reversi-view.vala"
				break;
#line 6441 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label42) ? _tmp64_label42 : (_tmp64_label42 = g_quark_from_static_string ("6")))) || (_tmp65_ == ((0 != _tmp64_label43) ? _tmp64_label43 : (_tmp64_label43 = g_quark_from_static_string ("KP_6"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6447 "reversi-view.c"
			default:
			{
#line 1169 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 5;
#line 1169 "../src/reversi-view.vala"
				break;
#line 6454 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label44) ? _tmp64_label44 : (_tmp64_label44 = g_quark_from_static_string ("7")))) || (_tmp65_ == ((0 != _tmp64_label45) ? _tmp64_label45 : (_tmp64_label45 = g_quark_from_static_string ("KP_7"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6460 "reversi-view.c"
			default:
			{
#line 1170 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 6;
#line 1170 "../src/reversi-view.vala"
				break;
#line 6467 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label46) ? _tmp64_label46 : (_tmp64_label46 = g_quark_from_static_string ("8")))) || (_tmp65_ == ((0 != _tmp64_label47) ? _tmp64_label47 : (_tmp64_label47 = g_quark_from_static_string ("KP_8"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6473 "reversi-view.c"
			default:
			{
#line 1171 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 7;
#line 1171 "../src/reversi-view.vala"
				break;
#line 6480 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label48) ? _tmp64_label48 : (_tmp64_label48 = g_quark_from_static_string ("9")))) || (_tmp65_ == ((0 != _tmp64_label49) ? _tmp64_label49 : (_tmp64_label49 = g_quark_from_static_string ("KP_9"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6486 "reversi-view.c"
			default:
			{
#line 1172 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 8;
#line 1172 "../src/reversi-view.vala"
				break;
#line 6493 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label50) ? _tmp64_label50 : (_tmp64_label50 = g_quark_from_static_string ("0")))) || (_tmp65_ == ((0 != _tmp64_label51) ? _tmp64_label51 : (_tmp64_label51 = g_quark_from_static_string ("KP_0"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6499 "reversi-view.c"
			default:
			{
#line 1173 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 9;
#line 1173 "../src/reversi-view.vala"
				break;
#line 6506 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label52) ? _tmp64_label52 : (_tmp64_label52 = g_quark_from_static_string ("Home")))) || (_tmp65_ == ((0 != _tmp64_label53) ? _tmp64_label53 : (_tmp64_label53 = g_quark_from_static_string ("KP_Home"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6512 "reversi-view.c"
			default:
			{
#line 1177 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 0;
#line 1178 "../src/reversi-view.vala"
				break;
#line 6519 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label54) ? _tmp64_label54 : (_tmp64_label54 = g_quark_from_static_string ("End")))) || (_tmp65_ == ((0 != _tmp64_label55) ? _tmp64_label55 : (_tmp64_label55 = g_quark_from_static_string ("KP_End"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6525 "reversi-view.c"
			default:
			{
#line 1181 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) (self->priv->game_size - 1);
#line 1182 "../src/reversi-view.vala"
				break;
#line 6532 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label56) ? _tmp64_label56 : (_tmp64_label56 = g_quark_from_static_string ("Page_Up")))) || (_tmp65_ == ((0 != _tmp64_label57) ? _tmp64_label57 : (_tmp64_label57 = g_quark_from_static_string ("KP_Page_Up"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6538 "reversi-view.c"
			default:
			{
#line 1185 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 0;
#line 1186 "../src/reversi-view.vala"
				break;
#line 6545 "reversi-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label58) ? _tmp64_label58 : (_tmp64_label58 = g_quark_from_static_string ("Page_Down")))) || (_tmp65_ == ((0 != _tmp64_label59) ? _tmp64_label59 : (_tmp64_label59 = g_quark_from_static_string ("KP_Next"))))) {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6551 "reversi-view.c"
			default:
			{
#line 1189 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) (self->priv->game_size - 1);
#line 1190 "../src/reversi-view.vala"
				break;
#line 6558 "reversi-view.c"
			}
		}
	} else {
#line 1101 "../src/reversi-view.vala"
		switch (0) {
#line 6564 "reversi-view.c"
			default:
			{
#line 1194 "../src/reversi-view.vala"
				result = FALSE;
#line 1194 "../src/reversi-view.vala"
				_g_free0 (key);
#line 1194 "../src/reversi-view.vala"
				return result;
#line 6573 "reversi-view.c"
			}
		}
	}
#line 1197 "../src/reversi-view.vala"
	self->priv->highlight_set = TRUE;
#line 1199 "../src/reversi-view.vala"
	_tmp94_ = key;
#line 1199 "../src/reversi-view.vala"
	if (g_strcmp0 (_tmp94_, "space") != 0) {
#line 6583 "reversi-view.c"
		const gchar* _tmp95_;
#line 1199 "../src/reversi-view.vala"
		_tmp95_ = key;
#line 1199 "../src/reversi-view.vala"
		_tmp93_ = g_strcmp0 (_tmp95_, "Return") != 0;
#line 6589 "reversi-view.c"
	} else {
#line 1199 "../src/reversi-view.vala"
		_tmp93_ = FALSE;
#line 6593 "reversi-view.c"
	}
#line 1199 "../src/reversi-view.vala"
	if (_tmp93_) {
#line 6597 "reversi-view.c"
		const gchar* _tmp96_;
#line 1199 "../src/reversi-view.vala"
		_tmp96_ = key;
#line 1199 "../src/reversi-view.vala"
		_tmp92_ = g_strcmp0 (_tmp96_, "KP_Enter") != 0;
#line 6603 "reversi-view.c"
	} else {
#line 1199 "../src/reversi-view.vala"
		_tmp92_ = FALSE;
#line 6607 "reversi-view.c"
	}
#line 1199 "../src/reversi-view.vala"
	if (_tmp92_) {
#line 1200 "../src/reversi-view.vala"
		g_signal_emit (self, reversi_view_signals[REVERSI_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL], 0);
#line 6613 "reversi-view.c"
	}
#line 1202 "../src/reversi-view.vala"
	_tmp97_ = key;
#line 1202 "../src/reversi-view.vala"
	if (g_strcmp0 (_tmp97_, "Escape") == 0) {
#line 1203 "../src/reversi-view.vala"
		self->priv->show_highlight = FALSE;
#line 6621 "reversi-view.c"
	} else {
#line 1204 "../src/reversi-view.vala"
		if (self->priv->show_highlight) {
#line 1205 "../src/reversi-view.vala"
			self->priv->highlight_state = REVERSI_VIEW_HIGHLIGHT_MAX;
#line 6627 "reversi-view.c"
		} else {
#line 1207 "../src/reversi-view.vala"
			self->priv->show_highlight = TRUE;
#line 6631 "reversi-view.c"
		}
	}
#line 1209 "../src/reversi-view.vala"
	reversi_view_queue_draw_tile (self, self->priv->old_highlight_x, self->priv->old_highlight_y);
#line 1210 "../src/reversi-view.vala"
	if (self->priv->old_highlight_x != self->priv->highlight_x) {
#line 1210 "../src/reversi-view.vala"
		_tmp98_ = TRUE;
#line 6640 "reversi-view.c"
	} else {
#line 1211 "../src/reversi-view.vala"
		_tmp98_ = self->priv->old_highlight_y != self->priv->highlight_y;
#line 6644 "reversi-view.c"
	}
#line 1210 "../src/reversi-view.vala"
	if (_tmp98_) {
#line 1212 "../src/reversi-view.vala"
		reversi_view_queue_draw_tile (self, self->priv->highlight_x, self->priv->highlight_y);
#line 6650 "reversi-view.c"
	}
#line 1213 "../src/reversi-view.vala"
	_tmp99_ = key;
#line 1213 "../src/reversi-view.vala"
	if (g_strcmp0 (_tmp99_, "Escape") != 0) {
#line 1215 "../src/reversi-view.vala"
		self->priv->show_mouse_highlight = FALSE;
#line 1216 "../src/reversi-view.vala"
		if (self->priv->mouse_position_set) {
#line 1217 "../src/reversi-view.vala"
			reversi_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 6662 "reversi-view.c"
		}
	} else {
		gboolean _tmp100_ = FALSE;
#line 1219 "../src/reversi-view.vala"
		if (self->priv->mouse_position_set) {
#line 1219 "../src/reversi-view.vala"
			_tmp100_ = self->priv->mouse_is_in;
#line 6670 "reversi-view.c"
		} else {
#line 1219 "../src/reversi-view.vala"
			_tmp100_ = FALSE;
#line 6674 "reversi-view.c"
		}
#line 1219 "../src/reversi-view.vala"
		if (_tmp100_) {
#line 1221 "../src/reversi-view.vala"
			self->priv->highlight_x = self->priv->mouse_position_x;
#line 1222 "../src/reversi-view.vala"
			self->priv->highlight_y = self->priv->mouse_position_y;
#line 1223 "../src/reversi-view.vala"
			_reversi_view_on_motion (self, self->priv->highlight_x, self->priv->highlight_y, TRUE);
#line 6684 "reversi-view.c"
		}
	}
#line 1225 "../src/reversi-view.vala"
	result = TRUE;
#line 1225 "../src/reversi-view.vala"
	_g_free0 (key);
#line 1225 "../src/reversi-view.vala"
	return result;
#line 6693 "reversi-view.c"
}

static void
reversi_view_init_possible_moves (ReversiView* self)
{
	gboolean* _tmp0_;
#line 1235 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1237 "../src/reversi-view.vala"
	self->priv->playable_tiles_highlight_state = (guint8) 0;
#line 1238 "../src/reversi-view.vala"
	_tmp0_ = g_new0 (gboolean, self->priv->game_size * self->priv->game_size);
#line 1238 "../src/reversi-view.vala"
	self->priv->possible_moves = (g_free (self->priv->possible_moves), NULL);
#line 1238 "../src/reversi-view.vala"
	self->priv->possible_moves = _tmp0_;
#line 1238 "../src/reversi-view.vala"
	self->priv->possible_moves_length1 = self->priv->game_size;
#line 1238 "../src/reversi-view.vala"
	self->priv->possible_moves_length2 = self->priv->game_size;
#line 6714 "reversi-view.c"
	{
		guint8 x = 0U;
#line 1240 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 6719 "reversi-view.c"
		{
			gboolean _tmp1_ = FALSE;
#line 1240 "../src/reversi-view.vala"
			_tmp1_ = TRUE;
#line 1240 "../src/reversi-view.vala"
			while (TRUE) {
#line 1240 "../src/reversi-view.vala"
				if (!_tmp1_) {
#line 6728 "reversi-view.c"
					guint8 _tmp2_;
#line 1240 "../src/reversi-view.vala"
					_tmp2_ = x;
#line 1240 "../src/reversi-view.vala"
					x = _tmp2_ + 1;
#line 6734 "reversi-view.c"
				}
#line 1240 "../src/reversi-view.vala"
				_tmp1_ = FALSE;
#line 1240 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 1240 "../src/reversi-view.vala"
					break;
#line 6742 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 1241 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 6748 "reversi-view.c"
					{
						gboolean _tmp3_ = FALSE;
#line 1241 "../src/reversi-view.vala"
						_tmp3_ = TRUE;
#line 1241 "../src/reversi-view.vala"
						while (TRUE) {
#line 6755 "reversi-view.c"
							gboolean* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
#line 1241 "../src/reversi-view.vala"
							if (!_tmp3_) {
#line 6761 "reversi-view.c"
								guint8 _tmp4_;
#line 1241 "../src/reversi-view.vala"
								_tmp4_ = y;
#line 1241 "../src/reversi-view.vala"
								y = _tmp4_ + 1;
#line 6767 "reversi-view.c"
							}
#line 1241 "../src/reversi-view.vala"
							_tmp3_ = FALSE;
#line 1241 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 1241 "../src/reversi-view.vala"
								break;
#line 6775 "reversi-view.c"
							}
#line 1242 "../src/reversi-view.vala"
							_tmp5_ = self->priv->possible_moves;
#line 1242 "../src/reversi-view.vala"
							_tmp5__length1 = self->priv->possible_moves_length1;
#line 1242 "../src/reversi-view.vala"
							_tmp5__length2 = self->priv->possible_moves_length2;
#line 1242 "../src/reversi-view.vala"
							_tmp5_[(x * _tmp5__length2) + y] = FALSE;
#line 6785 "reversi-view.c"
						}
					}
				}
			}
		}
	}
}

static inline void
reversi_view_move_if_possible (ReversiView* self,
                               guint8 x,
                               guint8 y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	Iagno* _tmp2_;
	ComputerPlayer* _tmp3_;
	ComputerPlayer* _tmp4_;
#line 1245 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1247 "../src/reversi-view.vala"
	_tmp2_ = self->priv->iagno_instance;
#line 1247 "../src/reversi-view.vala"
	_tmp3_ = iagno_get_computer (_tmp2_);
#line 1247 "../src/reversi-view.vala"
	_tmp4_ = _tmp3_;
#line 1247 "../src/reversi-view.vala"
	if (_tmp4_ == NULL) {
#line 1247 "../src/reversi-view.vala"
		_tmp1_ = TRUE;
#line 6816 "reversi-view.c"
	} else {
		Iagno* _tmp5_;
		Player _tmp6_;
		Player _tmp7_;
		Game* _tmp8_;
		Game* _tmp9_;
		Player _tmp10_;
		Player _tmp11_;
#line 1247 "../src/reversi-view.vala"
		_tmp5_ = self->priv->iagno_instance;
#line 1247 "../src/reversi-view.vala"
		_tmp6_ = iagno_get_player_one (_tmp5_);
#line 1247 "../src/reversi-view.vala"
		_tmp7_ = _tmp6_;
#line 1247 "../src/reversi-view.vala"
		_tmp8_ = reversi_view_get_game (self);
#line 1247 "../src/reversi-view.vala"
		_tmp9_ = _tmp8_;
#line 1247 "../src/reversi-view.vala"
		_tmp10_ = game_get_current_color (_tmp9_);
#line 1247 "../src/reversi-view.vala"
		_tmp11_ = _tmp10_;
#line 1247 "../src/reversi-view.vala"
		_tmp1_ = _tmp7_ == _tmp11_;
#line 6841 "reversi-view.c"
	}
#line 1247 "../src/reversi-view.vala"
	if (_tmp1_) {
#line 6845 "reversi-view.c"
		Game* _tmp12_;
		Game* _tmp13_;
#line 1248 "../src/reversi-view.vala"
		_tmp12_ = reversi_view_get_game (self);
#line 1248 "../src/reversi-view.vala"
		_tmp13_ = _tmp12_;
#line 1248 "../src/reversi-view.vala"
		_tmp0_ = game_get_owner (_tmp13_, x, y) != PLAYER_NONE;
#line 6854 "reversi-view.c"
	} else {
#line 1247 "../src/reversi-view.vala"
		_tmp0_ = FALSE;
#line 6858 "reversi-view.c"
	}
#line 1247 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 1249 "../src/reversi-view.vala"
		reversi_view_highlight_playable_tiles (self);
#line 6864 "reversi-view.c"
	} else {
#line 1251 "../src/reversi-view.vala"
		g_signal_emit (self, reversi_view_signals[REVERSI_VIEW_MOVE_SIGNAL], 0, x, y);
#line 6868 "reversi-view.c"
	}
}

static void
_possible_move_free0_ (gpointer var)
{
#line 1260 "../src/reversi-view.vala"
	(var == NULL) ? NULL : (var = (possible_move_free (var), NULL));
#line 6877 "reversi-view.c"
}

static inline void
_g_slist_free__possible_move_free0_ (GSList* self)
{
#line 1260 "../src/reversi-view.vala"
	g_slist_free_full (self, (GDestroyNotify) _possible_move_free0_);
#line 6885 "reversi-view.c"
}

static void
__lambda19_ (ReversiView* self,
             PossibleMove* move)
{
	guint8 x = 0U;
	guint8 y = 0U;
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 1263 "../src/reversi-view.vala"
	x = ((PossibleMove) (*move)).x;
#line 1264 "../src/reversi-view.vala"
	y = ((PossibleMove) (*move)).y;
#line 1265 "../src/reversi-view.vala"
	_tmp0_ = self->priv->possible_moves;
#line 1265 "../src/reversi-view.vala"
	_tmp0__length1 = self->priv->possible_moves_length1;
#line 1265 "../src/reversi-view.vala"
	_tmp0__length2 = self->priv->possible_moves_length2;
#line 1265 "../src/reversi-view.vala"
	_tmp0_[(x * _tmp0__length2) + y] = TRUE;
#line 1266 "../src/reversi-view.vala"
	reversi_view_queue_draw_tile (self, x, y);
#line 6911 "reversi-view.c"
}

static void
___lambda19__gfunc (gconstpointer data,
                    gpointer self)
{
#line 1262 "../src/reversi-view.vala"
	__lambda19_ ((ReversiView*) self, (PossibleMove*) data);
#line 6920 "reversi-view.c"
}

static inline void
reversi_view_highlight_playable_tiles (ReversiView* self)
{
	GSList* moves = NULL;
	Game* _tmp0_;
	Game* _tmp1_;
	GSList* _tmp2_ = NULL;
	GSList* _tmp3_;
#line 1254 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1256 "../src/reversi-view.vala"
	if (((gint) self->priv->playable_tiles_highlight_state) != 0) {
#line 1257 "../src/reversi-view.vala"
		return;
#line 6937 "reversi-view.c"
	}
#line 1260 "../src/reversi-view.vala"
	_tmp0_ = reversi_view_get_game (self);
#line 1260 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_;
#line 1260 "../src/reversi-view.vala"
	game_get_possible_moves (_tmp1_, &_tmp2_);
#line 1260 "../src/reversi-view.vala"
	(moves == NULL) ? NULL : (moves = (_g_slist_free__possible_move_free0_ (moves), NULL));
#line 1260 "../src/reversi-view.vala"
	moves = _tmp2_;
#line 1261 "../src/reversi-view.vala"
	self->priv->playable_tiles_highlight_state = (guint8) 1;
#line 1262 "../src/reversi-view.vala"
	_tmp3_ = moves;
#line 1262 "../src/reversi-view.vala"
	g_slist_foreach (_tmp3_, ___lambda19__gfunc, self);
#line 1254 "../src/reversi-view.vala"
	(moves == NULL) ? NULL : (moves = (_g_slist_free__possible_move_free0_ (moves), NULL));
#line 6957 "reversi-view.c"
}

static gboolean
reversi_view_get_show_turnable_tiles (ReversiView* self)
{
	gboolean result;
#line 25 "../src/reversi-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 25 "../src/reversi-view.vala"
	result = self->priv->_show_turnable_tiles;
#line 25 "../src/reversi-view.vala"
	return result;
#line 6970 "reversi-view.c"
}

void
reversi_view_set_show_turnable_tiles (ReversiView* self,
                                      gboolean value)
{
#line 25 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/reversi-view.vala"
	if (reversi_view_get_show_turnable_tiles (self) != value) {
#line 25 "../src/reversi-view.vala"
		self->priv->_show_turnable_tiles = value;
#line 25 "../src/reversi-view.vala"
		g_object_notify_by_pspec ((GObject *) self, reversi_view_properties[REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY]);
#line 6985 "reversi-view.c"
	}
}

const gchar*
reversi_view_get_sound_flip (ReversiView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 66 "../src/reversi-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../src/reversi-view.vala"
	_tmp0_ = self->priv->_sound_flip;
#line 66 "../src/reversi-view.vala"
	result = _tmp0_;
#line 66 "../src/reversi-view.vala"
	return result;
#line 7002 "reversi-view.c"
}

static void
reversi_view_set_sound_flip (ReversiView* self,
                             const gchar* value)
{
	gchar* _tmp0_;
#line 66 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/reversi-view.vala"
	_tmp0_ = g_strdup (value);
#line 66 "../src/reversi-view.vala"
	_g_free0 (self->priv->_sound_flip);
#line 66 "../src/reversi-view.vala"
	self->priv->_sound_flip = _tmp0_;
#line 7018 "reversi-view.c"
}

const gchar*
reversi_view_get_sound_gameover (ReversiView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 67 "../src/reversi-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../src/reversi-view.vala"
	_tmp0_ = self->priv->_sound_gameover;
#line 67 "../src/reversi-view.vala"
	result = _tmp0_;
#line 67 "../src/reversi-view.vala"
	return result;
#line 7034 "reversi-view.c"
}

static void
reversi_view_set_sound_gameover (ReversiView* self,
                                 const gchar* value)
{
	gchar* _tmp0_;
#line 67 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 67 "../src/reversi-view.vala"
	_tmp0_ = g_strdup (value);
#line 67 "../src/reversi-view.vala"
	_g_free0 (self->priv->_sound_gameover);
#line 67 "../src/reversi-view.vala"
	self->priv->_sound_gameover = _tmp0_;
#line 7050 "reversi-view.c"
}

Game*
reversi_view_get_game (ReversiView* self)
{
	Game* result;
	Game* _tmp0_;
#line 114 "../src/reversi-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "../src/reversi-view.vala"
	if (!self->priv->game_is_set) {
#line 117 "../src/reversi-view.vala"
		g_assert_not_reached ();
#line 7064 "reversi-view.c"
	}
#line 118 "../src/reversi-view.vala"
	_tmp0_ = self->priv->_game;
#line 118 "../src/reversi-view.vala"
	result = _tmp0_;
#line 118 "../src/reversi-view.vala"
	return result;
#line 7072 "reversi-view.c"
}

static void
_reversi_view_game_is_complete_cb_game_completeness_updated (Game* _sender,
                                                             gboolean completeness,
                                                             gpointer self)
{
#line 138 "../src/reversi-view.vala"
	reversi_view_game_is_complete_cb ((ReversiView*) self);
#line 7082 "reversi-view.c"
}

static void
_reversi_view_turn_ended_cb_game_turn_ended (Game* _sender,
                                             gboolean undoing,
                                             gboolean no_draw,
                                             gpointer self)
{
#line 139 "../src/reversi-view.vala"
	reversi_view_turn_ended_cb ((ReversiView*) self, undoing, no_draw);
#line 7093 "reversi-view.c"
}

void
reversi_view_set_game (ReversiView* self,
                       Game* value)
{
	Game* test = NULL;
	Game* _tmp0_;
	Game* _tmp2_;
	Game* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	gint* _tmp6_;
	gint* _tmp7_;
	gint* _tmp8_;
	Game* _tmp15_;
	Game* _tmp16_;
	gboolean odd_game = FALSE;
	gboolean _tmp17_ = FALSE;
	Game* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	guint8 _tmp21_ = 0U;
#line 120 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/reversi-view.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 122 "../src/reversi-view.vala"
	test = _tmp0_;
#line 123 "../src/reversi-view.vala"
	if (test == NULL) {
#line 124 "../src/reversi-view.vala"
		g_assert_not_reached ();
#line 7127 "reversi-view.c"
	}
#line 126 "../src/reversi-view.vala"
	if (self->priv->game_is_set) {
#line 7131 "reversi-view.c"
		Game* _tmp1_;
#line 127 "../src/reversi-view.vala"
		_tmp1_ = self->priv->_game;
#line 127 "../src/reversi-view.vala"
		g_signal_handlers_disconnect_by_func (_tmp1_, NULL, self);
#line 7137 "reversi-view.c"
	}
#line 128 "../src/reversi-view.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 128 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 128 "../src/reversi-view.vala"
	self->priv->_game = _tmp2_;
#line 129 "../src/reversi-view.vala"
	self->priv->game_is_set = TRUE;
#line 130 "../src/reversi-view.vala"
	_tmp3_ = self->priv->_game;
#line 130 "../src/reversi-view.vala"
	_tmp4_ = game_get_size (_tmp3_);
#line 130 "../src/reversi-view.vala"
	_tmp5_ = _tmp4_;
#line 130 "../src/reversi-view.vala"
	self->priv->game_size = _tmp5_;
#line 131 "../src/reversi-view.vala"
	_tmp6_ = g_new0 (gint, self->priv->game_size * self->priv->game_size);
#line 131 "../src/reversi-view.vala"
	self->priv->pixmaps = (g_free (self->priv->pixmaps), NULL);
#line 131 "../src/reversi-view.vala"
	self->priv->pixmaps = _tmp6_;
#line 131 "../src/reversi-view.vala"
	self->priv->pixmaps_length1 = self->priv->game_size;
#line 131 "../src/reversi-view.vala"
	self->priv->pixmaps_length2 = self->priv->game_size;
#line 132 "../src/reversi-view.vala"
	_tmp7_ = g_new0 (gint, self->priv->game_size * self->priv->game_size);
#line 132 "../src/reversi-view.vala"
	self->priv->tile_xs = (g_free (self->priv->tile_xs), NULL);
#line 132 "../src/reversi-view.vala"
	self->priv->tile_xs = _tmp7_;
#line 132 "../src/reversi-view.vala"
	self->priv->tile_xs_length1 = self->priv->game_size;
#line 132 "../src/reversi-view.vala"
	self->priv->tile_xs_length2 = self->priv->game_size;
#line 133 "../src/reversi-view.vala"
	_tmp8_ = g_new0 (gint, self->priv->game_size * self->priv->game_size);
#line 133 "../src/reversi-view.vala"
	self->priv->tile_ys = (g_free (self->priv->tile_ys), NULL);
#line 133 "../src/reversi-view.vala"
	self->priv->tile_ys = _tmp8_;
#line 133 "../src/reversi-view.vala"
	self->priv->tile_ys_length1 = self->priv->game_size;
#line 133 "../src/reversi-view.vala"
	self->priv->tile_ys_length2 = self->priv->game_size;
#line 134 "../src/reversi-view.vala"
	reversi_view_init_possible_moves (self);
#line 7187 "reversi-view.c"
	{
		guint8 x = 0U;
#line 135 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 7192 "reversi-view.c"
		{
			gboolean _tmp9_ = FALSE;
#line 135 "../src/reversi-view.vala"
			_tmp9_ = TRUE;
#line 135 "../src/reversi-view.vala"
			while (TRUE) {
#line 135 "../src/reversi-view.vala"
				if (!_tmp9_) {
#line 7201 "reversi-view.c"
					guint8 _tmp10_;
#line 135 "../src/reversi-view.vala"
					_tmp10_ = x;
#line 135 "../src/reversi-view.vala"
					x = _tmp10_ + 1;
#line 7207 "reversi-view.c"
				}
#line 135 "../src/reversi-view.vala"
				_tmp9_ = FALSE;
#line 135 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 135 "../src/reversi-view.vala"
					break;
#line 7215 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 136 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 7221 "reversi-view.c"
					{
						gboolean _tmp11_ = FALSE;
#line 136 "../src/reversi-view.vala"
						_tmp11_ = TRUE;
#line 136 "../src/reversi-view.vala"
						while (TRUE) {
#line 7228 "reversi-view.c"
							gint* _tmp13_;
							gint _tmp13__length1;
							gint _tmp13__length2;
							Game* _tmp14_;
#line 136 "../src/reversi-view.vala"
							if (!_tmp11_) {
#line 7235 "reversi-view.c"
								guint8 _tmp12_;
#line 136 "../src/reversi-view.vala"
								_tmp12_ = y;
#line 136 "../src/reversi-view.vala"
								y = _tmp12_ + 1;
#line 7241 "reversi-view.c"
							}
#line 136 "../src/reversi-view.vala"
							_tmp11_ = FALSE;
#line 136 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 136 "../src/reversi-view.vala"
								break;
#line 7249 "reversi-view.c"
							}
#line 137 "../src/reversi-view.vala"
							_tmp13_ = self->priv->pixmaps;
#line 137 "../src/reversi-view.vala"
							_tmp13__length1 = self->priv->pixmaps_length1;
#line 137 "../src/reversi-view.vala"
							_tmp13__length2 = self->priv->pixmaps_length2;
#line 137 "../src/reversi-view.vala"
							_tmp14_ = self->priv->_game;
#line 137 "../src/reversi-view.vala"
							_tmp13_[(x * _tmp13__length2) + y] = reversi_view_get_pixmap (game_get_owner (_tmp14_, x, y));
#line 7261 "reversi-view.c"
						}
					}
				}
			}
		}
	}
#line 138 "../src/reversi-view.vala"
	_tmp15_ = self->priv->_game;
#line 138 "../src/reversi-view.vala"
	g_signal_connect_object (_tmp15_, "completeness-updated", (GCallback) _reversi_view_game_is_complete_cb_game_completeness_updated, self, 0);
#line 139 "../src/reversi-view.vala"
	_tmp16_ = self->priv->_game;
#line 139 "../src/reversi-view.vala"
	g_signal_connect_object (_tmp16_, "turn-ended", (GCallback) _reversi_view_turn_ended_cb_game_turn_ended, self, 0);
#line 141 "../src/reversi-view.vala"
	self->priv->show_highlight = FALSE;
#line 142 "../src/reversi-view.vala"
	odd_game = (self->priv->game_size % 2) != 0;
#line 143 "../src/reversi-view.vala"
	_tmp18_ = self->priv->_game;
#line 143 "../src/reversi-view.vala"
	_tmp19_ = game_get_alternative_start (_tmp18_);
#line 143 "../src/reversi-view.vala"
	_tmp20_ = _tmp19_;
#line 143 "../src/reversi-view.vala"
	if (_tmp20_) {
#line 143 "../src/reversi-view.vala"
		_tmp17_ = TRUE;
#line 7290 "reversi-view.c"
	} else {
#line 143 "../src/reversi-view.vala"
		_tmp17_ = odd_game;
#line 7294 "reversi-view.c"
	}
#line 143 "../src/reversi-view.vala"
	self->priv->highlight_set = _tmp17_;
#line 144 "../src/reversi-view.vala"
	if (odd_game) {
#line 144 "../src/reversi-view.vala"
		_tmp21_ = (guint8) (self->priv->game_size / 2);
#line 7302 "reversi-view.c"
	} else {
#line 144 "../src/reversi-view.vala"
		_tmp21_ = (guint8) ((self->priv->game_size / 2) - 1);
#line 7306 "reversi-view.c"
	}
#line 144 "../src/reversi-view.vala"
	self->priv->highlight_x = _tmp21_;
#line 145 "../src/reversi-view.vala"
	self->priv->highlight_y = self->priv->highlight_x;
#line 146 "../src/reversi-view.vala"
	self->priv->highlight_state = (guint8) 0;
#line 148 "../src/reversi-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 120 "../src/reversi-view.vala"
	_g_object_unref0 (test);
#line 7318 "reversi-view.c"
}

const gchar*
reversi_view_get_theme (ReversiView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 185 "../src/reversi-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 185 "../src/reversi-view.vala"
	_tmp0_ = self->priv->_theme;
#line 185 "../src/reversi-view.vala"
	result = _tmp0_;
#line 185 "../src/reversi-view.vala"
	return result;
#line 7334 "reversi-view.c"
}

void
reversi_view_set_theme (ReversiView* self,
                        const gchar* value)
{
	GKeyFile* key = NULL;
	GKeyFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GKeyFile* _tmp15_;
	gchar* _tmp16_;
	GError* _inner_error0_ = NULL;
#line 186 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/reversi-view.vala"
	_tmp0_ = g_key_file_new ();
#line 187 "../src/reversi-view.vala"
	key = _tmp0_;
#line 188 "../src/reversi-view.vala"
	if (value == NULL) {
#line 188 "../src/reversi-view.vala"
		_tmp1_ = TRUE;
#line 7357 "reversi-view.c"
	} else {
#line 188 "../src/reversi-view.vala"
		_tmp1_ = g_strcmp0 ((const gchar*) value, "default") == 0;
#line 7361 "reversi-view.c"
	}
#line 188 "../src/reversi-view.vala"
	if (_tmp1_) {
#line 189 "../src/reversi-view.vala"
		reversi_view_set_default_theme (self, &key);
#line 7367 "reversi-view.c"
	} else {
		{
			gchar* key_path = NULL;
			gchar* _tmp2_;
			gchar* filepath = NULL;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_;
			gboolean _tmp9_;
			GKeyFile* _tmp11_;
			const gchar* _tmp12_;
#line 193 "../src/reversi-view.vala"
			_tmp2_ = g_build_filename (DATA_DIRECTORY, "themes", "key", NULL);
#line 193 "../src/reversi-view.vala"
			key_path = _tmp2_;
#line 194 "../src/reversi-view.vala"
			_tmp3_ = key_path;
#line 194 "../src/reversi-view.vala"
			_tmp4_ = g_build_filename (_tmp3_, (const gchar*) value, NULL);
#line 194 "../src/reversi-view.vala"
			filepath = _tmp4_;
#line 195 "../src/reversi-view.vala"
			_tmp5_ = filepath;
#line 195 "../src/reversi-view.vala"
			_tmp6_ = g_path_get_dirname (_tmp5_);
#line 195 "../src/reversi-view.vala"
			_tmp7_ = _tmp6_;
#line 195 "../src/reversi-view.vala"
			_tmp8_ = key_path;
#line 195 "../src/reversi-view.vala"
			_tmp9_ = g_strcmp0 (_tmp7_, _tmp8_) != 0;
#line 195 "../src/reversi-view.vala"
			_g_free0 (_tmp7_);
#line 195 "../src/reversi-view.vala"
			if (_tmp9_) {
#line 7406 "reversi-view.c"
				GError* _tmp10_;
#line 196 "../src/reversi-view.vala"
				_tmp10_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, "Theme file is not in the \"key\" directory.");
#line 196 "../src/reversi-view.vala"
				_inner_error0_ = _tmp10_;
#line 196 "../src/reversi-view.vala"
				_g_free0 (filepath);
#line 196 "../src/reversi-view.vala"
				_g_free0 (key_path);
#line 7416 "reversi-view.c"
				goto __catch12_g_error;
			}
#line 198 "../src/reversi-view.vala"
			_tmp11_ = key;
#line 198 "../src/reversi-view.vala"
			_tmp12_ = filepath;
#line 198 "../src/reversi-view.vala"
			g_key_file_load_from_file (_tmp11_, _tmp12_, G_KEY_FILE_NONE, &_inner_error0_);
#line 198 "../src/reversi-view.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 198 "../src/reversi-view.vala"
				_g_free0 (filepath);
#line 198 "../src/reversi-view.vala"
				_g_free0 (key_path);
#line 7431 "reversi-view.c"
				goto __catch12_g_error;
			}
#line 191 "../src/reversi-view.vala"
			_g_free0 (filepath);
#line 191 "../src/reversi-view.vala"
			_g_free0 (key_path);
#line 7438 "reversi-view.c"
		}
		goto __finally12;
		__catch12_g_error:
		{
			GError* e = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
#line 191 "../src/reversi-view.vala"
			e = _inner_error0_;
#line 191 "../src/reversi-view.vala"
			_inner_error0_ = NULL;
#line 202 "../src/reversi-view.vala"
			_tmp13_ = e;
#line 202 "../src/reversi-view.vala"
			_tmp14_ = _tmp13_->message;
#line 202 "../src/reversi-view.vala"
			g_warning ("reversi-view.vala:202: Failed to load theme: %s", _tmp14_);
#line 203 "../src/reversi-view.vala"
			reversi_view_set_default_theme (self, &key);
#line 204 "../src/reversi-view.vala"
			value = "default";
#line 191 "../src/reversi-view.vala"
			_g_error_free0 (e);
#line 7462 "reversi-view.c"
		}
		__finally12:
#line 191 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 191 "../src/reversi-view.vala"
			_g_key_file_unref0 (key);
#line 191 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 191 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 191 "../src/reversi-view.vala"
			return;
#line 7475 "reversi-view.c"
		}
	}
#line 207 "../src/reversi-view.vala"
	_tmp15_ = key;
#line 207 "../src/reversi-view.vala"
	reversi_view_load_theme (self, _tmp15_);
#line 208 "../src/reversi-view.vala"
	_tmp16_ = g_strdup (value);
#line 208 "../src/reversi-view.vala"
	_g_free0 (self->priv->_theme);
#line 208 "../src/reversi-view.vala"
	self->priv->_theme = _tmp16_;
#line 211 "../src/reversi-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 211 "../src/reversi-view.vala"
	self->priv->tiles_pattern = NULL;
#line 212 "../src/reversi-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 186 "../src/reversi-view.vala"
	_g_key_file_unref0 (key);
#line 7496 "reversi-view.c"
}

static void
g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UCHAR_UCHAR) (gpointer data1, guint8 arg_1, guint8 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UCHAR_UCHAR callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 23 "../src/reversi-view.vala"
	g_return_if_fail (n_param_values == 3);
#line 23 "../src/reversi-view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 23 "../src/reversi-view.vala"
		data1 = closure->data;
#line 23 "../src/reversi-view.vala"
		data2 = param_values->data[0].v_pointer;
#line 7521 "reversi-view.c"
	} else {
#line 23 "../src/reversi-view.vala"
		data1 = param_values->data[0].v_pointer;
#line 23 "../src/reversi-view.vala"
		data2 = closure->data;
#line 7527 "reversi-view.c"
	}
#line 23 "../src/reversi-view.vala"
	callback = (GMarshalFunc_VOID__UCHAR_UCHAR) (marshal_data ? marshal_data : cc->callback);
#line 23 "../src/reversi-view.vala"
	callback (data1, g_value_get_uchar (param_values + 1), g_value_get_uchar (param_values + 2), data2);
#line 7533 "reversi-view.c"
}

static GObject *
reversi_view_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ReversiView * self;
#line 152 "../src/reversi-view.vala"
	parent_class = G_OBJECT_CLASS (reversi_view_parent_class);
#line 152 "../src/reversi-view.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 152 "../src/reversi-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_REVERSI_VIEW, ReversiView);
#line 154 "../src/reversi-view.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 155 "../src/reversi-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 157 "../src/reversi-view.vala"
	gtk_widget_set_events ((GtkWidget*) self, (gint) (((((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_POINTER_MOTION_MASK) | GDK_ENTER_NOTIFY_MASK) | GDK_LEAVE_NOTIFY_MASK));
#line 163 "../src/reversi-view.vala"
	reversi_view_init_mouse (self);
#line 152 "../src/reversi-view.vala"
	return obj;
#line 7560 "reversi-view.c"
}

static void
reversi_view_class_init (ReversiViewClass * klass,
                         gpointer klass_data)
{
#line 23 "../src/reversi-view.vala"
	reversi_view_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/reversi-view.vala"
	g_type_class_adjust_private_offset (klass, &ReversiView_private_offset);
#line 23 "../src/reversi-view.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) reversi_view_real_draw;
#line 23 "../src/reversi-view.vala"
	((GtkWidgetClass *) klass)->enter_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) reversi_view_real_enter_notify_event;
#line 23 "../src/reversi-view.vala"
	((GtkWidgetClass *) klass)->leave_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) reversi_view_real_leave_notify_event;
#line 23 "../src/reversi-view.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) reversi_view_real_button_press_event;
#line 23 "../src/reversi-view.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) reversi_view_real_key_press_event;
#line 23 "../src/reversi-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_reversi_view_get_property;
#line 23 "../src/reversi-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_reversi_view_set_property;
#line 23 "../src/reversi-view.vala"
	G_OBJECT_CLASS (klass)->constructor = reversi_view_constructor;
#line 23 "../src/reversi-view.vala"
	G_OBJECT_CLASS (klass)->finalize = reversi_view_finalize;
#line 23 "../src/reversi-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY, reversi_view_properties[REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY] = g_param_spec_boolean ("show-turnable-tiles", "show-turnable-tiles", "show-turnable-tiles", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 23 "../src/reversi-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), REVERSI_VIEW_SOUND_FLIP_PROPERTY, reversi_view_properties[REVERSI_VIEW_SOUND_FLIP_PROPERTY] = g_param_spec_string ("sound-flip", "sound-flip", "sound-flip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/reversi-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), REVERSI_VIEW_SOUND_GAMEOVER_PROPERTY, reversi_view_properties[REVERSI_VIEW_SOUND_GAMEOVER_PROPERTY] = g_param_spec_string ("sound-gameover", "sound-gameover", "sound-gameover", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/reversi-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), REVERSI_VIEW_GAME_PROPERTY, reversi_view_properties[REVERSI_VIEW_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/reversi-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), REVERSI_VIEW_THEME_PROPERTY, reversi_view_properties[REVERSI_VIEW_THEME_PROPERTY] = g_param_spec_string ("theme", "theme", "theme", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/reversi-view.vala"
	reversi_view_signals[REVERSI_VIEW_MOVE_SIGNAL] = g_signal_new ("move", TYPE_REVERSI_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UCHAR_UCHAR, G_TYPE_NONE, 2, G_TYPE_UCHAR, G_TYPE_UCHAR);
#line 23 "../src/reversi-view.vala"
	reversi_view_signals[REVERSI_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL] = g_signal_new ("clear-impossible-to-move-here-warning", TYPE_REVERSI_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "../src/reversi-view.vala"
	reversi_view_signals[REVERSI_VIEW_NOTIFY_FINAL_ANIMATION_SIGNAL] = g_signal_new ("notify-final-animation", TYPE_REVERSI_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 7605 "reversi-view.c"
}

static void
reversi_view_instance_init (ReversiView * self,
                            gpointer klass)
{
#line 23 "../src/reversi-view.vala"
	self->priv = reversi_view_get_instance_private (self);
#line 25 "../src/reversi-view.vala"
	self->priv->_show_turnable_tiles = FALSE;
#line 30 "../src/reversi-view.vala"
	self->priv->background_red = 0.2;
#line 31 "../src/reversi-view.vala"
	self->priv->background_green = 0.6;
#line 32 "../src/reversi-view.vala"
	self->priv->background_blue = 0.4;
#line 33 "../src/reversi-view.vala"
	self->priv->background_radius = 0;
#line 35 "../src/reversi-view.vala"
	self->priv->texture_alpha = 0.25;
#line 36 "../src/reversi-view.vala"
	self->priv->apply_texture = FALSE;
#line 38 "../src/reversi-view.vala"
	self->priv->mark_red = 0.2;
#line 39 "../src/reversi-view.vala"
	self->priv->mark_green = 0.6;
#line 40 "../src/reversi-view.vala"
	self->priv->mark_blue = 0.4;
#line 41 "../src/reversi-view.vala"
	self->priv->mark_width = 2;
#line 43 "../src/reversi-view.vala"
	self->priv->border_red = 0.1;
#line 44 "../src/reversi-view.vala"
	self->priv->border_green = 0.1;
#line 45 "../src/reversi-view.vala"
	self->priv->border_blue = 0.1;
#line 46 "../src/reversi-view.vala"
	self->priv->border_width = 3;
#line 47 "../src/reversi-view.vala"
	self->priv->half_border_width = 1.5;
#line 49 "../src/reversi-view.vala"
	self->priv->spacing_red = 0.1;
#line 50 "../src/reversi-view.vala"
	self->priv->spacing_green = 0.3;
#line 51 "../src/reversi-view.vala"
	self->priv->spacing_blue = 0.2;
#line 52 "../src/reversi-view.vala"
	self->priv->spacing_width = 2;
#line 54 "../src/reversi-view.vala"
	self->priv->highlight_hard_red = 0.1;
#line 55 "../src/reversi-view.vala"
	self->priv->highlight_hard_green = 0.3;
#line 56 "../src/reversi-view.vala"
	self->priv->highlight_hard_blue = 0.2;
#line 57 "../src/reversi-view.vala"
	self->priv->highlight_hard_alpha = 0.4;
#line 59 "../src/reversi-view.vala"
	self->priv->highlight_soft_red = 0.1;
#line 60 "../src/reversi-view.vala"
	self->priv->highlight_soft_green = 0.3;
#line 61 "../src/reversi-view.vala"
	self->priv->highlight_soft_blue = 0.2;
#line 62 "../src/reversi-view.vala"
	self->priv->highlight_soft_alpha = 0.2;
#line 73 "../src/reversi-view.vala"
	self->priv->show_highlight = FALSE;
#line 74 "../src/reversi-view.vala"
	self->priv->highlight_set = FALSE;
#line 75 "../src/reversi-view.vala"
	self->priv->highlight_x = G_MAXUINT8;
#line 76 "../src/reversi-view.vala"
	self->priv->highlight_y = G_MAXUINT8;
#line 77 "../src/reversi-view.vala"
	self->priv->old_highlight_x = G_MAXUINT8;
#line 78 "../src/reversi-view.vala"
	self->priv->old_highlight_y = G_MAXUINT8;
#line 79 "../src/reversi-view.vala"
	self->priv->highlight_state = (guint8) 0;
#line 83 "../src/reversi-view.vala"
	self->priv->show_mouse_highlight = FALSE;
#line 84 "../src/reversi-view.vala"
	self->priv->mouse_position_set = FALSE;
#line 85 "../src/reversi-view.vala"
	self->priv->mouse_highlight_x = G_MAXUINT8;
#line 86 "../src/reversi-view.vala"
	self->priv->mouse_highlight_y = G_MAXUINT8;
#line 87 "../src/reversi-view.vala"
	self->priv->mouse_position_x = G_MAXUINT8;
#line 88 "../src/reversi-view.vala"
	self->priv->mouse_position_y = G_MAXUINT8;
#line 94 "../src/reversi-view.vala"
	self->priv->render_size = (guint) 0;
#line 95 "../src/reversi-view.vala"
	self->priv->tiles_pattern = NULL;
#line 96 "../src/reversi-view.vala"
	self->priv->board_pattern = NULL;
#line 98 "../src/reversi-view.vala"
	self->priv->noise_pixbuf_loaded = FALSE;
#line 104 "../src/reversi-view.vala"
	self->priv->animate_timeout = (guint) 0;
#line 109 "../src/reversi-view.vala"
	self->priv->game_is_set = FALSE;
#line 182 "../src/reversi-view.vala"
	self->priv->_theme = NULL;
#line 659 "../src/reversi-view.vala"
	self->priv->last_state_set = FALSE;
#line 825 "../src/reversi-view.vala"
	self->priv->flip_final_result_now = FALSE;
#line 910 "../src/reversi-view.vala"
	self->priv->mouse_is_in = FALSE;
#line 970 "../src/reversi-view.vala"
	self->priv->timeout_id = (guint) 0;
#line 7718 "reversi-view.c"
}

static void
reversi_view_finalize (GObject * obj)
{
	ReversiView * self;
#line 23 "../src/reversi-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_REVERSI_VIEW, ReversiView);
#line 28 "../src/reversi-view.vala"
	_g_free0 (self->priv->pieces_file);
#line 66 "../src/reversi-view.vala"
	_g_free0 (self->priv->_sound_flip);
#line 67 "../src/reversi-view.vala"
	_g_free0 (self->priv->_sound_gameover);
#line 95 "../src/reversi-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 96 "../src/reversi-view.vala"
	_cairo_pattern_destroy0 (self->priv->board_pattern);
#line 101 "../src/reversi-view.vala"
	self->priv->pixmaps = (g_free (self->priv->pixmaps), NULL);
#line 111 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 166 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->iagno_instance);
#line 182 "../src/reversi-view.vala"
	_g_free0 (self->priv->_theme);
#line 298 "../src/reversi-view.vala"
	self->priv->tile_xs = (g_free (self->priv->tile_xs), NULL);
#line 299 "../src/reversi-view.vala"
	self->priv->tile_ys = (g_free (self->priv->tile_ys), NULL);
#line 660 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->last_state);
#line 909 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 1233 "../src/reversi-view.vala"
	self->priv->possible_moves = (g_free (self->priv->possible_moves), NULL);
#line 23 "../src/reversi-view.vala"
	G_OBJECT_CLASS (reversi_view_parent_class)->finalize (obj);
#line 7757 "reversi-view.c"
}

GType
reversi_view_get_type (void)
{
	static volatile gsize reversi_view_type_id__volatile = 0;
	if (g_once_init_enter (&reversi_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ReversiViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) reversi_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ReversiView), 0, (GInstanceInitFunc) reversi_view_instance_init, NULL };
		GType reversi_view_type_id;
		reversi_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "ReversiView", &g_define_type_info, 0);
		ReversiView_private_offset = g_type_add_instance_private (reversi_view_type_id, sizeof (ReversiViewPrivate));
		g_once_init_leave (&reversi_view_type_id__volatile, reversi_view_type_id);
	}
	return reversi_view_type_id__volatile;
}

static void
_vala_reversi_view_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	ReversiView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_REVERSI_VIEW, ReversiView);
#line 23 "../src/reversi-view.vala"
	switch (property_id) {
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY:
#line 23 "../src/reversi-view.vala"
		g_value_set_boolean (value, reversi_view_get_show_turnable_tiles (self));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_SOUND_FLIP_PROPERTY:
#line 23 "../src/reversi-view.vala"
		g_value_set_string (value, reversi_view_get_sound_flip (self));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_SOUND_GAMEOVER_PROPERTY:
#line 23 "../src/reversi-view.vala"
		g_value_set_string (value, reversi_view_get_sound_gameover (self));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_GAME_PROPERTY:
#line 23 "../src/reversi-view.vala"
		g_value_set_object (value, reversi_view_get_game (self));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_THEME_PROPERTY:
#line 23 "../src/reversi-view.vala"
		g_value_set_string (value, reversi_view_get_theme (self));
#line 23 "../src/reversi-view.vala"
		break;
#line 7814 "reversi-view.c"
		default:
#line 23 "../src/reversi-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/reversi-view.vala"
		break;
#line 7820 "reversi-view.c"
	}
}

static void
_vala_reversi_view_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	ReversiView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_REVERSI_VIEW, ReversiView);
#line 23 "../src/reversi-view.vala"
	switch (property_id) {
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY:
#line 23 "../src/reversi-view.vala"
		reversi_view_set_show_turnable_tiles (self, g_value_get_boolean (value));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_SOUND_FLIP_PROPERTY:
#line 23 "../src/reversi-view.vala"
		reversi_view_set_sound_flip (self, g_value_get_string (value));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_SOUND_GAMEOVER_PROPERTY:
#line 23 "../src/reversi-view.vala"
		reversi_view_set_sound_gameover (self, g_value_get_string (value));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_GAME_PROPERTY:
#line 23 "../src/reversi-view.vala"
		reversi_view_set_game (self, g_value_get_object (value));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_THEME_PROPERTY:
#line 23 "../src/reversi-view.vala"
		reversi_view_set_theme (self, g_value_get_string (value));
#line 23 "../src/reversi-view.vala"
		break;
#line 7864 "reversi-view.c"
		default:
#line 23 "../src/reversi-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/reversi-view.vala"
		break;
#line 7870 "reversi-view.c"
	}
}

